      program pm7
c---  A version of pm which uses TSC for density & 4-point FDA for force
c---  The same as pm3 but does not use the 3 force arrays!
c---  Uses SGI's sfft3du
c---  Modified from pm4.f  by Park, Changbom at Jan. 22, 2000, CITA
c---  Code tested !!
c---  Code changed for Itanium, Feb. 4, 2004 at KIAS
c---  Code modified for Slice simulations, July 20, 2004 at KIAS

      parameter (m=512,mz=m,m2=m+2,mh=m/2)
      parameter (mp=2,mmp=m/mp,mzmp=mz/mp)
      parameter (mbias=4)

      real*4 den(m2,m,mz)
      real*4   x(mmp*mmp*mzmp),  y(mmp*mmp*mzmp),  z(mmp*mmp*mzmp)
      real*4  xx(mmp,mmp,mzmp), yy(mmp,mmp,mzmp), zz(mmp,mmp,mzmp)
      real*4  vx(mmp*mmp*mzmp), vy(mmp*mmp*mzmp), vz(mmp*mmp*mzmp)
      real*4 vxx(mmp,mmp,mzmp),vyy(mmp,mmp,mzmp),vzz(mmp,mmp,mzmp)
      real*4  xb(mbias),   yb(mbias),   zb(mbias)
      real*4 vxb(mbias),  vyb(mbias), vzb(mbias)  
      real*4 pk(m+1),npk(m+1),cor(m+1),corw(m),cpu(2)
      real*4 ken,kenold,kenata,ktot
c     REAL   FFTWORK(m+15+2*(m+15)+2*(m+15))

      integer*4 tabp0(-10:m+10),tabp1(-10:m+10),tabm1(-10:m+10)
      integer*4 zabp0(-10:mz+10),zabp1(-10:mz+10),zabm1(-10:mz+10)
      integer*8 plan, iplan
      character*3 number
      equivalence (x,xx),(y,yy),(z,zz),(vx,vxx),(vy,vyy),(vz,vzz)
      common/pos/x,y,z
      common/vel/vx,vy,vz
      common/seed/den
      common/seed2/a,kenold,ktot,iseed,amax,astep,
     &             xb,yb,zb,vxb,vyb,vzb,nbias
      common/cospar/omep,omepb,omeplam,h,size

c#ifdef SGI
cc      CALL SFFT3DUI(m,m,m,FFTWORK)
c#endif
c     call sfftw_plan_dft_r2c_3d(plan,m,m,mz,den,den,FFTW_ESTIMATE)
c     call sfftw_plan_dft_c2r_3d(iplan,m,m,mz,den,den,FFTW_ESTIMATE)

c---  rth = top-hat radius in pixels
c---  omep  = present total matter density parameter = omepc+omepb
c---  omepb = present baryon matter density parameter.
      write(6,*)' nspace,omep,omepb,omeplam,rth ?'
      read(5,*)   nspace,omep,omepb,omeplam,rth
      ng    = m
      rng   = real(ng)
      ngz   = mz
      rngz  = real(ngz)
      ngh   = ng/2
      nghp1 = ng/2+1
      rngc  = rng**3
      rngp6 = rngc*rngc
      rngm6 = 1./rngp6
      ngzc  = ng*ng*ngz
      rngzc = real(ngzc)
      zxy   = rngz/rng
      xyz   = rng/rngz
      np = ngzc/nspace**3
      pi = 3.141592654
c---  Total mass in the rectangle is ngz/ng so that the mean density = 1
      pmas  = real(nspace)**3
      pmass = pmas/rngzc
      knyq = ngh
      rknyq = ngh
      rknyq2 = rknyq**2
      nfft = (ngh+1)*ng*ngz

c---  Call pmseed to get the initial conditions  
c---  Get position and velocity at a(initial)
      print *,'PMSEED'
      call pmseed

      zi = amax-1.
      omei = omep*(1.+zi)/(1.+omep*zi)
      omei = omep*(1+zi)**3
     &     /(omep*(1+zi)**3+omeplam+(1-omep-omeplam)*(1+zi)**2)
      nowflag = 0

c---  Making periodic tables
      do 10 i=-10,0
      tabm1(i)=ng+i-1
      tabp0(i)=ng+i
      tabp1(i)=ng+i+1
      zabm1(i)=ngz+i-1
      zabp0(i)=ngz+i
   10 zabp1(i)=ngz+i+1
      tabp1(0)=1
      zabp1(0)=1
      do 20 i=1,ng
      tabm1(i)=i-1
      tabp0(i)=i
   20 tabp1(i)=i+1
      tabm1(1)=ng
      tabp1(ng)=1
      do 30 i=1,ngz
      zabm1(i) = i-1
      zabp0(i) = i
   30 zabp1(i) = i+1
      zabm1(1) = ngz
      zabp1(ngz)=1
      do 40 i=ng+1,ng+10
      tabm1(i)=i-ng-1
      tabp0(i)=i-ng
   40 tabp1(i)=i+1-ng
      tabm1(ng+1)=ng
      do 50 i=ngz+1,ngz+10
      zabm1(i)=i-ngz-1
      zabp0(i)=i-ngz
   50 zabp1(i)=i+1-ngz
      zabm1(ngz+1) = ngz

      now = 0
      nstep = 0
c---  Number of steps between integer a's
      istep = nint(1./astep)
c---  Step numbers corresponding to z = 2 and 1
      zout2=1+2
      zout1=1+1
      nstep2 = nint((amax/zout2-1)/astep)
      nstep1 = nint((amax/zout1-1)/astep)
      print *,' nstep2, nstep1, istep =',nstep2,nstep1,istep

c     **************************************
c     *  Loop for Gravitational Evolution  *
c     **************************************

c---  Cell positions run from 0 to n-1 while particle positions
c---  run from 0 to n
c---  (xp,yp,zp) = particle position
c---  (ic,jc,kc) = major cell's position the superparticle clould belongs to.
c---  (icc,jcc,kcc) = minor cell's position
c---  CPU : Scalar (1.84), Vector (1.02,8.1,65) for ng = 32,64,128
   70 nstep = nstep+1
c     tstep = etime(cpu)
      call cpu_time(tstep)
      tzero = tstep

c***  Find the density at the grid using the TSC scheme 
c---  Assign the mean density to initialize the density arrary
      do 75 k=1,mz
      do 75 j=1,m
      do 75 i=1,m
   75 den(i,j,k) = -1
 
      p05 = pmas*0.5
      do 80 i=1,np
      xp = x(i)
      yp = y(i)
      zp = z(i)
      nearx = nint(xp)
      neary = nint(yp)
      nearz = nint(zp)
      xmin = xp-nearx
      ymin = yp-neary
      zmin = zp-nearz
      isign= sign(1.,xmin)
      jsign= sign(1.,ymin)
      ksign= sign(1.,zmin)
      i1  = mod(nearx+ng,ng)+1
      j1  = mod(neary+ng,ng)+1
      k1  = mod(nearz+ngz,ngz)+1
      i2  = mod(nearx+ng+isign,ng)+1
      j2  = mod(neary+ng+jsign,ng)+1
      k2  = mod(nearz+ngz+ksign,ngz)+1
      i3  = mod(nearx+ng-isign,ng)+1
      j3  = mod(neary+ng-jsign,ng)+1
      k3  = mod(nearz+ngz-ksign,ngz)+1
      xd1 = abs(xmin)
      yd1 = abs(ymin)
      zd1 = abs(zmin)
      wx1 =(0.75-xd1**2)*pmas
      wy1 = 0.75-yd1**2
      wz1 = 0.75-zd1**2
      wx2 = p05*(0.5+xd1)**2
      wy2 = 0.5*(0.5+yd1)**2
      wz2 = 0.5*(0.5+zd1)**2
      wx3 = p05*(0.5-xd1)**2
      wy3 = 0.5*(0.5-yd1)**2
      wz3 = 0.5*(0.5-zd1)**2
c---  Assign mass to the grid the particle overlaps
      den(i1,j1,k1) = den(i1,j1,k1) + wx1*wy1*wz1
      den(i2,j1,k1) = den(i2,j1,k1) + wx2*wy1*wz1
      den(i3,j1,k1) = den(i3,j1,k1) + wx3*wy1*wz1
      den(i1,j2,k1) = den(i1,j2,k1) + wx1*wy2*wz1
      den(i2,j2,k1) = den(i2,j2,k1) + wx2*wy2*wz1
      den(i3,j2,k1) = den(i3,j2,k1) + wx3*wy2*wz1
      den(i1,j3,k1) = den(i1,j3,k1) + wx1*wy3*wz1
      den(i2,j3,k1) = den(i2,j3,k1) + wx2*wy3*wz1
      den(i3,j3,k1) = den(i3,j3,k1) + wx3*wy3*wz1
      den(i1,j1,k2) = den(i1,j1,k2) + wx1*wy1*wz2
      den(i2,j1,k2) = den(i2,j1,k2) + wx2*wy1*wz2
      den(i3,j1,k2) = den(i3,j1,k2) + wx3*wy1*wz2
      den(i1,j2,k2) = den(i1,j2,k2) + wx1*wy2*wz2
      den(i2,j2,k2) = den(i2,j2,k2) + wx2*wy2*wz2
      den(i3,j2,k2) = den(i3,j2,k2) + wx3*wy2*wz2
      den(i1,j3,k2) = den(i1,j3,k2) + wx1*wy3*wz2
      den(i2,j3,k2) = den(i2,j3,k2) + wx2*wy3*wz2
      den(i3,j3,k2) = den(i3,j3,k2) + wx3*wy3*wz2
      den(i1,j1,k3) = den(i1,j1,k3) + wx1*wy1*wz3
      den(i2,j1,k3) = den(i2,j1,k3) + wx2*wy1*wz3
      den(i3,j1,k3) = den(i3,j1,k3) + wx3*wy1*wz3
      den(i1,j2,k3) = den(i1,j2,k3) + wx1*wy2*wz3
      den(i2,j2,k3) = den(i2,j2,k3) + wx2*wy2*wz3
      den(i3,j2,k3) = den(i3,j2,k3) + wx3*wy2*wz3
      den(i1,j3,k3) = den(i1,j3,k3) + wx1*wy3*wz3
      den(i2,j3,k3) = den(i2,j3,k3) + wx2*wy3*wz3
      den(i3,j3,k3) = den(i3,j3,k3) + wx3*wy3*wz3
   80 continue
c     if(nstep.le.2)print *,'CPU(TSC) =',etime(cpu)-tzero
      call cpu_time(tnow)
      if(nstep.le.2)print *,'CPU(TSC) =',tnow-tzero


c***  Get the Fourier components of the density by forward FFT
c---  CPU : Scalar (0.41), Vector (0.41,2.77,28.8) for ng = 32,64,128
c     tzero = etime(cpu)
      call cpu_time(tzero)
      call src3ft(den,ng,ng,ngz,m2,m,1,ier)
c     CALL SFFT3DU(-1,m,m,m,den,m+2,m,FFTWORK)
cccc      call sfftw_execute(plan)
c     if(nstep.le.2)print *,'CPU(FFT) =',etime(cpu)-tzero
      call cpu_time(tnow)
      if(nstep.le.2)print *,'CPU(FFT) =',tnow-tzero

      if(mod(nstep-1,istep).eq.0.)then
c***  Calculate the power spectrum and correlation function
c***  and rms fluctuation of density smoothed over 8 Mpc
c---  CPU : Scalar (0.41), Vector (0.295,1.84,12) for ng = 32,64,128
c     tzero = etime(cpu)
      call cpu_time(tzero)
      do 90 i=1,ng+1
      pk(i) = 0.
      npk(i) = 0
   90 cor(i) = 0.
      do 100 k=1,ngz
      wk = xyz*(k-1)
      if(wk.gt.ngh)wk = wk-ng
      do 100 j=1,ng
      wj = j-1
      if(wj.gt.ngh)wj = wj-ng
      do 100 i=0,ngh
      wave = sqrt(i*i+wj*wj+wk*wk)
      delksq = (den(2*i+1,j,k)**2+den(2*i+2,j,k)**2)*rngm6
      kbin1 = nint(wave)+1
      wt1 = wave-kbin1+1
      kbin2 = kbin1+sign(1.,wt1)
      wt1 = abs(wt1)
      pk(kbin1) = pk(kbin1)+(1.-wt1)*delksq
      pk(kbin2) = pk(kbin2)+wt1*delksq
      npk(kbin1) = npk(kbin1)+1.-wt1
      npk(kbin2) = npk(kbin2)+wt1
  100 continue
      std = 0.
      fact = 2.*pi*rth/rng
      do 110 i=2,ng+1
      if(npk(i).gt.0)then
         pk(i)=pk(i)/npk(i)
      else
         pk(i) = 0.
      end if
      thk = fact*(i-1.)
  110 std = std+pk(i)*(i-1.)**2*(sin(thk)-thk*cos(thk))**2/thk**6
      std = sqrt(4.*pi*std*9.)
      do 130 i=2,ng+1
      seper = 2.*pi*(i-1.)/rng
      do 120 k=2,ng+1
  120 cor(i) = cor(i)+sin((k-1.)*seper)*(k-1.)*pk(k)
  130 cor(i) = 2.*rng*cor(i)/(i-1.)
      if(cor(4).gt.0..and.cor(3).gt.0.)then
      corn2 = (alog(cor(4))-alog(cor(3)))/(alog(4.)-alog(3.))
      if(nowflag.eq.1)then
      if(a.ne.1..and.(corn1+1.8)*(corn2+1.8).le.0.)now=1
      if(now.eq.1)goto 180
      end if
      corn1 = corn2
      end if
      open(7,file='pmevol.map',access='append')
      write(7,*)a,std,corn1
      close(7)
c     if(nstep.le.2)print *,'CPU(Pk) =',etime(cpu)-tzero
      call cpu_time(tnow)
      if(nstep.le.2)print *,'CPU(Pk) =',tnow-tzero
      end if

c***  Calculate the Fourier component of potential
c---  CPU : Scalar (0.194), Vector (0.175,1.36,10.2) for ng = 32,64,128
c     tzero = etime(cpu)
      call cpu_time(tzero)
      poten1 = 0
      poten2 = 0
      fact = -1./pi
      do 140 k=1,ngz
      wk = xyz*(k-1)
      if(wk.gt.ngh)wk = wk-ng
      do 140 j=1,ng
      wj = j-1
      if(wj.gt.ngh)wj = wj-ng
      do 140 i=0,ngh
      wave = i*i+wj*wj+wk*wk
ccc-- Now keeping the modes higher than the Knyquist frequency
c     if(wave.eq.0..or.wave.ge.rknyq2)then
      if(wave.eq.0.)then
      den(2*i+1,j,k) = 0
      den(2*i+2,j,k) = 0
      else
      factor = fact/wave
c---  Division by n**3 is due to the length unit convention (dx^3=1/n**3)
      delksq = (den(2*i+1,j,k)**2+den(2*i+2,j,k)**2)*rngm6
      if(i.eq.0)then
         poten1 = poten1+factor*delksq
      else
         poten2 = poten2+factor*delksq
      end if
c     den(2*i+1,j,k) = factor*den(2*i+1,j,k)/rngc
c     den(2*i+2,j,k) = factor*den(2*i+2,j,k)/rngc
      den(2*i+1,j,k) = factor*den(2*i+1,j,k)
      den(2*i+2,j,k) = factor*den(2*i+2,j,k)
      end if
  140 continue
      poten = 0.5*(poten1+2.*poten2)
c     if(nstep.le.2)print *,'CPU(Poisson) =',etime(cpu)-tzero
      call cpu_time(tnow)
      if(nstep.le.2)print *,'CPU(Poisson) =',tnow-tzero

c***  Get the potential by inverse FFT
      call src3ft(den,ng,ng,ngz,m2,m,-1,ier)
c     CALL SFFT3DU(+1,m,m,m,den,m2,m,FFTWORK)
ccccc      call sfftw_execute(iplan)

      if(mod(nstep-1,istep).eq.0.)then
      open(7,file='pmevol.map',access='append')
      do 150 i=1,ngh
  150 write(7,11)i,i-1,pk(i),cor(i)
      close(7)
   11 format(1x,2i4,1p2e10.2)
      end if
      if(now.eq.1)goto 180

c***  Solve the momentum equation by using Friedman equations
      if(a.eq.1)astep = 0.5*astep
      ainv = 1./a
      app  = -4.*pi/3.*(ainv*ainv-2*omeplam/omep*a/amax**3)
      apsq = 8.*pi/3.*(ainv+1./omei-1+omeplam/omep*(a**2-1)/amax**3)
      afact = (2.+app*a/apsq)/2.*ainv
      bfact = ainv**3/apsq
      fact1 = (1.-afact*astep)/(1.+afact*astep)
      fact2 = bfact*astep/(1.+afact*astep)*rng
      if(a.eq.1)astep = 2.*astep
      pfact = rng*astep

c***  Force at grid points by 2-point FDA
c     tzero = etime(cpu)
      call cpu_time(tzero)
      ffact1 = (4./3.)/2.
      ffact2 = (-1./3.)/4.

c***  Cell position run from 0 to n-1 and particles from 0 to n 
c---  (xp,yp,zp) = particle position
c---  (ic,jc,kc) = major cell's position the superparticle clould belongs to.
c---  (icc,jcc,kcc) = position of the minor cell
c---  Now find the velocity at a+astep/2
c---  CPU : Scalar (4.62), Vector (1.53,12.2,96) for ng = 32,64,128
      do 160 i=1,np
      xp   = x(i)
      yp   = y(i)
      zp   = z(i)
      nearx= nint(xp)
      neary= nint(yp)
      nearz= nint(zp)
      xmin = xp-nearx
      ymin = yp-neary
      zmin = zp-nearz
      isign= sign(1.,xmin)
      jsign= sign(1.,ymin)
      ksign= sign(1.,zmin)
      i1  = mod(nearx+ng,ng)+1
      j1  = mod(neary+ng,ng)+1
      k1  = mod(nearz+ngz,ngz)+1
      i2  = mod(nearx+ng+isign,ng)+1
      j2  = mod(neary+ng+jsign,ng)+1
      k2  = mod(nearz+ngz+ksign,ngz)+1
      i3  = mod(nearx+ng-isign,ng)+1
      j3  = mod(neary+ng-jsign,ng)+1
      k3  = mod(nearz+ngz-ksign,ngz)+1
      xd1 = abs(xmin)
      yd1 = abs(ymin)
      zd1 = abs(zmin)
      wx1 = 0.75-xd1**2
      wy1 = 0.75-yd1**2
      wz1 = 0.75-zd1**2
      wx2 = 0.5*(0.5+xd1)**2
      wy2 = 0.5*(0.5+yd1)**2
      wz2 = 0.5*(0.5+zd1)**2
      wx3 = 0.5*(0.5-xd1)**2
      wy3 = 0.5*(0.5-yd1)**2
      wz3 = 0.5*(0.5-zd1)**2
      wt1  = wx1*wy1*wz1
      wt2  = wx2*wy1*wz1
      wt3  = wx3*wy1*wz1
      wt4  = wx1*wy2*wz1
      wt5  = wx2*wy2*wz1
      wt6  = wx3*wy2*wz1
      wt7  = wx1*wy3*wz1
      wt8  = wx2*wy3*wz1
      wt9  = wx3*wy3*wz1
      wt10 = wx1*wy1*wz2
      wt11 = wx2*wy1*wz2
      wt12 = wx3*wy1*wz2
      wt13 = wx1*wy2*wz2
      wt14 = wx2*wy2*wz2
      wt15 = wx3*wy2*wz2
      wt16 = wx1*wy3*wz2
      wt17 = wx2*wy3*wz2
      wt18 = wx3*wy3*wz2
      wt19 = wx1*wy1*wz3
      wt20 = wx2*wy1*wz3
      wt21 = wx3*wy1*wz3
      wt22 = wx1*wy2*wz3
      wt23 = wx2*wy2*wz3
      wt24 = wx3*wy2*wz3
      wt25 = wx1*wy3*wz3
      wt26 = wx2*wy3*wz3
      wt27 = wx3*wy3*wz3

      i1m1 = tabm1(i1)
      i1m2 = tabm1(i1m1)
      i1p1 = tabp1(i1)
      i1p2 = tabp1(i1p1)
      i2m1 = tabm1(i2)
      i2m2 = tabm1(i2m1)
      i2p1 = tabp1(i2)
      i2p2 = tabp1(i2p1)
      i3m1 = tabm1(i3)
      i3m2 = tabm1(i3m1)
      i3p1 = tabp1(i3)
      i3p2 = tabp1(i3p1)

      j1m1 = tabm1(j1)
      j1m2 = tabm1(j1m1)
      j1p1 = tabp1(j1)
      j1p2 = tabp1(j1p1)
      j2m1 = tabm1(j2)
      j2m2 = tabm1(j2m1)
      j2p1 = tabp1(j2)
      j2p2 = tabp1(j2p1)
      j3m1 = tabm1(j3)
      j3m2 = tabm1(j3m1)
      j3p1 = tabp1(j3)
      j3p2 = tabp1(j3p1)

      k1m1 = zabm1(k1)
      k1m2 = zabm1(k1m1)
      k1p1 = zabp1(k1)
      k1p2 = zabp1(k1p1)
      k2m1 = zabm1(k2)
      k2m2 = zabm1(k2m1)
      k2p1 = zabp1(k2)
      k2p2 = zabp1(k2p1)
      k3m1 = zabm1(k3)
      k3m2 = zabm1(k3m1)
      k3p1 = zabp1(k3)
      k3p2 = zabp1(k3p1)

      fx1 = ffact1*(den(i1m1,j1,k1)-den(i1p1,j1,k1))+
     &      ffact2*(den(i1m2,j1,k1)-den(i1p2,j1,k1))
      fx2 = ffact1*(den(i2m1,j1,k1)-den(i2p1,j1,k1))+
     &      ffact2*(den(i2m2,j1,k1)-den(i2p2,j1,k1))
      fx3 = ffact1*(den(i3m1,j1,k1)-den(i3p1,j1,k1))+
     &      ffact2*(den(i3m2,j1,k1)-den(i3p2,j1,k1))
      fx4 = ffact1*(den(i1m1,j2,k1)-den(i1p1,j2,k1))+
     &      ffact2*(den(i1m2,j2,k1)-den(i1p2,j2,k1))
      fx5 = ffact1*(den(i2m1,j2,k1)-den(i2p1,j2,k1))+
     &      ffact2*(den(i2m2,j2,k1)-den(i2p2,j2,k1))
      fx6 = ffact1*(den(i3m1,j2,k1)-den(i3p1,j2,k1))+
     &      ffact2*(den(i3m2,j2,k1)-den(i3p2,j2,k1))
      fx7 = ffact1*(den(i1m1,j3,k1)-den(i1p1,j3,k1))+
     &      ffact2*(den(i1m2,j3,k1)-den(i1p2,j3,k1))
      fx8 = ffact1*(den(i2m1,j3,k1)-den(i2p1,j3,k1))+
     &      ffact2*(den(i2m2,j3,k1)-den(i2p2,j3,k1))
      fx9 = ffact1*(den(i3m1,j3,k1)-den(i3p1,j3,k1))+
     &      ffact2*(den(i3m2,j3,k1)-den(i3p2,j3,k1))

      fx10 = ffact1*(den(i1m1,j1,k2)-den(i1p1,j1,k2))+
     &       ffact2*(den(i1m2,j1,k2)-den(i1p2,j1,k2))
      fx11 = ffact1*(den(i2m1,j1,k2)-den(i2p1,j1,k2))+
     &       ffact2*(den(i2m2,j1,k2)-den(i2p2,j1,k2))
      fx12 = ffact1*(den(i3m1,j1,k2)-den(i3p1,j1,k2))+
     &       ffact2*(den(i3m2,j1,k2)-den(i3p2,j1,k2))
      fx13 = ffact1*(den(i1m1,j2,k2)-den(i1p1,j2,k2))+
     &       ffact2*(den(i1m2,j2,k2)-den(i1p2,j2,k2))
      fx14 = ffact1*(den(i2m1,j2,k2)-den(i2p1,j2,k2))+
     &       ffact2*(den(i2m2,j2,k2)-den(i2p2,j2,k2))
      fx15 = ffact1*(den(i3m1,j2,k2)-den(i3p1,j2,k2))+
     &       ffact2*(den(i3m2,j2,k2)-den(i3p2,j2,k2))
      fx16 = ffact1*(den(i1m1,j3,k2)-den(i1p1,j3,k2))+
     &       ffact2*(den(i1m2,j3,k2)-den(i1p2,j3,k2))
      fx17 = ffact1*(den(i2m1,j3,k2)-den(i2p1,j3,k2))+
     &       ffact2*(den(i2m2,j3,k2)-den(i2p2,j3,k2))
      fx18 = ffact1*(den(i3m1,j3,k2)-den(i3p1,j3,k2))+
     &       ffact2*(den(i3m2,j3,k2)-den(i3p2,j3,k2))

      fx19 = ffact1*(den(i1m1,j1,k3)-den(i1p1,j1,k3))+
     &       ffact2*(den(i1m2,j1,k3)-den(i1p2,j1,k3))
      fx20 = ffact1*(den(i2m1,j1,k3)-den(i2p1,j1,k3))+
     &       ffact2*(den(i2m2,j1,k3)-den(i2p2,j1,k3))
      fx21 = ffact1*(den(i3m1,j1,k3)-den(i3p1,j1,k3))+
     &       ffact2*(den(i3m2,j1,k3)-den(i3p2,j1,k3))
      fx22 = ffact1*(den(i1m1,j2,k3)-den(i1p1,j2,k3))+
     &       ffact2*(den(i1m2,j2,k3)-den(i1p2,j2,k3))
      fx23 = ffact1*(den(i2m1,j2,k3)-den(i2p1,j2,k3))+
     &       ffact2*(den(i2m2,j2,k3)-den(i2p2,j2,k3))
      fx24 = ffact1*(den(i3m1,j2,k3)-den(i3p1,j2,k3))+
     &       ffact2*(den(i3m2,j2,k3)-den(i3p2,j2,k3))
      fx25 = ffact1*(den(i1m1,j3,k3)-den(i1p1,j3,k3))+
     &       ffact2*(den(i1m2,j3,k3)-den(i1p2,j3,k3))
      fx26 = ffact1*(den(i2m1,j3,k3)-den(i2p1,j3,k3))+
     &       ffact2*(den(i2m2,j3,k3)-den(i2p2,j3,k3))
      fx27 = ffact1*(den(i3m1,j3,k3)-den(i3p1,j3,k3))+
     &       ffact2*(den(i3m2,j3,k3)-den(i3p2,j3,k3))

      fy1 = ffact1*(den(i1,j1m1,k1)-den(i1,j1p1,k1))+
     &      ffact2*(den(i1,j1m2,k1)-den(i1,j1p2,k1))
      fy2 = ffact1*(den(i2,j1m1,k1)-den(i2,j1p1,k1))+
     &      ffact2*(den(i2,j1m2,k1)-den(i2,j1p2,k1))
      fy3 = ffact1*(den(i3,j1m1,k1)-den(i3,j1p1,k1))+
     &      ffact2*(den(i3,j1m2,k1)-den(i3,j1p2,k1))
      fy4 = ffact1*(den(i1,j2m1,k1)-den(i1,j2p1,k1))+
     &      ffact2*(den(i1,j2m2,k1)-den(i1,j2p2,k1))
      fy5 = ffact1*(den(i2,j2m1,k1)-den(i2,j2p1,k1))+
     &      ffact2*(den(i2,j2m2,k1)-den(i2,j2p2,k1))
      fy6 = ffact1*(den(i3,j2m1,k1)-den(i3,j2p1,k1))+
     &      ffact2*(den(i3,j2m2,k1)-den(i3,j2p2,k1))
      fy7 = ffact1*(den(i1,j3m1,k1)-den(i1,j3p1,k1))+
     &      ffact2*(den(i1,j3m2,k1)-den(i1,j3p2,k1))
      fy8 = ffact1*(den(i2,j3m1,k1)-den(i2,j3p1,k1))+
     &      ffact2*(den(i2,j3m2,k1)-den(i2,j3p2,k1))
      fy9 = ffact1*(den(i3,j3m1,k1)-den(i3,j3p1,k1))+
     &      ffact2*(den(i3,j3m2,k1)-den(i3,j3p2,k1))

      fy10 = ffact1*(den(i1,j1m1,k2)-den(i1,j1p1,k2))+
     &       ffact2*(den(i1,j1m2,k2)-den(i1,j1p2,k2))
      fy11 = ffact1*(den(i2,j1m1,k2)-den(i2,j1p1,k2))+
     &       ffact2*(den(i2,j1m2,k2)-den(i2,j1p2,k2))
      fy12 = ffact1*(den(i3,j1m1,k2)-den(i3,j1p1,k2))+
     &       ffact2*(den(i3,j1m2,k2)-den(i3,j1p2,k2))
      fy13 = ffact1*(den(i1,j2m1,k2)-den(i1,j2p1,k2))+
     &       ffact2*(den(i1,j2m2,k2)-den(i1,j2p2,k2))
      fy14 = ffact1*(den(i2,j2m1,k2)-den(i2,j2p1,k2))+
     &       ffact2*(den(i2,j2m2,k2)-den(i2,j2p2,k2))
      fy15 = ffact1*(den(i3,j2m1,k2)-den(i3,j2p1,k2))+
     &       ffact2*(den(i3,j2m2,k2)-den(i3,j2p2,k2))
      fy16 = ffact1*(den(i1,j3m1,k2)-den(i1,j3p1,k2))+
     &       ffact2*(den(i1,j3m2,k2)-den(i1,j3p2,k2))
      fy17 = ffact1*(den(i2,j3m1,k2)-den(i2,j3p1,k2))+
     &       ffact2*(den(i2,j3m2,k2)-den(i2,j3p2,k2))
      fy18 = ffact1*(den(i3,j3m1,k2)-den(i3,j3p1,k2))+
     &       ffact2*(den(i3,j3m2,k2)-den(i3,j3p2,k2))

      fy19 = ffact1*(den(i1,j1m1,k3)-den(i1,j1p1,k3))+
     &       ffact2*(den(i1,j1m2,k3)-den(i1,j1p2,k3))
      fy20 = ffact1*(den(i2,j1m1,k3)-den(i2,j1p1,k3))+
     &       ffact2*(den(i2,j1m2,k3)-den(i2,j1p2,k3))
      fy21 = ffact1*(den(i3,j1m1,k3)-den(i3,j1p1,k3))+
     &       ffact2*(den(i3,j1m2,k3)-den(i3,j1p2,k3))
      fy22 = ffact1*(den(i1,j2m1,k3)-den(i1,j2p1,k3))+
     &       ffact2*(den(i1,j2m2,k3)-den(i1,j2p2,k3))
      fy23 = ffact1*(den(i2,j2m1,k3)-den(i2,j2p1,k3))+
     &       ffact2*(den(i2,j2m2,k3)-den(i2,j2p2,k3))
      fy24 = ffact1*(den(i3,j2m1,k3)-den(i3,j2p1,k3))+
     &       ffact2*(den(i3,j2m2,k3)-den(i3,j2p2,k3))
      fy25 = ffact1*(den(i1,j3m1,k3)-den(i1,j3p1,k3))+
     &       ffact2*(den(i1,j3m2,k3)-den(i1,j3p2,k3))
      fy26 = ffact1*(den(i2,j3m1,k3)-den(i2,j3p1,k3))+
     &       ffact2*(den(i2,j3m2,k3)-den(i2,j3p2,k3))
      fy27 = ffact1*(den(i3,j3m1,k3)-den(i3,j3p1,k3))+
     &       ffact2*(den(i3,j3m2,k3)-den(i3,j3p2,k3))

      fz1 = ffact1*(den(i1,j1,k1m1)-den(i1,j1,k1p1))+
     &      ffact2*(den(i1,j1,k1m2)-den(i1,j1,k1p2))
      fz2 = ffact1*(den(i2,j1,k1m1)-den(i2,j1,k1p1))+
     &      ffact2*(den(i2,j1,k1m2)-den(i2,j1,k1p2))
      fz3 = ffact1*(den(i3,j1,k1m1)-den(i3,j1,k1p1))+
     &      ffact2*(den(i3,j1,k1m2)-den(i3,j1,k1p2))
      fz4 = ffact1*(den(i1,j2,k1m1)-den(i1,j2,k1p1))+
     &      ffact2*(den(i1,j2,k1m2)-den(i1,j2,k1p2))
      fz5 = ffact1*(den(i2,j2,k1m1)-den(i2,j2,k1p1))+
     &      ffact2*(den(i2,j2,k1m2)-den(i2,j2,k1p2))
      fz6 = ffact1*(den(i3,j2,k1m1)-den(i3,j2,k1p1))+
     &      ffact2*(den(i3,j2,k1m2)-den(i3,j2,k1p2))
      fz7 = ffact1*(den(i1,j3,k1m1)-den(i1,j3,k1p1))+
     &      ffact2*(den(i1,j3,k1m2)-den(i1,j3,k1p2))
      fz8 = ffact1*(den(i2,j3,k1m1)-den(i2,j3,k1p1))+
     &      ffact2*(den(i2,j3,k1m2)-den(i2,j3,k1p2))
      fz9 = ffact1*(den(i3,j3,k1m1)-den(i3,j3,k1p1))+
     &      ffact2*(den(i3,j3,k1m2)-den(i3,j3,k1p2))

      fz10 = ffact1*(den(i1,j1,k2m1)-den(i1,j1,k2p1))+
     &       ffact2*(den(i1,j1,k2m2)-den(i1,j1,k2p2))
      fz11 = ffact1*(den(i2,j1,k2m1)-den(i2,j1,k2p1))+
     &       ffact2*(den(i2,j1,k2m2)-den(i2,j1,k2p2))
      fz12 = ffact1*(den(i3,j1,k2m1)-den(i3,j1,k2p1))+
     &       ffact2*(den(i3,j1,k2m2)-den(i3,j1,k2p2))
      fz13 = ffact1*(den(i1,j2,k2m1)-den(i1,j2,k2p1))+
     &       ffact2*(den(i1,j2,k2m2)-den(i1,j2,k2p2))
      fz14 = ffact1*(den(i2,j2,k2m1)-den(i2,j2,k2p1))+
     &       ffact2*(den(i2,j2,k2m2)-den(i2,j2,k2p2))
      fz15 = ffact1*(den(i3,j2,k2m1)-den(i3,j2,k2p1))+
     &       ffact2*(den(i3,j2,k2m2)-den(i3,j2,k2p2))
      fz16 = ffact1*(den(i1,j3,k2m1)-den(i1,j3,k2p1))+
     &       ffact2*(den(i1,j3,k2m2)-den(i1,j3,k2p2))
      fz17 = ffact1*(den(i2,j3,k2m1)-den(i2,j3,k2p1))+
     &       ffact2*(den(i2,j3,k2m2)-den(i2,j3,k2p2))
      fz18 = ffact1*(den(i3,j3,k2m1)-den(i3,j3,k2p1))+
     &       ffact2*(den(i3,j3,k2m2)-den(i3,j3,k2p2))

      fz19 = ffact1*(den(i1,j1,k3m1)-den(i1,j1,k3p1))+
     &       ffact2*(den(i1,j1,k3m2)-den(i1,j1,k3p2))
      fz20 = ffact1*(den(i2,j1,k3m1)-den(i2,j1,k3p1))+
     &       ffact2*(den(i2,j1,k3m2)-den(i2,j1,k3p2))
      fz21 = ffact1*(den(i3,j1,k3m1)-den(i3,j1,k3p1))+
     &       ffact2*(den(i3,j1,k3m2)-den(i3,j1,k3p2))
      fz22 = ffact1*(den(i1,j2,k3m1)-den(i1,j2,k3p1))+
     &       ffact2*(den(i1,j2,k3m2)-den(i1,j2,k3p2))
      fz23 = ffact1*(den(i2,j2,k3m1)-den(i2,j2,k3p1))+
     &       ffact2*(den(i2,j2,k3m2)-den(i2,j2,k3p2))
      fz24 = ffact1*(den(i3,j2,k3m1)-den(i3,j2,k3p1))+
     &       ffact2*(den(i3,j2,k3m2)-den(i3,j2,k3p2))
      fz25 = ffact1*(den(i1,j3,k3m1)-den(i1,j3,k3p1))+
     &       ffact2*(den(i1,j3,k3m2)-den(i1,j3,k3p2))
      fz26 = ffact1*(den(i2,j3,k3m1)-den(i2,j3,k3p1))+
     &       ffact2*(den(i2,j3,k3m2)-den(i2,j3,k3p2))
      fz27 = ffact1*(den(i3,j3,k3m1)-den(i3,j3,k3p1))+
     &       ffact2*(den(i3,j3,k3m2)-den(i3,j3,k3p2))

      vx(i)=(wt1*fx1+wt2*fx2+wt3*fx3+wt4*fx4  +wt5 *fx5 +wt6 *fx6+
     & wt7 *fx7 +wt8 *fx8 +wt9 *fx9 +wt10*fx10+wt11*fx11+wt12*fx12+
     & wt13*fx13+wt14*fx14+wt15*fx15+wt16*fx16+wt17*fx17+wt18*fx18+
     & wt19*fx19+wt20*fx20+wt21*fx21+wt22*fx22+wt23*fx23+wt24*fx24+
     & wt25*fx25+wt26*fx26+wt27*fx27)*fact2+fact1*vx(i)
      vy(i)=(wt1*fy1+wt2*fy2+wt3*fy3+wt4*fy4  +wt5 *fy5 +wt6 *fy6+
     & wt7 *fy7 +wt8 *fy8 +wt9 *fy9 +wt10*fy10+wt11*fy11+wt12*fy12+
     & wt13*fy13+wt14*fy14+wt15*fy15+wt16*fy16+wt17*fy17+wt18*fy18+
     & wt19*fy19+wt20*fy20+wt21*fy21+wt22*fy22+wt23*fy23+wt24*fy24+
     & wt25*fy25+wt26*fy26+wt27*fy27)*fact2+fact1*vy(i)
      vz(i)=(wt1*fz1+wt2*fz2+wt3*fz3+wt4*fz4  +wt5 *fz5 +wt6 *fz6+
     & wt7 *fz7 +wt8 *fz8 +wt9 *fz9 +wt10*fz10+wt11*fz11+wt12*fz12+
     & wt13*fz13+wt14*fz14+wt15*fz15+wt16*fz16+wt17*fz17+wt18*fz18+
     & wt19*fz19+wt20*fz20+wt21*fz21+wt22*fz22+wt23*fz23+wt24*fz24+
     & wt25*fz25+wt26*fz26+wt27*fz27)*fact2+fact1*vz(i)

      x(i)=amod(x(i)+vx(i)*pfact+rng,rng)
      y(i)=amod(y(i)+vy(i)*pfact+rng,rng)
      z(i)=amod(z(i)+vz(i)*pfact+rngz,rngz)
  160 continue

      do 161 i=1,nbias
      xp   = xb(i)
      yp   = yb(i)
      zp   = zb(i)
      nearx= nint(xp)
      neary= nint(yp)
      nearz= nint(zp)
      ic   = tabp1(nearx)
      jc   = tabp1(neary)
      kc   = zabp1(nearz)
      xmin = xp-nearx
      ymin = yp-neary
      zmin = zp-nearz
      nextx= nearx+sign(1.,xmin)
      nexty= neary+sign(1.,ymin)
      nextz= nearz+sign(1.,zmin)
      icc  = tabp1(nextx)
      jcc  = tabp1(nexty)
      kcc  = zabp1(nextz)
      xmin = abs(xmin)
      ymin = abs(ymin)
      zmin = abs(zmin)
      xmax = 1.-xmin
      ymax = 1.-ymin
      zmax = 1.-zmin
      ics  = tabp1(min0(nearx,nextx))
      jcs  = tabp1(min0(neary,nexty))
      kcs  = zabp1(min0(nearz,nextz))
      iccs = tabp0(ics+nearx-nextx)
      jccs = tabp0(jcs+neary-nexty)
      kccs = zabp0(kcs+nearz-nextz)
      xas  = xmin+0.5
      yas  = ymin+0.5
      zas  = zmin+0.5
      xis  = 1.-xas
      yis  = 1.-yas
      zis  = 1.-zas
      icp1 = tabp1(ic)
      jcp1 = tabp1(jc)
      kcp1 = zabp1(kc)
      iccp1 = tabp1(icc)
      jccp1 = tabp1(jcc)
      kccp1 = zabp1(kcc)
      icsp1 = tabp1(ics)
      jcsp1 = tabp1(jcs)
      kcsp1 = zabp1(kcs)
      iccsp1= tabp1(iccs)
      jccsp1= tabp1(jccs)
      kccsp1= zabp1(kccs)
c---  Calculate the force on a particle by volumn weighted sum
c---  of forces at 8 nearby pixels the particle overlaps
      vxb(i)=(xas*ymax*zmax*(den(ics,jc,kc)-den(icsp1,jc,kc))+
     &       xis*ymax*zmax*(den(iccs,jc,kc)-den(iccsp1,jc,kc))+
     &       xas*ymin*zmax*(den(ics,jcc,kc)-den(icsp1,jcc,kc))+
     &       xis*ymin*zmax*(den(iccs,jcc,kc)-den(iccsp1,jcc,kc))+
     &       xas*ymax*zmin*(den(ics,jc,kcc)-den(icsp1,jc,kcc))+
     &       xis*ymax*zmin*(den(iccs,jc,kcc)-den(iccsp1,jc,kcc))+
     &       xas*ymin*zmin*(den(ics,jcc,kcc)-den(icsp1,jcc,kcc))+
     &       xis*ymin*zmin*(den(iccs,jcc,kcc)-den(iccsp1,jcc,kcc))
     &       )*fact2+fact1*vxb(i) 
      vyb(i)=(xmax*yas*zmax*(den(ic,jcs,kc)-den(ic,jcsp1,kc))+
     &       xmin*yas*zmax*(den(icc,jcs,kc)-den(icc,jcsp1,kc))+
     &       xmax*yis*zmax*(den(ic,jccs,kc)-den(ic,jccsp1,kc))+
     &       xmin*yis*zmax*(den(icc,jccs,kc)-den(icc,jccsp1,kc))+
     &       xmax*yas*zmin*(den(ic,jcs,kcc)-den(ic,jcsp1,kcc))+
     &       xmin*yas*zmin*(den(icc,jcs,kcc)-den(icc,jcsp1,kcc))+
     &       xmax*yis*zmin*(den(ic,jccs,kcc)-den(ic,jccsp1,kcc))+
     &       xmin*yis*zmin*(den(icc,jccs,kcc)-den(icc,jccsp1,kcc))
     &       )*fact2+fact1*vyb(i) 
      vzb(i)=(xmax*ymax*zas*(den(ic,jc,kcs)-den(ic,jc,kcsp1))+
     &       xmin*ymax*zas*(den(icc,jc,kcs)-den(icc,jc,kcsp1))+
     &       xmax*ymin*zas*(den(ic,jcc,kcs)-den(ic,jcc,kcsp1))+
     &       xmin*ymin*zas*(den(icc,jcc,kcs)-den(icc,jcc,kcsp1))+
     &       xmax*ymax*zis*(den(ic,jc,kccs)-den(ic,jc,kccsp1))+
     &       xmin*ymax*zis*(den(icc,jc,kccs)-den(icc,jc,kccsp1))+
     &       xmax*ymin*zis*(den(ic,jcc,kccs)-den(ic,jcc,kccsp1))+
     &       xmin*ymin*zis*(den(icc,jcc,kccs)-den(icc,jcc,kccsp1))
     &       )*fact2+fact1*vzb(i) 
      xb(i)=amod(xb(i)+vxb(i)*pfact+rng,rng)
      yb(i)=amod(yb(i)+vyb(i)*pfact+rng,rng)
      zb(i)=amod(zb(i)+vzb(i)*pfact+rngz,rngz)
  161 continue
c     if(nstep.le.2)print *,'CPU(force) =',etime(cpu)-tzero
      call cpu_time(tnow)
      if(nstep.le.2)print *,'CPU(force) =',tnow-tzero

c***  Position at a+astep (Integration is position centered)
c---  CPU : Scalar (0.765), Vector (0.099,0.78) for ng = 32,64
c      tzero = etime(cpu)
c      fact = rng*astep
c      do 170 i = 1,np
c      x(i)=amod(x(i)+vx(i)*fact+rng,rng)
c      y(i)=amod(y(i)+vy(i)*fact+rng,rng)
c  170 z(i)=amod(z(i)+vz(i)*fact+rngz,rngz)

c      do 171 i = 1,nbias
c      xb(i)=amod(xb(i)+vxb(i)*fact+rng,rng)
c      yb(i)=amod(yb(i)+vyb(i)*fact+rng,rng)
c  171 zb(i)=amod(zb(i)+vzb(i)*fact+rngz,rngz)
c      if(nstep.le.2)print *,'CPU(push) =',etime(cpu)-tzero


c***  Energy
c     ken = snrsq(np,vx ,1)+snrsq(np,vy ,1)+snrsq(np,vz ,1)
      ken = 0
      dzmax = 0
      do i=1,np
      ken = ken+vx(i)**2+vy(i)**2+vz(i)**2
      if(abs(vz(i)*pfact).gt.dzmax)dzmax=abs(vz(i)*pfact)
      end do
      print *,'Max. displacement in z =',dzmax
      dxda2=ken
c     ken=0.5*pmass*8*pi/3.*(1/(a+0.5*astep)+1/omei-1)*ken
      ken=0.5*pmass*8*pi/3.*ken*
     &   (1/(a+0.5*astep)+1/omei-1+
     &    omeplam/omep/amax**3*((a+0.5*astep)**2-1))
      kenata=(ken+kenold)/2.
      ktot = ktot+a*a*kenold*astep
      if(a.eq.1)then
         kenata = kenold
         ktot = 0.
         poten0 = poten
      end if
      const = a**3.*kenata+poten+ktot
      if(a.eq.1)then
        const0 = const
        conserv = 0.
      else
        conserv = (const-const0)/(poten-poten0)
      end if
      time  = (a/amax)**1.5
      print *,a,std,poten,kenata,const
      open(8,file='pm3.out',access='append')
      write(8,22)a,time,poten,kenata,const,conserv,dxda2
      close(8)
   22 format(1x,f6.2,f9.4,1x,1pe11.3,e10.3,e10.2,0pf8.4,f9.4)
      a = a+astep
      redshift = amax/a-1.
      nred = nint(100.*redshift)
      pconv = 1
      vconv = 1

c---  Writing Data at z = 0, 0.5, 1, 2, 3, 5, 7, 11, 17 if nwrite=1
      nwrite = 1
      if(nwrite.eq.1)then

      nred100 = nint(100.*redshift)
      nred10  = nint(10.*redshift)
      if(nred100.eq.0)then
      number = '000'
      if(nred10.eq.5 ) number = '00'//char(nred10+48)
      if(nred10.ge.10) number = '0'//char(nred10/10+48)//'0'
      if(nred10.ge.100)number = '1'//char((nred10-100)/10+48)//'0'

      open(21,file='p512.z'//number,form='unformatted')
      print *,' writing data at a=',a
      write(21)ng,ngz,nspace,iseed,np
      write(21)size,omep,amax,astep,pconv,vconv
      write(21)a,redshift

c     do 179 k=1,mzmp
c 179 write(21)((xx(i,j,k),i=1,mmp),j=1,mmp)
c     do 181 k=1,mzmp
c 181 write(21)((yy(i,j,k),i=1,mmp),j=1,mmp)
c     do 182 k=1,mzmp
c 182 write(21)((zz(i,j,k),i=1,mmp),j=1,mmp)

      write(21)(((xx(i,j,k),i=1,mmp),j=1,mmp),k=1,mzmp)
      write(21)(((yy(i,j,k),i=1,mmp),j=1,mmp),k=1,mzmp)
      write(21)(((zz(i,j,k),i=1,mmp),j=1,mmp),k=1,mzmp)
      close(21)

      open(23,file='v512.z'//number,form='unformatted')
      write(23)ng,ngz,nspace,iseed,np
      write(23)size,omep,amax,astep,pconv,vconv
      write(23)a,redshift

c     do 183 k=1,mzmp
c 183 write(23)((vxx(i,j,k),i=1,mmp),j=1,mmp)
c     do 184 k=1,mzmp
c 184 write(23)((vyy(i,j,k),i=1,mmp),j=1,mmp)
c     do 185 k=1,mzmp
c 185 write(23)((vzz(i,j,k),i=1,mmp),j=1,mmp)

      write(23)(((vxx(i,j,k),i=1,mmp),j=1,mmp),k=1,mzmp)
      write(23)(((vyy(i,j,k),i=1,mmp),j=1,mmp),k=1,mzmp)
      write(23)(((vzz(i,j,k),i=1,mmp),j=1,mmp),k=1,mzmp)
      close(23)

c     open(21,file='p512s.z'//number,form='unformatted')
c     print *,' writing data at a=',a
c     write(21)ng,ngz,nspace,iseed,np
c     write(21)size,omep,amax,astep,pconv,vconv
c     write(21)a,redshift
c     write(21)(((xx(i,j,k),i=1,mmp,2),j=1,mmp,2),k=1,mzmp,2)
c     write(21)(((yy(i,j,k),i=1,mmp,2),j=1,mmp,2),k=1,mzmp,2)
c     write(21)(((zz(i,j,k),i=1,mmp,2),j=1,mmp,2),k=1,mzmp,2)
c     close(21)

c     open(23,file='v512s.z'//number,form='unformatted')
c     write(23)ng,ngz,nspace,iseed,np
c     write(23)size,omep,amax,astep,pconv,vconv
c     write(23)a,redshift
c     write(23)(((vxx(i,j,k),i=1,mmp,2),j=1,mmp,2),k=1,mzmp,2)
c     write(23)(((vyy(i,j,k),i=1,mmp,2),j=1,mmp,2),k=1,mzmp,2)
c     write(23)(((vzz(i,j,k),i=1,mmp,2),j=1,mmp,2),k=1,mzmp,2)
c     close(23)


      end if
      end if

      if(nint(1000*a).ge.nint(1000*amax))now = 1
      kenold = ken
c     print *,'Step CPU=',etime(cpu)-tstep
      call cpu_time(tnow)
      print *,'Step CPU =',tnow-tstep
      goto 70

  180 print *,' Finishing at a=',a

c---  Writing extra data at z=0
c     do k=1,mzmp
c     do j=1,mmp
c     do i=1,mmp
c     if(zz(i,j,k).gt.0.and.zz(i,j,k).lt.8)
c    &    write(9,*)xx(i,j,k),yy(i,j,k)
c     end do
c     end do
c     end do

ccccc      call sfftw_destroy_plan(plan)
ccccc      call sfftw_destroy_plan(iplan)
      stop
      end


      subroutine pmseed
c---  No potential array : July 10
c---  Initial allocation and dimension statement for denv in cicell
c---          changed    : July 17 
c---  Simulation box with non-equal side : Jul 26
c---  random seed for minimal fluctuation from the theory :
c---     iseed=(23,50,11,7,2 52 17 50 7) for ng=(64,128,324,480,512)

      parameter (max=512,maxz=max,max2=max+2,maxh=max/2)
      parameter (mp=2,mmp=max/mp,mzmp=maxz/mp)
      parameter (mbias=4)
      external bpowint
      real*4   den(max2,max,maxz)
      real*4   x(mmp*mmp*mzmp),  y(mmp*mmp*mzmp),  z(mmp*mmp*mzmp)
      real*4  xx(mmp,mmp,mzmp), yy(mmp,mmp,mzmp), zz(mmp,mmp,mzmp)
      real*4  vx(mmp*mmp*mzmp), vy(mmp*mmp*mzmp), vz(mmp*mmp*mzmp)
      real*4 vxx(mmp,mmp,mzmp),vyy(mmp,mmp,mzmp),vzz(mmp,mmp,mzmp)
      real*4  xb(mbias),        yb(mbias),        zb(mbias)
      real*4 vxb(mbias),       vyb(mbias),       vzb(mbias)
      real*4  ken,kenold,ktot,cpu(2),npow 
c     REAL   FFTWORK(max+15+2*(max+15)+2*(max+15))

      integer*4 tabp0(-10:max+10),tabp1(-10:max+10)
      integer*4 zabp0(-10:maxz+10),zabp1(-10:maxz+10)
      integer*4 ttabp0(-10:mmp+10),tzabp0(-10:mzmp+10)
      integer*8 plan,iplan
      character*3 dark
      equivalence (x,xx),(y,yy),(z,zz),(vx,vxx),(vy,vyy),(vz,vzz)
      common/powsp/rknyq,rkinv,powh,smooth,omehs,dark
      common/tophat/rth
      common/evolve/tabp0,tabp1,zabp0,zabp1,ng,ngz,pmas,nspace
      common/pos/x,y,z
      common/vel/vx,vy,vz
      common/seed/den
      common/seed2/ai,ken,ktot,iseed,amax,astep,
     &             xb,yb,zb,vxb,vyb,vzb,nbias
      common/cospar/omep,omepb,omeplam,h,size

      m = max
cccc      call sfftw_plan_dft_r2c_3d( plan,m,m,m,den,den,FFTW_ESTIMATE)
cccc      call sfftw_plan_dft_c2r_3d(iplan,m,m,m,den,den,FFTW_ESTIMATE)

      write(6,*)' ng,ngz,nspace,size,amax,astep ?'
      read(5,*)   ng,ngz,nspace,size,amax,astep
      write(6,*)' npow,e-folding smooth,h,rth,bias,seed ?'
      read(5,*)   npow,smooth,h,rth,bias,iseed
      write(6,*)' Dark matter (cdm,hdm,non) ?'
      read(5,22)  dark
   22 format(a3)
      iiseed = iseed
      xxx = ran3(iiseed)
      ngh = ng/2
      rng = real(ng)
      rngc = rng**3
      rngz = real(ngz)
      rngzc = rng*rng*rngz
      xyz  = rng/rngz
      pi = 3.141592654
      twopi = 2.*pi
      nnp  = ng/nspace
      nznp = ngz/nspace
      np   = nnp*nnp*nznp
      knyq = ng/2
      rknyq2 = real(knyq)**2
      rknyq = twopi*real(knyq)
      rkinv = 1./rknyq
      powh = 0.5*npow
      ai = 1.
      zi = amax-1
      anow = ai*(1.+zi)
c     omei = omep*(1.+zi)/(1.+omep*zi)
      omei = omep*(1+zi)**3
     &     /(omep*(1+zi)**3+omeplam+(1-omep-omeplam)*(1+zi)**2)
      omehs = 1./(omep*h*size)
      smooth = (smooth/sqrt(2.))/rng/sqrt(2.)
      rth = rth/rng
c---  Total mass is ngz/ng so that the mean density = 1
      pmas  = real(nspace)**3
      pmass = pmas/rngzc

c---  Initializing the work array 
c     CALL SFFT3DUI(max,max,max,FFTWORK)

ccccccccccccccc
      print *,omep,omepb,omeplam,h,size


      wavemax = 1000
c     if(size.lt.33)wavemax = 300
      call qsimp(bpowint,0.0001,wavemax,pamp)
c     call qsimp(pow2int,0.0001,wavemax,pamp2)
      print *,' <1>, <k^2>=',pamp,pamp2

c---  Here pamp = initial ms of top-hat smoothed density fluctuation
c---  pamp = 50.06, 800.95, 12815 for 64, 128, 256 h^-1 Mpc
c---  Now pamp*sqrt(P(k)) give rms fluctuation equal to thamp initially.
c---  After the expansion factor grows by the factor anow, the linear
c---  amplitude of fluctuation  will be (1/bias) over the scale rth.
c---  I. Einstein-de Sitter model
      if(omep.eq.1.)then
        pamp = (1./bias)/sqrt(pamp)*ai/anow
        vamp = 1
c---  II. Open model
      else if(omep.lt.1.and.omeplam.eq.0)then
        xnow = (1.-omep)/omep
        xini = xnow/(1.+zi)
        bini = 1.+3./xini+3.*sqrt(1.+xini)/xini**1.5*alog(sqrt(1.+xini)
     &         -sqrt(xini)) 
       bnow = 1.+3./xnow+3.*sqrt(1.+xnow)/xnow**1.5*alog(sqrt(1.+xnow)
     &         -sqrt(xnow)) 
       pamp = (1./bias)/sqrt(pamp)*bini/bnow
        vamp = omei**0.6
      else if(omep.lt.1.and.omeplam.gt.0)then
c---  III. Zero curvature with cosmological constant model
        bini = growth(1.,  amax,omep)
        bnow = growth(amax,amax,omep)
       pamp = (1./bias)/sqrt(pamp)*bini/bnow
        vamp = (growth(1.+0.005,amax,omep)-growth(1.-0.005,amax,omep))
     &        /(0.01)*1./bini
        print *,omep,' bini=',bini,' bnow=',bnow,vamp
      end if

c---  Periodic table for particles
      do 1 i=-10,0
    1 ttabp0(i)=nnp+i
      do 2 i=1,nnp
    2 ttabp0(i)=i
      do 3 i=nnp+1,nnp+10
    3 ttabp0(i)=i-nnp
      do i=-10,0
        tzabp0(i)=nznp+i
      end do
      do i=1,nznp
        tzabp0(i)=i
      end do
      do i=nznp+1,nznp+10
        tzabp0(i)=i-nznp
      end do

c---  Periodic table for mesh
      do 4 i=-10,0
      tabp0(i)=ng+i
      tabp1(i)=ng+i+1
      zabp0(i)=ngz+i
    4 zabp1(i)=ngz+i+1
      tabp1(0)=1
      zabp1(0)=1
      do 5 i=1,ng
      tabp0(i)=i
    5 tabp1(i)=i+1
      tabp1(ng)=1
      do 6 i=1,ngz
      zabp0(i) = i
    6 zabp1(i) = i+1
      zabp1(ngz)=1
      do 7 i=ng+1,ng+10
      tabp0(i)=i-ng
    7 tabp1(i)=i+1-ng
      do 8 i=ngz+1,ngz+10
      zabp0(i)=i-ngz
    8 zabp1(i)=i+1-ngz

c---  Gaussian smoothing length of 0.585 h^-1 Mpc
      efold = 0.585*sqrt(2.)
      sfac   = -(pi*efold/size)**2

c***  Velocity Potential
c     pamp = pamp*rngzc*xyz*sqrt(0.5)/rng**3
      pamp = pamp*rngzc*sqrt(xyz)*sqrt(0.5)
      do 10 i=0,ngh
      do 10 j=1,ng
      ky=j-1
      if(ky.gt.ngh)ky=ky-ng
      do 10 k=1,ngz
      kz=xyz*(k-1)
      if(kz.gt.ngh)kz=kz-ng
      xksq = i**2+ky**2+kz**2
      if(xksq.eq.0..or.xksq.gt.rknyq2)then
        den(2*i+1,j,k)=0.
        den(2*i+2,j,k)=0.
      else
        rk = twopi*sqrt(xksq)
c---    Velocity potential generation for N-body simulation
        velpot = pamp*bpower(rk)/rk**2
        den(2*i+1,j,k) = velpot*gasdev(0)
        den(2*i+2,j,k) = velpot*gasdev(0)

c---    Smoothed density field generation
c       sfact = pamp*bpower(rk)*exp(xksq*sfac)
c       den(2*i+1,j,k) = sfact*gasdev(0)
c       den(2*i+2,j,k) = sfact*gasdev(0)
      end if
   10 continue
      print *,'last #=',ran3(0)

c---  Satisfy complex conjugation relation for a real array
c     do 12 k=2,ngh
      do 12 k=2,ngz/2
      den(1,1,ngz+2-k) = den(1,1,k)
      den(2,1,ngz+2-k) =-den(2,1,k)
      do 12 j=2,ngh
      den(1,ng+2-j,ngz+2-k) = den(1,j,k)
   12 den(2,ng+2-j,ngz+2-k) =-den(2,j,k)

      do 13 j=2,ngh
      den(1,ng+2-j,1) = den(1,j,1)
   13 den(2,ng+2-j,1) =-den(2,j,1)

c     do 14 k=2,ngh
      do 14 k=2,ngz/2
      do 14 j=ngh+2,ng
      den(1,ng+2-j,ngz+2-k) = den(1,j,k)
   14 den(2,ng+2-j,ngz+2-k) =-den(2,j,k)

      call src3ft(den,ng,ng,ngz,max2,max,-1,ier)
c     CALL SFFT3DU(+1,ng,ng,ng,den,max2,max,FFTWORK)
cccc      call sfftw_execute(iplan)

cccccccccc looking for peaks in the initial density field
c     do k=1,200,50
c     write(6,*)den(1,1,k),den(10,1,k),den(1,10,k),den(40,40,k)
c     end do 
c     open(9,file='rho.smooth',form='unformatted')
c     do k=1,ngz
c       write(9)((den(i,j,k),i=1,ng),j=1,ng)
c     end do
c     stop
cccccccccc looking for peaks in the initial density field


c---  For positions we use the pixel size as the length unit
      vfact = (4./3.)*rng/2.*vamp
      vfact2 = -(1./3.)*rng/4.*vamp
      do 20 k=1,nznp
      do 20 j=1,nnp
      do 20 i=1,nnp
      xx(i,j,k)=nspace*(i-1.)
      yy(i,j,k)=nspace*(j-1.)
      zz(i,j,k)=nspace*(k-1.)
      ii = nspace*i-nspace+1
      jj = nspace*j-nspace+1
      kk = nspace*k-nspace+1
      iim1 = tabp0(ii-1)
      jjm1 = tabp0(jj-1)
      kkm1 = zabp0(kk-1)
      iim2 = tabp0(iim1-1)
      jjm2 = tabp0(jjm1-1)
      kkm2 = zabp0(kkm1-1)
      iip1 = tabp1(ii)
      jjp1 = tabp1(jj)
      kkp1 = zabp1(kk)
      iip2 = tabp1(iip1)
      jjp2 = tabp1(jjp1)
      kkp2 = zabp1(kkp1)
      vxx(i,j,k) = vfact*(den(iip1,jj,kk)-den(iim1,jj,kk))
     &          +vfact2*(den(iip2,jj,kk)-den(iim2,jj,kk))
      vyy(i,j,k) = vfact*(den(ii,jjp1,kk)-den(ii,jjm1,kk))
     &          +vfact2*(den(ii,jjp2,kk)-den(ii,jjm2,kk))
      vzz(i,j,k) = vfact*(den(ii,jj,kkp1)-den(ii,jj,kkm1))
     &          +vfact2*(den(ii,jj,kkp2)-den(ii,jj,kkm2))
   20 continue
c---  For (n,size,seed)=(64,64,17), vx(1,1,1)=-0.0051 & vy(1,1,1)=-0.0049

c***  Push : position at a=ai (dx/da is constant from a=0 to ai)
c---  Displacement from ai*dx/da at particle position
      pfact = rng*ai/vamp
      delx = 0
      cross = 0
      dzmax = 0
      do 50 k=1,nznp
      do 50 j=1,nnp
      do 50 i=1,nnp
      xx(i,j,k)=amod(xx(i,j,k)+vxx(i,j,k)*pfact+rng,rng)
      yy(i,j,k)=amod(yy(i,j,k)+vyy(i,j,k)*pfact+rng,rng)
      zz(i,j,k)=amod(zz(i,j,k)+vzz(i,j,k)*pfact+rngz,rngz)
      delx = delx+vxx(i,j,k)**2+vyy(i,j,k)**2+vzz(i,j,k)**2
      if(abs(vzz(i,j,k)*pfact).gt.dzmax)dzmax=abs(vzz(i,j,k)*pfact)
      ip1 = ttabp0(i+1)
      im1 = ttabp0(i-1)
      jp1 = ttabp0(j+1)
      jm1 = ttabp0(j-1)
      kp1 = tzabp0(k+1)
      km1 = tzabp0(k-1)
      ddx =
     &amax1(abs(vxx(im1,j,k)-vxx(i,j,k)),abs(vxx(ip1,j,k)-vxx(i,j,k))
     &     ,abs(vyy(i,jm1,k)-vyy(i,j,k)),abs(vyy(i,jp1,k)-vyy(i,j,k))
     &     ,abs(vzz(i,j,km1)-vzz(i,j,k)),abs(vzz(i,j,kp1)-vzz(i,j,k)))
      if(ddx.gt.cross)cross = ddx
   50 continue
      print *,'rms displacement=',sqrt(delx)*pfact
     &           /real(nnp)/sqrt(real(nznp))
      print *,'Max. displacement in z =',dzmax
c---  For ng=256, nspace=2, size=1.28 (pixel=0.005), bias=1, amax=98
c---     rms displacement = 2.441
c---     max relative displacement wrt nearby particles = 1.04
      print *,'max relative displacement wrt nearby particles=',
     & cross*pfact

c***  Biased particles 
      do 60 i=1,nbias
      ii   = nint(xb(i)+1)
      jj   = nint(yb(i)+1)
      kk   = nint(zb(i)+1)
      iim1 = tabp0(ii-1)
      jjm1 = tabp0(jj-1)
      kkm1 = zabp0(kk-1)
      iim2 = tabp0(iim1-1)
      jjm2 = tabp0(jjm1-1)
      kkm2 = zabp0(kkm1-1)
      iip1 = tabp1(ii)
      jjp1 = tabp1(jj)
      kkp1 = zabp1(kk)
      iip2 = tabp1(iip1)
      jjp2 = tabp1(jjp1)
      kkp2 = zabp1(kkp1)
      vxb(i) = vfact*(den(iip1,jj,kk)-den(iim1,jj,kk))
     &       +vfact2*(den(iip2,jj,kk)-den(iim2,jj,kk))
      vyb(i) = vfact*(den(ii,jjp1,kk)-den(ii,jjm1,kk))
     &       +vfact2*(den(ii,jjp2,kk)-den(ii,jjm2,kk))
      vzb(i) = vfact*(den(ii,jj,kkp1)-den(ii,jj,kkm1))
     &       +vfact2*(den(ii,jj,kkp2)-den(ii,jj,kkm2))
      xb(i) = amod(xb(i)+vxb(i)*pfact+rng,rng)
      yb(i) = amod(yb(i)+vyb(i)*pfact+rng,rng)
   60 zb(i) = amod(zb(i)+vzb(i)*pfact+rngz,rngz)

c***  Energy
      ken=0.
      do 70 k=1,nznp
      do 70 j=1,nnp
      do 70 i=1,nnp
   70 ken=ken+vxx(i,j,k)**2+vyy(i,j,k)**2+vzz(i,j,k)**2
      print *,'sum of dx/da**2=',ken
      ken=0.5*pmass*8.*pi/3.*(1./ai+1./omei-1.)*ken
      ktot = 0.
      const = ai**3.*ken+poten+ktot
      print *,' poten,ken,const=',poten,ken,const

cccc      call sfftw_destroy_plan(plan)
cccc      call sfftw_destroy_plan(iplan)

      return
      end

c---  Growth factor in the universe with zero curvature
c---  omep= present matter density parameter
c---  omeplam = 1-omep is assumed (zero curvature inflation model)
      function growth(a,amax,omep)
      external coscon
      common/pass/x

      x0 = (1./omep-1)**(1./3.)
      red = amax/a-1
      x = (1./omep-1)**(1./3.)/(1+red)
      call qsimp(coscon,0.,1.,gfac)
      growth = (x/x0)*sqrt(x**3+1)*gfac
      return
      end

      function coscon(y)
      common/pass/x
      coscon = 1./(sqrt(1+x**3*y**1.2))**3
      return
      end
