#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<stdarg.h>
#define MEMMAIN
#include "Memory.h"
static void *SMalloc[MAX_MALLOC];
static void *FREE;
static long tsize,SizeMalloc[MAX_MALLOC];
static long Current_Stack,Current_Stack_org;
static void **P2Array[MAX_MALLOC];
static void *START_TOTAL_MEMORY;
long CheckAvailableMemory(){
	long i;
	long size;
	size = 0l;
	for(i=0;i<Current_Stack;i++) size += SizeMalloc[i];
	size = tsize - size;
	return size;
}
long Make_Total_Memory(){
	long i,size;
	Current_Stack = 0;
	FREE = NULL;
	for(i=0;i<MAX_MALLOC;i++){
		SMalloc[i] = NULL;
		SizeMalloc[i] = 0;
		P2Array[i] = NULL;
	}
	size = NMEG * MEGABYTE;
	FREE = (void *) malloc(size);
	tsize = size;
	START_TOTAL_MEMORY = FREE;
	if(FREE == NULL){
		size /= MEGABYTE;
		fprintf(stderr,"Error when initializing %d Mbytes memory space\n",size);
		return 0;
	}
	else {
		size /= MEGABYTE;
		fprintf(stderr,"Initial %d memory allocated\n",size);
		return 1;
	}

}
long ptrsize(void *p){
	long i;
	for(i=0;i<Current_Stack;i++){
		if(SMalloc[i] == p) return SizeMalloc[i];
	}
}
long freespace(){
	if(Current_Stack == 0){
		return tsize;
	}
	else{
		return tsize - ((long)((char *)SMalloc[Current_Stack-1]
				-(char *)START_TOTAL_MEMORY) + SizeMalloc[Current_Stack-1]);
	}
}
void *Malloc(long size, void **src){
	void *value;
	if(size == 0) return NULL;
	if(size == INFINITY){
		if(Current_Stack == 0){
			size = tsize;
		}
		else {
			size = tsize - ( (long)((char *)SMalloc[Current_Stack-1]-
					(char *)START_TOTAL_MEMORY) + SizeMalloc[Current_Stack-1]);
		}
	}
	SizeMalloc[Current_Stack] = size;
	SMalloc[Current_Stack] = FREE;
	P2Array[Current_Stack] = src;
	value = FREE;
	FREE = (void *)((char *)FREE + size);
	if(FREE > (void *)((char *)START_TOTAL_MEMORY + tsize)) {
		FREE = (void *)((char *)FREE-size); /* restore the original mem */
		fprintf(stderr,"Error allocating memory %d bytes in Malloc()\n",size);
		fprintf(stderr,"need more %d bytes \n",(long)(size - 
					(tsize-((char *)FREE-(char *)START_TOTAL_MEMORY))));
		value = NULL;
		value = (void *) malloc(size);
		if(value == NULL) {
			fprintf(stderr,"Cannot allocate memory any more\n");
			exit(0);
		}
		else {
			return value;
		}
	}
	Current_Stack++;
	return value;
}
void *Calloc(long num, long size,void **src){
	long i;
	char *value;
	size = size *num;
	value = (char *)Malloc(size,src);
	for(i=0;i<size;i++){
		value[i] = 0;
	}
	return (void *) value;
}
void EraseMemory(long srcn){
	long size=0,esize;
	long i,j,k;
	void *from;
	FREE = (void *)((char *)FREE - SizeMalloc[srcn]);
	*P2Array[srcn] = NULL;
	esize = SizeMalloc[srcn];
	if(srcn == Current_Stack-1){
		Current_Stack--;
		return;
	}
	else {
		from=SMalloc[srcn+1];
		for(i=srcn+1;i<Current_Stack;i++){
			SMalloc[i-1] = (void *)((char *)SMalloc[i]-esize);
			SizeMalloc[i-1] = SizeMalloc[i];
			P2Array[i-1] = P2Array[i];
			*P2Array[i-1] = SMalloc[i-1];
			size += SizeMalloc[i];
		}
		Current_Stack--;
		memmove(SMalloc[srcn],from,size);
	}
}
void Free(void *a){
	long i;
	if(Current_Stack == 0) return;
	if(a == NULL){
/*
		fprintf(stderr,"Attempt to free NULL pointer\n");
*/
	}
	else {
		for(i=0;i<Current_Stack;i++){
			if((char *)a == SMalloc[i]){
				EraseMemory(i);
				return;
			}
		}
		if(i==Current_Stack) {
			free(a);
			a = NULL;
		}
	}
}
void *Realloc(void *a, long size,void **src){
	long i,j,diffsize,nmove;
	void *from,*to;
	void *ptr,*ptr2;
	void *value;
	char *tmpptr;
	/* freeing the memory if size == 0 */
	if(size == 0) {
		Free(a);
		return NULL;
	}
	if(a == NULL){
		printf("Strange in Realloc ");
		printf("%d  size of %d\n",src,size);fflush(stdout);
		a = (void *)Malloc(size,src);
		return a;
	}
	for(i=0;i<Current_Stack;i++){
		if((char *)a == SMalloc[i]){
			break;
		}
	}
	/* If this memory was allocated using malloc */
	if(i == Current_Stack) {
		return (void *) realloc(a,size);
	}
	diffsize = size-SizeMalloc[i];
	if(diffsize == 0) return a;
	/* if there is no more free space */
	/*
	if(tsize <  (long)((char *)SMalloc[i]-
		(char *)START_TOTAL_MEMORY + size)) {
	*/
	if(tsize < (long)((char *)FREE-(char *)START_TOTAL_MEMORY + diffsize)) {
		fprintf(stderr,"Error allocating memory %d bytes in Realloc()\n",size);
		fprintf(stderr,"need more %d bytes \n",(long)(size - 
					(tsize-((char *)FREE-(char *)START_TOTAL_MEMORY))));
		fflush(stderr);
		value = NULL;
		value = (void *)malloc(size);
		if(value == NULL) {
			fprintf(stderr,"Cannot reallocate any more memory\n");
			fprintf(stderr,"Finish this program !!!!!!!!!!!!!!!! \n");
			exit(0);
		}
		ptr2 = SMalloc[i];
		memcpy(value,ptr2,SizeMalloc[i]);
		/*
		Current_Stack--;
		*/
		Free(a);
		return value;
	}
	if(i != Current_Stack-1){
		if(size > SizeMalloc[i]) {
			from = (void *)((char *)FREE-1);
			to = SMalloc[i+1];
			j = 0;
			tmpptr = (char *)SMalloc[Current_Stack-1]+
				SizeMalloc[Current_Stack-1] +diffsize;
			for(ptr=from;ptr>=to;ptr=(void *)((char *)ptr-1)){
				*(tmpptr+j-1) = *((char *)ptr);
				j--;
			}
		}
		else if( size < SizeMalloc[i]) {
			nmove = 0;
			for(j=i+1;j<Current_Stack;j++){
				nmove += SizeMalloc[j];
			}
			memmove((void *)((char *)SMalloc[i]+size),SMalloc[i+1],nmove);
		}
		for(j=i+1;j<Current_Stack;j++){
			*P2Array[j] = (void **) ((char *)*P2Array[j] + diffsize);
			/*
			SMalloc[j] += diffsize;
			*/
			SMalloc[j] = (void *)((char *) SMalloc[j]+diffsize);
		}
	}
	FREE = (void *)((char *)FREE + diffsize);
	SizeMalloc[i] = size;
	return a;
}
void *resizelast(void *p, long size){
	p = (void *)Realloc(p,size,P2Array[Current_Stack-1]);
	return;
}
void freelast(void *p){
	if(Current_Stack == 0){
		fprintf(stderr,"No current allocated space\n");
	}
	else {
		/*
		Free(*P2Array[Current_Stack-1]);
		*/
		Free(p);
	}
	return;
}
void dumpptr(){
	return;
}
void NumMemStack(){
	Current_Stack_org = Current_Stack;
	return ;
}
void FreeRightNumMemStack(){
	long i;
	for(i=Current_Stack_org;i<Current_Stack;i++){
		*P2Array[i] = NULL;
	}
	FREE = (void *)((char *) SMalloc[Current_Stack_org-1]
			+SizeMalloc[Current_Stack_org-1]);
	Current_Stack = Current_Stack_org;
	return;
}
long CurMemStack(){
	return Current_Stack;
}
void InitialOldMemStack(long oldstacknum){
	long i;
	if(Current_Stack == 0) return;
	for(i=oldstacknum;i<Current_Stack;i++){
		*P2Array[i] = NULL;
	}
	if(oldstacknum == 0) FREE = START_TOTAL_MEMORY;
	else 
		FREE = (void *)((char *) SMalloc[oldstacknum-1]+
			SizeMalloc[oldstacknum-1]);

	Current_Stack = oldstacknum;
	return;
}
void LastSwitchPointer(void **den){
	P2Array[Current_Stack-1] = den;
}
void MemSwitchPointer(void **den, void **den2){
	long i;
	for(i=0;i<Current_Stack;i++){
		if(P2Array[i] == den){
			P2Array[i] = den2;
			return;
		}
	}
}
