#include<stdio.h>
#include<stddef.h>
#include<stdlib.h>
#include<math.h>
#include<mpi.h>
#include "macros.h"
#include "pmheader.h"
size_t mx;
#define den(i,j,k) den[(long)(i)+ (long)mx*((long)(j)*(long)ny*(long)(k))]
#define PI 3.1415926535
float cputime0[100], cputime1[100];
void psolver(float *den,int nx,int ny,int nz,int local_nz,
		int local_ny_after_transpose, int local_y_start_after_transpose,
		float poten, float rngc, float rngm6, int myid, int nid, float efold){
	float fact;
	float sfact;
	int nxh,nyh,nzh,wy,wz,ierror;
	float wave,factr,factor,delksq,rknyq2,tpoten;
	double poten1,poten2;
	size_t i,j,k,ii;
	int nhx,nhy,nhz;
	float xyz,xyy;
	long npixel;

	fact = -1./PI;
	npixel = (long)nx*(long)ny*(long)nz;
	rngc = (float) npixel;
	xyz = (float) nx/ (float) nz;
	xyy = (float) nx/ (float) ny;
	if(myid==0) TIMER_START(23);
	poten1 = 0.L;
	poten2 = 0.L;
	sfact = -pow(PI*efold/(float)(nx),2);
	nxh = nx/2;
	nyh = ny/2;
	nzh = nz/2;
	rknyq2 = nxh*nxh;
	for(j=0;j<local_ny_after_transpose;j++){
		wy = xyy*(j+local_y_start_after_transpose);
		if(wy > nxh) wy = wy - ny;
		for(k=0;k<nz;k++){
			wz = xyz*k;
			if(wz > nzh) wz = wz - nz;
			for(i=0;i<=nxh;i++){
				wave = i*i+wy*wy+wz*wz;
				if(wave == 0.) {
					den(2*i+1,k,j) = 0.;
					den(2*i+2,k,j) = 0.;
				}
				else {
					factr = fact/wave;
					factor = factr*exp(wave*sfact);
/*
c---  Division by n**3 is due to the length unit convention (dx^3=1/n**3)
*/
					delksq = (den(2*i+1,k,j)*den(2*i+1,k,j)+
							den(2*i+2,k,j)*den(2*i+2,k,j))*rngm6;
					if( i == 0) poten1 += factor*delksq;
					else poten2 += factor*delksq;
					den(2*i+1,k,j) = factor*den(2*i+1,k,j)/rngc;
					den(2*i+2,k,j) = factor*den(2*i+2,k,j)/rngc;
				}
			}
		}

	}
	poten = 0.5*(poten1+2.*poten2);
	MPI_Reduce(&poten,&tpoten, 1, MPI_FLOAT,MPI_SUM,0,
			MPI_COMM_WORLD);
	poten = tpoten;
	MPI_Bcast(&poten,1,MPI_FLOAT,0,MPI_COMM_WORLD);
	if(myid==0) TIMER_STOP(23);
	if(myid==0) fprintf(stdout,"Total ellapsed time for Poisson : %g\n",
			ELAPSED_TIME(23));
}
