#include<stdio.h>
#include<math.h>
#include<stddef.h>
#include<stdlib.h>
#include<mpi.h>
#include "pmheader.h"
#include "macros.h"
size_t mx;
float cputime0[100], cputime1[100];
#define den(i,j,k) den[(long)(i)+(long)mx*((long)(j)+(long)(ny)*(long)(k))]
#define sign(a,b) (b)>0? (a) : (-b)
void tsc(float *den, int nx, int ny, int nz, int local_nz, int local_z_start,
		basicparticletype *particles, int nn, int nxpos, int np, 
		float pmas, int myid, int nid){
	basicparticletype *bp;
	size_t i,j,k;
	float pmas0,p05;
	int xsign,ysign,zsign;
	int nz_per;
	int nearx,neary,nearz;
	int i1,j1,k1,i2,j2,k2,i3,j3,k3;
	float xp,yp,zp,xmin,ymin,zmin;
	float wx1,wy1,wz1,wx2,wy2,wz2,wx3,wy3,wz3;
	float xd1,yd1,zd1, rngc;
	int usndsize,dgetsize,dsndsize,ugetsize;
	int dest,src;
	int ierror,stag,rtag,tag;
	MPI_Status status;
	float etime, stime,start_z;
	long npixel,ii;

	mx = 2*(nx/2+1);
	npixel = (long)nx*(long)ny*(long)nz;
    rngc = (float) npixel;
	if(myid==0) TIMER_START(22);
	nz_per = local_nz + 7;
#ifdef VarPM
	for(ii=0;ii<npixel;ii++) den[ii] = 0.;
#else
	for(ii=0;ii<npixel;ii++) den[ii] = -1.;
	for(k=local_nz;k<local_nz+7;k++)
		for(j=0;j<ny;j++)
			for(i=0;i<nx;i++){
				den(i,j,k) = 0;
			}

#endif
	start_z = local_z_start;
	bp = particles;
	for(i=0;i<np;i++){
#if defined(MULTIMASS)
		pmas0 = bp->mass*rngc;
#else
		pmas0 = pmas;
#endif
		p05 = pmas0*0.5;
		xp = bp->x;
		yp = bp->y;
		zp = bp->z-start_z;
		nearx = rint(xp);
		neary = rint(yp);
		nearz = rint(zp);
		xmin = xp - nearx;
		ymin = yp - neary;
		zmin = zp - nearz;
        xsign = sign(1.,xmin);
        ysign = sign(1.,ymin);
        zsign = sign(1.,zmin);
        i1 = (nearx+nx)%nx;
        j1 = (neary+ny)%ny;
        k1 = (nearz+nz_per)%nz_per;
        i2 = (nearx+nx+xsign)%nx;
        j2 = (neary+ny+ysign)%ny;
        k2 = (nearz+nz_per+zsign)%nz_per;
        i3 = (nearx+nx-xsign)%nx;
        j3 = (neary+ny-ysign)%ny;
        k3 = (nearz+nz_per-zsign)%nz_per;
        xd1 = fabs(xmin);
        yd1 = fabs(ymin);
        zd1 = fabs(zmin);
        wx1 =(0.75-xd1*xd1)*pmas0;
        wy1 = 0.75-yd1*yd1;
        wz1 = 0.75-zd1*zd1;
        wx2 = p05*(0.5+xd1)*(0.5+xd1);
        wy2 = 0.5*(0.5+yd1)*(0.5+yd1);
        wz2 = 0.5*(0.5+zd1)*(0.5+zd1);
        wx3 = p05*(0.5-xd1)*(0.5-xd1);
        wy3 = 0.5*(0.5-yd1)*(0.5-yd1);
        wz3 = 0.5*(0.5-zd1)*(0.5-zd1);

		/* Assign mass to the grid the particle overlaps */
        den(i1,j1,k1) = den(i1,j1,k1) + wx1*wy1*wz1;
        den(i2,j1,k1) = den(i2,j1,k1) + wx2*wy1*wz1;
        den(i3,j1,k1) = den(i3,j1,k1) + wx3*wy1*wz1;
        den(i1,j2,k1) = den(i1,j2,k1) + wx1*wy2*wz1;
        den(i2,j2,k1) = den(i2,j2,k1) + wx2*wy2*wz1;
        den(i3,j2,k1) = den(i3,j2,k1) + wx3*wy2*wz1;
        den(i1,j3,k1) = den(i1,j3,k1) + wx1*wy3*wz1;
        den(i2,j3,k1) = den(i2,j3,k1) + wx2*wy3*wz1;
        den(i3,j3,k1) = den(i3,j3,k1) + wx3*wy3*wz1;
        den(i1,j1,k2) = den(i1,j1,k2) + wx1*wy1*wz2;
        den(i2,j1,k2) = den(i2,j1,k2) + wx2*wy1*wz2;
        den(i3,j1,k2) = den(i3,j1,k2) + wx3*wy1*wz2;
        den(i1,j2,k2) = den(i1,j2,k2) + wx1*wy2*wz2;
        den(i2,j2,k2) = den(i2,j2,k2) + wx2*wy2*wz2;
        den(i3,j2,k2) = den(i3,j2,k2) + wx3*wy2*wz2;
        den(i1,j3,k2) = den(i1,j3,k2) + wx1*wy3*wz2;
        den(i2,j3,k2) = den(i2,j3,k2) + wx2*wy3*wz2;
        den(i3,j3,k2) = den(i3,j3,k2) + wx3*wy3*wz2;
        den(i1,j1,k3) = den(i1,j1,k3) + wx1*wy1*wz3;
        den(i2,j1,k3) = den(i2,j1,k3) + wx2*wy1*wz3;
        den(i3,j1,k3) = den(i3,j1,k3) + wx3*wy1*wz3;
        den(i1,j2,k3) = den(i1,j2,k3) + wx1*wy2*wz3;
        den(i2,j2,k3) = den(i2,j2,k3) + wx2*wy2*wz3;
        den(i3,j2,k3) = den(i3,j2,k3) + wx3*wy2*wz3;
        den(i1,j3,k3) = den(i1,j3,k3) + wx1*wy3*wz3;
        den(i2,j3,k3) = den(i2,j3,k3) + wx2*wy3*wz3;
        den(i3,j3,k3) = den(i3,j3,k3) + wx3*wy3*wz3;
		bp++;
	}
	/*
ccccc These lines send upper swap den(den(*,*,Nz_local+1~2)) to a upper node.
ccccc Be careful! The small size of buffer resources makes the sending
ccccc process with one column! Not one slice!!!!! 
ccccc dest : send array to dest`th node
ccccc src : receivce array from src`th node
*/
#ifdef VarPM
/* rearrange the tsc mesh  in normal ordering for slicemigrate processes. */
	for(k=local_nz+1;k>0;k--)
		for(j=0;j<ny;j++)
			for(i=0;i<nx;i++)
				den(i,j,k+1) = den(i,j,k);
	k = local_nz + 6;
	for(j=0;j<ny;j++)
		for(i=0;i<nx;i++)
			den(i,j,0) = den(i,j,k);
#else
    dest = (myid+1+nid)%nid;
    src = (myid-1+nid)%nid;
    stag = 0;
    rtag = 0;
    usndsize = 2*(nx/2+1)*ny*2;
    dgetsize = usndsize;
	MPI_Sendrecv_replace(den+(long)local_nz*mx*(long)ny,usndsize, MPI_FLOAT,
			dest,stag,src,rtag,MPI_COMM_WORLD,&status);
	for(k=0;k<2;k++)
		for(j=0;j<ny;j++)
			for(i=0;i<nx;i++)
				den(i,j,k) += den(i,j,local_nz+k);
	/*
ccccc These lines send lower swap(den(*,*,Nz_local+7)) to a lower slice.
ccccc dest : send array to dest'th node
ccccc src : receivce array from src'th node
     */
    dsndsize = 2*(nx/2+1)*ny;
    ugetsize = dsndsize;
    dest = (myrank-1+nrank)%nrank;
    src = (myrank+1+nrank)%nrank;
    stag = 0;
    rtag = 0;
    MPI_Sendrecv_replace(den+(long)(local_nz+6)*mx*(long)ny,dsndsize,
			  MPI_FLOAT,dest,stag,src,rtag,MPI_COMM_WORLD,&status);
    for(j=0;j<ny;j++)
		for(i=0;i<nx;i++)
			den(i,j,local_nz-1) += den(i,j,local_nz+6);

#endif
	if(myid==0) TIMER_STOP(22);
	if(myid==0) fprintf(stdout,"Total ellapsed time for TSC : %g\n",
			ELAPSED_TIME(22));


}
