c234567
      subroutine pswitch(den,den1,nx,ny,nz,local_nz)
	  integer nx,ny,nz,local_nz
	  real den1(-1:nx+2,-1:ny+2,-1:local_nz+2)
	  real den(-1:nx+2,-1:ny+2,-1:local_nz+2)

	  do k = -1, local_nz+2
	  do j = -1, ny+2
	  do i = -1, nx+2
	     den(i,j,k) = den1(i,j,k)
	  enddo
	  enddo
	  enddo
	  return
	  end
c---  den --> potential
c---  den1 --> natural intrinsic periodic potential.
c---  The order of copying den() data to den1() is not important
c     because, for example, den1(-1,-1,-1) which has no relevant data,
c     is needless in deriving force(force is calculated only in that direction).
c---  den(*,*,*) --> den1(*,*,*) for generic periodic conditions.
c     so there is no need to use tabp??? tabm???
      subroutine fdarearrange(den,den1,nx,ny,nz,local_nz,myrank,nrank)
	  include 'mpif.h'
      real den(2*(nx/2+1),ny,local_nz+7)
	  real den1(-1:nx+2,-1:ny+2,-1:local_nz+2)
	  real ffact1,ffact2
	  integer sendsize,recvsize,nx,ny,nz,local_nz,local_z_start
	  integer dest, src,stag,rtag

	  integer nz_per
      integer status(MPI_STATUS_SIZE)

      nz_per = local_nz+7
      sendsize = 2*(nx/2+1)*ny*2
      recvsize = sendsize
      dest = mod(myrank+1+nrank,nrank)
      src = mod(myrank-1+nrank,nrank)
      stag = 1
      rtag = 1
      call MPI_SENDRECV(den(1,1,local_nz-1),sendsize,MPI_REAL,dest,
     &        stag,den(1,1,nz_per-1),recvsize,MPI_REAL,src,rtag,
     &                 MPI_COMM_WORLD,status,ierror)
      sendsize = 2*(nx/2+1)*ny*2
      recvsize = sendsize
      dest = mod(myrank-1+nrank,nrank)
      src = mod(myrank+1+nrank,nrank)
      stag = 2
      rtag = 2
      call MPI_SENDRECV(den(1,1,1),sendsize,MPI_REAL,dest,stag,
     &          den(1,1,local_nz+1),recvsize,MPI_REAL,src,rtag,
     &                  MPI_COMM_WORLD,status,ierror)
c---  making periodic conditions in z-direction
      do k = 1, local_nz+2
      do j = 1, ny
   	  do i = 1, nx
    	 den1(i,j,k) = den(i,j,k)
	  enddo
	  enddo
	  enddo
	  do k = -1, 0
      do j = 1, ny
   	  do i = 1, nx
	     den1(i,j,k) = den(i,j,nz_per+k)
      enddo
      enddo
	  enddo

c---  making periodic conditions in x-direction
	  do k = -1, local_nz+2
	     do j = -1, ny+2
	        do i = -1, 0
	            den1(i,j,k) = den1(nx+i,j,k)
         	enddo
	        do i = nx+1, nx+2
	             den1(i,j,k) = den1(i-nx,j,k)
	        enddo
    	  enddo
	  enddo

c---  making periodic conditions in y-direction
	  do k = -1, local_nz+2
	     do j = -1, 0
	        do i = -1, nx+2
	           den1(i,j,k) = den1(i,ny+j,k)
	        enddo
	     enddo
         do j = ny+1,ny+2
		    do i = -1, nx+2
			   den1(i,j,k) = den1(i,j-ny ,k)
			enddo
		 enddo
	  enddo
c---- Now den1 has values of potential with intrinsic 
c     natural periodic conditions
      return
	  end

	  subroutine findgridforce(den,force,nx,ny,local_nz,myrank,nrank)
	  include 'mpif.h'
	  real den(-1:nx+2,-1:ny+2,-1:local_nz+2)
	  real force(3,-1:nx+2,-1:ny+2,-1:local_nz+2)
	  integer nx,ny,local_nz,myrank,nrank
	  real ffact1,ffact2
	  integer dest,src,rtag,stag,sendsize,recvsize
      integer status(MPI_STATUS_SIZE)

      ffact1 = (4./3.)/2.
      ffact2 = (-1./3.)/4.
      do k = 1, local_nz
      do j = 1, ny
      do i = 1, nx
      force(1,i,j,k) = ffact1*(den(i-1,j,k)-den(i+1,j,k))
     &            +ffact2*(den(i-2,j,k)-den(i+2,j,k))
      force(2,i,j,k) = ffact1*(den(i,j-1,k)-den(i,j+1,k))
     &            +ffact2*(den(i,j-2,k)-den(i,j+2,k))
      force(3,i,j,k) = ffact1*(den(i,j,k-1)-den(i,j,k+1))
     &            +ffact2*(den(i,j,k-2)-den(i,j,k+2))
	  enddo
	  enddo
	  enddo
c---  copying data first in x-direction.
	  do k = 1, local_nz
	  do j = 1, ny   ! 1 <= j <= ny
	     do i = -1,0
	     do ix = 1, 3
	        force(ix,i,j,k) = force(ix,nx+i,j,k)
	     enddo
	     enddo
	     do i = nx+1,nx+2
	     do ix = 1, 3
	        force(ix,i,j,k) = force(ix,i-nx,j,k)
	     enddo
	     enddo
	  enddo
	  enddo
c---  copying data in y-direction.
	  do k = 1, local_nz
	     do j = -1, 0
		    do i = -1, nx+2   ! -1 <= i <= nx+2
			do ix = 1, 3
			   force(ix,i,j,k) = force(ix,i,ny+j,k)
			enddo
			enddo
	     enddo
		 do j = ny+1, ny+2
		    do i = -1, nx+2   ! -1 <= i <= nx+2
			do ix = 1, 3
			   force(ix,i,j,k) = force(ix,i,j-ny,k)
			enddo
			enddo
	     enddo
	  enddo
c---- This is for intrisic boundary conditions of force in z-direction.
c---  send upward last two real slices and receive from down-processor saving
c     data in first two boundary slices.
      sendsize = 3*(nx+2+2)*(ny+2+2)*2
      recvsize = sendsize
      dest = mod(myrank+1+nrank,nrank)
      src = mod(myrank-1+nrank,nrank)
      stag = 1
      rtag = 1
      call MPI_SENDRECV(force(1,-1,-1,local_nz-1),sendsize,MPI_REAL,
     &     dest,stag,force(1,-1,-1,-1),recvsize,MPI_REAL,src,rtag,
     &                 MPI_COMM_WORLD,status,ierror)
c---  send down first two real slices and receive from up-processor saving
c     data in last two boundary slices.
      stag = 2
      rtag = 2
	  dest = mod(myrank-1+nrank,nrank)
	  src = mod(myrank+1+nrank,nrank)
      call MPI_SENDRECV(force(1,-1,-1,1),sendsize,MPI_REAL,dest,
     &      stag,force(1,-1,-1,local_nz+1),recvsize,MPI_REAL,src,rtag,
     &                 MPI_COMM_WORLD,status,ierror)
	 
	  return
	  end

c------------------------------------------------------------------------
c     den --> potential array from FFT
c     swpden ---> same address as den
c     den1 ---> den+worksize
c     force ---> den+worksize
      subroutine fda4gfswp(x,y,z,vx,vy,vz,np,den,swpden,den1,force,
     &          Nx,Ny,Nz,Nz_local,
     &          a,astep,amax,omei,omep,omeplam,pfact,
     &          nstart_z,myrank,nrank)
      IMPLICIT none
      include 'mpif.h'
      real pi,rng,rngz,amax,omei,omeplam,omep
      parameter(pi=3.1415926535)
      integer np,Nx,Ny,Nz,Nz_local,nstart_z
	  real start_z
      real x(np),y(np),z(np),vx(np),vy(np),vz(np)
      real den(2*(Nx/2+1),Ny,Nz_local+7)
c     swpden is same as den() but different size.
	  real swpden(-1:nx+2,-1:ny+2,-1:Nz_local+2) 
	  real den1(-1:nx+2,-1:ny+2,-1:Nz_local+2)
	  real force(3,-1:nx+2,-1:ny+2,-1:Nz_local+2)
      real astep,a,ainv,app,apsq,afact,bfact,fact1,fact2,pfact
      real ffact1,ffact2
      real xp,yp,zp,xmin,ymin,zmin,xd1,yd1,zd1
      real wx1,wy1,wz1,wx2,wy2,wz2,wx3,wy3,wz3
      real wt1,wt2,wt3,wt4,wt5,wt6,wt7,wt8,wt9,wt10
      real wt11,wt12,wt13,wt14,wt15,wt16,wt17,wt18,wt19,wt20
      real wt21,wt22,wt23,wt24,wt25,wt26,wt27
      real fx1,fx2,fx3,fx4,fx5,fx6,fx7,fx8,fx9,fx10
      real fx11,fx12,fx13,fx14,fx15,fx16,fx17,fx18,fx19,fx20
      real fx21,fx22,fx23,fx24,fx25,fx26,fx27
      real fy1,fy2,fy3,fy4,fy5,fy6,fy7,fy8,fy9,fy10
      real fy11,fy12,fy13,fy14,fy15,fy16,fy17,fy18,fy19,fy20
      real fy21,fy22,fy23,fy24,fy25,fy26,fy27
      real fz1,fz2,fz3,fz4,fz5,fz6,fz7,fz8,fz9,fz10
      real fz11,fz12,fz13,fz14,fz15,fz16,fz17,fz18,fz19,fz20
      real fz21,fz22,fz23,fz24,fz25,fz26,fz27
      integer nearx,neary,nearz,xsign,ysign,zsign
      integer i1,j1,k1,i2,j2,k2,i3,j3,k3
      integer i,ng,j,k

c     integer i1m1,i1m2,i1p1,i1p2,i2m1,i2m2,i2p1,i2p2,i3m1,i3m2,i3p1
c     integer i3p2,j1m1,j1m2,j1p1,j1p2,j2m1,j2m2,j2p1,j2p2,j3m1,j3m2
c     integer j3p1,j3p2,k1m1,k1m2,k1p1,k1p2,k2m1,k2m2,k2p1,k2p2,k3m1
c     integer k3m2,k3p1,k3p2
	  integer im1,im2,ip1,ip2,jm1,jm2,jp1,jp2,km1,km2,kp1,kp2
 
      integer Nz_per,dest,src,sendsize,recvsize,stag,rtag
      integer status(MPI_STATUS_SIZE)
      integer myrank,nrank,ierror
	  real*4 CPU(2),stime,etime



      if(myrank .eq. 0) stime = etime(CPU)
ccc   Nz_per is the z size of local array to pretend periodic 
ccc   boundary conditions in the calculation of local density.
      Nz_per = Nz_local+7

c***  Solve the momentum equation by using Friedman equations
      ng = Nz
      rng = ng
      rngz = rng
      if(a.eq.1)astep = 0.5*astep
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccc MODIFIED FOR semi-VARIABLE TIME STEP
ccccc 1) a should be shifted back by a-astep/8
ccccc 2) astep in fact1,fact2 should be modified to 3/4*astep
ccccc 3) pfact should be halved.
ccccc 4) astep -> astep/2
ccccc 5) a should be shifted forward by a+astep/8
c---
      if(abs(a,12.) .lt. astep/2.) then
         a = a - astep/8.
         astep = 3./4.*astep
      endif
c---
      ainv = 1./a
      app  = -4.*pi/3.*(ainv*ainv-2*omeplam/omep*a/amax**3)
      apsq = 8.*pi/3.*(ainv+1./omei-1+omeplam/omep*(a**2-1)/amax**3)
      afact = (2.+app*a/apsq)/2.*ainv
      bfact = ainv**3/apsq
      fact1 = (1.-afact*astep)/(1.+afact*astep)
      fact2 = bfact*astep/(1.+afact*astep)*rng
      if(a.eq.1)astep = 2.*astep
c---
      if(abs(a,12.) .lt. astep/2.) then
         a = a + astep/8.
         astep = 4./3.*astep
         astep = astep*0.5
      endif
c---
      pfact = rng*astep

      call fdarearrange(den,den1,nx,ny,nz,Nz_local,myrank,nrank)
	  call pswitch(swpden,den1,nx,ny,nz,Nz_local)
	  call findgridforce(swpden,force,nx,ny,Nz_local,myrank,nrank)
c***  Cell position run from 0 to n-1 and particles from 0 to n
c---  (xp,yp,zp) = particle position
c---  (ic,jc,kc) = major cell's position the superparticle clould belongs to.
c---  (icc,jcc,kcc) = position of the minor cell
c---  Now find the velocity at a+astep/2
c---  CPU : Scalar (4.62), Vector (1.53,12.2,96) for ng = 32,64,128
      start_z = nstart_z
      do 160 i=1,np
      xp   = x(i)
      yp   = y(i)
      zp   = z(i)-start_z
      nearx= nint(xp)
      neary= nint(yp)
      nearz= nint(zp)
      xmin = xp-nearx
      ymin = yp-neary
      zmin = zp-nearz
      xsign= sign(1.,xmin)
      ysign= sign(1.,ymin)
      zsign= sign(1.,zmin)
      i1  = nearx+1
      j1  = neary+1
      k1  = nearz+1
      i2  = i1+xsign
      j2  = j1+ysign
      k2  = k1+zsign
      i3  = i1-xsign
      j3  = j1-ysign
      k3  = k1-zsign

      xd1 = abs(xmin)
      yd1 = abs(ymin)
      zd1 = abs(zmin)
      wx1 = 0.75-xd1**2
      wy1 = 0.75-yd1**2
      wz1 = 0.75-zd1**2
      wx2 = 0.5*(0.5+xd1)**2
      wy2 = 0.5*(0.5+yd1)**2
      wz2 = 0.5*(0.5+zd1)**2
      wx3 = 0.5*(0.5-xd1)**2
      wy3 = 0.5*(0.5-yd1)**2
      wz3 = 0.5*(0.5-zd1)**2
      wt1  = wx1*wy1*wz1
      wt2  = wx2*wy1*wz1
      wt3  = wx3*wy1*wz1
      wt4  = wx1*wy2*wz1
      wt5  = wx2*wy2*wz1
      wt6  = wx3*wy2*wz1
      wt7  = wx1*wy3*wz1
      wt8  = wx2*wy3*wz1
      wt9  = wx3*wy3*wz1
      wt10 = wx1*wy1*wz2
      wt11 = wx2*wy1*wz2
      wt12 = wx3*wy1*wz2
      wt13 = wx1*wy2*wz2
      wt14 = wx2*wy2*wz2
      wt15 = wx3*wy2*wz2
      wt16 = wx1*wy3*wz2
      wt17 = wx2*wy3*wz2
      wt18 = wx3*wy3*wz2
      wt19 = wx1*wy1*wz3
      wt20 = wx2*wy1*wz3
      wt21 = wx3*wy1*wz3
      wt22 = wx1*wy2*wz3
      wt23 = wx2*wy2*wz3
      wt24 = wx3*wy2*wz3
      wt25 = wx1*wy3*wz3
      wt26 = wx2*wy3*wz3
      wt27 = wx3*wy3*wz3

      vx(i)=(wt1 *force(1,i1,j1,k1)+wt2 *force(1,i2,j1,k1)+
     &       wt3 *force(1,i3,j1,k1)+wt4 *force(1,i1,j2,k1)+
     &       wt5 *force(1,i2,j2,k1)+wt6 *force(1,i3,j2,k1)+
     &       wt7 *force(1,i1,j3,k1)+wt8 *force(1,i2,j3,k1)+
     &       wt9 *force(1,i3,j3,k1)+wt10*force(1,i1,j1,k2)+
     &       wt11*force(1,i2,j1,k2)+wt12*force(1,i3,j1,k2)+
     &       wt13*force(1,i1,j2,k2)+wt14*force(1,i2,j2,k2)+
     &       wt15*force(1,i3,j2,k2)+wt16*force(1,i1,j3,k2)+
     &       wt17*force(1,i2,j3,k2)+wt18*force(1,i3,j3,k2)+
     &       wt19*force(1,i1,j1,k3)+wt20*force(1,i2,j1,k3)+
     &       wt21*force(1,i3,j1,k3)+wt22*force(1,i1,j2,k3)+
     &       wt23*force(1,i2,j2,k3)+wt24*force(1,i3,j2,k3)+
     &       wt25*force(1,i1,j3,k3)+wt26*force(1,i2,j3,k3)+
     &       wt27*force(1,i3,j3,k3))*fact2+
     &       fact1*vx(i)

      vy(i)=(wt1 *force(2,i1,j1,k1)+wt2 *force(2,i2,j1,k1)+
     &       wt3 *force(2,i3,j1,k1)+wt4 *force(2,i1,j2,k1)+
     &       wt5 *force(2,i2,j2,k1)+wt6 *force(2,i3,j2,k1)+
     &       wt7 *force(2,i1,j3,k1)+wt8 *force(2,i2,j3,k1)+
     &       wt9 *force(2,i3,j3,k1)+wt10*force(2,i1,j1,k2)+
     &       wt11*force(2,i2,j1,k2)+wt12*force(2,i3,j1,k2)+
     &       wt13*force(2,i1,j2,k2)+wt14*force(2,i2,j2,k2)+
     &       wt15*force(2,i3,j2,k2)+wt16*force(2,i1,j3,k2)+
     &       wt17*force(2,i2,j3,k2)+wt18*force(2,i3,j3,k2)+
     &       wt19*force(2,i1,j1,k3)+wt20*force(2,i2,j1,k3)+
     &       wt21*force(2,i3,j1,k3)+wt22*force(2,i1,j2,k3)+
     &       wt23*force(2,i2,j2,k3)+wt24*force(2,i3,j2,k3)+
     &       wt25*force(2,i1,j3,k3)+wt26*force(2,i2,j3,k3)+
     &       wt27*force(2,i3,j3,k3))*fact2+
     &       fact1*vy(i)

      vz(i)=(wt1 *force(3,i1,j1,k1)+wt2 *force(3,i2,j1,k1)+
     &       wt3 *force(3,i3,j1,k1)+wt4 *force(3,i1,j2,k1)+
     &       wt5 *force(3,i2,j2,k1)+wt6 *force(3,i3,j2,k1)+
     &       wt7 *force(3,i1,j3,k1)+wt8 *force(3,i2,j3,k1)+
     &       wt9 *force(3,i3,j3,k1)+wt10*force(3,i1,j1,k2)+
     &       wt11*force(3,i2,j1,k2)+wt12*force(3,i3,j1,k2)+
     &       wt13*force(3,i1,j2,k2)+wt14*force(3,i2,j2,k2)+
     &       wt15*force(3,i3,j2,k2)+wt16*force(3,i1,j3,k2)+
     &       wt17*force(3,i2,j3,k2)+wt18*force(3,i3,j3,k2)+
     &       wt19*force(3,i1,j1,k3)+wt20*force(3,i2,j1,k3)+
     &       wt21*force(3,i3,j1,k3)+wt22*force(3,i1,j2,k3)+
     &       wt23*force(3,i2,j2,k3)+wt24*force(3,i3,j2,k3)+
     &       wt25*force(3,i1,j3,k3)+wt26*force(3,i2,j3,k3)+
     &       wt27*force(3,i3,j3,k3))*fact2+
     &       fact1*vz(i)

      x(i)=amod(x(i)+vx(i)*pfact+rng,rng)
      y(i)=amod(y(i)+vy(i)*pfact+rng,rng)
      z(i)=amod(z(i)+vz(i)*pfact+rngz,rngz)
  160 continue


      if(myrank .eq. 0) print *,' CPU(FDA4.swp) ', etime(CPU)-stime
      return
      end
