#include<stdio.h>
#include<math.h>
#include<mpi.h>
extern int worksize;
#define pi 3.1415926535
#define SIGN(A) (A > 0. ?  1. : -1.)
void fda4gfswp_c(float *x,float *y,float *z,float *vx,float *vy,float *vz,
		int np,float *den,int nx,int ny,int nz,int local_nz,float a,
		float astep,float amax,float omei,float omep,float omeplam,float pfact,
        int local_nz_start,int myrank,int nrank){
	float *swpden,*den1,*force;
	float ainv,app,apsq,afact,bfact,fact1,fact2;
	float ffact1,ffact2,xp,yp,zp,xmin,ymin,zmin,xd1,yd1,zd1;
	float wx1,wy1,wz1,wx2,wy2,wz2,wx3,wy3,wz3;
	float wt1,wt2,wt3,wt4,wt5,wt6,wt7,wt8,wt9,wt10;
	float wt11,wt12,wt13,wt14,wt15,wt16,wt17,wt18,wt19,wt20;
	float wt21,wt22,wt23,wt24,wt25,wt26,wt27;
	int nearx,neary,nearz,xsign,ysign,zsign;
	int i1,j1,k1,i2,j2,k2,i3,j3,k3;
	int i,ng,j,k;
	int nz_per,dest,src,sendsize,recvsize,stag,rtag;
	MPI_Status status;
	int myrank,nrank,ierror;

	nz_per = local_nz+7;
	ng = nz;
	rngz = rng;
	if(a == 1.)astep = 0.5*astep;
	ainv = 1./a;
    app  = -4.*pi/3.*(ainv*ainv-2*omeplam/omep*a/pow(amax,3));
    apsq = 8.*pi/3.*(ainv+1./omei-1+omeplam/omep*(a*a-1)/pow(amax,3));
    afact = (2.+app*a/apsq)/2.*ainv;
    bfact = pow(ainv,3)/apsq;
    fact1 = (1.-afact*astep)/(1.+afact*astep);
    fact2 = bfact*astep/(1.+afact*astep)*rng;
    if(a == 1)astep = 2.*astep;
    pfact = rng*astep;
	den1 = den+worksize;
	fdarearrange_(den,den1,&nx,&ny,&nz,&local_nz,&myrank,&nrank);
	swpden = den;
	pswitch_(swpden,den1,&nx,&ny,&nz,local_nz);
	force = den1;
	findgridforce_(swpden,force,&nx,&ny,&local_nz,&myrank,&nrank);
	for(i=0;i<np;i++){
		xp = *(x+i);
		yp = *(y+i);
		zp = *(z+i);
		nearx = rint(xp);
		neary = rint(yp);
		nearz = rint(zp)-local_z_start;
		xmin = xp - nearx;
		ymin = yp - neary;
		zmin = zp - nearz;
		xsign = SIGN(xmin);
		ysign = SIGN(ymin);
		zsign = SIGN(zmin);
		i1 = nearx + 1;
		j1 = neary + 1;
		k1 = nearz + 1;
		i2  = i1+xsign;
		j2  = j1+ysign;
		k2  = k1+zsign;
		i3  = i1-xsign;
		j3  = j1-ysign;
		k3  = k1-zsign;
		xd1 = fabs(xmin);
		yd1 = fabs(ymin);
		zd1 = fabs(zmin);
		wx1 = 0.75-xd1*xd1;
		wy1 = 0.75-yd1*yd1;
		wz1 = 0.75-zd1*zd1;
		wx2 = 0.5*pow((0.5+xd1),2);
		wy2 = 0.5*pow((0.5+yd1),2);
		wz2 = 0.5*pow((0.5+zd1),2);
		wx3 = 0.5*pow((0.5-xd1),2);
		wy3 = 0.5*pow((0.5-yd1),2);
		wz3 = 0.5*pow((0.5-zd1),2);
		wt1  = wx1*wy1*wz1;



	}
}





