#include<stdio.h>
#include<stdlib.h>
#include<stddef.h>
#include<math.h>
#include<omp.h>
#include "pmheader.h"
#include "kjhtree.h"
#include "force_spline.h"
#define RANGE 6
#define MIN(a,b) (a)>(b) ? (b): (a)
forceprecision diff[NSPLINE][3],slope[NSPLINE][3], ran2nran,invran2nran;
float LL;
double pmcf(double);
double AA[8] = {
	1.L/256.L/256.L,
	0.78224E+00L,
	0.37971E-06L,
	-0.60338E+00L,
	-0.34419E-07L,
	-0.39741E+01L,
	-0.10607E+01L,
	-0.38145E+00L
};
void i_force_spline(int nx, float rsphere){
	double r;
	int i,j,k;
	double e,dr;
	double rp2,rp1,rm1,rm2;
	double  fp, fpp,fr;

	LL = nx*nx;
	ran2nran=(float)RANGE/(float)NSPLINE;
	invran2nran = 1./ran2nran;

	for(i=0;i<3;i++){
		slope[0][i] = diff[0][i] = 0.;
	}
	dr = ran2nran*0.1;
#ifdef _OPENMP
#pragma omp parallel for private(i,r,rm1,rm2,rp1,rp2,fp,fpp,fr)
#endif
	for(i=1;i<NSPLINE;i++){
		r = (double)(i) * ran2nran;
		rm1 = r - dr; rm2 = r - 2*dr; rp1 = r + dr; rp2 = r + 2*dr;
		fp = (pmcf(rp1) - pmcf(rm1))/(2.*dr);
		fpp = (pmcf(rp2) - 2.*pmcf(r) + pmcf(rm2))/(4.*dr*dr);
		fr = pmcf(r);
		diff[i][0] = -(float)(fr/r);
		diff[i][1] = -(float)(0.5L*(fp*r-fr)/r/r/r);
		diff[i][2] = -(float)(0.5L*(fpp*r*r - 3.L*fp*r + 3.L*fr)/r/r/r/r/r);
		/*
		diff[i][0] = -fr;
		diff[i][1] = -0.5*(fp*r-fr);
		diff[i][2] = -0.5L*(fpp*r*r - 3.L*fp*r + 3.L*fr);
		*/
	}
#ifdef _OPENMP
#pragma omp parallel for 
#endif
	for(i=0;i<NSPLINE;i++){
		slope[i][0] = (diff[i+1][0]-diff[i][0])/ran2nran;
		slope[i][1] = (diff[i+1][1]-diff[i][1])/ran2nran;
		slope[i][2] = (diff[i+1][2]-diff[i][2])/ran2nran;
	}
	for(i=0;i<3;i++){
		diff[NSPLINE-1][i]  =0 ;
		slope[NSPLINE-1][i]  =0 ;
	}
	/*
    j = rsphere/ran2nran;
	k = MIN(j,NSPLINE);
    for(i=j-1;i<k;i++){
        slope[i][0] = slope[j-2][0];
        slope[i][1] = slope[j-2][1];
        slope[i][2] = slope[j-2][2];
        diff[i][0] = diff[j-2][0];
        diff[i][1] = diff[j-2][1];
        diff[i][2] = diff[j-2][2];
	}
	*/

	return;
}
double pmcf(double r){
	double fr;
	double tmp1;
	double e;
	/*
	if(r == 0.L) {
		fr = 0.;
	}
	else 
	*/
	{
		tmp1 = cosh(AA[1]*r);
		fr = r/pow(r*r+EPSILON*EPSILON,1.5L)
			- (
					(1.L/(r*r)*tanh(AA[1]*r)-AA[1]/(tmp1*tmp1*r)
					-2.L*AA[2]/AA[0]*r*exp(AA[3]*r*r)
					-2.L*AA[2]*AA[3]/AA[0]*r*r*r*exp(AA[3]*r*r)
					+AA[4]/AA[0]*(1.L+AA[5]*r*r+AA[6]*r*r*r*r)*exp(AA[7]*r*r))
				);
		fr = fr/LL; /* scaling for the PM force \propto 1/L**2 */
	}
	return fr;
}
void i_potent_spline(){
	double x;
	double xstep;
	int i,j,k;
	double e,dx;
	double g(double);
	double xp2,xp1,xm1,xm2;
	double  gp, gpp;
	ran2nran=(float)RANGE/(float)NSPLINE;
	invran2nran=1./ran2nran;

	for(i=0;i<3;i++){
		slope[0][i] = diff[0][i] = 0.;
	}
	dx = ran2nran;

#ifdef _OPENMP
#pragma omp parallel for private(i,x,xm1,xm2,xp1,xp2,gp,gpp)
#endif
	for(i=1;i<NSPLINE;i++){
		x = (double)(i) * ran2nran;
		xm1 = x - dx; xm2 = x - 2*dx; xp1 = x + dx; xp2 = x + 2*dx;
		gp = (g(xp1) - g(xm1))/(2.*dx);
		gpp = (g(xp2) - 2.*g(x) + g(xm2))/(4.*dx*dx);
		diff[i][0] = g(x);
		diff[i][1] = 0.5L*gp/x;
		diff[i][2] = 0.5L*(gpp/x/x - gp/x/x/x);
	}
#ifdef _OPENMP
#pragma omp parallel for
#endif
	for(i=1;i<NSPLINE;i++){
		slope[i][0] = (diff[i+1][0]-diff[i][0])/dx;
		slope[i][1] = (diff[i+1][1]-diff[i][1])/dx;
		slope[i][2] = (diff[i+1][2]-diff[i][2])/dx;
	}
	return;
}
double g(double x){
	double e,g;
	g = -1.L/sqrt(x*x+EPSILON*EPSILON);
	return g;
}
