#include "defs.h"
#include "extern.h"

int groupcount, pcount;
particleStruct *plist[GROUPNUM];

CheckGroups(ngroups)
int ngroups;
{
	int i, pcount, count, fcount;
	particleStruct *p;

	pcount = 0; fcount = 0;
	for(i=0; i<ngroups; i++) {
		p = theGroupNodes[i];
		count = 0;
		while( p != NULL ) {
			pcount++;
			count++;
			p = (particleStruct *) (p->next);
		}
		fprintf(stderr,"G%d n=%d\n",i,count);
		fcount += (count)*(count-1);
	}
	fprintf(stderr,"total n=%d fcount %d\n",pcount, fcount);
}

GroupParticles(theRoot)
cellStruct *theRoot;
{
	groupcount = 0;
	FindGroups(theRoot);
	MakeGroupLists(groupcount,theTreeNodes);
	
	NGroup = groupcount;
}

FindGroups(theNode)
nodeStruct *theNode;
{
	int i, nchildren;
	cellStruct *c;
	nodeStruct *child;

	if( theNode->type == CELL_TYPE ) {
		c = (cellStruct *) theNode;
		nchildren = c->nchildren;
		child = theNode->next;
		for(i=0; i<nchildren; i++) {
			switch( child->type ) {
				case PARTICULE_TYPE:
				theTreeNodes[groupcount] = (cellStruct *) child;
				groupcount++;
				break;

				case CELL_TYPE:
				c = (cellStruct *) child;
				if( c->nbodies > GROUPNUM ) {
					FindGroups(child);
				}
				else {
					theTreeNodes[groupcount] = (cellStruct *) child;
					groupcount++;
				}
			}
			child = child->sibling;
		}
	}
}

MakeGroupLists(ngroups,nodes)
int ngroups;
nodeStruct **nodes;
{
	int i, j, k;

	for(i=0; i<ngroups; i++) {
		pcount = 0;
		GroupWalk(nodes[i]);
		for(j=0, k=0; j<pcount; j++) {
			if( !(plist[j]->visitor) ) {
				plist[k] = plist[j];
				k++;
			}
		}
		if( k > 0 ) {
			theGroupNodes[i] = plist[0];
			for(j=0; j<k-1; j++)
				plist[j]->next = (nodeStruct *) plist[j+1];
			plist[j]->next = NULL;
		}
		else {
			theGroupNodes[i] = NULL;
		}
	}
}

GroupWalk(theNode)
nodeStruct *theNode;
{
	int i, nchildren;
	cellStruct *c;
	nodeStruct *child;
	particleStruct *p;

	if( theNode->type == CELL_TYPE ) {
		c = (cellStruct *)  theNode;
		nchildren = c->nchildren;
		child = c->next;
		for(i=0; i<nchildren; i++) {
			switch( child->type ) {
				case PARTICULE_TYPE:
				p = (particleStruct *) child;
				plist[pcount] = (particleStruct *) child;
				pcount++;
				break;

				case CELL_TYPE:
				GroupWalk(child);
				break;
			}
			child = child->sibling;
		}
	}
	else if (theNode->type == PARTICULE_TYPE) { 
				/* In case the group contains only one particle */
		p = (particleStruct *) theNode;
		plist[pcount] = (particleStruct *) theNode;
		pcount++;
	}
}

SingleGroup(particlebin)
particleStruct *particlebin;
{
	int j;
	particleStruct *p;

	pcount = 0;
	for(p=particlebin; p != NULL; p=p->nextinbin ) {
		if( !(p->visitor) ) {
			plist[pcount] = p;
			pcount++;
		}
	}
	if( pcount > 0 ) {
		NGroup = 1;
		theGroupNodes[0] = plist[0];
		for(j=0; j<pcount-1; j++)
			plist[j]->next = (nodeStruct *) plist[j+1];
		plist[j]->next = NULL;
	}
	else {
		NGroup = 0;
	}
}
