#include "defs.h"
#include "extern.h"

#define COMPLETED 0
#define NOTCOMPLETED 1
#define GHOST 0
#define NOTGHOST 1
#define Nbuffer 1000000L
#define MIN(a,b) ((a)<(b) ? (a):(b))
#define MAX(a,b) ((a)>(b) ? (a):(b))
#define	UPSENDPARTICLE \
{\
	npsend = 0;\
	for(bp=BasicParticles+(size_t)startp;bp<BasicParticles+(size_t)np;bp++){\
		if(bp->z> zlimit){\
			sendp[npsend] = *bp ; \
			npsend ++;\
			if(npsend == Nbuffer){\
				MPI_Send(sendp,sizeof(basicparticletype)*npsend,\
						MPI_BYTE,dest,0,MPI_COMM_WORLD);\
				npsend = 0;\
			}\
		}\
	}\
	if(npsend != 0){\
		MPI_Send(sendp,sizeof(basicparticletype)*npsend,\
                        MPI_BYTE,dest,0,MPI_COMM_WORLD);\
	}\
}
#define	DOWNSENDPARTICLE \
{\
	npsend = 0;\
	for(bp=BasicParticles+(size_t)startp;bp<BasicParticles+(size_t)np;bp++){\
		if(bp->z < zlimit && bp->u.keepflag != GHOST){\
			sendp[npsend] = *bp; \
			npsend ++;\
			if(npsend == Nbuffer){\
				MPI_Send(sendp,sizeof(basicparticletype)*npsend,\
						MPI_BYTE,dest,0,MPI_COMM_WORLD);\
				npsend = 0;\
			}\
		}\
	}\
	if(npsend != 0){\
		MPI_Send(sendp,sizeof(basicparticletype)*npsend,\
                        MPI_BYTE,dest,0,MPI_COMM_WORLD);\
	}\
}
#define RECVPARTICLE \
{\
	if(receivflag != COMPLETED){\
		for(i=0;i<nprecv;i+= Nbuffer){\
			nptmprecv = MIN(Nbuffer,nprecv-i);\
			MPI_Recv(BasicParticles+((INT8)np+(INT8)i),sizeof(basicparticletype)*\
					nptmprecv,MPI_BYTE,src,0,MPI_COMM_WORLD,&status);\
		}\
	}\
}

int receivflag;
extern float zboxup,zboxsize;
float height[512];
float z0n[512], z1n[512], dzn[512];



int GetVisitors(Np,BasicParticles,dz,z0,height)
int Np;
basicparticletype *BasicParticles;
float dz, z0, height;
{
	int i, j, k, p, s;
	INT8 Nmax,Nvisitors;
	int nvisitors;
	int offset; 
    int buffersize;
	float z1, z2, dz1, zmin, zmax; 
	float zlimit;
	double zmid, dz2;
	basicparticletype *bp,*sendp;
	INT8 npsend,nprecv,nptmprecv;
	INT8 np,startp;
	float zupbuffer,zdownbuffer;
	int dest,src;
	INT8 nmax;
	MPI_Status status;

	z1 = z0 + height;

	(void) MPI_Gather(&dz,1,MPI_FLOAT,dzn,1,MPI_FLOAT,0,MPI_COMM_WORLD);
	(void) MPI_Bcast(dzn,numprocs,MPI_FLOAT,0,MPI_COMM_WORLD);
	(void) MPI_Gather(&z0,1,MPI_FLOAT,z0n,1,MPI_FLOAT,0,MPI_COMM_WORLD);
	(void) MPI_Bcast(z0n,numprocs,MPI_FLOAT,0,MPI_COMM_WORLD);
	(void) MPI_Gather(&z1,1,MPI_FLOAT,z1n,1,MPI_FLOAT,0,MPI_COMM_WORLD);
	(void) MPI_Bcast(z1n,numprocs,MPI_INT,0,MPI_COMM_WORLD);
	/* sending particles up */
	dest = (myid+1+numprocs)%numprocs;
	src = (myid-1+numprocs)%numprocs;
	startp = 0;
	np = Np;
	/*
	zlimit = z0+height - dz;
	*/
	zlimit = z0n[dest]-dzn[dest];
	if(myid == numprocs-1) zlimit = zlimit + zboxsize;

	z1 = z0+height;
	receivflag = NOTCOMPLETED;
	nmax = Np + freespace()/sizeof(basicparticletype) -Nbuffer -32LL;
	BasicParticles = (basicparticletype *)resizelast(BasicParticles,
			nmax*sizeof(basicparticletype));
	sendp = (basicparticletype *)malloc(sizeof(basicparticletype)
				*Nbuffer);
	while(startp != np){
		npsend = 0;
		for(bp=BasicParticles+(size_t)startp;bp<BasicParticles+(size_t)np;bp++){
			if(bp->z > zlimit) {
				npsend ++;
			}
		}
		printf("P%d sending to P%d with %d\n",myid,dest,npsend);fflush(stdout);
		if(myid%2 == 0){
			MPI_Send(&npsend,1,MPI_INT8,dest,0,MPI_COMM_WORLD);
			if(receivflag !=COMPLETED)
				MPI_Recv(&nprecv,1,MPI_INT8,src,0,MPI_COMM_WORLD,&status);
		}
		else {
			if(receivflag != COMPLETED) 
				MPI_Recv(&nprecv,1,MPI_INT8,src,0,MPI_COMM_WORLD,&status);
			MPI_Send(&npsend,1,MPI_INT8,dest,0,MPI_COMM_WORLD);
		}
		printf("P%d receiving from P%d with %d\n",myid,dest,npsend);fflush(stdout);
		/*
		BasicParticles =(basicparticletype *)resizelast(BasicParticles,
				sizeof(basicparticletype)*(np+nprecv));
		BasicParticles =(basicparticletype *)Realloc(BasicParticles,
				sizeof(basicparticletype)*(np+nprecv));
				*/

		if(myid%2 == 0){
			UPSENDPARTICLE;
			RECVPARTICLE;
		}
		else {
			RECVPARTICLE;
			UPSENDPARTICLE;
		}
		/*
		sendp = (basicparticletype *)malloc(sizeof(basicparticletype)
				*MAX(npsend,Nbuffer));
		npsend = 0;
		nownp = 0;

		for(bp=BasicParticles+startp;bp<BasicParticles+np;bp++){
			if(bp->z >=zlimit) {
				sendp[npsend] = BasicParticles[nownp];
				npsend ++;
			}
			nownp ++;
		}
		if(myid%2 == 0){
			MPI_Send(sendp,sizeof(basicparticletype)*npsend,MPI_BYTE,dest,
					0,MPI_COMM_WORLD);
			if(receivflag != COMPLETED) 
				MPI_Recv(BasicParticles+np,sizeof(basicparticletype)*nprecv,
					MPI_BYTE,src,0,MPI_COMM_WORLD,&status);
		}
		else {
			if(receivflag != COMPLETED) 
				MPI_Recv(BasicParticles+np,sizeof(basicparticletype)*nprecv,
					MPI_BYTE,src,0,MPI_COMM_WORLD,&status);
			MPI_Send(sendp,sizeof(basicparticletype)*npsend,MPI_BYTE,dest,
					0,MPI_COMM_WORLD);
		}
		*/

		/* fitting the z-value to the local domain z */
		/*
		zmid = (double) (0.5*(z0+z1));
		for(bp=BasicParticles+np;bp<BasicParticles+np+nprecv;bp++){
			dz2 = (double) (bp->z) - zmid;
			if( dz2 < -0.5*zboxsize) dz2 += zboxsize;
			if( dz2 > zboxsize*0.5) dz2 -= zboxsize;
			bp->z = (float) (dz2 + zmid);
		}
		*/
		if(myid ==0)
			for(bp=BasicParticles+(size_t)np;bp<BasicParticles+(size_t)np+(size_t)nprecv;bp++){
				bp->z = bp->z - zboxsize;
			}
		if(nprecv == 0) receivflag = COMPLETED;

		startp = np;
		np = np + nprecv;
	}
	for(bp=BasicParticles;bp<BasicParticles+(size_t)Np;bp++)
		bp->u.keepflag = NOTGHOST;
	for(bp=BasicParticles+(size_t)Np;bp<BasicParticles+(size_t)np;bp++)
		bp->u.keepflag = GHOST;
	MPI_Barrier(MPI_COMM_WORLD);
	/* sending particles down */
	dest = (myid-1+numprocs)%numprocs;
	src = (myid+1+numprocs)%numprocs;
	startp = 0;
	/*
	np = Np;
	*/
	/*
	zlimit = z0+dz;
	*/
	zlimit = z1n[dest]+dzn[dest];
	if(myid == 0)  zlimit = zlimit - zboxsize;
	z1 = z0+height;
	receivflag = NOTCOMPLETED;

	while(startp != np){
		npsend = 0;
		for(bp=BasicParticles+(size_t)startp;bp<BasicParticles+(size_t)np;bp++){
			if(bp->z < zlimit && bp->u.keepflag != GHOST) npsend ++;
		}
		printf("P%d sending to P%d with %d\n",myid,dest,npsend);fflush(stdout);
		if(myid%2 == 0){
			MPI_Send(&npsend,1,MPI_INT8,dest,0,MPI_COMM_WORLD);
			if(receivflag !=COMPLETED)
				MPI_Recv(&nprecv,1,MPI_INT8,src,0,MPI_COMM_WORLD,&status);
		}
		else {
			if(receivflag != COMPLETED) 
				MPI_Recv(&nprecv,1,MPI_INT8,src,0,MPI_COMM_WORLD,&status);
			MPI_Send(&npsend,1,MPI_INT8,dest,0,MPI_COMM_WORLD);
		}
		printf("P%d receiving from P%d with %d\n",myid,dest,npsend);fflush(stdout);
		/*
		BasicParticles =(basicparticletype *)Realloc(BasicParticles,
				sizeof(basicparticletype)*(np+nprecv));
				*/

		if(myid%2 == 0){
			DOWNSENDPARTICLE;
			RECVPARTICLE;
		}
		else {
			RECVPARTICLE;
			DOWNSENDPARTICLE;
		}
		/*
		sendp = (basicparticletype *)malloc(sizeof(basicparticletype)
				*MAX(npsend,Nbuffer));
		npsend = 0;
		nownp = 0;
		for(bp=BasicParticles+startp;bp<BasicParticles+np;bp++){
			if(bp->z < zlimit && bp->u.keepflag != GHOST) {
				sendp[npsend] = BasicParticles[nownp];
				npsend ++;
			}
			nownp ++;
		}
		if(myid%2 == 0){
			MPI_Send(sendp,sizeof(basicparticletype)*npsend,MPI_BYTE,dest,
					0,MPI_COMM_WORLD);
			if(receivflag != COMPLETED) 
				MPI_Recv(BasicParticles+np,sizeof(basicparticletype)*nprecv,
					MPI_BYTE,src,0,MPI_COMM_WORLD,&status);
		}
		else {
			if(receivflag != COMPLETED) 
				MPI_Recv(BasicParticles+np,sizeof(basicparticletype)*nprecv,
					MPI_BYTE,src,0,MPI_COMM_WORLD,&status);
			MPI_Send(sendp,sizeof(basicparticletype)*npsend,MPI_BYTE,dest,
					0,MPI_COMM_WORLD);
		}
		*/
		/* fitting the z-value to the local domain z */
		/*
		zmid = (double) (0.5*(z0+z1));
		for(bp=BasicParticles+np;bp<BasicParticles+np+nprecv;bp++){
			dz2 = (double) (bp->z) - zmid;
			if( dz2 < -0.5*zboxsize) dz2 += zboxsize;
			if( dz2 > zboxsize*0.5) dz2 -= zboxsize;
			bp->z = (float) (dz2 + zmid);
		}
		*/
		if(myid ==numprocs-1){
			for(bp=BasicParticles+(size_t)np;bp<BasicParticles+(size_t)np+(size_t)nprecv;bp++)
            	bp->z += zboxsize;
		}

		if(nprecv == 0) receivflag = COMPLETED;

		startp = np;
		np = np + nprecv;
	}
	Nvisitors = np - (long)Np;
	Free(sendp);
/*
	for(i=0;i<numprocs;i++){
			for(j=0;j<np;j++){
				if(BasicParticles[j].z < z0-dz || BasicParticles[j].z >=z1+dz)
					printf("P%d %d in %d has %g : %g %g id=%d\n",myid,j,Np,
							BasicParticles[j].z, z0-dz,z1+dz,
							BasicParticles[j].u.keepflag);
			}
		fflush(stdout);
		MPI_Barrier(MPI_COMM_WORLD);
	}
*/
	BasicParticles = (basicparticletype *)
		resizelast(BasicParticles,np*sizeof(basicparticletype));
	MPI_Barrier(MPI_COMM_WORLD);
	nvisitors = Nvisitors;
	return nvisitors;
}
