/* This routine has a restriction that the # of sent or received particles
 * should be less than the single precision integer */
/* It is modified to release the limitation. 08 May 2008 */
/* It is not yet conformed whether it is behaving properly. */
#include<stdio.h>
#include<stdlib.h>
#include<stddef.h>
#include<math.h>
#include "pmheader.h"
#include "mpi.h"
#include "Memory.h"
#define max(A,B) ( (A) > (B) ? (A) : (B) )
#define min(A,B) ( (A) < (B) ? (A) : (B) )
#define TICKS 100.
MPI_Datatype MPI_SIZE_T;
#define GETCOMM(mp,mmp) {\
	MPI_Reduce(&mp,&mmp,1,MPI_SIZE_T,MPI_SUM,0,MPI_COMM_WORLD);\
		MPI_Bcast(&mmp,1,MPI_SIZE_T,0,MPI_COMM_WORLD);\
}
int nid,myid;
#define MPI_SENDRECV(send,numa,tpa,dst,sf,recv,numb,tpb,src,rf,comm,sta){\
	for(i=0;i<nid;i++){\
		if(myid==i) MPI_Send(send,numa,tpa,dst,sf,comm);\
		else if(src==i) MPI_Recv(recv,numb,tpb,src,rf,comm,sta);\
	}\
}
#define GETTNP {\
	tnp = np;\
	MPI_Reduce(&tnp,&ttnp,1,MPI_LONG,MPI_SUM,0,MPI_COMM_WORLD);\
}
extern pmparticletype  *pmparticles;
void migrate(size_t *mp,int nz,float zwidth, float zmin){
  	pmparticletype *p,tmp,*ptr,*bp,*sp;
	pmparticletype *sndp,*lp,*rp;
	MPI_Status status;
	int src,dest;
	size_t nrecv,nsend,commsize;
	size_t i,j,k,np,sndnp;
	float zmax,zp,zup,zdown;
	long tnp,ttnp;

	if(sizeof(size_t)==sizeof(unsigned int)) {
		MPI_SIZE_T = MPI_UNSIGNED;
	}
	else if(sizeof(size_t) == sizeof(unsigned long)){
		MPI_SIZE_T = MPI_UNSIGNED_LONG;
	}
	else{
		fprintf(stderr,"Wrong size of size_t in adkjhmigrate.c\n");
		exit(99999);
	}

	np = *mp;

	MPI_Comm_rank(MPI_COMM_WORLD,&myid);
	MPI_Comm_size(MPI_COMM_WORLD,&nid);
	zmax = zmin + zwidth;
	printf("P%d has zmin=%g zmax=%g\n",myid,zmin,zmax);

	commsize = 100;
	sp = pmparticles;

	while(commsize != 0){
		rp = pmparticles + np - 1;
		for(lp=sp;lp<=rp;){
			zp = lp->z;
			/*
			if(zp >=zmax || zp < zmin){
			*/
			if( !(zp <zmax && zp >= zmin) ){
				zup = fabs(zmax - zp);
				zup = min(zup,nz-zup);
				zdown = fabs(zmin-zp);
				zdown = min(zdown,nz-zdown);
				if(zup <= zdown){
					tmp = *lp;
					*lp = *rp;
					*rp = tmp;
					rp --;
				}
				else lp ++;
			}
			else lp++;
		}
		sndnp = np-(rp-pmparticles+1);
		sndp = (pmparticletype *)malloc(sizeof(pmparticletype)*sndnp);
		for(p=rp+1,ptr=sndp;p<pmparticles+np;p++,ptr++) *ptr = *p;
		nsend = sndnp;
		dest = (myid+1+nid)%nid;
		src = (myid-1+nid)%nid;
		GETCOMM(nsend,commsize);
		if(commsize==1){
			if(nsend==1){
				printf("P%d strange comm particle %g %g %g in %g <z< %g\n",myid,sndp->x,sndp->y,sndp->z,zmin,zmax);
			}
		}
		MPI_Sendrecv(&nsend,1,MPI_SIZE_T,dest,0,
				&nrecv,1,MPI_SIZE_T,src,0,MPI_COMM_WORLD,&status);
		pmparticles = (pmparticletype *)Realloc(pmparticles,
				sizeof(pmparticletype)*(np-nsend+nrecv));
		MPI_Sendrecv(sndp,nsend*sizeof(pmparticletype),MPI_BYTE,dest,0,
				&(rp[1]),nrecv*sizeof(pmparticletype),MPI_BYTE,src,0,
				MPI_COMM_WORLD,&status);
		Free(sndp);
		sp = pmparticles+np-nsend;
		np = np-nsend+nrecv;
		/*
		printf("+P%d has sent %d particle to P%d in total=%d \n",
				myid,sndnp,dest,commsize);
				*/
		GETTNP;
		if(myid==0) printf("+total com pmparticles =%ld in %ld\n",commsize,ttnp);
		fflush(stdout);
	}

	commsize =100;
	sp = pmparticles;

	while(commsize != 0){
		rp = pmparticles + np - 1;
		for(lp=sp;lp<=rp;){
			zp = lp->z;
			if( !(zp >= zmin && zp <zmax) ){
				tmp = *lp;
				*lp = *rp;
				*rp = tmp;
				rp --;
			}
			else lp ++;
		}
		sndnp = np-(rp-pmparticles+1);
		sndp = (pmparticletype *)malloc(sizeof(pmparticletype)*sndnp);
		for(p=rp+1,ptr=sndp;p<pmparticles+np;p++,ptr++) *ptr = *p;
		nsend = sndnp;
		dest = (myid-1+nid)%nid;
		src = (myid+1+nid)%nid;
		GETCOMM(nsend,commsize);
		if(commsize==1){
			if(nsend==1){
				printf("P%d strange comm particle %g %g %g in %g <z< %g\n",myid,sndp->x,sndp->y,sndp->z,zmin,zmax);
			}
		}
		MPI_Sendrecv(&nsend,1,MPI_SIZE_T,dest,0,
				&nrecv,1,MPI_SIZE_T,src,0,MPI_COMM_WORLD,&status);
		pmparticles = (pmparticletype *)Realloc(pmparticles,
				sizeof(pmparticletype)*(np-nsend+nrecv));
		MPI_Sendrecv(sndp,nsend*sizeof(pmparticletype),MPI_BYTE,dest,0,
				&(rp[1]),nrecv*sizeof(pmparticletype),MPI_BYTE,src,0,
				MPI_COMM_WORLD,&status);
		Free(sndp);
		sp = pmparticles+np-nsend;
		np = np-nsend+nrecv;
		GETTNP;
		if(myid==0) printf("-total com pmparticles =%ld in %ld\n",commsize,ttnp);
		/*
		printf("-P%d has sent %d pmparticles to P%d in total=%d \n",
				myid,sndnp,dest,commsize);
				*/
		fflush(stdout);
	}
	*mp = np;
}
