#include "defs.h"
#include "extern_simparam.h"
/*
#include "pm_extern.h"
*/
extern int np;
extern pmparticletype *pmparticles;
int  myid,nid;
#define max(a,b) ((a) > (b) ? (a): (b))
#define min(a,b) ((a) < (b) ? (a): (b))

#define PASSFLAG 33
#define COUNTFLAG 34
#define PARTICLEFLAG 35

typedef struct {
	float  x, y, z, vx, vy, vz;
#ifdef INDEX
	indextype indx;
#endif
} phase;



pmparticletype bpblock[BLOCKSIZE];
phase pblock[BLOCKSIZE];
extern float zstart, zheight;

/*
int jwrite(ng,ngz,nspace,iseed,size,omep,omeplam, amax,astep,
			a, redshift,particles,np,myid, nid,nred10)
int ng, ngz, nspace, iseed;
float size, omep, omeplam, amax, astep, a, redshift;
pmparticletype *particles;
int np, myid, nid, nred10;
*/

int jwrite(int stepcount) {
	FILE *fp;
	int i,j,k, p;
/*
	int nptot;
*/
	int count;
	int ncount, nblock, nremain, ncheck;
	int dummy=0;
	float m;
	char *fileheader = FILEHEADER;
	char procname[3],number[3];
	char filename[80];
	MPI_Status status;
	size_t nwritecheck;

/*
	MPI_Allreduce(&np,&nptot, 1, MPI_INT, MPI_SUM, MPI_COMM_WORLD);
fprintf(stderr,"P%d np %d nptot %d\n",myid,np,nptot);
*/
	MPI_Comm_rank(MPI_COMM_WORLD,&myid);
	MPI_Comm_size(MPI_COMM_WORLD,&nid);

	if( myid == 0 ) 
		fprintf(stderr," writing data at a=%g,z=%g \n",a,amax/a - 1.0);
	for(i=0;i<nid;i++){
		if(myid == i){ 
			sprintf(filename,"%s.%.5d%.5d",rvprefix,stepcount,myid);
			fprintf(stderr," writing file: %s %d\n",filename,np);
			fp = fopen(filename,"w");
			ncheck = np;
			count = 0;
			if((nwritecheck =fwrite(&zstart,sizeof(float),1,fp)) != 1){
				exit(0);
			}
			fwrite(&zheight,sizeof(float),1,fp);
			fwrite(&np,sizeof(int),1,fp);
			for(k=0;k<np;k++){
				pblock[count].x = pmparticles[k].x;
				pblock[count].y = pmparticles[k].y;
				pblock[count].z = pmparticles[k].z;
				pblock[count].vx = pmparticles[k].vx;
				pblock[count].vy = pmparticles[k].vy;
				pblock[count].vz = pmparticles[k].vz;
#ifdef INDEX
				pblock[count].indx = pmparticles[k].indx;
#endif
				count ++;
				if( count == BLOCKSIZE){
					if((nwritecheck = fwrite(pblock,count*sizeof(phase),1,fp)) != 1) exit(0);
					count = 0;
				}
			}
			if(count > 0){
				if((nwritecheck = fwrite(pblock, count*sizeof(phase),1,fp)) != 1) exit(0);
				count = 0;
			}
			fclose(fp);
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}
/*########################################################### */
	if( myid == 0 ) {
		FILE *paramfile;
		char paramname[80];

		sprintf(paramname,"params.%.5d",stepcount);
		paramfile = fopen(paramname,"w");
		
		fprintf(paramfile,"%.8g %.8g\n",boxsize_hinv_mpc,hubble_parameter);
	    fprintf(paramfile,"%.8g %.8g %.8g %.8g %.8g %.8g\n",
           npow0,omega,omegabaryon,lambda,bias_8mpc,rsmooth);
		fprintf(paramfile,"%d %d %d %d\n",nxmesh,nymesh,nzmesh,nspace0);
		fprintf(paramfile,"%.8g %.8g %.8g\n",
				SPHERE_RADIUS,particle_radius,theta);
		fprintf(paramfile,"%.8g %.8g %.8g\n",z_init,delta_a,a);
		fprintf(paramfile,"%d %d %d\n",nstep,stepcount,nskip);
		fprintf(paramfile,"%d\n",seed);
		sprintf(filename,"%s.%.5d",rvprefix,stepcount);
		fprintf(paramfile,"%s %s\n",filename, rvprefix);
		fprintf(paramfile,"%.8g %.8g %.8g %.8g\n",
			ken, ktot, const0, poten0);
		fprintf(paramfile,"%s\n",camerafilename);

		fclose(paramfile);
	}
	return 0;
}

/*
void jread(int *ng,int *ngz,int *nspace,int *iseed,float *size,float *omep,
		float *omeplam, float *amax,float *astep,float *pconv,
		float *vconv,float *a, float *redshift,pmparticletype *pmparticles, 
		int *np,int myid, int nid,int *nstep)
*/
void jread()
{
	int i, j, k, count;
	INT8 nmax;
	int nsend, nrecv;
	int passflag;
	INT8 NTotal, NLocal, NLocal0, NTotalcheck;
        int Ntotal;
	INT8 nbytes;
	float m, mrv[6];
	FILE *rvfile;
	char rvname[80],filename[80];
	MPI_Status status;
	float ksum, totalken;
	pmparticletype *p;

	MPI_Comm_rank(MPI_COMM_WORLD,&myid);
	MPI_Comm_size(MPI_COMM_WORLD,&nid);
/* passed the test already for the existence of this file */
	sprintf(filename,"%s%.5d",rvfilename,myid);
	rvfile = fopen(filename,"r");
/*
	if( myid == 0 ) {
		fseek(rvfile,0,2); nbytes = ftell(rvfile); fseek(rvfile,0,0);
		NTotal = nbytes/(6*sizeof(FLOAT_TYPE));
		fprintf(stderr,"In file: NTotal %d\n",NTotal);
	}
	MPI_Bcast(&NTotal, 1, MPI_LONG_LONG, 0, MPI_COMM_WORLD);
	fprintf(stderr,"P%d has NTotal %d\n",myid,NTotal);
	NLocal = NTotal/nid;
	if( myid == 0 ) {
		NLocal0 = NLocal;
		NLocal += (NTotal - NLocal*nid);
	}
	MPI_Allreduce(&NLocal,&NTotalcheck, 1, MPI_LONG_LONG, MPI_SUM, MPI_COMM_WORLD);
	fprintf(stderr,"Checking NTotal %d = NTotalcheck %d\n",NTotal, NTotalcheck);
	fprintf(stderr,"P%d NLocal %d\n",myid,NLocal);
*/
	fread(&zstart,sizeof(float),1,rvfile);
	fread(&zheight,sizeof(float),1,rvfile);
	fread(&np,sizeof(int),1,rvfile);
	NLocal = np;
    MPI_Allreduce(&NLocal,&NTotal,1,MPI_INT8,MPI_SUM,MPI_COMM_WORLD);

	m =  1.0/NTotal*nspace0*nspace0*nspace0;
	
	nmax = ptrsize(pmparticles)/sizeof(pmparticletype);
	fprintf(stderr,"P%d nmax %d\n",myid,nmax); fflush(stderr);
	for(i=0;i<nid;i++){
		if(i == myid){
			phase mrv[10000];
			NLocal = np;
           	fprintf(stderr,"P%d starts reading data. %d",myid,NLocal);
			fflush(stderr);
			k = 0;
			while((np=fread(mrv,sizeof(phase),10000,rvfile))){
				for(j=0;j<np;j++){
#if defined(MULTIMASS)
					pmparticles[k].mass = mrv[j].mass;
#endif
					pmparticles[k].x = mrv[j].x;
					pmparticles[k].y = mrv[j].y;
					pmparticles[k].z = mrv[j].z;
					pmparticles[k].vx = mrv[j].vx;
					pmparticles[k].vy = mrv[j].vy;
					pmparticles[k].vz = mrv[j].vz;
#ifdef INDEX
					pmparticles[k].indx = mrv[j].indx;
#endif
#ifndef VarPM
					pmparticles[k].freework = 1.0;
#endif
					k++;
				}
			}
           	fprintf(stderr,"--  P%d finishes reading data, %d \n",myid, NLocal);
			fflush(stderr);
			np = NLocal;
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}
/*
        fprintf(stderr,"%d %g\n",myid,pmparticles[np-1].x);
        MPI_Finalize();
        exit(0);
*/
/* Initialize kinetic energy term */
	ksum = 0;
	for(p=pmparticles; p<pmparticles+NLocal; p++) {
#if defined(MULTIMASS)
		ksum += (p->mass)*((p->vx)*(p->vx) + (p->vy)*(p->vy) + (p->vz)*(p->vz));
#else
		ksum += ((p->vx)*(p->vx) + (p->vy)*(p->vy) + (p->vz)*(p->vz));
#endif
	}
	MPI_Allreduce(&ksum,&totalken,1,MPI_FLOAT,MPI_SUM,MPI_COMM_WORLD);
	ken = totalken;
	/*
	np = NLocal;
	*/
}
