/*
 * In this code, the MPI_Sendrecv uses MPI_BYTE type instead of somewhat
 * complicated routines.   So if you want to run this code in different
 * OS(for example, little endian and large endian computer system),
 * please use MPI_Aint and MPI_Datatype......   12/22  2000.
 */
#include<stdio.h>
#include<math.h>
#include<mpi.h>
#include<stdlib.h>
#include<sys/times.h>
/*
#include "pmheader.h"
#include "macros.h"
*/
#include "defs.h"
float gettime();
float cputime0[100], cputime1[100];
#define max(A,B) ( (A) > (B) ? (A) : (B) )
#define min(A,B) ( (A) < (B) ? (A) : (B) )
/*
extern float *mass,*x,*y,*z,*vx,*vy,*vz;
extern int *indx;
*/
extern float *work;
extern basicparticletype *particles;
extern int densize;
extern float *den;
#define TICKS 100.
extern float ctimes();

void migrate_indx(int *np,int myrank,int nrank,int tnp)
{
	int sortindx();
	int blocklens[]={1,1,1,1,1,1,1,1,1,1,1};
	MPI_Datatype old_types[]={MPI_FLOAT,MPI_FLOAT,MPI_FLOAT,
	        MPI_FLOAT,MPI_FLOAT,MPI_FLOAT,MPI_FLOAT,MPI_FLOAT,MPI_FLOAT,
	        MPI_INT,MPI_UB};
	MPI_Datatype MPI_BASIC_PARTICLE;
	MPI_Aint indices[11];
  	basicparticletype tmpparticle,*ptri,*ptrunp;
	int ntmp,i,j,unp,zp;
	int indxdbound,indxubound;
	int nget,nput,src,dest,numrecv,ierror,numsend,nend,npold;
	MPI_Status status;
	int commsize,zup,zdown;
	int *intwork;
	/*
	float *fltwork;
	float *tmpz;
	*/
	basicparticletype *pstack;
	int ptrsize(), nmax;
	void *Malloc(), *resizelast();
	float sstep;

	TIMER_START(99);
    indices[0] = 0;
    indices[1] = sizeof(float);
    indices[2] = sizeof(float)+indices[1];
    indices[3] = sizeof(float)+indices[2];
    indices[4] = sizeof(float)+indices[3];
    indices[5] = sizeof(float)+indices[4];
    indices[6] = sizeof(float)+indices[5];
    indices[7] = sizeof(float)+indices[6];
    indices[8] = sizeof(float)+indices[7];
    indices[9] = sizeof(int)+indices[8];
    indices[10] = sizeof(basicparticletype);

	MPI_Type_struct(11,blocklens,indices,old_types,&MPI_BASIC_PARTICLE);

	nmax = ptrsize(particles)/sizeof(basicparticletype);
	particles = (basicparticletype *) 
			resizelast(particles,nmax*sizeof(basicparticletype));
	pstack = particles + (*np);

	/*
	tmpz = (float *)malloc(*np*sizeof(float));
	for(i=0;i<*np;i++) tmpz[i] = particles[i].z;
	*/

	/*
	 * These two lines are to reduce the call on Operating system for
	 * more memory.  So reduce or free current massive memory usage
	 * into free list.
	*/
	/*
  	work = (float *)dlrealloc(work,densize*sizeof(float));
	den = work;
	*/


    if(myrank == 0) sstep = ctimes();

	/*
	intwork = (int *) work;
	fltwork = (float *) work;
	*/

	/*
	zdbound = local_z_start;
	zubound = local_z_start+local_nz;
	*/
	indxdbound = tnp/nrank*myrank;
	indxubound = tnp/nrank*(myrank+1);
	do {
		unp = *np; ptrunp = particles+*np;
		/*
		 *  These lines are for the case
		 *  **********-----, where - is for migration.
		 */
		/*i = unp;*/ ptri = ptrunp;

		do {
			/*i = i - 1;*/ ptri--;
			zp = ptri->indx;
			/*
			zp = (int) particles[i].z;
			zp = (int) tmpz[i];
			*/
	    	zup = abs(indxubound-zp);
	    	zup = min(zup,tnp-zup);
	    	zdown = abs(indxdbound-zp);
	    	zdown = min(zdown,tnp-zdown);
		} while( (zp >= indxubound || zp < indxdbound) && zup <= zdown );
		/* unp = i + 1;*/ 	ptrunp = ptri+1;
		/*
		 */
		/* i = 0;*/ 	ptri = particles;
        while(ptri < ptrunp){
			zp = ptri->indx;
			/*
			zp = (int) particles[i].z;
			zp = (int) tmpz[i];
			*/
 	      	zup = abs(indxubound - zp);
        	zup = min(zup,tnp-zup);
			zdown = abs(indxdbound-zp);
			zdown = min(zdown,tnp-zdown);
			if((zp >= indxubound || zp < indxdbound) && zup <= zdown){
				/*
				copyparticle(&tmpparticle,&particles[i]);
				tmpparticle = particles[i];
				*/
				tmpparticle = particles[ptri-particles];
				do {
					/* unp = unp - 1;*/  ptrunp--;
					zp = ptrunp->indx;
					/*
					zp = (int) particles[unp].z;
					*/
					zup = abs(indxubound-zp);
					zup = min(zup,tnp-zup);
					zdown = abs(indxdbound-zp);
					zdown = min(zdown,tnp-zdown);
				} while((zp>=indxubound || zp<indxdbound) 
						&& zup<=zdown && ptrunp>ptri);
				/* exchange two elements */
				/*
				copyparticle(&particles[i],&particles[unp]);
				particles[i] = particles[unp];
				particles[ptri-particles] = particles[ptrunp-particles];
				*/
				*(ptri) = *(ptrunp);
				/*
				tmpz[i] = tmpz[unp];
				*/
				/*
				copyparticle(&particles[unp],&tmpparticle);
				particles[unp] = tmpparticle;
				particles[ptrunp-particles] = tmpparticle;
				*/
				*(ptrunp) = tmpparticle;
				/*
				tmpz[unp] = tmpparticle.z;
				*/
			}
			/* i++;*/ ptri++;
		}
		src = (myrank-1+nrank) % nrank;
		dest = (myrank+1+nrank) % nrank;
		/*
  		numsend = *np-unp;
		*/
		numsend = *np-(ptrunp-particles);
		numrecv = numsend;
		MPI_Sendrecv_replace(&numrecv,1,MPI_INT,dest,1,
				src,1,MPI_COMM_WORLD,&status);
		/*
		 * resize memory(x,y,z,vx,vy,vz,indx);
		 */
		/*
		 * total # of particles to send;
		 */
   		MPI_Reduce(&numsend,&commsize,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
   		MPI_Bcast(&commsize,1,MPI_INT,0,MPI_COMM_WORLD);
		if(commsize != 0){
			unp = ptrunp - particles;
		    nend = max(numrecv+unp,*np);
			pstack = particles + nend;
	     	if(myrank == 0) printf("total upper sending .... %d \n",commsize);
			/*
			MPI_Sendrecv(&particles[unp],numsend*sizeof(basicparticletype),
					MPI_BYTE,dest,0,work_particles,
					numrecv*sizeof(basicparticletype),
					MPI_BYTE,src,0,MPI_COMM_WORLD,&status);
					*/
			MPI_Sendrecv(&particles[unp],numsend,MPI_BASIC_PARTICLE,
					dest,1,pstack,numrecv,MPI_BASIC_PARTICLE,
					src,1,MPI_COMM_WORLD,&status);
			/*
			copyparticles(&particles[unp],&work_particles[0],numrecv);
			*/
			memcpy(&particles[unp],&pstack[0],
					numrecv*sizeof(basicparticletype));
			/*
			tmpz = realloc(tmpz,nend*sizeof(float));
			for(j=0;j<numrecv;j++)
				tmpz[unp+j] = work_particles[j].z;
			*/
		    *np = *np-numsend+numrecv;
		}
	} while(commsize != 0);

	do {
		/* unp = *np;*/ ptrunp = particles+*np;
		/*
		 *  These lines are for the case
		 *  **********-----, where - is for migration.
		 */
		/* i = unp;*/ ptri = ptrunp;
		do {
			/* i = i - 1;*/ ptri--;
			zp = ptri->indx;
			/*
			zp = (int) particles[i].z;
			zp = (int) tmpz[i];
			*/
		} while(zp >= indxubound || zp < indxdbound);
		/* unp = i + 1;*/  ptrunp = ptri + 1;
		/*
		 */
		/* i = 0; */ptri = particles;
        while( ptri < ptrunp){
			zp = ptri->indx;
			/*
			zp = (int) particles[i].z;
			zp = (int) tmpz[i];
			*/
			if((zp >= indxubound || zp < indxdbound)){
				/*
				copyparticle(&tmpparticle,&particles[i]);
				tmpparticle = particles[i];
				*/
				tmpparticle = particles[ptri-particles];
				do {
					/* unp = unp - 1;*/ ptrunp--;
					zp = ptrunp->indx;
					/*
					zp = (int) particles[unp].z;
					*/
				} while((zp >= indxubound || zp < indxdbound)&& ptrunp > ptri);
				/* change two elements */
				/*
				copyparticle(&particles[i],&particles[unp]);
				particles[i] = particles[unp];
				particles[ptri-particles] = particles[ptrunp-particles];
				*/
				*ptri = *ptrunp;
				/*
				tmpz[i] = tmpz[unp];
				*/
				/*
				copyparticle(&particles[unp],&tmpparticle);
				particles[unp] = tmpparticle;
				particles[ptrunp-particles] = tmpparticle;
				*/
				particles[ptrunp-particles] = tmpparticle;
				*ptrunp = tmpparticle;
				/*
				tmpz[unp] = tmpparticle.z;
				*/
			}
			/* i++;*/ ptri++;
		}
		src = (myrank+1+nrank)%nrank;
		dest = (myrank-1+nrank)%nrank;
		/*
  		numsend = *np-unp;
		*/
		numsend = *np -(ptrunp-particles);
		numrecv = numsend;
		MPI_Sendrecv_replace(&numrecv,1,MPI_INT,dest,1,
		     src,1,MPI_COMM_WORLD,&status);
		/*
		 * resize memory(x,y,z,vx,vy,vz,indx);
		 */
		/*
		 * total # of particles to send;
		 */
   		MPI_Reduce(&numsend,&commsize,1,MPI_INT,MPI_SUM, 0,MPI_COMM_WORLD);
   		MPI_Bcast(&commsize,1,MPI_INT,0,MPI_COMM_WORLD);
		if(commsize != 0){
			unp = ptrunp - particles;
		    nend = max(numrecv+unp,*np);
			pstack = particles + nend;
	     	if(myrank == 0) printf("total down sending .... %d \n",commsize);
			/*
			MPI_Sendrecv(&particles[unp],numsend*sizeof(basicparticletype),
					MPI_BYTE,dest,0,work_particles,
					numrecv*sizeof(basicparticletype),
					MPI_BYTE,src,0,MPI_COMM_WORLD,&status);
					*/
			MPI_Sendrecv(&particles[unp],numsend,MPI_BASIC_PARTICLE,
					dest,1,pstack,numrecv,MPI_BASIC_PARTICLE,
					src,1,MPI_COMM_WORLD,&status);
			/*
			copyparticles(&particles[unp],&work_particles[0],numrecv);
			*/
			memcpy(&particles[unp],&pstack[0],
					numrecv*sizeof(basicparticletype));
			/*
			tmpz = realloc(tmpz,nend*sizeof(float));
			for(j=0;j<numrecv;j++)
				tmpz[unp+j] = work_particles[j].z;
				*/

			/*
			 * resize memory
			 */
		    *np = *np-numsend+numrecv;
		}
	} while(commsize != 0);
    if(myrank == 0) printf("  CPU(migrate) %G \n",ctimes()-sstep);
	/*
	free(tmpz);
	*/
	particles = (basicparticletype *) 
				resizelast(particles,(*np)*sizeof(basicparticletype));
	qsort(particles,*np,sizeof(basicparticletype),sortindx);
	TIMER_STOP(99);
	if(myrank == 0)
		fprintf(stdout,"CPU(migrate.indx) = %g \n",ELAPSED_TIME(99));
}
int sortindx(basicparticletype *a,basicparticletype *b){
	if(a->indx < b->indx) 
		return -1;
	else if(a->indx > b->indx) 
		return +1;
	else
		return 0;
}
	/*
#include<unistd.h>
void fresize(int np)
{
	particles = (basicparticletype *) realloc(particles,
			np*sizeof(basicparticletype));
}
	*/
