/*
 * In this code, the MPI_Sendrecv uses MPI_BYTE type instead of somewhat
 * complicated routines.   So if you want to run this code in different
 * OS(for example, little endian and large endian computer system),
 * please use MPI_Aint and MPI_Datatype......   12/22  2000.
 */
#include "defs.h"
#include "extern.h"
#include "pm_extern.h"

#define max(A,B) ( (A) > (B) ? (A) : (B) )
#define min(A,B) ( (A) < (B) ? (A) : (B) )
#define TICKS 100.
extern float ctimes();

void hpsort(int, basicparticletype *);

void migrate_indx()
{
	int sortindx();
  	basicparticletype tmpparticle,*ptri,*ptrunp;
	int ntmp,i,j,unp,zp;
	int indxdbound,indxubound;
	int nget,nput,src,dest,numrecv,ierror,numsend,nend,npold;
	MPI_Status status;
	int commsize,zup,zdown;
	int *intwork;
	basicparticletype *pstack;
	int ptrsize(), freespace(); 
	long nmax;
	int tnp;
	void *Malloc(), *resizelast();
	float sstep;

	TIMER_START(99);

	nmax = np + freespace()/sizeof(basicparticletype) -32L;

fprintf(stderr,"migrate_indx_byte -- P%d np %d nmax %d\n",myrank,np,nmax);

	particles = (basicparticletype *) 
			resizelast(particles,nmax*sizeof(basicparticletype));
	pstack = particles + (np);

	/*
	 * These two lines are to reduce the call on Operating system for
	 * more memory.  So reduce or free current massive memory usage
	 * into free list.
	*/

    if(myrank == 0) sstep = ctimes();

	MPI_Allreduce(&np,&tnp,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
	fprintf(stderr,"np %d tnp %d\n",np,tnp);

	indxdbound = tnp/nrank*myrank;
	indxubound = tnp/nrank*(myrank+1);
	do {
		unp = np; ptrunp = particles+np;
		/*
		 *  These lines are for the case
		 *  **********-----, where - is for migration.
		 */
		/*i = unp;*/ ptri = ptrunp;

		do {
			/*i = i - 1;*/ ptri--;
			zp = ptri->indx;
			/*
			zp = (int) particles[i].z;
			zp = (int) tmpz[i];
			*/
	    	zup = abs(indxubound-zp);
	    	zup = min(zup,tnp-zup);
	    	zdown = abs(indxdbound-zp);
	    	zdown = min(zdown,tnp-zdown);
		} while( (zp >= indxubound || zp < indxdbound) && zup <= zdown );
		/* unp = i + 1;*/ 	ptrunp = ptri+1;
		/*
		 */
		/* i = 0;*/ 	ptri = particles;
        while(ptri < ptrunp){
			zp = ptri->indx;
			/*
			zp = (int) particles[i].z;
			zp = (int) tmpz[i];
			*/
			if((zp >= indxubound || zp < indxdbound) ){
	 	      	zup = abs(indxubound - zp);
   		     	zup = min(zup,tnp-zup);
				zdown = abs(indxdbound-zp);
				zdown = min(zdown,tnp-zdown);
				if(zup <= zdown){
					/*
					copyparticle(&tmpparticle,&particles[i]);
					tmpparticle = particles[i];
					*/
					tmpparticle = particles[ptri-particles];
					do {
						/* unp = unp - 1;*/  ptrunp--;
						zp = ptrunp->indx;
						/*
						zp = (int) particles[unp].z;
						*/
						zup = abs(indxubound-zp);
						zup = min(zup,tnp-zup);
						zdown = abs(indxdbound-zp);
						zdown = min(zdown,tnp-zdown);
					} while((zp>=indxubound || zp<indxdbound) 
							&& zup<=zdown && ptrunp>ptri);
					/* exchange two elements */
					/*
					copyparticle(&particles[i],&particles[unp]);
					particles[i] = particles[unp];
					particles[ptri-particles] = particles[ptrunp-particles];
					*/
					*(ptri) = *(ptrunp);
					/*
					tmpz[i] = tmpz[unp];
					*/
					/*
					copyparticle(&particles[unp],&tmpparticle);
					particles[unp] = tmpparticle;
					particles[ptrunp-particles] = tmpparticle;
					*/
					*(ptrunp) = tmpparticle;
					/*
					tmpz[unp] = tmpparticle.z;
					*/
				}
			}
			/* i++;*/ ptri++;
		}
		src = (myrank-1+nrank) % nrank;
		dest = (myrank+1+nrank) % nrank;
		/*
  		numsend = np-unp;
		*/
		numsend = np-(ptrunp-particles);
		numrecv = numsend;
		MPI_Sendrecv_replace(&numrecv,1,MPI_INT,dest,1,
				src,1,MPI_COMM_WORLD,&status);
		/*
		 * resize memory(x,y,z,vx,vy,vz,indx);
		 */
		/*
		 * total # of particles to send;
		 */
   		MPI_Reduce(&numsend,&commsize,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
   		MPI_Bcast(&commsize,1,MPI_INT,0,MPI_COMM_WORLD);
		if(commsize != 0){
			unp = ptrunp - particles;
		    nend = max(numrecv+unp,np);
			pstack = particles + nend;
	     	if(myrank == 0) printf("total upper sending .... %d \n",commsize);
			/*
			MPI_Sendrecv(&particles[unp],numsend*sizeof(basicparticletype),
					MPI_BYTE,dest,0,work_particles,
					numrecv*sizeof(basicparticletype),
					MPI_BYTE,src,0,MPI_COMM_WORLD,&status);
					*/
			/*
			MPI_Sendrecv(&particles[unp],numsend,MPI_BASIC_PARTICLE,
					dest,1,pstack,numrecv,MPI_BASIC_PARTICLE,
					src,1,MPI_COMM_WORLD,&status);
					*/
			MPI_Sendrecv(&particles[unp],numsend*sizeof(basicparticletype),
					MPI_BYTE,
					dest,1,pstack,numrecv*sizeof(basicparticletype),
					MPI_BYTE,
					src,1,MPI_COMM_WORLD,&status);
			/*
			copyparticles(&particles[unp],&work_particles[0],numrecv);
			*/
			memcpy(&particles[unp],&pstack[0],
					numrecv*sizeof(basicparticletype));
			/*
			tmpz = realloc(tmpz,nend*sizeof(float));
			for(j=0;j<numrecv;j++)
				tmpz[unp+j] = work_particles[j].z;
			*/
		    np = np-numsend+numrecv;
		}
	} while(commsize != 0);

	do {
		/* unp = np;*/ ptrunp = particles+np;
		/*
		 *  These lines are for the case
		 *  **********-----, where - is for migration.
		 */
		/* i = unp;*/ ptri = ptrunp;
		do {
			/* i = i - 1;*/ ptri--;
			zp = ptri->indx;
			/*
			zp = (int) particles[i].z;
			zp = (int) tmpz[i];
			*/
		} while(zp >= indxubound || zp < indxdbound);
		/* unp = i + 1;*/  ptrunp = ptri + 1;
		/*
		 */
		/* i = 0; */ptri = particles;
        while( ptri < ptrunp){
			zp = ptri->indx;
			if((zp >= indxubound || zp < indxdbound)){
				tmpparticle = particles[ptri-particles];
				do {
					 ptrunp--;
					zp = ptrunp->indx;
				} while((zp >= indxubound || zp < indxdbound) &&
						ptrunp > ptri) ;
				*ptri = *ptrunp;
				particles[ptrunp-particles] = tmpparticle;
				*ptrunp = tmpparticle;
			}
			ptri++;
		}
		src = (myrank+1+nrank)%nrank;
		dest = (myrank-1+nrank)%nrank;
		/*
  		numsend = np-unp;
		*/
		numsend = np -(ptrunp-particles);
		numrecv = numsend;
		MPI_Sendrecv_replace(&numrecv,1,MPI_INT,dest,1,
		     src,1,MPI_COMM_WORLD,&status);
		/*
		 * resize memory(x,y,z,vx,vy,vz,indx);
		 */
		/*
		 * total # of particles to send;
		 */
   		MPI_Reduce(&numsend,&commsize,1,MPI_INT,MPI_SUM, 0,MPI_COMM_WORLD);
   		MPI_Bcast(&commsize,1,MPI_INT,0,MPI_COMM_WORLD);
		if(commsize != 0){
			unp = ptrunp - particles;
		    nend = max(numrecv+unp,np);
			pstack = particles + nend;
	     	if(myrank == 0) printf("total down sending .... %d \n",commsize);
			/*
			MPI_Sendrecv(&particles[unp],numsend*sizeof(basicparticletype),
					MPI_BYTE,dest,0,work_particles,
					numrecv*sizeof(basicparticletype),
					MPI_BYTE,src,0,MPI_COMM_WORLD,&status);
					*/
			/*
			MPI_Sendrecv(&particles[unp],numsend,MPI_BASIC_PARTICLE,
					dest,1,pstack,numrecv,MPI_BASIC_PARTICLE,
					src,1,MPI_COMM_WORLD,&status);
					*/
			MPI_Sendrecv(&particles[unp],numsend*sizeof(basicparticletype),
					MPI_BYTE,
					dest,1,pstack,numrecv*sizeof(basicparticletype),
					MPI_BYTE,
					src,1,MPI_COMM_WORLD,&status);
			/*
			copyparticles(&particles[unp],&work_particles[0],numrecv);
			*/
			memcpy(&particles[unp],&pstack[0],
					numrecv*sizeof(basicparticletype));
			/*
			tmpz = realloc(tmpz,nend*sizeof(float));
			for(j=0;j<numrecv;j++)
				tmpz[unp+j] = work_particles[j].z;
				*/

			/*
			 * resize memory
			 */
		    np = np-numsend+numrecv;
		}
	} while(commsize != 0);
    if(myrank == 0) printf("  CPU(migrate) %G \n",ctimes()-sstep);
	/*
	free(tmpz);
	*/
	particles = (basicparticletype *) 
				resizelast(particles,(np)*sizeof(basicparticletype));

fprintf(stderr,"P%d contains %d particles after sort\n",myrank,np);

	qsort(particles,np,sizeof(basicparticletype),sortindx);

/* Use the simpler heapsort to save memory */

/*
	hpsort((np),particles-1);
*/
	{
		int imin, imax;

		imin = particles[0].indx;
		imax = particles[0].indx;
		for(i=0; i<np; i++) {
			if( particles[i].indx > imax ) imax = particles[i].indx;
			if( particles[i].indx < imin ) imin = particles[i].indx;
		}	
		fprintf(stderr,"P%d imin %d imax %d\n",myrank,imin,imax);
	}

	TIMER_STOP(99);
	if(myrank == 0)
		fprintf(stdout,"CPU(migrate.indx) = %g \n",ELAPSED_TIME(99));
}

int sortindx(basicparticletype *a,basicparticletype *b)
{
	if(a->indx > b->indx) return +1;
	if(a->indx < b->indx) return -1;
	return 0;
}

void hpsort(int n, basicparticletype *ra)
{
    int i,ir,j,l;
    basicparticletype rra;

    if (n < 2) return;
    l=(n >> 1)+1;
    ir=n;
    for (;;) {
        if (l > 1) {
            rra=ra[--l];
        } else {
            rra=ra[ir];
            ra[ir]=ra[1];
            if (--ir == 1) {
                ra[1]=rra;
                break;
            }
        }
        i=l;
        j=l+l;
        while (j <= ir) {
            if (j < ir && ra[j].indx < ra[j+1].indx) j++;
            if (rra.indx < ra[j].indx) {
                ra[i]=ra[j];
                i=j;
                j <<= 1;
            } else j=ir+1;
        }
        ra[i]=rra;
    }
}
