/* My GOTPM code using the tree corrections developed by Juhan Kim
 * =======================================================================
 * It is in an interim code for the 4096^3 particle simulations at PSC.
 ***************************************************************************
 * In mytreecorrection, there is no preprocessor for the sake of simplicity.
 * parpmseed_force.F is not yet implemented into namu.c
 ***************************************************************************
 * Comparison to the original code has been checked with a success. 
 * (Jan. 17th 2006)
 * Time evolution has been checked ? (Jan. 18th 2006)
 * FoF group test has been passed ? (Jan. 19th 2006)
 * FoF mass function has been checked when z=0 (Mar. 12th 2006)
 * Simulated matter power spectrum has been checked when z=0 & z=47 
 * (Mar. 13th 2006)
 */
#include<stdio.h>
#include<math.h>
#include<mpi.h>
#include<stddef.h>
#include <stdlib.h>
#include<sys/times.h>
#include "pmheader.h"
#include "common_simparam.h"
#include "pm_common.h"
#include "Memory.h"
#include "varpm.h"
#include <srfftw_mpi.h>

#define MAXINHOMO 0.2 /* in % */
#define getsign(i) ((i)>0? 1:-1)
#define max(A,B) ( (A) > (B) ? (A) : (B) )
#define min(A,B) ( (A) < (B) ? (A) : (B) )
#define pow2(A) ( (A)*(A))
#define pow3(A) ( (A)*(A)*(A))
void migrate(size_t *,int ,float,float);
int flagpsmeasure(float , float , float ,int );
int flagsyncwholeden(float , float , float );
float cputime0[100],cputime1[100];
float gettime(),elapsedtime,treetime;

void pm(int, int, int, int, int, int);
int nxpos,nsizepmparticletype;
int nlzfloor,nlzceil,local_nz_varpm;
float lzfloor,lzceil;
int now,nowflag;
int myid,nid;
float omep,omeplam,size,astep,zi,omei,redshift,hubble;
float zheight,zstart,kenold;
float poten;
float *den,*fftwmesh;
int iseed,local_z_start,local_ny_after_transpose;
int local_y_start_after_transpose,total_local_size;
int stepcount;
int nforcepos;
float pmas;

float pfact,fact1,fact2;
float nextastep;
int nstep=0;
void jwrite(int );
int syncflag;
typedef struct HALF{
	int first,second;
}HALF;
HALF halfstep;

#define DomainDecomp {\
	int npmin,npmax,npav;\
	long nptot,lnp;\
	float ratio1,ratio2;\
	lnp = np;\
	MPI_Reduce(&lnp,&nptot,1,MPI_LONG,MPI_SUM,0,MPI_COMM_WORLD);\
	if(myid==0) npav = nptot/nid;\
	MPI_Bcast(&npav,1,MPI_INT,0,MPI_COMM_WORLD);\
	MPI_Reduce(&np,&npmin,1,MPI_INT,MPI_MIN,0,MPI_COMM_WORLD);\
	MPI_Reduce(&np,&npmax,1,MPI_INT,MPI_MAX,0,MPI_COMM_WORLD);\
	MPI_Bcast(&npmin,1,MPI_INT,0,MPI_COMM_WORLD);\
	MPI_Bcast(&npmax,1,MPI_INT,0,MPI_COMM_WORLD);\
	ratio1 = (float)(npav-npmin)/(float)npav*100.;\
	ratio2 = (float)(npmax-npav)/(float)npav*100.;\
	if(myid==0)printf("The inhomogeneities are %g %g\n",ratio1,ratio2);\
	if(ratio1 > MAXINHOMO || ratio2 > MAXINHOMO) {\
		long tnp,lnp;\
		float zmin,zmax;\
		int mydomaindecomposition(pmparticletype *, int ,long ,\
				        float ,float , float *, float *,int );\
		TIMER_START(39)\
		lnp = np;\
		MPI_Reduce(&lnp,&tnp,1,MPI_LONG,MPI_SUM,0,MPI_COMM_WORLD);\
		MPI_Bcast(&tnp,1,MPI_LONG,0,MPI_COMM_WORLD);\
		zmin = zstart; zmax = zstart+zheight;\
		np= mydomaindecomposition(pmparticles, np,tnp,zmin,zmax, &zmin, &zmax,nz);\
		zstart = zmin; zheight = zmax-zmin;\
		TIMER_STOP(39);\
       	if(myid==0) fprintf(stdout,"DomainDecomp. CPU= %f \n", ELAPSED_TIME(39));\
	}\
}


#ifdef INCLUDE_TREE_FORCE
    static float efold=0.9;
#else
    static float efold = 0.5;
#endif
void Savingalldata(){
	int suddenstop;
	suddenstop = flagsuddenstop(stepcount+1);
	/*
	if( elapsedtime > maxtime|| stepcount%2000 == 0 || suddenstop) {
	*/
	if( elapsedtime > maxtime|| suddenstop) {
		delta_a = astep;
		jwrite(stepcount+1);
		if(elapsedtime > maxtime || suddenstop == 1) {
			MPI_Finalize();exit(0);
		}
	}
	/*
	if(flagsuddenstop(stepcount+1)) suddenstop = 1;
	else suddenstop = 0;
	if( elapsedtime > maxtime|| stepcount%2000 == 0 || suddenstop) {
		if() MPI_Finalize();exit(0);
	}
	*/
}
void SaveWholeDen(float *fftwmesh,int nx,int ny,int nz,int local_nz,
		int myid,int nid, int stepcount, float amax,float a){
	int i,j,k;
	int ii,niter,slicepixel;
	FILE *fp;
	char filename[100];
	MPI_Status status;
	float *tmpden;
	sprintf(filename,"WholeDen.%.5d",stepcount);
	slicepixel = 2*(nx/2+1)*ny;
	if(myid==0){
		fp = fopen(filename,"w");
		fwrite(&amax,sizeof(float),1,fp);
		fwrite(&a,sizeof(float),1,fp);
		fwrite(&omep,sizeof(float),1,fp);
		fwrite(&omegabaryon,sizeof(float),1,fp);
		fwrite(&omeplam,sizeof(float),1,fp);
		fwrite(&hubble,sizeof(float),1,fp);
		fwrite(&bias_8mpc,sizeof(float),1,fp);
		fwrite(&size,sizeof(float),1,fp);
		fwrite(&nx,sizeof(int),1,fp);
		fwrite(&ny,sizeof(int),1,fp);
		fwrite(&nz,sizeof(int),1,fp);
		fwrite(fftwmesh,sizeof(float),2*(nx/2+1)*ny*local_nz,fp);
		tmpden = (float*)Malloc(sizeof(float)*slicepixel,PPTR(tmpden));
		for(i=1;i<nid;i++){
			MPI_Recv(&niter,1,MPI_INT,i,i,MPI_COMM_WORLD,&status);
			for(j=0;j<niter;j++){
				MPI_Recv(tmpden,slicepixel,MPI_FLOAT,i,j,MPI_COMM_WORLD,
						&status);
				fwrite(tmpden,sizeof(float),slicepixel,fp);
			}
		}
		fclose(fp);
		Free(tmpden);
	}
	else {
		MPI_Send(&local_nz,1,MPI_INT,0,myid,MPI_COMM_WORLD);
		for(i=0;i<local_nz;i++)
			MPI_Send(fftwmesh+i*slicepixel,slicepixel,MPI_FLOAT,0,i,
					MPI_COMM_WORLD);		
	}

}

/*
void SaveWholeDen(float *fftwmesh,int nx,int ny,int nz,int local_nz,
		int myid,int nid, int stepcount, float amax,float a){
	int i,j,k;
	int ii;
	FILE *fp;
	char filename[100];
	sprintf(filename,"WholeDen.%.5d",stepcount);
	for(ii=0;ii<nid;ii++){
		if(ii == myid){
			if(myid ==0)  fp = fopen(filename,"w");
			else fp = fopen(filename,"a");
			if(myid == 0) {
				fwrite(&amax,sizeof(float),1,fp);
				fwrite(&a,sizeof(float),1,fp);
				fwrite(&omep,sizeof(float),1,fp);
				fwrite(&omegabaryon,sizeof(float),1,fp);
				fwrite(&omeplam,sizeof(float),1,fp);
				fwrite(&hubble,sizeof(float),1,fp);
				fwrite(&bias_8mpc,sizeof(float),1,fp);
				fwrite(&size,sizeof(float),1,fp);
				fwrite(&nx,sizeof(int),1,fp);
				fwrite(&ny,sizeof(int),1,fp);
				fwrite(&nz,sizeof(int),1,fp);
			}
			fwrite(fftwmesh,sizeof(float),2*(nx/2+1)*ny*local_nz,fp);
			fclose(fp);
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}

}
*/

void tree2pmtype(int np){
	int i;
	for(i=0;i<np;i++){
		pmparticles[i].x = treeparticles[i].x;
		pmparticles[i].y = treeparticles[i].y;
		pmparticles[i].z = treeparticles[i].z;
		pmparticles[i].vx = treeparticles[i].vx;
		pmparticles[i].vy = treeparticles[i].vy;
		pmparticles[i].vz = treeparticles[i].vz;
#ifdef INDEX
		pmparticles[i].indx = treeparticles[i].indx;
#endif
	}
	pmparticles = (pmparticletype*)Realloc(pmparticles,sizeof(pmparticletype)*np);
}
void pm2treetype(int np){
	int i;
	pmparticles = (pmparticletype*)Realloc(pmparticles,sizeof(treeparticletype)*np);
	for(i=np-1;i>=0;i--){
#ifdef INDEX
		treeparticles[i].indx = pmparticles[i].indx;
#endif
		treeparticles[i].vz = pmparticles[i].vz;
		treeparticles[i].vy = pmparticles[i].vy;
		treeparticles[i].vx = pmparticles[i].vx;
		treeparticles[i].z = pmparticles[i].z;
		treeparticles[i].y = pmparticles[i].y;
		treeparticles[i].x = pmparticles[i].x;
	}
}
void Savexzslice(float *sden,int nx,int ny,int nz,int local_nz, int myid,int nid,
		int stepcount){
	char filename[100];
	FILE *fp;
	float *tden,*allden;
	int i,j,k,ii,mx,slocal_nz;
	int offset;
	MPI_Status status;
	sprintf(filename,"xzslice.%.5d",stepcount);
	mx = 2*(nx/2+1);
	{
		if(local_nz)
			tden = (float*)Malloc(sizeof(float)*nx*local_nz,PPTR(tden));
		for(i=0;i<nx*local_nz;i++) tden[i] = 0.;
		for(k=0;k<local_nz;k++) for(j=0;j<3;j++)for(i=0;i<nx;i++)
			tden[i+nx*k] += sden[i+mx*(j+ny*k)];

	}
	if(myid==0){
		allden=(float*) Malloc(sizeof(float)*nx*nz,PPTR(allden));
		for(i=0;i<nx*local_nz;i++) allden[i] = tden[i];
		offset=local_nz*nx;
		for(i=1;i<nid;i++){
			MPI_Recv(&slocal_nz,1,MPI_INT,i,0,MPI_COMM_WORLD,&status);
			MPI_Recv(allden+offset,
					slocal_nz*nx,MPI_FLOAT,i,1,MPI_COMM_WORLD,&status);
			offset += slocal_nz*nx;
		}
		fp=fopen(filename,"w");
		fwrite(&nx,sizeof(int),1,fp);
		fwrite(&nz,sizeof(int),1,fp);
		fwrite(allden,sizeof(float),nx*nz,fp);
		fclose(fp);
		Free(allden);
	}
	else {
		MPI_Send(&local_nz,1,MPI_INT,0,0,MPI_COMM_WORLD);
		MPI_Send(tden,local_nz*nx,MPI_FLOAT,0,1,MPI_COMM_WORLD);
	}
	/*
	for(ii=0;ii<nid;ii++){
		if(myid == ii){
			if(myid == 0){
				fp = fopen(filename,"w");
				fwrite(&nx,sizeof(int),1,fp);
				fwrite(&nz,sizeof(int),1,fp);
			}
			else fp = fopen(filename,"a");
			fwrite(tden,sizeof(float),nx*local_nz,fp);
			fflush(fp);
			fclose(fp);
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}
	*/
	if(local_nz) Free(tden);
}
void Savexyslice(float *sden,int nx,int ny,int nz,int myid,int stepcount){
	char filename[100];
	float *tden;
	FILE *fp;
	int i,j,k,mx;
	int npix;
	if(myid == 0){
		mx = 2*(nx/2+1);
		sprintf(filename,"xyslice.%.5d",stepcount);
		fp = fopen(filename,"w");
		fwrite(&nx,sizeof(int),1,fp);
		fwrite(&ny,sizeof(int),1,fp);
		tden = (float *)Malloc(sizeof(float)*nx*ny,PPTR(tden));
		/*
		for(i=0;i<nx*ny;i++) tden[i] = 0.;
		for(k=0;k<3;k++) for(j=0;j<ny;j++) for(i=0;i<nx;i++)
				tden[i+nx*j] += sden[i+mx*(j+ny*k)];
		fwrite(tden,sizeof(float),nx*ny,fp);
		*/
		for(k=0;k<4;k++) {
			for(j=0;j<ny;j++) for(i=0;i<nx;i++){
				npix = i+mx*(j+ny*k);
				tden[i+nx*j] = sden[npix];
			}
			fwrite(tden,sizeof(float),nx*ny,fp);
		}
		fflush(fp);
		fclose(fp);
		Free(tden);
	}
}
/*
void main(int argc, char *argv[]){
*/
void MAIN_(int argc, char *argv[]){
	int i,j,k;
	int nx, ny, nz, local_nz;
	int nspace;
	int ierror=1, iwrite=0, icont;
    char c;
	int memflag, InitializeBigMemory();
	FILE *simfile;
	rfftwnd_mpi_plan plan,iplan;

	MPI_Init(&argc,&argv);
	MPI_Comm_rank(MPI_COMM_WORLD,&myid);
	MPI_Comm_size(MPI_COMM_WORLD,&nid);

	if( argc == 3 ) {
		if( !(simfile = fopen(argv[1],"r")) ) {
		    fprintf(stderr,"Can't open %s - exiting\n",argv[1]);
			MPI_Finalize();
			exit(0);
		}
		maxtime = atof(argv[2]);
   	}
	else {
		fprintf(stderr,"usage: pyul paramsfile maximum_run_time\n");
		MPI_Finalize();
		exit(0);
	}
	{
		/* reading parameters */
		ReadSimulationParameters(simfile,&icont);
		nx = nxmesh; ny = nymesh; nz = nzmesh;
		nspace = nspace0;
		rth = rtophat_mesh;
		omep = omega;
		omeplam = lambda;
		kenold = ken;
		size = boxsize_hinv_mpc;
		iseed = seed;
		hubble = hubble_parameter;
		amax = 1.0 + z_init;
		astep = delta_a;
		zi = amax - 1.;
	    omei = omep*pow3(1.+zi)/
        	(omep*pow3((1.+zi))+omeplam+(1.-omep-omeplam)*pow2((1.+zi)));
	    redshift = amax/a - 1.0;
	}
#if defined(_OPENMP)
	fflush(stdout);
	MPI_Barrier(MPI_COMM_WORLD);
	if(myid==0){
		printf("##################### OpenMP Setting ##################\n");
		fflush(stdout);
	}
	MPI_Barrier(MPI_COMM_WORLD);
#pragma omp parallel
	{
		if(omp_get_thread_num_())
			printf("P%d has %d threads\n",myid,omp_get_num_threads());
		fflush(stdout);
	}
	fflush(stdout);
	MPI_Barrier(MPI_COMM_WORLD);
	if(myid==0){
		printf("#######################################################\n");
		fflush(stdout);
	}
#endif


	if(Make_Total_Memory() == 0 ){
		fprintf(stderr,"Can't initialize memory - aborting job\n");
		MPI_Finalize();
		exit(0);
	}
	{
		/* determining local_nz for fftw */
		fftwinit_(&nx,&ny,&nz,&local_nz,&local_z_start);
		printf("P%d local_domain %d : %d\n",myid,local_z_start,local_nz);
	}

	fprintf(stderr,"icont %d\n",icont);
	iwrite = 0;
	if( icont == 0 ) { iwrite = 1; }

	nxpos = (int)offsetof(pmparticletype,x) /sizeof(float);
	nsizepmparticletype = (int)sizeof(pmparticletype) /sizeof(float);

	zheight = (float) local_nz;
	zstart = (float) local_z_start;
	fda4sup_(&nx,&ny,&nz, &local_nz);
	/* PMSEED */
	if(icont ==0){
		float *fx,*fy,*fz,*denpmseedpad;
		float *ffx,*ffy,*ffz;
		{
			int densize;
			int izstart,izwidth,nadd,nzparticles,nzprefixel;
			float *pvmesh;
			float zfinal,vamp,zstartpos,omei;
			zheight = (float)nz/(float)nid; /*equal slab width */
			zstart = zheight*myid;
			zfinal = zheight*(myid+1);
			zheight = zfinal-zstart;

			izstart = (int)zstart;
			izwidth = ceil(zstart+zheight)-izstart;

			nzparticles = 0;
			zstartpos = 2*nz;
			for(i=0;i<nz;i+=nspace){
				if((float)i>=zstart && (float)i<(zstart+zheight)) {
					nzparticles ++;
					zstartpos=min(zstartpos,(float)i);
				}
			}
			nzprefixel = zstartpos-izstart;

			printf("P%d: %g %g nzzzz: %d %d %g\n",myid,zstart,zstart+zheight,
					nzparticles,nzprefixel,zstartpos);

			densize = 2*(nx/2+1)*ny*(local_nz+0);
			if(densize==0) densize=10;
			den=(float*) Malloc(sizeof(float)*densize, PPTR(den));
			denpmseedpad = (float *) Malloc(2*ny*nz*sizeof(float),PPTR(denpmseedpad));
#ifdef PMSEEDFORCE
			fx = (float*) Malloc(sizeof(float)*densize,PPTR(fx));
			fy = (float*) Malloc(sizeof(float)*densize,PPTR(fy));
			fz = (float*) Malloc(sizeof(float)*densize,PPTR(fz));
			pmseedforce_(&np,pmparticles,&nsizepmparticletype,&nxpos,den,
					&omep,&omeplam,&kenold,denpmseedpad,&zstart,&zheight,&vamp,&omei,
					fx,fy,fz);
			Free(den); /* Now free den in the pmseedforce */
#else
			pmseed_(&np,pmparticles,&nsizepmparticletype,&nxpos,den,
					&omep,&omeplam,&kenold,denpmseedpad,&zstart,&zheight,&vamp,&omei);
#endif
			Free(denpmseedpad);

			zfinal = zstart+zheight;
#ifdef PMSEEDFORCE
			ffx = (float*)Malloc(sizeof(float)*2*(nx/2+1)*ny*
					(ceil(zstart+zheight)-(int)zstart+1),PPTR(ffx));
			MPI_Barrier(MPI_COMM_WORLD);
			if(myid==0) printf("Now passing fda4 mesh for fx\n");
			adVarPM_fda4_mesh(fx,local_nz,local_z_start,ffx,zstart,zfinal,nx,ny,nz);
			Free(fx);
			ffy = (float*)Malloc(sizeof(float)*2*(nx/2+1)*ny*
					(ceil(zstart+zheight)-(int)zstart+1),PPTR(ffy));
			MPI_Barrier(MPI_COMM_WORLD);
			if(myid==0) printf("Now passing fda4 mesh for fy\n");
			adVarPM_fda4_mesh(fy,local_nz,local_z_start,ffy,zstart,zfinal,nx,ny,nz);
			Free(fy);
			ffz = (float*)Malloc(sizeof(float)*2*(nx/2+1)*ny*
					(ceil(zstart+zheight)-(int)zstart+1),PPTR(ffz));
			MPI_Barrier(MPI_COMM_WORLD);
			if(myid==0) printf("Now passing fda4 mesh for fz\n");
			adVarPM_fda4_mesh(fz,local_nz,local_z_start,ffz,zstart,zfinal,nx,ny,nz);
			Free(fz);
#else
			pvmesh = (float *)
				Malloc(sizeof(float)*2*(nx/2+1)*ny*(ceil(zstart+zheight)-(int)zstart+4),
					PPTR(pvmesh));
			adVarPM_fda4_mesh(den,local_nz,local_z_start,pvmesh,zstart,zfinal,nx,ny,nz);
			Free(den);
			paddingpotentialmesh(pvmesh,izstart,izwidth,izwidth,nx,ny,nz,-2,2);
#endif
			{
				long nmax;
				nmax = freespace()/sizeof(pmparticletype) - 32L;
				pmparticles=(pmparticletype*) Malloc(sizeof(pmparticletype)*nmax,
						PPTR(pmparticles));
				if(myid==0) printf("Now P%d has maximum %ld particles\n",myid,nmax);
			}
#ifdef PMSEEDFORCE
			setboundaryparticlesforce_(&np,pmparticles,&nsizepmparticletype,&nxpos,
					&nzparticles,&zstartpos,&nzprefixel,&omep,&omeplam,
					&ken,&zstart,&zheight,&vamp,&nspace,&omei,&amax,ffx,ffy,ffz);
			if(myid==0) printf("Now passing boundaryparitlces\n");
#else
			setboundaryparticles_(&np,pmparticles,&nsizepmparticletype,&nxpos,
					&nzparticles,&zstartpos,&nzprefixel,&omep,&omeplam,
					&ken,pvmesh,&zstart,&zheight,&vamp,&nspace,&omei,&amax);
#endif

			pmparticles=(pmparticletype*) Realloc(pmparticles,
						sizeof(pmparticletype)*np);
			printf("P%d %g %g %g\n",myid,pmparticles[0].x,pmparticles[0].y,pmparticles[0].z);
			{ size_t sizetnp; sizetnp=np;
				migrate(&sizetnp,nz,zheight,zstart);
				np = sizetnp;
			}
			{/* Maximize the number of pmparticles */
				size_t nmax;
				nmax = freespace()/sizeof(pmparticletype) - 32L;
				pmparticles=(pmparticletype*) Realloc(pmparticles,
						sizeof(pmparticletype)*(np+nmax));
			}
#ifdef PMSEEDFORCE
			{
				pmvrparticletype *pvr;
				int nnp;
				pvr = (pmvrparticletype *)((pmparticletype*)(pmparticles+np));
				nnp = 0;
				getinnerparticlesforce_(&nnp,pvr,&nsizepmparticletype,&nxpos,
						&nzparticles,&zstartpos,&nzprefixel,&omep,&omeplam,
						&ken,&zstart,&zheight,&vamp,&nspace,&omei,&amax,
						ffx,ffy,ffz);
				Free(ffz);Free(ffy);Free(ffx);
				pmparticles=(pmparticletype*) Realloc(pmparticles,
						sizeof(pmparticletype)*(np+nnp));
				/* This is needed because the address of pvr has changed due to the
				 * Free(ff?) */
				pvr = (pmvrparticletype *)((pmparticletype*)(pmparticles+np));
				for(i=nnp-1;i>=0;i--){ /* copy in reverse order to prevent overwriting */
					pmparticles[i+np].vz = pvr[i].vz;
					pmparticles[i+np].vy = pvr[i].vy;
					pmparticles[i+np].vx = pvr[i].vx;
				}
				setinnerparticlesforce_(&np,pmparticles,&nsizepmparticletype,&nxpos,
						&nzparticles,&zstartpos,&nzprefixel,&omep,&omeplam,
						&ken,&zstart,&zheight,&vamp,&nspace,&omei,&amax);
			}
#else
			setinnerparticles_(&np,pmparticles,&nsizepmparticletype,&nxpos,
					&nzparticles,&zstartpos,&nzprefixel,&omep,&omeplam,
					&ken,pvmesh,&zstart,&zheight,&vamp,&nspace,&omei,&amax);
			Free(pvmesh);
#endif
			pmparticles=(pmparticletype*)Realloc(pmparticles,
					sizeof(pmparticletype)*np);
		}
		/*
		lzfloor = local_z_start; lzceil = local_z_start + local_nz;
		*/
		now = 0;
		nowflag = 0;
		{ size_t sizetnp; sizetnp=np;
			migrate(&sizetnp,nz,zheight,zstart);
			np = sizetnp;
		}
        if( myid == 0 ) {
			pmparticletype *bp;
			bp = pmparticles;
			fprintf(stderr,"after migrate\n");
			fprintf(stderr,"P%d particle0 is %g %g %g %g %g %g\n", myid,
				bp->x, bp->y, bp->z, bp->vx, bp->vy, bp->vz);
		}
		{
			long lnp,tlnp;
			lnp = (long ) np;
			MPI_Reduce(&lnp,&tlnp,1,MPI_LONG,MPI_SUM,0,MPI_COMM_WORLD);
			if(myid == 0) fprintf(stderr,"Total particle number : %ld\n",tlnp);
		}
	}
	else if(icont ==1){
		int nmax;
		nmax = freespace()/sizeof(pmparticletype)-1000L;
		pmparticles = (pmparticletype *)Malloc(sizeof(pmparticletype)*nmax,
				PPTR(pmparticles));
		jread();
		pmparticles = (pmparticletype *)Realloc(pmparticles,np*sizeof(pmparticletype));
		{ size_t sizetnp; sizetnp=np;
			migrate(&sizetnp,nz,zheight,zstart);
			np = sizetnp;
		}
	}
	printf("P%d has %d %d %d\n",myid,stepcount,stepnum,nstep);
	{
		long tlnp,lnp;
		float rngc;
		rngc = (float)nx*(float)ny*(float)nz;
		lnp = (long ) np;
		MPI_Reduce(&lnp,&tlnp,1,MPI_LONG,MPI_SUM,0,MPI_COMM_WORLD);
		MPI_Bcast(&tlnp,1,MPI_LONG,0,MPI_COMM_WORLD);
		pmas = rngc/(float)tlnp;

	}
	/*
	 *  Cell positions run from 0 to n-1 while particle positions
	 *  run from 0 to n
	 *  (xp,yp,zp) = particle position
	 *  CPU : Scalar (1.84), Vector (1.02,8.1,65) for ng = 32,64,128
	 *  */
/* MAIN TIME LOOP FOR SIMULATION */
	/* nzheight : variable width == local_nz_varpm
	 * local_nz : fftw width */
	for(stepcount=stepnum; stepcount<=nstep; stepcount++) {
		int nzheight;
		if(myid==0) fprintf(stderr,"Now in the position of stack =%d\n",CurMemStack());
		TIMER_START(51);
		lzfloor = zstart; lzceil = zstart+zheight;

		nzheight = ceil(lzceil) - (int)lzfloor;
		printf("P%d has np=%d %d from %g to %g and local_z_start=%d local_nz=%d\n",myid,np,
				nzheight,lzfloor,lzceil,local_z_start,local_nz);
		{
			float maxd;
			void CObs0ExtractingLightConeParticles(pmparticletype *, int ,int ,int ,int , 
					int , float , float , float ,float , float , float ,float ,
					float ,int ,int ,float );
			void Obs0ExtractingLightConeParticles(pmparticletype *, int ,int ,int ,int , 
					int , float , float , float ,float , float , float ,float ,
					float ,int ,int ,float );
			void Obs1ExtractingLightConeParticles(pmparticletype *, int ,int ,int ,int , 
					int , float , float , float ,float , float , float ,float ,
					float ,int ,int ,float );
			void Obs2ExtractingLightConeParticles(pmparticletype *, int ,int ,int ,int , 
					int , float , float , float ,float , float , float ,float ,
					float ,int ,int ,float );
			void Obs3ExtractingLightConeParticles(pmparticletype *, int ,int ,int ,int , 
					int , float , float , float ,float , float , float ,float ,
					float ,int ,int ,float );
			void Obs4ExtractingLightConeParticles(pmparticletype *, int ,int ,int ,int , 
					int , float , float , float ,float , float , float ,float ,
					float ,int ,int ,float );
			void Obs5ExtractingLightConeParticles(pmparticletype *, int ,int ,int ,int , 
					int , float , float , float ,float , float , float ,float ,
					float ,int ,int ,float );
			void Obs6ExtractingLightConeParticles(pmparticletype *, int ,int ,int ,int , 
					int , float , float , float ,float , float , float ,float ,
					float ,int ,int ,float );
			void Obs7ExtractingLightConeParticles(pmparticletype *, int ,int ,int ,int , 
					int , float , float , float ,float , float , float ,float ,
					float ,int ,int ,float );
			void PSliceExtractingLightConeParticles(pmparticletype *, int ,int ,int ,int , 
					int , float , float , float ,float , float , float ,float ,
					float ,int ,int ,float );
			void PBeamExtractingLightConeParticles(pmparticletype *, int ,int ,int ,int , 
					int , float , float , float ,float , float , float ,float ,
					float ,int ,int ,float );
			nextastep = astep;
			maxd = 0.1*nspace;
			TIMER_START(82);
			CObs0ExtractingLightConeParticles(pmparticles, np,nx,ny,nz, stepcount, 
						amax, a, astep,nextastep, size, omep,omeplam,hubble,
						myid,nid,maxd);
			Obs0ExtractingLightConeParticles(pmparticles, np,nx,ny,nz, stepcount, 
						amax, a, astep,nextastep, size, omep,omeplam,hubble,
						myid,nid,maxd);
			Obs1ExtractingLightConeParticles(pmparticles, np,nx,ny,nz, stepcount, 
						amax, a, astep,nextastep, size, omep,omeplam,hubble,
						myid,nid,maxd);
			Obs2ExtractingLightConeParticles(pmparticles, np,nx,ny,nz, stepcount, 
						amax, a, astep,nextastep, size, omep,omeplam,hubble,
						myid,nid,maxd);
			Obs3ExtractingLightConeParticles(pmparticles, np,nx,ny,nz, stepcount, 
						amax, a, astep,nextastep, size, omep,omeplam,hubble,
						myid,nid,maxd);
			Obs4ExtractingLightConeParticles(pmparticles, np,nx,ny,nz, stepcount, 
						amax, a, astep,nextastep, size, omep,omeplam,hubble,
						myid,nid,maxd);
			Obs5ExtractingLightConeParticles(pmparticles, np,nx,ny,nz, stepcount, 
						amax, a, astep,nextastep, size, omep,omeplam,hubble,
						myid,nid,maxd);
			Obs6ExtractingLightConeParticles(pmparticles, np,nx,ny,nz, stepcount, 
						amax, a, astep,nextastep, size, omep,omeplam,hubble,
						myid,nid,maxd);
			Obs7ExtractingLightConeParticles(pmparticles, np,nx,ny,nz, stepcount, 
						amax, a, astep,nextastep, size, omep,omeplam,hubble,
						myid,nid,maxd);
			PSliceExtractingLightConeParticles(pmparticles, np,nx,ny,nz, stepcount, 
						amax, a, astep,nextastep, size, omep,omeplam,hubble,
						myid,nid,maxd);
			PBeamExtractingLightConeParticles(pmparticles, np,nx,ny,nz, stepcount, 
						amax, a, astep,nextastep, size, omep,omeplam,hubble,
						myid,nid,maxd);
			TIMER_STOP(82);
			if(myid==0) fprintf(stdout,"Setting Observation CPU= %f \n", ELAPSED_TIME(82));
		}


		if(flagsyncwholeden(amax,a,astep)){
			halfstep.first = 1;
			halfstep.second = 0;
		}
		else {
			halfstep.first = halfstep.second=0;
		}
halfevolution:
		den = (float *) Malloc(((nzheight+4)*(2*(nx/2+1))*ny)*
				sizeof(float), PPTR(den));
		if(local_nz > 0) fftwmesh = (float *) Malloc(((local_nz+0)*(2*(nx/2+1))*ny)*
				sizeof(float),PPTR(fftwmesh));
		else fftwmesh = (float *) Malloc(sizeof(float),PPTR(fftwmesh));
		VarPM_tsc2(den,nx,ny,nz, lzfloor,lzceil, pmparticles,
				nsizepmparticletype,nxpos, np,pmas,
                fftwmesh, local_nz,local_z_start);
#ifdef SAVESLICE
		/*
		Savexyslice(fftwmesh,nx,ny,nz,myid,stepcount);
		*/
		Savexzslice(fftwmesh,nx,ny,nz,local_nz,myid,nid,stepcount);
#endif
		if(halfstep.first != 1 || halfstep.second !=1 ) 
			if(flagsyncwholeden(amax,a,astep))
				SaveWholeDen(fftwmesh,nx,ny,nz,local_nz,myid,nid, 
						stepcount,amax,a);
		fftforward_(fftwmesh);
		if(flagpsmeasure(amax,a,astep,stepcount)){
			FILE *fp;
			correl_(fftwmesh,&a,&nowflag,&now,&rth,&nstep);
		}
		psolver_(fftwmesh,&poten,&efold);
		fftbackward_(fftwmesh);
		{
			int nzfloor,izslice,izslicep1;
			lzfloor = zstart; lzceil = zstart+zheight;
			/* No buffer slab is needed */
			den = (float*)Realloc(den,nzheight*(2*(nx/2+1))*ny*sizeof(float));
			adVarPM_fda4_mesh(fftwmesh,local_nz,local_z_start,den,zstart,
					lzceil, nx,ny,nz);
			Free(fftwmesh);
			nzfloor = (int) zstart;
			local_nz_varpm = nzheight;

#ifdef MEMORY_DEFICIENT
			/*
			fda4inner_(pmparticles,&nsizepmparticletype,&nxpos,&np,den,
					&local_nz_varpm,&a,&astep,&nextastep,
					&amax,&omei,&omep,&omeplam,&pfact,&nlzfloor,
					&fact1,&fact2,&(halfstep.first),&(halfstep.second));
			for(i=-3;i<=4;i++){
				if(i==0) continue;
				else if(i<0) izslicep1 = i+1;
				else izslicep1 = local_nz_varpm+i;
				paddingonepotentialmesh(den,nzfloor,nzheight,local_nz_varpm,nx,ny,nz,
						i,getsign(i));
				fda4boundary_(pmparticles,&nsizepmparticletype,&nxpos,&np,
						&local_nz_varpm,&a,&astep,&nextastep,
						&amax,&omei,&omep,&omeplam,&pfact,&nlzfloor,
						&fact1,&fact2,&(halfstep.first),&(halfstep.second),&izslicep1);
			}
			*/
#else
			den = (float*)Realloc(den,sizeof(float)*2*(nx/2+1)*ny*(nzheight+7));
			/* This is for the padding of boundary slices */
			paddingpotentialmesh(den,nzfloor,nzheight,local_nz_varpm,nx,ny,nz,
					-3, 4);
			/*
			MPI_Barrier(MPI_COMM_WORLD);
			*/
        	fda4sup_(&nx,&ny,&nz,&local_nz_varpm);
			/* WARNING local_nz --> local_nz_varpm*/
			nlzfloor = lzfloor;
			fda4_(pmparticles,&nsizepmparticletype,&nxpos,&np,den,
					&local_nz_varpm,&a,&astep,&nextastep,
					&amax,&omei,&omep,&omeplam,&pfact,&nlzfloor,
					&fact1,&fact2,&(halfstep.first),&(halfstep.second));
#endif

		}
		Free(den);
		/* TREE FORCE CORRECTION */
		TIMER_START(59);
		{
			long nplong;
			float mass;
			float treecorrection(treeparticletype *, long,int,int,int,
					float,float,float,float,float,float,float);
			nplong = np;
			if(stepcount < 10) theta = 0.4;
			else if(stepcount < 20) theta = 0.4;
			else theta = 0.45;
			treeparticles = (treeparticletype *) pmparticles;
			pm2treetype(np);
			treetime=treecorrection(treeparticles,nplong, nx, ny, nz,
			  zstart,zheight, fact1, fact2, pfact,theta,(mass=nspace*nspace*nspace));
			tree2pmtype(np);
		}
		TIMER_STOP(59);
		if(myid==0) fprintf(stdout,"Treecorrectingtime CPU= %f \n", ELAPSED_TIME(59));
		if(halfstep.first==1 && halfstep.second==0) {
		/* Now positions and velocities of all simulation particles are 
		 * synchronized */
			char saveprefix[80],synchronizervprefix[80];
			strcpy(saveprefix,rvprefix);
			strcpy(synchronizervprefix,rvprefix);
			sprintf(rvprefix,"Sync%s",synchronizervprefix);

			/*
			HyperSort(&np,particles);
			*/
			delta_a = astep;
			jwrite(stepcount);
			strcpy(rvprefix,saveprefix);
		}
		if(halfstep.first==1 && halfstep.second==0) {
			halfstep.second = 1;
			goto halfevolution;
		}
		{
			void CObs0SavingLightConeData(pmparticletype *,int ,int ,int , int , int , 
					float , float , float ,float , float ,float , float ,float ,
					float, float ,int ,int);
			void Obs0SavingLightConeData(pmparticletype *,int ,int ,int , int , int , 
					float , float , float ,float , float ,float , float ,float ,
					float, float ,int ,int);
			void Obs1SavingLightConeData(pmparticletype *,int ,int ,int , int , int , 
					float , float , float ,float , float ,float , float ,float ,
					float, float ,int ,int);
			void Obs2SavingLightConeData(pmparticletype *,int ,int ,int , int , int , 
					float , float , float ,float , float ,float , float ,float ,
					float, float ,int ,int);
			void Obs3SavingLightConeData(pmparticletype *,int ,int ,int , int , int , 
					float , float , float ,float , float ,float , float ,float ,
					float, float ,int ,int);
			void Obs4SavingLightConeData(pmparticletype *,int ,int ,int , int , int , 
					float , float , float ,float , float ,float , float ,float ,
					float, float ,int ,int);
			void Obs5SavingLightConeData(pmparticletype *,int ,int ,int , int , int , 
					float , float , float ,float , float ,float , float ,float ,
					float, float ,int ,int);
			void Obs6SavingLightConeData(pmparticletype *,int ,int ,int , int , int , 
					float , float , float ,float , float ,float , float ,float ,
					float, float ,int ,int);
			void Obs7SavingLightConeData(pmparticletype *,int ,int ,int , int , int , 
					float , float , float ,float , float ,float , float ,float ,
					float, float ,int ,int);
			void PBeamSavingLightConeData(pmparticletype *,int ,int ,int , int , int , 
					float , float , float ,float , float ,float , float ,float ,
					float, float ,int ,int);
			void PSliceSavingLightConeData(pmparticletype *,int ,int ,int , int , int , 
					float , float , float ,float , float ,float , float ,float ,
					float, float ,int ,int);
			TIMER_START(82);
			CObs0SavingLightConeData(pmparticles,np,nx,ny, nz, stepcount, amax, 
					a, astep,nextastep, size, omei, omep,omegabaryon,
					omeplam,hubble,myid,nid);
			Obs0SavingLightConeData(pmparticles,np,nx,ny, nz, stepcount, amax, 
					a, astep,nextastep, size, omei, omep,omegabaryon,
					omeplam,hubble,myid,nid);
			Obs1SavingLightConeData(pmparticles,np,nx,ny, nz, stepcount, amax, 
					a, astep,nextastep, size, omei, omep,omegabaryon,
					omeplam,hubble,myid,nid);
			Obs2SavingLightConeData(pmparticles,np,nx,ny, nz, stepcount, amax, 
					a, astep,nextastep, size, omei, omep,omegabaryon,
					omeplam,hubble,myid,nid);
			Obs3SavingLightConeData(pmparticles,np,nx,ny, nz, stepcount, amax, 
					a, astep,nextastep, size, omei, omep,omegabaryon,
					omeplam,hubble,myid,nid);
			Obs4SavingLightConeData(pmparticles,np,nx,ny, nz, stepcount, amax, 
					a, astep,nextastep, size, omei, omep,omegabaryon,
					omeplam,hubble,myid,nid);
			Obs5SavingLightConeData(pmparticles,np,nx,ny, nz, stepcount, amax, 
					a, astep,nextastep, size, omei, omep,omegabaryon,
					omeplam,hubble,myid,nid);
			Obs6SavingLightConeData(pmparticles,np,nx,ny, nz, stepcount, amax, 
					a, astep,nextastep, size, omei, omep,omegabaryon,
					omeplam,hubble,myid,nid);
			Obs7SavingLightConeData(pmparticles,np,nx,ny, nz, stepcount, amax, 
					a, astep,nextastep, size, omei, omep,omegabaryon,
					omeplam,hubble,myid,nid);
			PBeamSavingLightConeData(pmparticles,np,nx,ny, nz, stepcount, amax, 
					a, astep,nextastep, size, omei, omep,omegabaryon,
					omeplam,hubble,myid,nid);
			PSliceSavingLightConeData(pmparticles,np,nx,ny, nz, stepcount, amax, 
					a, astep,nextastep, size, omei, omep,omegabaryon,
					omeplam,hubble,myid,nid);
			TIMER_STOP(82);
			if(myid==0) fprintf(stdout,"Saving Observation CPU= %f \n", ELAPSED_TIME(82));
		}

		/* One step forward with particle positions */
		{
			void onestepforwardposition_(pmparticletype*,int*,int*,int*,float *,
					int *, int *,int *, int *);
			onestepforwardposition_(pmparticles,&np,&nsizepmparticletype,
					&nxpos,&pfact,&nx,&ny,&nz,&stepcount);
		}
		TIMER_STOP(51);
		if(myid==0){
			pmparticletype *bp;
			bp = pmparticles;
			printf("+P%d %g %g %g %g %g %g\n",myid,bp->x,bp->y,bp->z,
					bp->vx,bp->vy,bp->vz);
		}
		{ size_t sizetnp; sizetnp=np;
			migrate(&sizetnp,nz,zheight,zstart);
			np = sizetnp;
		}

		if(myid==0) fprintf(stdout,"Step %d CPU= %f \n", stepcount,ELAPSED_TIME(51));
		if(myid==0){
			elapsedtime = gettime();
			fprintf(stderr,"Wallclock time %d = %g\n",stepcount,elapsedtime);
		}
		MPI_Bcast(&elapsedtime, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
		a += astep;
		Savingalldata();

		DomainDecomp;

	}



	MPI_Barrier(MPI_COMM_WORLD);
	MPI_Finalize();
	exit(0);
}

int ReadSimulationParameters(simfile,icont)
FILE *simfile;
int *icont;
{
        char filename[180];
	FILE *rvfile;
	int abortflag;

    /* Box size */
	fscanf(simfile,"%f %f\n",&boxsize_hinv_mpc,&hubble_parameter);

	/* Power Spectrum */
	fscanf(simfile,"%f %f %f %f %f %f\n",
           &npow0,&omega,&omegabaryon, &lambda,&bias_8mpc,&rsmooth);
 
	/* Mesh Parameters */
	fscanf(simfile,"%d %d %d %d\n",&nxmesh, &nymesh, &nzmesh,&nspace0);

    /* Tree parameters */
	fscanf(simfile,"%f %f %f\n",&SPHERE_RADIUS,&particle_radius,&theta);
	L = nxmesh; /* Set L parameter */
	L2 = L*L;
		 
	/* Time Parameters */
	fscanf(simfile,"%f %f %f\n",&z_init,&delta_a,&a);
	amax = 1.0 + z_init;

	/* Stepping Parameters */
	fscanf(simfile,"%d %d %d\n",&nstep,&stepnum,&nskip);
		 
	/* Negative integer for random number generator for initial conditions */
    fscanf(simfile,"%d\n",&seed);
		 
	rtophat_mesh = nxmesh/boxsize_hinv_mpc*8.0;

    /* RV file name*/
	fscanf(simfile,"%s %s\n",rvfilename, rvprefix);

    /* Energy parameters */
	fscanf(simfile,"%f %f %f %f\n",
		&ken, &ktot, &const0, &poten0);

    /* Camera file name */
	fscanf(simfile,"%s\n",camerafilename);

    fclose(simfile);

/* Ok now output to stdout to verify all is well */
	if( myid ==0 ) {
		fprintf(stdout,"*** INPUT PARAMETER LIST ***\n\n");
		fprintf(stdout,"*** Cosmological Parameters ***\n");
		fprintf(stdout,"Box size = %g hinv_Mpc   Hubble_parameter = %g\n",
			boxsize_hinv_mpc, hubble_parameter);
		fprintf(stdout,"npow = %g Omega = %g OmegaBaryon = %g Lambda = %g\nBias_8Mpc = %g Rsmooth = %g\n\n", npow0,omega,omegabaryon,lambda,bias_8mpc,rsmooth);
		
		fprintf(stdout,"\n*** Mesh Parameters ***\n");
		fprintf(stdout,"Nxmesh = %d Nymesh = %d Nzmesh = %d Spacing = %d\n\n",
				nxmesh,nymesh,nzmesh,nspace0);
		fprintf(stdout,"\n*** Tree Parameters ***\n");
		fprintf(stdout,"SPHERE_RADIUS = %g Theta = %g\n\n",SPHERE_RADIUS,theta);
		fprintf(stdout,"\n*** Time Parameters ***\n");
		fprintf(stdout,"Initial Redshift = %g Delta_a = %g Current a = %g\n\n",z_init,delta_a,a);
		fprintf(stdout,"\n*** Stepping Parameters ***\n");
		fprintf(stdout,"Nstep = %d Stepnum = %d Nskip = %d\n", 
			nstep,stepnum,nskip);
		fprintf(stdout,"Random Seed = %d\n\n",seed);
		fprintf(stdout,"Initial RV File %s  RV File Prefix %s\n\n",
			rvfilename,rvprefix);
	}
	fflush(stdout);

/* Check to see if the initial conditions file exists - if not then default to g   generating your own initial conditions */

	abortflag = 0;
	if( myid == 0 ) {

/* if strcmp() == 0 then string comparison is successful */
		if( strcmp(rvfilename,"INITIAL") == 0 ) {
			fprintf(stderr,"Generating Initial Conditions for run....\n");
			*icont = 0;
			a = 1.0;
		}
		else {
                        sprintf(filename,"%s%.5d",rvfilename,0);
			rvfile = fopen(filename,"r");
			if( rvfile == NULL ) {
				fprintf(stderr,"Can't open initial rvfile %s - exiting\n",	
					rvfilename);
				abortflag = 1;
			}	
			else { 
				fprintf(stderr,"Successfully opened rvfile %s - starting simulation\n",rvfilename);
				fclose(rvfile); 
				*icont = 1;
			}
		}
	}
	MPI_Bcast(&abortflag, 1, MPI_INT, 0, MPI_COMM_WORLD);
	if( abortflag ) {
		fprintf(stderr,"Aborting can't find initial rvfile\n");
		MPI_Finalize();
		exit(0);
	}

	MPI_Bcast(icont, 1, MPI_INT, 0, MPI_COMM_WORLD);
/* SAMPLE PARAMETER FILE 
 * 65 0.65
 * 1.0 0.3 0.7 1.0 0.0
 * 128 1
 * 4 1.0
 * 71 .10
 * 700 0 100
 * -1
 */
		 
}
			 
/* Initialization for power spectrum and initial condition generator */
			 
void getpowerparams_(nspace,size,amax,astep,npow,smooth,h,rth,bias,iseed,
		omepb)
int *nspace;
float *size, *amax, *astep;
float *npow;
int *iseed;
float *smooth, *h, *rth, *bias;
float *omepb;
{
 
     *nspace = nspace0;
     *size = boxsize_hinv_mpc;
     *amax = 1.0 + z_init;
     *astep = delta_a;
     *npow = npow0;
     *iseed = seed;
     *smooth = rsmooth;
     *h = hubble_parameter;
     *rth = rtophat_mesh;
     *bias = bias_8mpc;
	 *omepb = omegabaryon;
}
