#include<stdio.h>
#include<stdlib.h>
#include <math.h>
#include <mpi.h>
/*
#include "common_simparam.h"
#include "nrutil.h"
*/
#include "pmheader.h"
#include "Memory.h"
#define X0 0.234582747494050
#define Y0 0.438948474590104
#define Z0 0.762363272390401
#define MULTI 3
#define PI 3.1415926535
static float xo, yo, zo;
extern basicparticletype *particles;
extern int myrank,nrank;
/*
char *mymalloc();
*/
typedef struct _shellparticles{
	float x,y,z,vx,vy,vz;
} shellparticles;
void getpowerparams_();
int checkinside(int ,int ,int ,int , float ,float);
static float omega0,lambda0,redshift,H,astep,amax;
static float a;
typedef struct _box{
	int check;
} box;

/* here a is redshift */
float func1(float a){
	return 2997.92/sqrt((1.+a)*(1.+a)*(1.+a)*omega0
			+(1.+a)*(1.+a)*(1.-omega0-lambda0) +lambda0);
}
float qsimp(float (*func)(float),float,float);
float size;
/* the scale of this function  is based on pixel */
void z2comoving(float *R,float *dR,int nx){
	float initz = 0;
	float shellwidth;
	shellwidth = amax/(a+astep) - 1.;
	if(omega0 == 1.0){
		*R = 2.L*2997.92L*(1.-1./sqrt(1.+redshift));
		*dR = 2.L*2997.92L*(1.-1./sqrt(1.+shellwidth));
	}
	else { 
		*R = qsimp(func1,initz,redshift); 
		*dR = qsimp(func1,initz,shellwidth);
	}
	*R = *R/size*nx;
	*dR = *dR/size*nx;
	*dR = *R - *dR;
}
float selection(void){
	float result;
	result = 0.01;
	return result;
}
typedef struct _meshell{
	float n1,n2,n3;
	float n1nx, n2nx, n3nx;
	float n2L;
	float twoLn1,twoLn2,twoLn3;
} meshell;
/*
int np;
*/
void observer(int np,int nx,float A,float omega,float lambda,int nstep){
	int i,j,k,accept;
	shellparticles  *op,*pop;
	/* n1,n2,n3 is temporary arrays to accelerate computations */
	int nend;
	meshell *nn,*pnn;
	int width,nshellparticle;
	/* general properties of the simulation */
	int nspace,iseed;
	float npow;
	float smooth,h,rth,bias;

	float Redshift,dRedshift,R,dR,Rsq,dRsq;

	float tmpx,tmpy,tmpz,dist2,tmpr;
	int size_malloc;
	int init_nend;

	FILE *wp;
	char *filename;
	float omepb;

	xo = nx/2 + X0;
	yo = nx/2 + Y0;
	zo = nx/2 + Z0;
    if(myrank == 0) {
		printf("Entering observation mode\n");
		fflush(stdout);
	}

	/* reading simulation properties */
	getpowerparams_(&nspace,&size,&amax,&astep,&npow,&smooth,&h,&rth,
			&bias,&iseed,&omepb);
	a = A;
	Redshift = amax/a - 1.;
	omega0 = omega; lambda0 = lambda;redshift = Redshift;H = h;
	z2comoving(&R,&dR,nx);
	Rsq = R*R; dRsq = (R+dR)*(R+dR);
	/* making array for the periodic conditions */
	width = R/nx+1;
	/*
	nn = (meshell *) malloc(sizeof(float)*(2*width+1)*(2*width+1)*(2*width+1));
	*/
	init_nend = 100000;
	nn = (meshell *) Malloc(sizeof(meshell)*init_nend,PPTR(nn));
	nend = 0;
	pnn = nn;
	for(i=-width;i<=width;i++)
		for(j=-width;j<=width;j++)
			for(k=-width;k<=width;k++){
				accept = checkinside(i,j,k,nx,Rsq,dRsq);
				if(accept != 0){
					pnn->n1 = (float )i;
					pnn->n2 = (float )j;
					pnn->n3 = (float )k;
					pnn->n1nx = (float ) (i*nx);
					pnn->n2nx = (float ) (j*nx);
					pnn->n3nx = (float ) (k*nx);
					pnn->n2L = (float ) ((i*i+j*j+k*k)*nx*nx);
					pnn->twoLn1 = (float )(2*nx*i);
					pnn->twoLn2 = (float )(2*nx*j);
					pnn->twoLn3 = (float )(2*nx*k);
					nend++;pnn++;
					if(nend > (init_nend -100)){
						init_nend += 100;
						nn = Realloc(nn,init_nend*sizeof(meshell));
						if(nn == NULL){
							fprintf(stdout,"NO Space left for nn to alloc\n");
							fflush(stdout);
							MPI_Finalize();
							exit(0);
						}
					}
				}
			}
	/* setting for temporary particles to save */
	size_malloc = selection()*MULTI*4.*PI*R*R*dR/(nspace*nspace*nspace);
	op = (shellparticles *) Malloc(size_malloc *sizeof(shellparticles),
			PPTR(op));
	pop = op;
	if(myrank ==0){
		printf("%d rank has :",myrank);
	}
	nshellparticle = 0;
	for(i=0;i<np;i++){
		tmpx = (particles[i].x-xo);
		tmpy = (particles[i].y-yo);
		tmpz = (particles[i].z-zo);
		tmpr = tmpx*tmpx+tmpy*tmpy+tmpz*tmpz;
		for(j=0;j<nend;j++){
			dist2 = tmpr + nn[j].n2L
				+ nn[j].twoLn1*tmpx + nn[j].twoLn2*tmpy +nn[j].twoLn3*tmpz;
			if(dist2 > Rsq && dist2 <= dRsq ){
				pop->x = tmpx + nn[j].n1nx;
				pop->y = tmpy + nn[j].n2nx;
				pop->z = tmpz + nn[j].n3nx;
				pop->vx = particles[i].vx;
				pop->vy = particles[i].vy;
				pop->vz = particles[i].vz;
				nshellparticle++; pop++;
				if(myrank == 0){
					if(nshellparticle%100 == 0){
					printf("%10d",nshellparticle);
					for(k=0;k<10;k++)printf("\b");
					}
				}
			}
		}
	}
	if(myrank == 0) {
		printf("%d Finishing sorting particles: %d\n",myrank, nshellparticle);
		fflush(stdout);
	}

	pop = op;
	for(i=0;i<nrank;i++){
		sprintf(filename,"obshell.%.5d",nstep);
		MPI_Barrier(MPI_COMM_WORLD);
		if(i == myrank){
			if(myrank == 0){
				wp = fopen(filename,"wb");
			}
			else {
				wp = fopen(filename,"a+b");
			}
			/*
			for(j=0,pop=op;j<nshellparticle;j++,pop++){
				if(-20<pop->z && pop->z<20) fprintf(wp,"%g %g %g\n",
						pop->x,pop->y,pop->z);
			}
			*/
			for(j=0,pop=op;j<nshellparticle;j++,pop++)
				fwrite(pop,sizeof(shellparticles),nshellparticle,wp);
			fflush(wp); fclose(wp);
		}
	}
	Free(nn);
	Free(op);
	/*
	MPI_Finalize();
	exit(0);
	*/
}
/* scale of this function is based on pixel */
int checkinside(int i,int j,int k,int nx, float dist2,float ddist2){
	int local_nz,nz_width;
	int sx,sy,sz;
	int inside;
	box local_box[27];
	float tmpdist2;
	int mx,my,mz,mm,m;
	float dx[3],dy[3],dz[3];

	local_nz = nx/nrank*myrank;
	nz_width = nx/nrank;

	sx = i*nx; sy = j*nx; sz = k*nx + local_nz;
	dx[0] = sx;dy[0] = sy;dz[0] = sz;

	dx[1] = sx+xo; dy[1] = sy+yo; 

	if( local_nz < zo && zo < local_nz+nz_width) dz[1] = sz - local_nz + zo;
	else dz[1] = sz + ((float)nz_width)/2.;

	dx[2] = sx + nx;dy[2] = sy + nx;dz[2] = sz + nz_width;
	mm = 0;
	for(mx=0;mx<3;mx++)
		for(my=0;my<3;my++)
			for(mz=0;mz<3;mz++){
				tmpdist2 = (dx[mx]-xo)*(dx[mx]-xo)+(dy[my]-yo)*(dy[my]-yo)
					+(dz[mz]-zo)*(dz[mz]-zo);
				if(tmpdist2 <= ddist2) local_box[mm].check = 0;
				else local_box[mm].check = 1;
				mm ++;
			}

	for(m=0;m<27;m++){
		if(local_box[m].check == 0){
			for(mm=0;mm<27;mm++){
				if(local_box[mm].check == 1) {
					return 1;
				}
			}
		}
	}
	return 0;
}
#define EPS 1.0e-6
#define JMAX 20

float qsimp(float (*func)(float), float a, float b)
{
	float trapzd(float (*func)(float), float a, float b, int n);
	void nrerror(char error_text[]);
	int j;
	float s,st,ost,os;

	ost = os = -1.0e30;
	for (j=1;j<=JMAX;j++) {
		st=trapzd(func,a,b,j);
		s=(4.0*st-ost)/3.0;
		if (fabs(s-os) < EPS*fabs(os)) return s;
		os=s;
		ost=st;
	}
	nrerror("Too many steps in routine qsimp");
	return 0.0;
}
#undef EPS
#undef JMAX
/* (C) Copr. 1986-92 Numerical Recipes Software 71.+I0>+. */
#define FUNC(x) ((*func)(x))

float trapzd(float (*func)(float), float a, float b, int n)
{
	float x,tnm,sum,del;
	static float s;
	int it,j;

	if (n == 1) {
		return (s=0.5*(b-a)*(FUNC(a)+FUNC(b)));
	} else {
		for (it=1,j=1;j<n-1;j++) it <<= 1;
		tnm=it;
		del=(b-a)/tnm;
		x=a+0.5*del;
		for (sum=0.0,j=1;j<=it;j++,x+=del) sum += FUNC(x);
		s=0.5*(s+(b-a)*sum/tnm);
		return s;
	}
}
#undef FUNC
/* (C) Copr. 1986-92 Numerical Recipes Software 71.+I0>+. */
