#include "defs.h"
#include "extern.h"
#include<sys/times.h>
#include<srfftw_mpi.h>
#include"fortran.h"
#include "extern_simparam.h"
#include "pm_extern.h"
#include <stddef.h>
#include "./PREWORK/pre.h"
#include "./WORKNEW/hfind.h"
#include "glacial.h"
#ifdef VarPM
#include "varpm.h"
#include "slicemigrate.h"
#endif
#define pow2(A) ((A)*(A))
#define pow3(A) ((A)*(A)*(A))
#define EXIT(A) { MPI_Abort(MPI_COMM_WORLD,A); exit(A); }
#define MIN(a,b) ((a)<(b)? (a):(b))
#define MAX(a,b) ((a)>(b)? (a):(b))
float cputime0[100], cputime1[100];


/* These lines are for common of fortran */
struct common{
    float a;
	float kenold;
	float size;
    int iseed;
    float amax;
	float astep;
} ;
extern struct common seed2_;
/*
#if !defined (INDVEPS) && !defined(MULTIMASS)
int TreeCorrection(int *,basicparticletype *,float,float,float,float,float,int);
#elif MULTIMASS
int TreeCorrection(int *,basicparticletype *,float,float,float,float,int);
#else
int TreeCorrection(int *,basicparticletype *,float,float,float, int);
#endif
*/
int TreeCorrection();
int treecorrection(basicparticletype *, long,int,int,int,float,float,float,
		float,float,float);
void SaveSlice(float *,int ,int ,int ,int ,int );
void savexzslice(float *,int ,int ,int, int ,int , int );
void makexzslice_(float *,int *, int *, int *,int *,  float *);
void SaveWholeDen(float *,int ,int ,int,int , int ,int , int , float ,float ); 
void SaveFSlice(float *,int ,int ,int ,int ,int ,int);
void migrate(int *, int , float ,float);
void fmod_(int *,float *,float *, float *,basicparticletype *,int *,int *);

/* This structure CPU is for checkinCurMemStack(),np);g the ellapsed time */

/*         */
int wdata2disk(int ,int ,int ,int ,float ,float , float , float ,float ,
		float ,float ,float , float ,basicparticletype *, int ,int ,
	        int ,int );

float zheight, zstart, zfinal;
float ozheight, ozstart, ozfinal;
float EPSSQ;
int flagsuddenstop(int),flagwholeden(float,float,float);
int suddenstop;

/* PM main */
void pm(int icont, int iwrite, int nx, int ny, int nz, int local_nz)
{
	int i,j,k;
    int iseed;
	INT8 maxnp,minnp;
	INT8 lnp,tlnp;
	int nn;
	int ierror;
	int local_ny_after_transpose, local_y_start_after_transpose;
	int total_local_size,local_z_start;
	int nxpos,nforcepos;
	int movieflag;
    float kenold, size, amax, astep,nextastep;
	float work1;
	MPI_Status status;
	rfftwnd_mpi_plan plan,iplan;
	float pmas,pmass,corn1, epssq;
	int ng,mgz,ngz,ngh,nghp1,ngzc,mz;
	float rngx,rngy,rngz,rng,rngc,rngp6,rngm6,rngzc,pi,xyz;
	float omei,zi,zout1,zout2;
	float omep,omeplam;
	float tzero,tstep=0.,sstep=0.;
	int nspace,nowflag,now,stepcount;
	float poten,tken,kenata;
#ifdef PMSEEDFORCE
	float *fx,*fy,*fz;
#endif
	double kentmp;
	FILE *fp;
	int nmax;
	basicparticletype *bp;
	/* nxpos indicate the position of "x" variable in the particle structure */
	/* Its value is relevant to the Fortran array convention */
	float dzmax,tdzmax,Const,conserv;
	float redshift,pconv,vconv,ttime,std,pfact,dxda2;
	float fact1, fact2;
    int nwrite,nred,nred10,nred100,nred1000;
	/* This is for the grid force */
	float *forcearray,*den1,*den2,*swpden,*gridfx,*gridfy,*gridfz;
	float *denpmseedpad;
	int enoughspace;
	float *addspace;
	float gettime(), elapsedtime;
#ifdef INCLUDE_TREE_FORCE
	static float efold=0.9;
#else
	static float efold = 0.5;
#endif
#ifdef VarPM
	int nlzfloor, nlzceil,local_nz_den;
	float lzfloor, lzceil, *fftwmesh,*xzslice;
	/*
	ZBox *zbox;
	zbox = (ZBox *)Malloc(sizeof(ZBox)*nrank,PPTR(zbox));
	*/
#endif

	/* setting of nxpos */
	nxpos = (int)offsetof(basicparticletype,x) /sizeof(float);
	nn = sizeof(basicparticletype)/sizeof(float);

#ifdef MOVIE
/* A. Neveol's imagelib initialization */
		movieflag = initCamera(camerafilename);
#endif

/* Initialize fftw plans */

#if defined ENOUGH_SPACE && FFTWORK
	fftwinitaddspace_(&plan,&iplan,&nx,&ny,&nz,&local_nz,&local_z_start,
			&local_ny_after_transpose,&local_y_start_after_transpose,
			&total_local_size);
	enoughspace = 1;
#else
	fftwinit_(&plan,&iplan,&nx,&ny,&nz,&local_nz,&local_z_start,
			&local_ny_after_transpose,&local_y_start_after_transpose,
			&total_local_size);
	enoughspace = 0;
#endif
	/*
	printf("P%d has before %d %d in z\n",myrank,local_z_start,local_nz);
	printf("P%d has after %d %d in y\n",myrank,local_y_start_after_transpose,
			local_ny_after_transpose);
			*/


/* icont=0 - use pmseed to generate initial conditions */
/* icont=1 - read in initial conditions */

	pi = M_PI;
	zheight = (float) local_nz;
	zstart = (float) local_z_start;

    nspace = nspace0;
    omep = omega;
    omeplam = lambda;
    rth = rtophat_mesh;

    kenold = ken;
    size = boxsize_hinv_mpc;
    iseed = seed;
    amax = 1.0 + z_init;
    astep = delta_a;
	zi = amax - 1.;
    omei = omep*pow3(1.+zi)/
		(omep*pow3((1.+zi))+omeplam+(1.-omep-omeplam)*pow2((1.+zi)));
	redshift = amax/a - 1.0;

	ng = nxmesh; rng = (float) ng; 
	rngx = (float)nxmesh;
	rngy = (float)nymesh;
	ngz = nzmesh; 
	rngz = (float) nxmesh;
	ngh = ng/2;
	nghp1 = ng/2+1;
	/*
	rngc  = pow3(rng);
	*/
	rngc  = (float)nx*(float)ny*(float)nz;

	rngp6 = rngc*rngc;
	rngm6 = 1./rngp6;
	/*
	ngzc  = ng*ng*ngz;
	*/
	ngzc  = (float)nx*(float)ny*(float)nz;

	xyz   = rng/rngz;
	rngzc = (float)nx*(float)ny*(float)nz;
  	pmas = pow3(nspace);
	pmass = pmas/rngc;


    /* PMSEED */
    if( icont == 0 ) {
/*
		np = ngzc/pow3(nspace)/nrank;
*/
		np = (nx/nspace)/nrank*(ny/nspace)*(nz/nspace);


		/* Determination of particle mass in PM (pmas) and Tree (pmass)*/
		{
			lnp = (INT8 ) np;
			MPI_Reduce(&lnp,&tlnp,1,MPI_INT8,MPI_SUM,0,MPI_COMM_WORLD);
			MPI_Bcast(&tlnp,1,MPI_INT8,0,MPI_COMM_WORLD);
			pmas = rngc/(float)tlnp;
			pmass = 1./(float)tlnp;
			EPSSQ =  pow(pow((float)ny*(float)nz/(float)nx/(float)nx/tlnp,0.3333333)*FACTEPSSQ,2.);
			printf("The total number of particle is %lld\n",tlnp);

		}

/*
		particles = (basicparticletype *)
					Realloc(particles,np*sizeof(basicparticletype));
*/
#ifdef INITIALREADING
		printf("P%d has %d paritlces in Glacial conditions\n",myrank,G_np_read());
		particles = (basicparticletype *) Realloc(particles,
				sizeof(basicparticletype)*G_np_read());
		np = G_read(particles,&zstart,&zheight);
		zstart = local_z_start;
		zheight = local_nz;
	  	migrate(&np, ngz, zheight, zstart); /* Back to the FFTW local domain for PMSEED */
#endif /*endif of INITIALREADING */


#ifdef PMSEEDFORCE
#ifdef ENOUGH_SPACE
		work = (float *) Malloc(4*worksize*sizeof(float),PPTR(work));
		addspace = (work+densize);
#else /* else ENOUGH_SPACE */
		work = (float *) Malloc(worksize*sizeof(float),PPTR(work));
		addspace = work;
#endif /* endof ENOUGH_SPACE */
		den = work;

		fx = (float *) Malloc(densize*sizeof(float),PPTR(fx));
		fy = (float *) Malloc(densize*sizeof(float),PPTR(fy));
		fz = (float *) Malloc(densize*sizeof(float),PPTR(fz));
		denpmseedpad = (float *) Malloc(2*ny*nz*sizeof(float),
				PPTR(denpmseedpad));
        pmseedforce_(&np,particles,&nn,&nxpos,den,&nx,&ny,&nz,&local_nz,
				&local_z_start,&myrank,&nrank,&iplan,rcounts,displs,
				&omep,&omeplam,xabp0,xabp1,yabp0,yabp1,zabp0,zabp1,&enoughspace,
				addspace,&kenold,fx,fy,fz,denpmseedpad);
		Free(denpmseedpad);
		Free(fz);Free(fy);Free(fx);
#else /* else of PMSEEDFORCE */
#ifdef ENOUGH_SPACE
		work = (float *) Malloc(4*worksize*sizeof(float),PPTR(work));
		addspace = (work+densize);
#else /* else ENOUGH_SPACE */
		work = (float *) Malloc(worksize*sizeof(float),PPTR(work));
		addspace = work;
#endif /* endof ENOUGH_SPACE */
		den = work;

		fda4sup_(xabp0,xabp1,xabm1,yabp0,yabp1,yabm1,zabp0,zabp1,zabm1,&nx,
				&ny,&nz, &local_nz);
		denpmseedpad = (float *) Malloc(2*ny*nz*sizeof(float),
				PPTR(denpmseedpad));
        pmseed_(&np,particles,&nn,&nxpos,den,&nx,&ny,&nz,&local_nz,
				&local_z_start,&myrank,&nrank,&iplan,rcounts,displs,
				&omep,&omeplam,xabp0,xabp1,xabm1,yabp0,yabp1,yabm1,
			    zabp0,zabp1,zabm1,&enoughspace,addspace,&kenold,denpmseedpad);
		Free(denpmseedpad);

#endif /*endif of PMSEEDFORCE */

		/* Determination of particle mass in PM (pmas) and Tree (pmass)*/
		{
			lnp = (INT8 ) np;
			MPI_Reduce(&lnp,&tlnp,1,MPI_INT8,MPI_SUM,0,MPI_COMM_WORLD);
			MPI_Bcast(&tlnp,1,MPI_INT8,0,MPI_COMM_WORLD);
			pmas = rngc/(float)tlnp;
			pmass = 1./(float)tlnp;
			EPSSQ =  pow(pow((float)ny*(float)nz/(float)nx/(float)nx/tlnp,0.3333333)*FACTEPSSQ,2.);
		}

#ifdef VarPM
		lzfloor = local_z_start; lzceil = local_z_start + local_nz;
#endif /* end of VarPM */
#if defined (MULTIMASS) && defined(INDVEPS)
		for(i=0; i<np; i++) {
			particles[i].mass = pmass;
#ifndef VarPM
			particles[i].freework = 1.0;
#endif /* end of VarPM */
			/*
			particles[i].epssq = pow(1./ng*nspace*0.1,2.);
			*/
			particles[i].epssq =  pow(pow((float)ny*(float)nz/(float)nx/(float)nx/tlnp,0.3333333)*FACTEPSSQ,2.);
		}
#elif MULTIMASS
		for(i=0; i<np; i++) {
			particles[i].mass = pmass;
		}
#endif
		delta_a = astep;
/*
		jwrite(0);
*/
/*
        kenold = seed2_.ken;
*/

		now = 0;
		nowflag = 0;
		/*
		fda4sup_(xabp0,xabp1,xabm1,yabp0,yabp1,yabm1,zabp0,zabp1,zabm1,&nx,&ny,&nz,
				&local_nz);
				*/

		/* Free up the work memory */
		freelast(work);

#ifdef ACCOUT
        getrv(myrank,np,particles);
		fprintf(stderr,"P%d got %d particles\n",myrank,np);
#endif
		if( myrank == 0 ) {
		    bp = particles;
		    fprintf(stderr,"P%d particle0 is %g %g %g %g %g %g\n", myrank,
			        bp->x, bp->y, bp->z, bp->vx, bp->vy, bp->vz);
		}
		fprintf(stderr,"P%d zheight %g zstart %g np=%d\n",
			myrank,zheight,zstart,np);

	  	migrate(&np, ngz, zheight, zstart);

		SYNCHRONIZE();

		if( myrank == 0 ) {
		    bp = particles;
		    fprintf(stderr,"after migrate\n");
		    fprintf(stderr,"P%d particle0 is %g %g %g %g %g %g\n", myrank,
			        bp->x, bp->y, bp->z, bp->vx, bp->vy, bp->vz);
		}
		lnp = (INT8 ) np;
		MPI_Reduce(&lnp,&tlnp,1,MPI_INT8,MPI_SUM,0,MPI_COMM_WORLD);

		if(myrank == 0) fprintf(stderr,"Total particle number : %d\n",tlnp);
	}
	else if (icont == 1) {

		jread();
		
/* Resize the particle array to the particle number size */
		particles = (basicparticletype *) 
					Realloc(particles,np*sizeof(basicparticletype));

#ifdef INDVEPS
		for(i=0; i<np; i++) {
#ifndef VarPM
			particles[i].freework = 1.0;
#endif
			particles[i].epssq =  pow(pow((float)ny*(float)nz/(float)nx/(float)nx/tlnp,0.3333333)*FACTEPSSQ,2.);
		}
		
#endif

	  	migrate(&np, ngz, zheight, zstart);

		/*
		pmas = nspace*nspace*nspace;
		pmass = pmas/rngc;
		*/
		/* Determination of particle mass in PM (pmas) and Tree (pmass)*/
		{
			lnp = (INT8 ) np;
			MPI_Reduce(&lnp,&tlnp,1,MPI_INT8,MPI_SUM,0,MPI_COMM_WORLD);
			MPI_Bcast(&tlnp,1,MPI_INT8,0,MPI_COMM_WORLD);
			pmas = rngc/(float)tlnp;
			pmass = 1./(float)tlnp;
			EPSSQ =  pow(pow((float)ny*(float)nz/(float)nx/(float)nx/tlnp,0.3333333)*FACTEPSSQ,2.);
		}
		fda4sup_(xabp0,xabp1,xabm1,yabp0,yabp1,yabm1,zabp0,zabp1,zabm1,&nx,&ny,&nz,
				&local_nz);
	}
    /*
      Cell positions run from 0 to n-1 while particle positions
      run from 0 to n
      (xp,yp,zp) = particle position
      (ic,jc,kc) = major cell's position the superparticle clould belongs to.
      (icc,jcc,kcc) = minor cell's position
      CPU : Scalar (1.84), Vector (1.02,8.1,65) for ng = 32,64,128
     */

/* MAIN TIME LOOP FOR SIMULATION */
	for(stepcount=stepnum; stepcount<=nstep; stepcount++) {
#ifdef OLDDEBUG
		{
			double max,may,maz,stdax,stday,stdaz;
			double tmax,tmay,tmaz,tstdax,tstday,tstdaz;
			max=may=maz=stdax=stday=stdaz = 0;
			for(i=0;i<np;i++){
				max += fabs(particles[i].vx);
				may += fabs(particles[i].vy);
				maz += fabs(particles[i].vz);
				stdax += pow(particles[i].vx,2);
				stday += pow(particles[i].vy,2);
				stdaz += pow(particles[i].vz,2);
			}
			lnp = (INT8) np;
			MPI_Reduce(&lnp,&tlnp,1,MPI_INT8,MPI_SUM,0,MPI_COMM_WORLD);
			MPI_Reduce(&max,&tmax,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
			MPI_Reduce(&may,&tmay,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
			MPI_Reduce(&maz,&tmaz,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
			MPI_Reduce(&stdax,&tstdax,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
			MPI_Reduce(&stday,&tstday,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
			MPI_Reduce(&stdaz,&tstdaz,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
			if(myrank ==0){
				tmax = tmax / (double) tlnp; tmay = tmay / (double) tlnp; tmaz = tmaz/(double)tlnp;
				tstdax = tstdax / (double) tlnp - tmax*tmax; 
				tstday = tstday / (double) tlnp - tmay*tmay; 
				tstdaz = tstdaz / (double) tlnp - tmaz*tmaz; 
				tstdax = sqrt(tstdax); tstday = sqrt(tstday); tstdaz = sqrt(tstdaz);
				printf("P%d has vel. mean %g %g %g and std %g %g %g\n",myid,
						tmax,tmay,tmaz,tstday,tstday,tstdaz);
			}
		}
#endif


		TIMER_START(51);

#ifdef MOVIE
/* A. Neveol's rendering tool */
		if( movieflag ) 
			RenderImage(&stepcount,L,&np,particles);

#endif

/* Allocate work array for FFT's */

#ifdef ENOUGH_SPACE
		/*
		mallocptr = (void **)(&work);
		work = (float *) Malloc(4*worksize*sizeof(float),mallocptr);
		*/
		work = (float *) Malloc(4*worksize*sizeof(float),PPTR(work));
		addspace = (work+densize);
#else
		/*
		mallocptr = (void **)(&work);
		work = (float *) Malloc(worksize*sizeof(float),mallocptr);
		*/
#ifdef VarPM
		work = (float *) Malloc(((zheight+10)*2*(nx/2+1)*ny)*sizeof(float),
				PPTR(work));
#else
		work = (float *) Malloc((worksize+2*(nx/2+1)*ny)*sizeof(float),
				PPTR(work));
#endif
		addspace = work;
#endif
		den = work;
 
#ifdef VarPM
		/*##############################################################*/
		/* define lzfloor and lzceil */
		/* VarPM TSC */
		/* local_nz+2 --> due to the incomplete boundary at the ceil of each 
		 * node */
		fftwmesh = (float *) Malloc(sizeof(float)*(local_nz+2)*2*(nx/2+1)*ny,
				PPTR(fftwmesh));
		lzfloor = zstart; lzceil = zstart+zheight;
		printf("P%d has %g -- %g\n",myrank,lzfloor,lzceil);
		VarPM_tsc2(den,nx,ny,nz, lzfloor,lzceil, particles,nn,nxpos, np,pmas,
				myrank,nrank, fftwmesh, local_nz,local_z_start);
#ifdef SAVESLICE
		SaveSlice(fftwmesh,nx,ny,nz,myrank,stepcount);
		xzslice = Malloc(sizeof(float)*nx*local_nz,PPTR(xzslice));
		makexzslice_(fftwmesh,&nx,&ny,&nz,&local_nz,xzslice);
		savexzslice(xzslice,nx,nz,local_nz,myrank,nrank,stepcount);
		Free(xzslice);
#endif
		{
			/*
			if(flagwholeden(amax,a,astep)) 
				SaveWholeDen(fftwmesh,nx,ny,nz,local_nz,myrank,nrank, stepcount,amax,a);
				*/
				float znow,zbefore,zafter;
				znow = amax/a-1.;
				zbefore = amax/(a-astep)-1.;
				zafter = amax/(a+astep)-1.;
				if((fabs(znow-12.)<fabs(zbefore-12.)&&fabs(znow-12.)<fabs(zafter-12.))||
						(fabs(znow-18.)<fabs(zbefore-18.)&&fabs(znow-18.)<fabs(zafter-18.))||
						(fabs(znow-15.)<fabs(zbefore-15.)&&fabs(znow-15.)<fabs(zafter-15.))||
						(fabs(znow-8.)<fabs(zbefore-8.)&&fabs(znow-8.)<fabs(zafter-8.))||
						(fabs(znow-5.)<fabs(zbefore-5.)&&fabs(znow-5.)<fabs(zafter-5.))||
						(fabs(znow-7.)<fabs(zbefore-7.)&&fabs(znow-7.)<fabs(zafter-7.))||
						(fabs(znow-10.)<fabs(zbefore-10.)&&fabs(znow-10.)<fabs(zafter-10.))||
						(fabs(znow-12.)<fabs(zbefore-12.)&&fabs(znow-12.)<fabs(zafter-12.))||
						(fabs(znow-3.)<fabs(zbefore-3.)&&fabs(znow-3.)<fabs(zafter-3.))||
						(fabs(znow-2.)<fabs(zbefore-2.)&&fabs(znow-2.)<fabs(zafter-2.))||
						(fabs(znow-0.)<fabs(zbefore-0.)&&fabs(znow-0.)<fabs(zafter-0.))||
						(fabs(znow-1.)<fabs(zbefore-1.)&&fabs(znow-1.)<fabs(zafter-1.))) 
					SaveWholeDen(fftwmesh,nx,ny,nz,local_nz,myrank,nrank, stepcount,
							amax,a);
		}
		/*##############################################################*/
#else
#if defined(TSC_SWAP)  && defined(ENOUGH_SPACE)
		den2 = (work+worksize);
#if defined(TSC_SWAP_TUNE)
		/*
		tscswptune_(den,den2,&nx,&ny,&nz,&local_nz,&local_z_start,x,y,z,
		            &np,&pmas,&myrank,&nrank);
					*/
		tscswptune_(den,den2,&nx,&ny,&nz,&local_nz,&local_z_start,particles,
				&nn,&nxpos,&np,&pmas,&myrank,&nrank);
#else
		tscswp_(den,den2,&nx,&ny,&nz,&local_nz,&local_z_start,particles,&nn
				&nxpos,&np,&pmas,&myrank,&nrank);
#endif
#else
#if defined(TSC_TUNE)
		tsctune_(den,&nx,&ny,&nz,&local_nz,&local_z_start,particles,&nn,
				&nxpos, &np,&pmas,&myrank,&nrank);
#endif
		tsc_(den,&nx,&ny,&nz,&local_nz,&local_z_start,particles,&nn,&nxpos,
				&np,&pmas,&myrank,&nrank);
		printf("P%d has %g\n",myrank,den[0]);
#endif
#ifdef SAVESLICE
		SaveSlice(den,nx,ny,nz,myrank,stepcount);
#endif

#endif
		/* Forward FFT */
#ifdef VarPM
	    fftforward_(&plan,fftwmesh,&myrank);
#else
  		if(enoughspace == 0){
		    fftforward_(&plan,den,&myrank);
		}
		else{
			addspace = (work+densize);
		    fftforwardaddspace_(&plan,den,addspace,&myrank);
		}
#endif
/*
		{
			char name[100]; FILE *ffp;
   		    if(fabs(a-2.) < astep/2.
				|| fabs(a-3.) < astep/2.
				|| fabs(a-4.) < astep/2. 
				|| fabs(a-6.) < astep/2.
				|| fabs(a-8.) < astep/2.
				|| fabs(a-12.) < astep/2. 
				|| fabs(a-24.) < astep/2.
				|| stepcount == nstep) {
				for(i=0;i<nrank;i++){
					sprintf(name,"KDomain.%.5d",stepcount);
					if(i == myrank){
						if(i==0){
							ffp=fopen(name,"w");
							fwrite(&nx,sizeof(int),1,ffp);
							fwrite(&ny,sizeof(int),1,ffp);
							fwrite(&nz,sizeof(int),1,ffp);
						}
						else ffp = fopen(name,"a");
						fwrite(fftwmesh,sizeof(float),2*(nx/2+1)*ny*local_nz,
								ffp);
						fclose(ffp);
					}
					MPI_Barrier(MPI_COMM_WORLD);
				}
			}
		}
*/
		/*
		printf("P%d %g %g %g %g\n",myrank,fftwmesh[0],fftwmesh[10],
				fftwmesh[100], fftwmesh[200]);
				*/
		/* Correlation Fct. and Power spectrum */
		std = 0;
#ifdef CORRELATION_FUNCTION
		/*
		if( stepcount == 0 ) {
		*/
		if( fmod(stepcount,(int)(1./astep)) == 0 || stepcount ==1||
					fabs(a-1.) < astep/2.
				|| fabs(a-2.) < astep/2.
				|| fabs(a-3.) < astep/2.
				|| fabs(a-4.) < astep/2.
				|| fabs(a-6.) < astep/2.
				|| fabs(a-9.) < astep/2.
				|| fabs(a-12.) < astep/2. 
				|| fmod(a,1.)*100 ==0
				|| stepcount <15) {
#ifdef VarPM
			correl_(fftwmesh, &nx,&ny,&nz,&local_nz,&local_z_start,
					pk,npk,cor,tpk,tnpk,tcor,&corn1,&std,&myrank,&nrank,
					&rngm6,&a,&nowflag,&now,&xyz,&rth,&nstep,
					&local_ny_after_transpose,
					&local_y_start_after_transpose);
#else
			correl_(den,&nx,&ny,&nz,&local_nz,&local_z_start,
					pk,npk,cor,tpk,tnpk,tcor,&corn1,&std,&myrank,&nrank,
					&rngm6,&a,&nowflag,&now,&xyz,&rth,&nstep,
					&local_ny_after_transpose,
					&local_y_start_after_transpose);
#endif
		}
		if(myrank == 0) {
			if( fmod(stepcount,(int)(1./astep)) == 0 || stepcount ==1
                                ||        fabs(a-1.) < astep/2.
                                || fabs(a-2.) < astep/2.
                                || fabs(a-3.) < astep/2.
                                || fabs(a-4.) < astep/2.
                                || fabs(a-6.) < astep/2.
                                || fabs(a-9.) < astep/2.
                                || fabs(a-12.) < astep/2.
								|| fmod(a,1.)*100 ==0
				|| stepcount <15) {
				if((fp = fopen("pmevol.map","a")) != NULL){
					for(i=0;i<ngh;i++){
						fprintf(fp,"%6d %6d  %.2E  %.2E \n",
								i+1,i,*(pk+i), *(cor+i));
					}
					ierror = fclose(fp);
				}
			}
		}
#endif


#ifdef VarPM
		psolver_(fftwmesh,&nx,&ny,&nz,&local_nz,&local_ny_after_transpose,
				&local_y_start_after_transpose,&poten,&rngc,&rngm6,
				&myrank,&nrank,&efold);
#else
		psolver_(den,&nx,&ny,&nz,&local_nz,&local_ny_after_transpose,
				&local_y_start_after_transpose,&poten,&rngc,&rngm6,
				&myrank,&nrank,&efold);
#endif

		/*
		for(i=0;i<nrank;i++){
			if(i==myrank){
				for(j=0;j<2*(nx/2+1)*nz*local_ny_after_transpose;j++){
					printf("%g\n",fftwmesh[j]);
				}
			}
			MPI_Barrier(MPI_COMM_WORLD);
		}
		MPI_Finalize();exit(0);
		*/
		/* Complex-to-Real FFT in a transposed order */
#ifdef VarPM
		fftbackward_(&iplan,fftwmesh,&myrank);
		/*
		for(i=0;i<nrank;i++){
			if(i==myrank)
			for(j=0;j<2*(nx/2+1)*ny*local_nz;j++) printf("%g \n",fftwmesh[j]);
				MPI_Barrier(MPI_COMM_WORLD);
		}
		MPI_Finalize();exit(0);
		*/

#else
  		if(enoughspace == 0){
			fftbackward_(&iplan,den,&myrank);
		}
		else {
			addspace = (work+densize);
			fftbackwardaddspace_(&iplan,den,addspace,&myrank);
		}
#endif





		/* four-point FDA in calculating force at each particle */

#ifdef VarPM

		lzfloor = zstart; lzceil = zstart+zheight;
		{
			VarPM_fda4_mesh(fftwmesh,local_nz,local_z_start,den,lzfloor,lzceil,
				nx,ny,nz);
			Free(fftwmesh);
		}
		/* */
		/* local_nz and local_z_start should be modified for variable PM */
		
		local_nz_den = (int)lzceil - (int) lzfloor + 1;
		fda4sup_(xabp0,xabp1,xabm1,yabp0,yabp1,yabm1,zabp0,zabp1,zabm1,&nx,&ny,&nz,
				&local_nz_den);
		nforcepos = (int)offsetof(basicparticletype,ax) /sizeof(float);
		/* WARNING local_nz --> local_nz_den */
		nlzfloor = lzfloor;
		fda4_(particles,&nn,&nxpos,&np,den,&nx,&ny,&nz,&local_nz_den,&a,&astep,
				&nextastep,
				&amax,&omei,&omep,&omeplam,&pfact,xabp0,xabp1,xabm1,
				yabp0,yabp1,yabm1,
		        zabp0,zabp1,zabm1,&nlzfloor,&myrank,&nrank,
				&fact1,&fact2,&nforcepos);
		/* */
#else
#ifdef ENOUGH_SPACE
#ifdef FDA_FORCE_ARRAY_SWAP
		forcearray = (work+worksize);
		swpden = den;
		den1 = forcearray;
#ifdef FDA_SWAP_TUNE
		/*
        fda4gfswptune_(x,y,z,vx,vy,vz,&np,den,swpden,den1,forcearray,
				&nx,&ny,&nz,&local_nz,&a,&astep,
				&amax,&omei,&omep,&omeplam,&pfact,&local_z_start,
				&myrank,&nrank,&fact1,&fact2);
				*/
        fda4gfswptune_(particles,&nn,&nxpos,&np,den,swpden,den1,forcearray,
				&nx,&ny,&nz,&local_nz,&a,&astep,
				&amax,&omei,&omep,&omeplam,&pfact,&local_z_start,
				&myrank,&nrank,&fact1,&fact2);
#else
        fda4gfswp_(particles,&nn,&nxpos,&np,den,swpden,den1,forcearray,
				&nx,&ny,&nz,&local_nz,&a,&astep,
				&amax,&omei,&omep,&omeplam,&pfact,&local_z_start,
				&myrank,&nrank,&fact1,&fact2);
#endif

#else
		gridfx = (work+worksize);
		gridfy = (work+2*worksize);
		gridfz = (work+3*worksize);
		fda4gf_(particles,&nn,&nxpos,&np,den,gridfx,gridfy,gridfz,
				&nx,&ny,&nz,&local_nz,&a,&astep,
				&amax,&omei,&omep,&omeplam,&pfact,xabp0,xabp1,xabm1,
				zabp0,zabp1,zabm1,&local_z_start,&myrank,&nrank,
				&fact1,&fact2);
#endif   
#else
		nforcepos = (int)offsetof(basicparticletype,ax) /sizeof(float);
		fda4_(particles,&nn,&nxpos,&np,den,&nx,&ny,&nz,&local_nz,&a,&astep,
				&nextastep,
				&amax,&omei,&omep,&omeplam,&pfact,xabp0,xabp1,xabm1,
				yabp0,yabp1,yabm1,
		        zabp0,zabp1,zabm1,&local_z_start,&myrank,&nrank,
				&fact1,&fact2,&nforcepos);
#endif
#endif

#ifdef OLDDEBUG
		{
			double max,may,maz,stdax,stday,stdaz;
			double tmax,tmay,tmaz,tstdax,tstday,tstdaz;
			max=may=maz=stdax=stday=stdaz = 0;
			for(i=0;i<np;i++){
				max += fabs(particles[i].ax);
				may += fabs(particles[i].ay);
				maz += fabs(particles[i].az);
				stdax += pow(particles[i].ax,2);
				stday += pow(particles[i].ay,2);
				stdaz += pow(particles[i].az,2);
			}
			lnp = (INT8) np
			MPI_Reduce(&lnp,&tlnp,1,MPI_INT8,MPI_SUM,0,MPI_COMM_WORLD);
			MPI_Reduce(&max,&tmax,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
			MPI_Reduce(&may,&tmay,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
			MPI_Reduce(&maz,&tmaz,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
			MPI_Reduce(&stdax,&tstdax,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
			MPI_Reduce(&stday,&tstday,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
			MPI_Reduce(&stdaz,&tstdaz,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
			if(myrank ==0){
				tmax = tmax / (double) tlnp; tmay = tmay / (double) tlnp; tmaz = tmaz/(double)tlnp;
				tstdax = tstdax / (double) tlnp - tmax*tmax; 
				tstday = tstday / (double) tlnp - tmay*tmay; 
				tstdaz = tstdaz / (double) tlnp - tmaz*tmaz; 
				tstdax = sqrt(tstdax); tstday = sqrt(tstday); tstdaz = sqrt(tstdaz);
				printf("P%d has accel. mean %g %g %g and std %g %g %g\n",myid,
						tmax,tmay,tmaz,tstday,tstday,tstdaz);
			}
		}
#endif

/* Free the work array for tree calculations */
		freelast(work);
		/*  
		 *  4-point FDA end
		 */
#ifdef INCLUDE_TREE_FORCE
		if( myrank == 0 ) {
			    bp = particles;
			    fprintf(stderr,"P%d particle0 is %g %g %g %g %g %g\n", myrank,
					        bp->x, bp->y, bp->z, bp->vx, bp->vy, bp->vz);
			    fprintf(stderr,"P%d particle0 accel. is %g %g %g\n", myrank,
					        bp->ax, bp->ay, bp->az);
		}
		
		TIMER_START(59);

		{
			long nplong;
			nplong = np;
			if(stepcount < 110) theta = 0.25;
			else theta = 0.4;
			(void) treecorrection(particles,nplong, nx, ny, nz, 
				(float)zstart,(float)zheight, fact1, fact2, pfact,theta);
		}
		/*
#ifdef VarPM
		zheight = zheight/(float)nz;
		zstart = zstart/(float)nz-0.5;
#endif

#if !defined (INDVEPS) && !defined(MULTIMASS)
		EPSSQ = epssq =  pow(pow((float)ny*(float)nz/(float)nx/(float)nx/tlnp,0.3333333)*FACTEPSSQ,2.);
        np = TreeCorrection(&np,particles,fact1,fact2,pfact,pmass,epssq,
				stepcount);
#elif MULTIMASS
		EPSSQ = epssq =  pow(pow((float)ny*(float)nz/(float)nx/(float)nx/tlnp,0.3333333)*FACTEPSSQ,2.);
        np = TreeCorrection(&np,particles,fact1,fact2,pfact,epssq,
				stepcount);
#else
        np = TreeCorrection(&np,particles,fact1,fact2,pfact,stepcount);
#endif
#ifdef VarPM
		zheight = zheight*(float) nz;
		zstart = (zstart+0.5)*(float)nz;
#endif
		*/


		TIMER_STOP(59);
        if(myid==0) fprintf(stdout,"Treecorrectingtime CPU= %f \n", ELAPSED_TIME(59));



#endif

#ifndef OBSERVATION_MODE
		/* one step forward for positions and velocities are done in tpm.c .*/
		fmod_(&np,&rngx,&rngy,&rngz,particles,&nn,&nxpos);
#endif

#ifdef OBSERVATION_MODE
		/* reordering particles for constant width */
		{
			float hhh = 1.;
			int nblur = 5;
			int magnitude = 5;
			float hh = 1.,epsilon = 0.01; /* epsilon means epsilon square */
			int oldstacknum;
			/* variables for local half step evolution */
			float ainv,app,apsq,afact,bfact;
			float half_fact1,half_fact2,inhalf_fact1;
			float half_astep;
			int halofinding,syncsaving,surveying,simplesurveying;
			int semi_simplesurveying;
	
			half_astep = astep*0.5;
			ainv = 1./a;
			app = -4.*pi/3.*(ainv*ainv-2*omeplam/omep*a/amax/amax/amax);
			apsq = 8.*pi/3.*(ainv+1./omei-1+omeplam/omep*(a*a-1)
					/amax/amax/amax);
			afact = (2.+app*a/apsq)/2.*ainv;
			bfact = ainv*ainv*ainv/apsq;
			half_fact1 = (1.-afact*half_astep)/(1.+afact*half_astep);
			half_fact2 = bfact*half_astep/(1.+afact*half_astep)*rng;
			/* check whether finding or syncsaving is necessary */
			if(stepcount % ObservationStride == ModulusOfObservationStride) 
				halofinding = 1;
			else halofinding = 0;
			{
				float znow,zbefore,zafter;
				znow = amax/a-1.;
				zbefore = amax/(a-astep)-1.;
				zafter = amax/(a+astep)-1.;
				if((fabs(znow-12.)<fabs(zbefore-12.)&&fabs(znow-12.)<fabs(zafter-12.))||
						(fabs(znow-15.)<fabs(zbefore-15.)&&fabs(znow-15.)<fabs(zafter-15.))||
						(fabs(znow-18.)<fabs(zbefore-18.)&&fabs(znow-18.)<fabs(zafter-18.))||
						(fabs(znow-8.)<fabs(zbefore-8.)&&fabs(znow-8.)<fabs(zafter-8.))||
						(fabs(znow-5.)<fabs(zbefore-5.)&&fabs(znow-5.)<fabs(zafter-5.))||
						(fabs(znow-7.)<fabs(zbefore-7.)&&fabs(znow-7.)<fabs(zafter-7.))||
						(fabs(znow-10.)<fabs(zbefore-10.)&&fabs(znow-10.)<fabs(zafter-10.))||
						(fabs(znow-12.)<fabs(zbefore-12.)&&fabs(znow-12.)<fabs(zafter-12.))||
						(fabs(znow-3.)<fabs(zbefore-3.)&&fabs(znow-3.)<fabs(zafter-3.))||
						(fabs(znow-2.)<fabs(zbefore-2.)&&fabs(znow-2.)<fabs(zafter-2.))||
						(fabs(znow-0.)<fabs(zbefore-0.)&&fabs(znow-0.)<fabs(zafter-0.))||
						(fabs(znow-0.5)<fabs(zbefore-0.5)&&fabs(znow-0.5)<fabs(zafter-0.5))||
						(fabs(znow-1.)<fabs(zbefore-1.)&&fabs(znow-1.)<fabs(zafter-1.))) 
					syncsaving = 1;
				else syncsaving = 0.;
			}
			surveying=halofinding = 0;
			semi_simplesurveying = 0;
			simplesurveying = 0;
			if(halofinding == 1 || syncsaving == 1 ||surveying ==1 || 
					simplesurveying==1|| semi_simplesurveying==1){
				/* half step evolution of velocities */
				bp = particles;
				for(i=0;i<np;i++){
					bp->vx = half_fact1*(bp->vx) + half_fact2*(bp->ax);
					bp->vy = half_fact1*(bp->vy) + half_fact2*(bp->ay);
					bp->vz = half_fact1*(bp->vz) + half_fact2*(bp->az);
					bp++;
				}
			}
			else {
				/* one step evolution of velocities */
				bp = particles;
				for(i=0;i<np;i++){
					bp->vx = fact1*(bp->vx) + fact2*(bp->ax);
					bp->vy = fact1*(bp->vy) + fact2*(bp->ay);
					bp->vz = fact1*(bp->vz) + fact2*(bp->az);
					bp++;
				}
			}
			/* if in this step surveying observations is needed */
			if(surveying == 1) {
				int survey(basicparticletype *,int,int,int,int,int,
						float,float,float,float,float,float,float,float,
						int,int,int),nntmp;
				nntmp = survey(particles,np,nx,ny,nz,stepcount,amax,a,
						 astep,nextastep,size,omep,omeplam,
						 hubble_parameter,myrank,nrank,0);
				nntmp = survey(particles,np,nx,ny,nz,stepcount,amax,a,
						 astep,nextastep,size,omep,omeplam,
						 hubble_parameter,myrank,nrank,1);
			}
			if(simplesurveying == 1){
				int simplesurvey(basicparticletype *,int ,int ,int ,int , 
						int , float , float , float ,float , float , float ,
						float ,float ,int ,int ,int ),nntmp;
				nntmp = simplesurvey(particles,np,nx,ny,nz,stepcount,amax,a,
						 astep,nextastep,size,omep,omeplam,
						 hubble_parameter,myrank,nrank,1);
			}
			if(semi_simplesurveying == 1){
				float maxd;
				int semi_simplesurvey(basicparticletype *,int ,int ,int ,int , 
						int , float , float , float ,float , float , float ,
						float ,float ,int ,int ,int , float),nntmp;
				maxd = 0.1*nspace;
				for(k=0;k<4;k++) 
					nntmp = semi_simplesurvey(particles,np,nx,ny,nz,
							stepcount,amax,a,
						 astep,nextastep,size,omep,omeplam,
						 hubble_parameter,myrank,nrank,k,maxd);
			}
			/* if in this step halo finding is needed */
			/*
			if(halofinding == 1){
				migrate(&np, ngz, zheight, zstart);
				printf("P%d before prework %d is allocated %d\n",
						myrank,CurMemStack(),np);
				fflush(stdout);
				prework(np,particles,hhh,nblur,ng,ngz,nspace,
						myrank,nrank,local_z_start,local_nz,stepcount);
				printf("P%d after prework %d is allocated %d\n",
						myrank,CurMemStack(),np);
				fflush(stdout);
				oldstacknum = CurMemStack();
				*/
/*
				(void) hfind(ng,nspace,omep,omeplam,hubble_parameter,
							 size,amax,a,
							 epsilon,hh,magnitude,stepcount,myrank,nrank);
*/
			/*
				InitialOldMemStack(oldstacknum);
				printf("P%d after hfind %d is allocated %d\n",
						myrank,CurMemStack(),np);
			}
			*/
			/* syncsaving particles */
			/* These data files have particles of synchronized pos. and vel. */
   		    if(syncsaving == 1){
				char saveprefix[80],synchronizervprefix[80];
				strcpy(saveprefix,rvprefix);
				strcpy(synchronizervprefix,rvprefix);
				sprintf(rvprefix,"Sync%s",synchronizervprefix);

/* Sort particles by index */
				/*
				HyperSort(&np,particles);
				*/
/* Write out the particles */
				delta_a = astep;
				jwrite(stepcount);
/* Resort particles by slice bins */
				migrate(&np, ngz, zheight, zstart);
	
				if(myrank == 0){
	   	            fp=fopen("PHYSICAL_PARAMETERS.dat","a");
              		fprintf(fp,"Synchronous saving\n");
   		            fprintf(fp,"%d %d %d %d %12.4f \n",ng,ngz,nspace,iseed,
							size);
   		            fprintf(fp,"%10.4f %10.4f %10.4f %10.4f %10.4f %10.4f \n",
   		                    omep,omeplam,amax,astep,pconv,vconv);
   		            fprintf(fp,"%10.4f %10.4f %d \n",a,redshift, stepcount);
   		            fclose(fp);
				}
				strcpy(rvprefix,saveprefix);
			}
			if(halofinding == 1 || syncsaving == 1 || surveying ==1 || 
					simplesurveying == 1 || semi_simplesurveying == 1){
				/* half step backward evolution of velocities.. */
				/* recover to original velocities */
				float Fact1InhalfFact1;
				inhalf_fact1 = 1./half_fact1;
				Fact1InhalfFact1 = fact1*inhalf_fact1;

#ifdef OLD_VERSION_OBSOLETE
				bp = particles;
				for(i=0;i<np;i++){
					bp->vx = inhalf_fact1*(bp->vx - half_fact2*(bp->ax));
					bp->vy = inhalf_fact1*(bp->vy - half_fact2*(bp->ay));
					bp->vz = inhalf_fact1*(bp->vz - half_fact2*(bp->az));
					bp++;
				}
				/* one step forward for velocities */
				bp = particles;
				for(i=0;i<np;i++){
					bp->vx = fact1*(bp->vx) + fact2*(bp->ax);
					bp->vy = fact1*(bp->vy) + fact2*(bp->ay);
					bp->vz = fact1*(bp->vz) + fact2*(bp->az);
					bp++;
				}
#endif
				bp = particles;
				for(i=0;i<np;i++){
					bp->vx = Fact1InhalfFact1*(bp->vx - half_fact2*(bp->ax))
						+ fact2*(bp->ax);
					bp->vy = Fact1InhalfFact1*(bp->vy - half_fact2*(bp->ay))
						+ fact2*(bp->ay);
					bp->vz = Fact1InhalfFact1*(bp->vz - half_fact2*(bp->az))
						+ fact2*(bp->az);
					bp++;
				}
			}
			/* one step forward for positions. This position data
			 * is at one step evolution.*/
			bp = particles;
			for(i=0;i<np;i++){
				bp->x += (pfact*(bp->vx));
				bp->y += (pfact*(bp->vy));
				bp->z += (pfact*(bp->vz));
				bp++;
			}
		}
		fmod_(&np,&rngx,&rngy,&rngz,particles,&nn,&nxpos);
#endif

		kentmp = 0.;
		dzmax = 0.;
		for(bp=particles; bp<particles+np; bp++) {
#if defined(MULTIMASS)
			kentmp += (bp->mass)*(pow2(bp->vx) + pow2(bp->vy) + pow2(bp->vz));
#else
			kentmp += (pow2(bp->vx) + pow2(bp->vy) + pow2(bp->vz));
#endif
			if(fabs((bp->vz)*pfact)>dzmax) 
				dzmax =  fabs((bp->vz)*pfact);
		}
		
		ken = (float) kentmp;

		MPI_Allreduce(&dzmax,&tdzmax,1,MPI_FLOAT,MPI_MAX,MPI_COMM_WORLD);
		dzmax = tdzmax;
		if(myrank == 0) fprintf(stderr,"Max. displacement in z = %f\n",dzmax);

		MPI_Allreduce(&ken,&tken,1,MPI_FLOAT,MPI_SUM,MPI_COMM_WORLD);
		ken = tken;
		dxda2 = ken;

/* Cosmic virial theorem */
		ken = 0.5*8.*pi/3.*ken*
             (1./(a+0.5*astep)+1./omei-1+
		     omeplam/omep/amax/amax/amax*((a+0.5*astep)*(a+0.5*astep)-1.));
		kenata = (ken+kenold)/2.;
		ktot = ktot + a*a*kenold*astep;

		if(a == 1) {
			ktot = 0.;
			poten0 = poten;
		}

		Const = a*a*a*kenata+poten+ktot;
		if(a == 1){
			const0 = Const;
			conserv = 0.;
		}
		else
			conserv = (Const-const0)/(poten-poten0);

		if(myrank == 0){
			if((fp=fopen("pm3.out","a")) != NULL){
				fprintf(fp,"%11.3E %11.3E %11.3E %11.3E %11.3E %11.3E\n",
						a,poten,kenata,Const,conserv,dxda2);
				fclose(fp);
			}
		}
		if( myrank == 0 ) {
		    bp = particles;
		    fprintf(stderr,"P%d particle0 is %g %g %g %g %g %g\n", myrank,
			        bp->x, bp->y, bp->z, bp->vx, bp->vy, bp->vz);
		}


	  	migrate(&np, ngz, zheight, zstart);

/*
#ifdef VarPM
		zfinal = zstart+zheight;
		EQNZBox(np,particles,zbox,zstart,zfinal,nz);
		if(myrank==0){
	        for(i=0;i<numprocs;i++){
	            printf("%g -- %g \n",zbox[i].zstart,zbox[i].zfinal);
	        }
	    }
#endif
*/

		if( myrank == 0 ) {
		    bp = particles;
		    fprintf(stderr,"P%d particle0 is %g %g %g %g %g %g\n", myrank,
			        bp->x, bp->y, bp->z, bp->vx, bp->vy, bp->vz);
		}

		lnp = (INT8) np;
		MPI_Reduce(&lnp,&tlnp,1,MPI_INT8,MPI_SUM,0,MPI_COMM_WORLD);
		MPI_Reduce(&lnp,&maxnp,1,MPI_INT8,MPI_MAX,0,MPI_COMM_WORLD);
		MPI_Reduce(&lnp,&minnp,1,MPI_INT8,MPI_MIN,0,MPI_COMM_WORLD);
		if(myrank == 0) {
			fprintf(stderr,"Total particle number : %d \n",tlnp);
			fprintf(stderr,"max. # of prts in slices : %d \n",maxnp);
			fprintf(stderr,"min. # of prts in slices : %d \n",minnp);
	    }
		a = a + astep;
		redshift = amax/a - 1.;
    	pconv = 1.; vconv = 1.;
        kenold = ken;
 
		if( myrank == 0 ) {
			elapsedtime = gettime();
		}
		MPI_Bcast(&elapsedtime, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
		if(flagsuddenstop(stepcount+1)) suddenstop = 1;
		else suddenstop = 0;
		/* save for the next run 
		 * Be careful that the data of velocity 
		 * have half step below the current "a" of position of particles */
		/*
        if( elapsedtime > maxtime|| stepcount%50 == 0 || suddenstop) {
		*/
        if( elapsedtime > maxtime|| stepcount%2000 == 0 || suddenstop) {
/* Sort particles by index */
			/*
			HyperSort(&np,particles);
			*/
/* Write out the particles */
			delta_a = astep;
			jwrite(stepcount+1);
/*
			if(myrank == 0){
				char removefilename[100];
				int iii;
				for(iii=0;iii<nrank;iii++){
					sprintf(removefilename,"%s.%.5d%.5d",rvprefix,
							stepcount-20+1,iii);
					remove(removefilename);
				}
			}
*/
/* Resort particles by slice bins */
			migrate(&np, ngz, zheight, zstart);
			if(myrank == 0){
              fp=fopen("PHYSICAL_PARAMETERS.dat","a");
              fprintf(fp,"Ansynchronous saving\n");
              fprintf(fp,"%d %d %d %d %12.4f \n",ng,ngz,nspace,iseed,size);
              fprintf(fp,"%10.4f %10.4f %10.4f %10.4f %10.4f %10.4f \n",
                      omep,omeplam,amax,astep,pconv,vconv);
              fprintf(fp,"%10.4f %10.4f %d \n",a,redshift, stepcount);
              fprintf(fp,"%12.6E %12.6E %12.6E %12.6E %f %d \n",
                      ken,ktot,const0,poten0,rth,0 );
              fclose(fp);
			}
			if(elapsedtime > maxtime || stepcount == nstep || suddenstop){
				MPI_Finalize();exit(0);
			}
		}
		TIMER_STOP(51);
		if(myrank == 0) {
			elapsedtime = gettime();
            fprintf(stderr,"Step %d CPU= %f \n", stepcount,ELAPSED_TIME(51));
			fprintf(stderr,"Wallclock time = %g\n",elapsedtime);
		}
		MPI_Bcast(&elapsedtime, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
		if( elapsedtime > maxtime ) {
			if( myrank == 0 ) {
				fprintf(stderr,"Exceeded time limit %g seconds - exiting\n",
					maxtime);
			}
		}

	}
    /* end of do-loop */
    if(myrank == 0) printf("Finishing at a = %f \n", a);
	fflush(stdout);
    fftwfinal_(&plan,&iplan);
	if(myrank ==0) fprintf(stderr,"Exiting pm\n");
}

#ifdef ACCOUT
void getrv(myrank,np,particles)
int myrank, np;
basicparticletype *particles;
{
	int i, numprocs, dummy, count;
	float m, x, y, z, vx, vy, vz;
	basicparticletype *p;
	MPI_Status receive_status;
	indextype indx
	FILE *rvfile;

	dummy = 1;
	MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
	if( myrank == 0 ) {
		rvfile = fopen("rvtmp","r");
		count = 0;
		for(i=0; i<np; i++) {
			fread(&m,sizeof(float),1,rvfile);
			fread(&x,sizeof(float),1,rvfile);
			fread(&y,sizeof(float),1,rvfile);
			fread(&z,sizeof(float),1,rvfile);
			fread(&vx,sizeof(float),1,rvfile);
			fread(&vy,sizeof(float),1,rvfile);
			fread(&vz,sizeof(float),1,rvfile);
			fread(&indx,sizeof(indextype),1,rvfile);
			p = &particles[i];
			p->mass = m;
			p->x = (x + 0.5)*L;
			p->y = (y + 0.5)*L;
			p->z = (z + 0.5)*L;
			p->vx = vx;
			p->vy = vy;
			p->vz = vz;
			p->indx = indx;
#ifndef VarPM
			p->freework = 1;
#endif
		}
		fclose(rvfile);
		SEND(1,0,&dummy,sizeof(dummy));
	}
	else {
		RECEIVE(myrank-1,0,&dummy,sizeof(int));
		rvfile = fopen("rvtmp","r");
		fseek(rvfile,myrank*np*28,0);
		for(i=0; i<np; i++) {
			fread(&m,sizeof(float),1,rvfile);
			fread(&x,sizeof(float),1,rvfile);
			fread(&y,sizeof(float),1,rvfile);
			fread(&z,sizeof(float),1,rvfile);
			fread(&vx,sizeof(float),1,rvfile);
			fread(&vy,sizeof(float),1,rvfile);
			fread(&vz,sizeof(float),1,rvfile);
			fread(&indx,sizeof(indextype),1,rvfile);
			p = &particles[i];
            p->mass = m;
            p->x = (x + 0.5)*L;
            p->y = (y + 0.5)*L;
            p->z = (z + 0.5)*L;
            p->vx = vx;
            p->vy = vy;
            p->vz = vz;
            p->indx = indx;
#ifndef VarPM
            p->freework = 1;
#endif
		}
		fclose(rvfile);
		if( myrank + 1 < numprocs ) SEND(myrank+1,0,&dummy,sizeof(int));
	}
    p = particles;
    fprintf(stderr,"P%d %g %g %g\n",myrank,p->x,p->y,p->z);


    SYNCHRONIZE();
}

#endif

/* This structure CPU is for checking the ellapsed time */
#define TICKS 100.
float ctimes(){
    struct tms local;
    times (&local);
    return((float) (local.tms_utime+local.tms_stime+local.tms_cutime
                +local.tms_cstime)/TICKS);
}


void SaveWholeDen(float *fftwmesh,int nx,int ny,int nz,int local_nz,
		int myrank,int nrank, int stepcount, float amax,float a){
	int i,j,k;
	int ii;
	FILE *fp;
	char filename[100];
	sprintf(filename,"WholeDen.%.5d",stepcount);
	for(ii=0;ii<nrank;ii++){
		if(ii == myrank){
			if(myrank ==0)  fp = fopen(filename,"w");
			else fp = fopen(filename,"a");
			if(myrank == 0) {
				fwrite(&amax,sizeof(int),1,fp);
				fwrite(&a,sizeof(int),1,fp);
				fwrite(&nx,sizeof(int),1,fp);
				fwrite(&ny,sizeof(int),1,fp);
				fwrite(&nz,sizeof(int),1,fp);
			}
			fwrite(fftwmesh,sizeof(float),2*(nx/2+1)*ny*local_nz,fp);
			fclose(fp);
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}

}
void savexzslice(float *den,int nx,int nz,int local_nz, int myrank,int nrank,
		int stepcount){
	char filename[100];
	FILE *fp;
	int i,ii;
	sprintf(filename,"xzslice.%.5d",stepcount);
	for(ii=0;ii<nrank;ii++){
		if(myrank == ii){
			if(ii == 0){
				fp = fopen(filename,"w");
				fwrite(&nx,sizeof(int),1,fp);
				fwrite(&nz,sizeof(int),1,fp);
			}
			else fp = fopen(filename,"a");
			fwrite(den,sizeof(float),nx*local_nz,fp);
			fflush(fp);
			fclose(fp);
		}
        MPI_Barrier(MPI_COMM_WORLD);
	}
}
void SaveSlice(float *den,int nx,int ny,int nz,int myrank,int stepcount){
	char filename[100];
	FILE *fp;
	int i;
	if(myrank == 0){
		sprintf(filename,"slice.%.5d",stepcount);
		fp = fopen(filename,"wb");
		fwrite(&nx,sizeof(int),1,fp);
		fwrite(&ny,sizeof(int),1,fp);
		for(i=0;i<ny;i++){
			fwrite(den+i*(2*(nx/2+1)),sizeof(float),nx,fp);
		}
		fflush(fp);
		fclose(fp);
	}
}

void SaveFSlice(float *den,int nx,int ny,int nz,int local_nz,
		int myrank,int stepcount){
	char filename[100];
	int nnx;
	FILE *fp;
	int i,numprocs;
	nnx = 2*(nx/2+1);
	MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
	sprintf(filename,"pslice.%.5d",stepcount);
	if(myrank == 0)
		fp = fopen(filename,"w");
	else 
		fp = fopen(filename,"a");
	for(i=0;i<numprocs;i++){
		if(myrank == i){
			fwrite(&nx,sizeof(int),1,fp);
			fwrite(&ny,sizeof(int),1,fp);
			fwrite(&nz,sizeof(int),1,fp);
			fwrite(den,sizeof(float),2*(nx/2+1)*ny*local_nz,fp);
			fflush(fp);
			fclose(fp);
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}
}
