#include "defs.h"
#include "extern.h"
#include<sys/times.h>
#include<srfftw_mpi.h>
#include"fortran.h"
#include "extern_simparam.h"
#include "pm_extern.h"
#include <stddef.h>
#define pow2(A) ((A)*(A))
#define EXIT(A) { MPI_Abort(MPI_COMM_WORLD,A); exit(A); }

/* These lines are for common of fortran */
struct common{
    float a;
	float kenold;
	float size;
    int iseed;
    float amax;
	float astep;
} ;
extern struct common seed2_;
int TreeCorrection();

/* This structure CPU is for checking the ellapsed time */
#define TICKS 100.
float ctimes(){
	struct tms local;
	times (&local);
	return((float) (local.tms_utime+local.tms_stime+local.tms_cutime
				+local.tms_cstime)/TICKS);
}
#define pow3(A) ((A)*(A)*(A))

/*         */
int wdata2disk(int ,int ,int ,int ,float ,float , float , float ,float ,
		float ,float ,float , float ,basicparticletype *, int ,int ,
	        int ,int );

/* PM main */
void pm(int icont, int iwrite, int nx, int ny, int nz, int local_nz)
{
	float stime;
	MPI_Status status;
    float kenold,size,amax,astep;
    int iseed;
	int maxnp,minnp,tnp;
	int nn;
	float dummytime;
	int ierror;
	float work1;
	int local_ny_after_transpose, local_y_start_after_transpose;
	int total_local_size,local_z_start;
	rfftwnd_mpi_plan plan,iplan;
	int i,j,k;
	float pmas,pmass,corn1, epssq;
	int ng,mgz,ngz,ngh,nghp1,ngzc,mz;
	float rng,rngz,rngc,rngp6,rngm6,rngzc,zxy,xyz,pi;
	float omei,zi,zout1,zout2;
	float omep,omeplam;
	float tzero,tstep=0.,sstep=0.;
	int nspace,nowflag,now,nstep1,nstep2,istep, stepcount;
	float poten,tken,kenata;
	double kentmp;
	FILE *fp;
	char *mymalloc();
	int nmax, ptrsize(), freespace();
	basicparticletype *bp;
	/* nxpos indicate the position of "x" variable in the particle structure */
	/* Its value is relevant to the Fortran array convention */
	int nxpos;
	int movieflag;


	float dzmax,tdzmax,Const,conserv;
	float redshift,pconv,vconv,ttime,std,pfact,dxda2;
	float fact1, fact2;
    int nwrite,nred,nred10,nred100,nred1000;
	/* This is for the grid force */
	float *forcearray,*den1,*den2,*swpden,*gridfx,*gridfy,*gridfz;
	int enoughspace;
	float *addspace;
#ifdef INCLUDE_TREE_FORCE
	static float efold=0.9;
#else
	static float efold = 0.5;
#endif
	float zheight, zstart;
	
	/* setting of nxpos */
	nxpos = (int)offsetof(basicparticletype,x) /sizeof(float);
	nn = sizeof(basicparticletype)/sizeof(float);

#ifdef MOVIE
/*
	A. Neveol's imagelib initialization
*/
		movieflag = initCamera(camerafilename);
#endif


#if defined ENOUGH_SPACE && FFTWORK
	fftwinitaddspace_(&plan,&iplan,&nx,&ny,&nz,&local_nz,&local_z_start,
			&local_ny_after_transpose,&local_y_start_after_transpose,
			&total_local_size);
	enoughspace = 1;
#else
	fftwinit_(&plan,&iplan,&nx,&ny,&nz,&local_nz,&local_z_start,
			&local_ny_after_transpose,&local_y_start_after_transpose,
			&total_local_size);
	enoughspace = 0;
#endif

	zheight = (float) local_nz;
	zstart = (float) local_z_start;

/* reading data and restarting */

	if(icont == 1) {
fprintf(stderr,"starting jread\n");

		ng = nmesh; ngz = nmesh; nspace = nspace0;
		pconv = vconv = 1.0; /* not sure what these do */
		redshift = amax/a - 1.0;
        nspace = nspace0;
        omep = omega;
        omeplam = lambda;
        rth = rtophat_mesh;

        kenold = ken;
        size = boxsize_hinv_mpc;
        iseed = seed;
        amax = 1.0 + z_init;
        astep = delta_a;

		jread();
fprintf(stderr,"particle ptrsize %d\n",ptrsize(particles));

/* Resize the particle array to the particle number size */
		particles = (basicparticletype *) 
					resizelast(particles,np*sizeof(basicparticletype));

		for(i=0; i<np; i++) {
			particles[i].freework = 1.0;
			particles[i].epssq = 4.0e-8;
		}

	  	migrate(&np, ngz, zheight, zstart);

		rng = (float) ng;
		mz = nz;
		ngz = mz;
		rngz = (float) ngz;
		ngh = ng/2;
		nghp1 = ng/2+1;
		rngc = rng*rng*rng;
		rngp6 = rngc*rngc;
		rngm6 = 1./rngp6;
		ngzc  = ng*ng*ngz;
		zxy   = rngz/rng;
		xyz   = rng/rngz;
		pi = 3.141592654;
		pmas = nspace*nspace*nspace;
		pmass = pmas/rngc;
		fda4sup_(tabp0,tabp1,tabm1,zabp0,zabp1,zabm1,&nx,&nz,&local_nz);
		zi = amax - 1.;
		omei = omep*pow3(1.+zi)/
			(omep*pow3(1+zi)+omeplam+(1-omep-omeplam)*pow2(1.+zi));

		istep = rint(1./astep);
	}
    /* PMSEED */
    else {
		/* clean this up later */

        nspace = nspace0;
        omep = omega;
        omeplam = lambda;
        rth = rtophat_mesh;

		ng = nx;
		rng = (float) ng;
		mz = nz;
		ngz = mz;
		rngz = (float) ngz;
		ngh = ng/2;
		nghp1 = ng/2+1;
		rngc  = pow3(rng);
		rngp6 = rngc*rngc;
		rngm6 = 1./rngp6;
		ngzc  = ng*ng*ngz;
		rngzc = (float) ngzc;
		zxy = rngz/rng;
		xyz = rng/rngz;
		np = ngzc/nspace/nspace/nspace/nrank;
		pi = 3.141592654;
  		pmas = pow3(nspace);
		pmass = pmas/rngc;
		ktot = 0.;

		particles = (basicparticletype *)
					resizelast(particles,np*sizeof(basicparticletype));

#ifdef ENOUGH_SPACE
		work = (float *) mymalloc(4*worksize*sizeof(float));
		addspace = (work+densize);
#else
		work = (float *) mymalloc(worksize*sizeof(float));
		addspace = work;
#endif
		den = work;
        pmseed_(&np,particles,&nn,&nxpos,den,&nx,&ny,&nz,&local_nz,
				&local_z_start,&myrank,&nrank,&iplan,rcounts,displs,
				&omep,&omeplam,tabp0,tabp1,zabp0,zabp1,&enoughspace,
				addspace);
#ifdef GIGA
#else
		for(i=0; i<np; i++) {
			particles[i].mass = pmass;
			particles[i].freework = 1.0;
			particles[i].epssq = 4.0e-8;
		}
#endif
		a = seed2_.a;
        kenold = seed2_.kenold;
        size = seed2_.size;
        iseed = seed2_.iseed;
        amax = seed2_.amax;
        astep = seed2_.astep;

		zi = amax - 1.;
        omei = omep*pow3(1.+zi)/
			(omep*pow3((1.+zi))+omeplam+(1.-omep-omeplam)*pow2((1.+zi)));
		nowflag = 0;
		fda4sup_(tabp0,tabp1,tabm1,zabp0,zabp1,zabm1,&nx,&nz,&local_nz);
		now = 0;
		redshift = amax/a - 1.;

		/* Free up the work memory */
		freelast(work);

#ifdef ACCOUT
        getrv(myrank,np,particles);
		fprintf(stderr,"P%d got %d particles\n",myrank,np);
#endif
				    
		if( myrank == 0 ) {
		    bp = particles;
		    fprintf(stderr,"P%d particle0 is %g %g %g %g %g %g\n", myrank,
			        bp->x, bp->y, bp->z, bp->vx, bp->vy, bp->vz);
		}


fprintf(stderr,"P%d zheight %g zstart %g np=%d\n",myrank,zheight,zstart,np);

		jwrite(stepnum);
	  	migrate(&np, ngz, zheight, zstart);

		SYNCHRONIZE();

		if( myrank == 0 ) {
		    bp = particles;
		    fprintf(stderr,"after migrate\n");
		    fprintf(stderr,"P%d particle0 is %g %g %g %g %g %g\n", myrank,
			        bp->x, bp->y, bp->z, bp->vx, bp->vy, bp->vz);
		}
		MPI_Reduce(&np,&tnp,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);

		if(myrank == 0) fprintf(stderr,"Total particle number : %d\n",tnp);
		fflush(stdout);
		istep = (2*(1./astep)+1)/2;
		zout2 = 1 + 2;
		zout1 = 1 + 1;
  		nstep2 = (2*(amax/zout2-1)/astep+1)/2;
  		nstep1 = (2*(amax/zout1-1)/astep+1)/2;
		if(myrank == 0) printf("nstep2, nstep1, istep = %d %d %d \n",
				nstep2,nstep1,istep);
		fflush(stdout);
	}

    /*
      Cell positions run from 0 to n-1 while particle positions
      run from 0 to n
      (xp,yp,zp) = particle position
      (ic,jc,kc) = major cell's position the superparticle clould belongs to.
      (icc,jcc,kcc) = minor cell's position
      CPU : Scalar (1.84), Vector (1.02,8.1,65) for ng = 32,64,128
     */

/* MAIN TIME LOOP FOR SIMULATION */
	for(stepcount=stepnum; stepcount<=nstep; stepcount++) {

		TIMER_START(51);

/* Allocate work array for FFT's */

#ifdef ENOUGH_SPACE
		work = (float *) mymalloc(4*worksize*sizeof(float));
		addspace = (work+densize);
#else
		work = (float *) mymalloc(worksize*sizeof(float));
		addspace = work;
#endif
		den = work;
 
#if defined(TSC_SWAP)  && defined(ENOUGH_SPACE)
		den2 = (work+worksize);
#if defined(TSC_SWAP_TUNE)
		/*
		tscswptune_(den,den2,&nx,&ny,&nz,&local_nz,&local_z_start,x,y,z,
		            &np,&pmas,&myrank,&nrank);
					*/
		tscswptune_(den,den2,&nx,&ny,&nz,&local_nz,&local_z_start,particles,
				&nn,&nxpos,&np,&pmas,&myrank,&nrank);
#else
		tscswp_(den,den2,&nx,&ny,&nz,&local_nz,&local_z_start,particles,&nn
				&nxpos,&np,&pmas,&myrank,&nrank);
#endif
#else
#if defined(TSC_TUNE)
		tsctune_(den,&nx,&ny,&nz,&local_nz,&local_z_start,particles,&nn,
				&nxpos, &np,&pmas,&myrank,&nrank);
#endif
		tsc_(den,&nx,&ny,&nz,&local_nz,&local_z_start,particles,&nn,&nxpos,
				&np,&pmas,&myrank,&nrank);
#endif
		/* Forward FFT */
  		if(enoughspace == 0){
		    fftforward_(&plan,den,&myrank);
		}
		else{
			addspace = (work+densize);
		    fftforwardaddspace_(&plan,den,addspace,&myrank);
		}
		/* Correlation Fct. and Power spectrum */
		std = 0;
#ifdef CORRELATION_FUNCTION
		if( stepcount == 0 ) {
			correl_(den,&nx,&ny,&nz,&local_nz,&local_z_start,
					pk,npk,cor,tpk,tnpk,tcor,&corn1,&std,&myrank,&nrank,
					&rngm6,&a,&nowflag,&now,&xyz,&rth,&nstep,
					&local_ny_after_transpose,
					&local_y_start_after_transpose);
		}
#endif

		psolver_(den,&nx,&ny,&nz,&local_nz,&local_ny_after_transpose,
				&local_y_start_after_transpose,&poten,&rngc,&rngm6,
				&myrank,&nrank,&efold);

		if(myrank == 0) {
			if( stepcount == 0 ) {
				if((fp = fopen("pmevol.map","a")) != NULL){
					for(i=0;i<ngh;i++){
						fprintf(fp,"%6d %6d  %.2E  %.2E \n",
								i+1,i,*(pk+i), *(cor+i));
					}
					ierror = fclose(fp);
				}
			}
		}

		/* Complex-to-Real FFT in a transposed order */
  		if(enoughspace == 0){
			fftbackward_(&iplan,den,&myrank);
		}
		else {
			addspace = (work+densize);
			fftbackwardaddspace_(&iplan,den,addspace,&myrank);
		}


		/* four-point FDA in calculating force at each particle */

#ifdef ENOUGH_SPACE
#ifdef FDA_FORCE_ARRAY_SWAP
		forcearray = (work+worksize);
		swpden = den;
		den1 = forcearray;
#ifdef FDA_SWAP_TUNE
		/*
        fda4gfswptune_(x,y,z,vx,vy,vz,&np,den,swpden,den1,forcearray,
				&nx,&ny,&nz,&local_nz,&a,&astep,
				&amax,&omei,&omep,&omeplam,&pfact,&local_z_start,
				&myrank,&nrank,&fact1,&fact2);
				*/
        fda4gfswptune_(particles,&nn,&nxpos,&np,den,swpden,den1,forcearray,
				&nx,&ny,&nz,&local_nz,&a,&astep,
				&amax,&omei,&omep,&omeplam,&pfact,&local_z_start,
				&myrank,&nrank,&fact1,&fact2);
#else
        fda4gfswp_(particles,&nn,&nxpos,&np,den,swpden,den1,forcearray,
				&nx,&ny,&nz,&local_nz,&a,&astep,
				&amax,&omei,&omep,&omeplam,&pfact,&local_z_start,
				&myrank,&nrank,&fact1,&fact2);
#endif

#else
		gridfx = (work+worksize);
		gridfy = (work+2*worksize);
		gridfz = (work+3*worksize);
		fda4gf_(particles,&nn,&nxpos,&np,den,gridfx,gridfy,gridfz,
				&nx,&ny,&nz,&local_nz,&a,&astep,
				&amax,&omei,&omep,&omeplam,&pfact,tabp0,tabp1,tabm1,
				zabp0,zabp1,zabm1,&local_z_start,&myrank,&nrank,
				&fact1,&fact2);
#endif   
#else
		fda4_(particles,&nn,&nxpos,&np,den,&nx,&ny,&nz,&local_nz,&a,&astep,
				&amax,&omei,&omep,&omeplam,&pfact,tabp0,tabp1,tabm1,
		        zabp0,zabp1,zabm1,&local_z_start,&myrank,&nrank,
				&fact1,&fact2);
#endif

/* Free the work array for tree calculations */
		freelast(work);

		/*  
		 *  4-point FDA end
		 */
#ifdef INCLUDE_TREE_FORCE
		if( myrank == 0 ) {
			    bp = particles;
			    fprintf(stderr,"P%d particle0 is %g %g %g %g %g %g\n", myrank,
					        bp->x, bp->y, bp->z, bp->vx, bp->vy, bp->vz);
		}

#ifdef GIGA
		epssq = 4.0e-8;
        np = TreeCorrection(&np,particles,fact1,fact2,pfact,pmass,epssq);
#else
        np = TreeCorrection(&np,particles,fact1,fact2,pfact);
#endif
		fmod_(&np,&rng,particles,&nn,&nxpos);
#endif

		kentmp = 0.;
		dzmax = 0.;
		for(i=0;i<np;i++){
			kentmp += pow2(particles[i].vx) + pow2(particles[i].vy)
				+ pow2(particles[i].vz);
			if(fabs(particles[i].vz*pfact)>dzmax) 
				dzmax =  fabs(particles[i].vz*pfact);
		}
		ken = (float) kentmp;

		MPI_Reduce(&dzmax,&tdzmax,1,MPI_FLOAT,MPI_MAX,0,MPI_COMM_WORLD);
		dzmax = tdzmax;
		MPI_Bcast(&dzmax,1,MPI_FLOAT,0,MPI_COMM_WORLD);
		if(myrank == 0) printf("Max. displacement in z = %f\n",dzmax);
		fflush(stdout);
		MPI_Reduce(&ken,&tken,1,MPI_FLOAT,MPI_SUM,0,MPI_COMM_WORLD);
		ken = tken;
		MPI_Bcast(&ken,1,MPI_FLOAT,0,MPI_COMM_WORLD);

		dxda2 = ken;
		ken = 0.5*pmass*8.*pi/3.*ken*
             (1./(a+0.5*astep)+1./omei-1+
		     omeplam/omep/amax/amax/amax*((a+0.5*astep)*(a+0.5*astep)-1.));
		kenata = (ken+kenold)/2.;
		ktot = ktot + a*a*kenold*astep;
		if(a == 1) {
			kenata = kenold;
			ktot = 0.;
			poten0 = poten;
		}
		Const = a*a*a*kenata+poten+ktot;
		if(a == 1){
			const0 = Const;
			conserv = 0.;
		}
		else
			conserv = (Const-const0)/(poten-poten0);
		ttime = pow(a/amax,1.5);
		if(myrank == 0){
			printf("%f   %g   %g   %g   %g \n",a,std,poten,kenata,Const);
			if((fp=fopen("pm3.out","a")) != NULL){
				fprintf(fp," %6.2f %9.4f %11.3E %10.3E %10.2E %8.4f %9.4f \n",
						a,ttime,poten,kenata,Const,conserv,dxda2);
				fclose(fp);
			}
		}
				
	  	migrate(&np, ngz, zheight, zstart);

	  MPI_Reduce(&np,&tnp,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
	  MPI_Reduce(&np,&maxnp,1,MPI_INT,MPI_MAX,0,MPI_COMM_WORLD);
	  MPI_Reduce(&np,&minnp,1,MPI_INT,MPI_MIN,0,MPI_COMM_WORLD);
	  if(myrank == 0) {
		  printf("Total particle number : %d \n",tnp);
		  printf("max. # of prts in slices : %d \n",maxnp);
		  printf("min. # of prts in slices : %d \n",minnp);
		  fflush(stdout);
	  }
	  /* Movie */
#ifdef MOVIE
/*
      dummytime = 0.0;
      mkframe(&stepcount,&dummytime,&np,particles);
*/
/* A. Neveol's rendering tool */
	if( movieflag ) 
		RenderImage(&stepcount,L,&np,particles);

#endif

	  /*
      Writing Data at z = 0, 0.5, 1, 2, 3, 5, 7 if nwrite=1
	  */
      nwrite = 1;
      if(nwrite == 1){
          if( stepcount > stepnum && stepcount % nskip == 0 ) {
	  		  migrate_indx(&np, myrank, nrank,ng*ng*ngz/nspace/nspace/nspace);
#ifdef never
              wdata2disk(ng,ngz,nspace,iseed,size,omep,omeplam,
                      amax,astep,pconv,vconv,a,redshift,particles,
                      np,myrank,nrank,nred10);
#endif
              jwrite(stepcount);
			  migrate(&np, ngz, zheight, zstart);

/*
#ifdef ENOUGH_SPACE
			  work = (float *)malloc(4*worksize*sizeof(float));
#else
              work = (float *)malloc(worksize*sizeof(float));
#endif
*/
			  den = work;
              if(myrank == 0){
                  fp=fopen("PHYSICAL_PARAMETERS.dat","a");
                  fprintf(fp,"%d %d %d %d %12.4f \n",ng,ngz,nspace,iseed,size);
                  fprintf(fp,"%10.4f %10.4f %10.4f %10.4f %10.4f %10.4f \n",
                          omep,omeplam,amax,astep,pconv,vconv);
                  fprintf(fp,"%10.4f %10.4f %d %d \n",a,redshift,nred10,
						stepcount);
                  fprintf(fp,"%12.6E %12.6E %12.6E %12.6E %f %d \n",
                          ken,ktot,const0,poten0,rth,0 );
                  fclose(fp);
              }
          }
      }

      kenold = ken;
	  TIMER_STOP(51);
      if(myrank == 0) {
            fprintf(stderr,"Step %d CPU= %f \n", stepcount,ELAPSED_TIME(51));
      }
	  fflush(stdout);

		a = a + astep;
		redshift = amax/a - 1.;
		pconv = 1.; vconv = 1.;

	}
    /* end of do-loop */

    if(myrank == 0) printf("Finishing at a = %f \n", a);
	fflush(stdout);
    fftwfinal_(&plan,&iplan);
	if(myrank ==0) fprintf(stderr,"Exiting pm\n");
}

#ifdef ACCOUT
getrv(myrank,np,particles)
int myrank, np;
basicparticletype *particles;
{
	int i, numprocs, dummy, count;
	float m, x, y, z, vx, vy, vz;
	basicparticletype *p;
	MPI_Status receive_status;
	FILE *rvfile;

	dummy = 1;
	MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
	if( myrank == 0 ) {
		rvfile = fopen("rvtmp","r");
		count = 0;
		for(i=0; i<np; i++) {
			fread(&m,sizeof(float),1,rvfile);
			fread(&x,sizeof(float),1,rvfile);
			fread(&y,sizeof(float),1,rvfile);
			fread(&z,sizeof(float),1,rvfile);
			fread(&vx,sizeof(float),1,rvfile);
			fread(&vy,sizeof(float),1,rvfile);
			fread(&vz,sizeof(float),1,rvfile);
			p = &particles[i];
/*
			p->mass = m;
*/
			p->x = (x + 0.5)*L;
			p->y = (y + 0.5)*L;
			p->z = (z + 0.5)*L;
			p->vx = vx;
			p->vy = vy;
			p->vz = vz;
			p->indx = i + myrank*np;
			p->freework = 1;
		}
		fclose(rvfile);
		SEND(1,0,&dummy,sizeof(dummy));
	}
	else {
		RECEIVE(myrank-1,0,&dummy,sizeof(int));
		rvfile = fopen("rvtmp","r");
		fseek(rvfile,myrank*np*28,0);
		for(i=0; i<np; i++) {
			fread(&m,sizeof(float),1,rvfile);
			fread(&x,sizeof(float),1,rvfile);
			fread(&y,sizeof(float),1,rvfile);
			fread(&z,sizeof(float),1,rvfile);
			fread(&vx,sizeof(float),1,rvfile);
			fread(&vy,sizeof(float),1,rvfile);
			fread(&vz,sizeof(float),1,rvfile);
			p = &particles[i];
/*
            p->mass = m;
*/
            p->x = (x + 0.5)*L;
            p->y = (y + 0.5)*L;
            p->z = (z + 0.5)*L;
            p->vx = vx;
            p->vy = vy;
            p->vz = vz;
            p->indx = i + myrank*np;
            p->freework = 1;
		}
		fclose(rvfile);
		if( myrank + 1 < numprocs ) SEND(myrank+1,0,&dummy,sizeof(int));
	}
    p = particles;
    fprintf(stderr,"P%d %g %g %g\n",myrank,p->x,p->y,p->z);


    SYNCHRONIZE();
}

#endif
