#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "mpi.h"
#include "pmheader.h"
int c_npdata(int nrank,int myrank,int *np,int inumber){
	FILE *fp;
	char *fileheader = FILEHEADER;
	char number[3],procname[3];
	char *filename =  (char *)malloc(100*sizeof(char));
	int i,j;
	sprintf(number,"%03d",inumber);
	sprintf(procname,"%03d",myrank);
	strcpy(filename,fileheader);
	strcat(filename,number);
	strcat(filename,"_");
	strcat(filename,procname);
	for(j=0;j<nrank;j++){
		if(j == myrank){
			fp = fopen(filename,"r");
			for(i=0;i<5;i++)
				fread(np,sizeof(int),1,fp);
			fclose(fp);
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}
	free(filename);
	return 0;
}
int c_rdatafromdisk(int *ng,int *ngz,int *nspace,int *iseed,
		float *size,float *omep,float *omeplam, 
		float *amax,float *astep,float *pconv,float *vconv,float *a,
		float *redshift,float *ken,basicparticletype *particles,
		int *np,int myrank,int nrank,int inumber,int nstep){
	int n,i,j;
	char *fileheader = FILEHEADER;
	char number[3],procname[3];
	FILE *fp;
	char *filename =  (char *)malloc(100*sizeof(char));
	sprintf(number,"%03d",inumber);
	sprintf(procname,"%03d",myrank);
	strcpy(filename,fileheader);
	strcat(filename,number);
	strcat(filename,"_");
	strcat(filename,procname);
	if(myrank == 0)
			fprintf(stdout,"reading data from a=%g,z=%g",a,redshift);
	for(j=0;j<nrank;j++){
		if(j == myrank){
			fp = fopen(filename,"r");
			reading_header(ng,ngz,nspace,iseed,np, size,omep,omeplam,
					amax,astep,pconv,vconv,a,redshift,fp);
			fread(particles,sizeof(basicparticletype),*np,fp);
			fflush(fp);
			fclose(fp);
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}
	if(myrank == 0)
			fprintf(stdout,"well read data from a=%g,z=%g",a,redshift);
	free(filename);
	return 0;
}
int reading_header(int *ng,int *ngz,int *nspace,int *iseed,int *np,
		float *size,float *omep,float *omeplam,float *amax,float *astep,
		float *pconv,float *vconv,float *a,float *redshift,FILE *fp){
	fread(ng,sizeof(int),1,fp);
	fread(ngz,sizeof(int),1,fp);
	fread(nspace,sizeof(int),1,fp);
	fread(iseed,sizeof(int),1,fp);
	fread(np,sizeof(int),1,fp);
	fread(size,sizeof(float),1,fp);
	fread(omep,sizeof(float),1,fp);
	fread(omeplam,sizeof(float),1,fp);
	fread(amax,sizeof(float),1,fp);
	fread(astep,sizeof(float),1,fp);
	fread(pconv,sizeof(float),1,fp);
	fread(vconv,sizeof(float),1,fp);
	fread(a,sizeof(float),1,fp);
	fread(redshift,sizeof(float),1,fp);
	fflush(fp);
	return 0;
}
