/*
 *  ڵ  X0,Y0,Z0  ġ ڰ ùķ̼ ڽ 
 * ùķ̼ ڵ     Ÿ.
 *   comoving space  ùķ̼ǿ  Ÿ ´.
 *  theta, phi    1и鿡  ϴ.
 *  2,3,4 и鿡 ϰ ҷ, min,max   
 * ٲپ Ѵ. ׸  κп ش ڸ ã  phi  
 * ϴµ,
 * ⿡ ׳ 1,4и̶  ߴ. 
 * wflag   2 ǥؾ Ѵ.
 * 09/08/2002  
 */
#include<stdio.h>
#include<stdlib.h>
#include <math.h>
#include <mpi.h>
#include "Memory.h"
#include "pmheader.h"
#include "lightcone.h"
#define MIN(A,B) ((A) <(B) ? (A):(B))
#define PI 3.1415926535L
double Theta,Phi,DTheta,DPhi;
char surveyfilename[100];
int *freework;
enum boolean { NO = 00,YES = 01};
typedef struct Spherical{
	double r,theta,phi;
} Spherical;
InBox *box;
double r1, r2;
double theta,phi,theta1,phi1,theta2,phi2;
float omega0,H,lambda0;
float qsimp(float (*)(float),float,float);
float trapzd(float (*)(float), float , float , int );
typedef struct slcparticletype{
	float x,y,z,vx,vy,vz;
	pmparticletype *bp;
	/*
	float dist;
	*/
#ifdef INDEX
	indextype indx;
#endif
	int type;
} slcparticletype;
typedef struct lightconetype{
	float x,y,z,vx,vy,vz;
#ifdef INDEX
	indextype indx;
#endif
} lightconetype;

int ssorttype(const void *a,const void *b){
	slcparticletype *aa,*bb;
	aa = (slcparticletype *)a;
	bb = (slcparticletype *)b;
	if(aa->type < bb->type) return -1;
	else if(aa->type > bb-> type) return +1;
	else return 0;
}

#define NPSTEP 10000

static float rmin2,rmax2;
static slcparticletype *slcparticles;
static int snlcp,maxlcp,tsnlcp,mbox;
/* if dist >= r1-maxd && dist < r1 --> located in inner buffer zone 
   if dist >= r1 && dist < r2 --> located in the main zone
   if dist >= r2 && dist < r2+maxd --> located in the outter buffer zone
   */
#define SX0 0.
#define SY0 (0.5*ny)
#define SZ0 0.
#define twoPI (6.283185306L)
#define deg2rad (0.017453292516L)
void a2comovingpixel(double *, double *, double *,int , float ,float , float ,float ,
		float ,float ,float , float );
void SliceExtractingLightConeParticles(pmparticletype *pmparticles,
		int np,int nx,int ny,int nz,
		int mstep, float amax, float a, float astep,float nextastep,
		float boxsize, float omep,float omeplam,float hubble,int myid,int nid,float maxd){
	pmparticletype *bp;
	float redshift;
	double r,dr1,dr2,distsq,dist,rot;
	double xp,yp,zp;
	double xpp,ypp,zpp;
	float rminsq,rmaxsq;
	int nbox,ibox;
	int i,j,k;


	nbox = 3*3*5;
	box = (InBox *)Malloc(sizeof(InBox)*nbox,PPTR(box));
	theta1 = 75.L*deg2rad;
	theta2 = 105.L*deg2rad;
	phi1 = 30.L*deg2rad;
	phi2 = 330.L*deg2rad;
	rot = 45.L*deg2rad;
	ibox = 0;
	for(k=0;k<=2;k++)
		for(j=-2;j<=2;j++)
			for(i=0;i<=2;i++){
				box[ibox].nx = i*nx-SX0;
				box[ibox].ny = j*ny-SY0;
				box[ibox].nz = k*nz-SZ0;
				ibox ++;
			}

	a2comovingpixel(&r,&dr1,&dr2,nx,amax,a,astep,nextastep,
			omep,omeplam,boxsize,hubble);
	r1 = (r-dr1);
	if(r1 <0.) r1 = 0;
	r2 = (r+dr2);
	rmin2 = r1*r1;
	rmax2 = r2*r2;
	rminsq = (r1-maxd)*(r1-maxd);
	if(r1<maxd) rminsq = 0.;
	rmaxsq = (r2+maxd)*(r2+maxd);
	if(myid==0) printf("Slice SURVEY %g %g %g at observer=%g %g %g ....",r,dr1,dr2,
			SX0,SY0,SZ0);
	snlcp = 0;
	maxlcp = NPSTEP;
	slcparticles = (slcparticletype *)Malloc(sizeof(slcparticletype)*maxlcp,
			PPTR(slcparticles));
	for(j=0;j<nbox;j++){
		bp = pmparticles;
		for(i=0;i<np;i++){
			xpp = bp->x + box[j].nx;
			yp = ypp = bp->y + box[j].ny;
			zpp = bp->z + box[j].nz;
			xp =  cos(rot)*xpp + sin(rot)*zpp;
			zp = -sin(rot)*xpp + cos(rot)*zpp;
			distsq = xp*xp+yp*yp+zp*zp;
			if(distsq >= rminsq && distsq < rmaxsq && distsq <35776189.L){
				dist = sqrt(distsq);
				theta = acos(zp/dist);
				if(theta >=theta1 && theta < theta2){
					double dtmp;
					dtmp = xp/sqrt(xp*xp+yp*yp);
					if(dtmp > 1.L) {
						phi=0.L;
					}
					else {
						phi = acos(dtmp);
					}
					if(phi <= phi1){
						slcparticles[snlcp].x = xpp;
						slcparticles[snlcp].y = ypp;
						slcparticles[snlcp].z = zpp;
						slcparticles[snlcp].vx = bp->vx;
						slcparticles[snlcp].vy = bp->vy;
						slcparticles[snlcp].vz = bp->vz;
						slcparticles[snlcp].bp = bp;
						if(dist>=r1&& dist < r2) slcparticles[snlcp].type = 0;
						else if(dist >=r2 && dist < r2+maxd) slcparticles[snlcp].type = 1;
						else slcparticles[snlcp].type = 2;
						/*
						slcparticles[snlcp].dist = dist;
						*/
#ifdef INDEX
						slcparticles[snlcp].indx = bp->indx;
#endif
						snlcp ++;
						if(snlcp >= maxlcp){
							maxlcp += NPSTEP;
							slcparticles = (slcparticletype*)Realloc(slcparticles,
									sizeof(slcparticletype)*maxlcp);
	
						}
					}
				}
			}
			bp++;
		}
	}
	slcparticles = (slcparticletype*)Realloc(slcparticles,
		sizeof(slcparticletype)*snlcp);
	/*
	for(i=0;i<snlcp;i++){
		dist = slcparticles[i].dist;
		if(dist >=r1 && dist < r2) slcparticles[i].type = 0;
		else if(dist >=r2 && dist < r2+maxd) slcparticles[i].type = 1;
		else slcparticles[i].type = 2;
	}
	*/
	if(myid==0) printf("Slice SURVEY %d detected\n",snlcp);
	Free(box);
}

#define writedownlightconedata(A,B,C) {\
	FILE *wp;\
	float x0,y0,z0;\
	int nmlcp;\
	lightconetype *ttmp;\
	x0 = SX0;\
	y0 = SY0;\
	z0 = SZ0;\
	{\
		if(myid==0) {\
			wp=fopen(A,"w");\
			fwrite(&nx,sizeof(int),1,wp);\
			fwrite(&ny,sizeof(int),1,wp);\
			fwrite(&nz,sizeof(int),1,wp);\
			fwrite(&omep,sizeof(float),1,wp);\
			fwrite(&omeplam,sizeof(float),1,wp);\
			fwrite(&omepb,sizeof(float),1,wp);\
			fwrite(&hubble,sizeof(float),1,wp);\
			fwrite(&boxsize,sizeof(float),1,wp);\
			fwrite(&amax,sizeof(float),1,wp);\
			fwrite(&a,sizeof(float),1,wp);\
			fwrite(&astep,sizeof(float),1,wp);\
			fwrite(&x0,sizeof(float),1,wp);\
			fwrite(&y0,sizeof(float),1,wp);\
			fwrite(&z0,sizeof(float),1,wp);\
			fwrite(&rmin2,sizeof(float),1,wp);\
			fwrite(&rmax2,sizeof(float),1,wp);\
			fwrite(&C,sizeof(int),1,wp);\
			fwrite(B,sizeof(lightconetype),C,wp);\
			for(i=1;i<nid;i++){	\
				MPI_Recv(&nmlcp,1,MPI_INT,i,i,MPI_COMM_WORLD,&status);\
				if(nmlcp >0) ttmp=(lightconetype*)Malloc(sizeof(lightconetype)*nmlcp,PPTR(ttmp));\
				MPI_Recv(ttmp,sizeof(lightconetype)*nmlcp,MPI_BYTE,i,i,\
						MPI_COMM_WORLD,&status);\
				fwrite(&nmlcp,sizeof(int),1,wp);\
				fwrite(ttmp,sizeof(lightconetype),nmlcp,wp);\
				if(nmlcp >0) Free(ttmp);\
			}\
			fclose(wp);\
		}\
		else  {\
			MPI_Send(&C,1,MPI_INT,0,myid,MPI_COMM_WORLD);\
			MPI_Send(B,sizeof(lightconetype)*C,MPI_BYTE,0,myid,MPI_COMM_WORLD);\
		}\
	}\
}

void SliceSavingLightConeData(pmparticletype *pmparticles,int np,
		int nx,int ny, int nz, int mstep, float amax, float a, 
		float astep,float nextastep, float boxsize,float omei,
		float omep,float omepb,float omeplam,float hubble,int myid,int nid){
	pmparticletype *bp;
	float redshift;
	double r,dr1,dr2;
	float xp,yp,zp,distsq,dist;
	float rminsq,rmaxsq;
	int nbox;
	int i,j,k;
	float ax,ay,az;
	int *nnp;
	slcparticletype *tp;
	lightconetype *lightcones;
	float ainv,app,apsq,afact,bfact,vfact1h,vfact2h,rng;
	float asteph;
	float vfact1,vfact2;
	MPI_Status status;

	MPI_Reduce(&snlcp,&tsnlcp,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
	MPI_Bcast(&tsnlcp,1,MPI_INT,0,MPI_COMM_WORLD);
	if(tsnlcp==0) return;


	asteph = astep*0.5;
	rng = nx;
	ainv = 1./a;
	app  = -4.*PI/3.*(ainv*ainv-2*omeplam/omep*a/amax/amax/amax);
	apsq = 8.*PI/3.*(ainv+1./omei-1+omeplam/omep*(a*a-1)/amax/amax/amax);
	afact = (2.+app*a/apsq)/2.*ainv;
	bfact = ainv*ainv*ainv/apsq;
	vfact1 = (1.-afact*astep)/(1.+afact*astep);
	vfact2 = bfact*astep/(1.+afact*astep)*rng;
	vfact1h = (1.-afact*asteph)/(1.+afact*asteph);
	vfact2h = bfact*asteph/(1.+afact*asteph)*rng;


	nnp = (int *)Malloc(sizeof(int)*3,PPTR(nnp));
	nnp[0] = nnp[1] = nnp[2] =0;
	tp = slcparticles;
	for(i=0;i<snlcp;i++){
		bp = tp->bp;
		ax = (bp->vx-vfact1*tp->vx)/vfact2;
		ay = (bp->vy-vfact1*tp->vy)/vfact2;
		az = (bp->vz-vfact1*tp->vz)/vfact2;
		tp->vx = vfact1h*tp->vx + vfact2h*ax;
		tp->vy = vfact1h*tp->vy + vfact2h*ay;
		tp->vz = vfact1h*tp->vz + vfact2h*az;
		tp++;
	}
	for(i=0;i<snlcp;i++){
		nnp[slcparticles[i].type]++;
	}
	if(snlcp>0) qsort(slcparticles,snlcp,sizeof(slcparticletype),ssorttype);
	if(snlcp>0) lightcones = (lightconetype *)Malloc(sizeof(lightconetype)*snlcp,
			PPTR(lightcones));
	for(i=0;i<snlcp;i++){
		lightcones[i].x = slcparticles[i].x;
		lightcones[i].y = slcparticles[i].y;
		lightcones[i].z = slcparticles[i].z;
		lightcones[i].vx = slcparticles[i].vx;
		lightcones[i].vy = slcparticles[i].vy;
		lightcones[i].vz = slcparticles[i].vz;
#ifdef INDEX
		lightcones[i].indx = slcparticles[i].indx;
#endif
	}
	{
		lightconetype *pp;

		sprintf(surveyfilename,"slightcone.main.%.5d",mstep);
		pp = lightcones;
		writedownlightconedata(surveyfilename,pp,nnp[0]);

		sprintf(surveyfilename,"slightcone.outer.%.5d",mstep);
		pp += nnp[0];
		writedownlightconedata(surveyfilename,pp,nnp[1]);

		sprintf(surveyfilename,"slightcone.inner.%.5d",mstep);
		pp += nnp[1];
		writedownlightconedata(surveyfilename,pp,nnp[2]);
	}
	/*
	for(i=0;i<nid;i++){
		if(myid==i){
			lightconetype *pp;
			sprintf(surveyfilename,"lightcone.main.%.5d",mstep);
			pp = lightcones;
			writedownlightconedata(surveyfilename,pp,nnp[0]);
	
			sprintf(surveyfilename,"lightcone.outer.%.5d",mstep);
			pp += nnp[0];
			writedownlightconedata(surveyfilename,pp,nnp[1]);
	
			sprintf(surveyfilename,"lightcone.inner.%.5d",mstep);
			pp += nnp[1];
			writedownlightconedata(surveyfilename,pp,nnp[2]);
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}
	*/
	if(snlcp>0) Free(lightcones);
	Free(nnp);
	Free(slcparticles);
}

#undef npstep
