c---  Reads position or position & velocity of particles
c---  npkid = number of particles in the subset

      subroutine pvread(iread,itype,x,y,z,vx,vy,vz,npkid)
      real*4 x(npkid),y(npkid),z(npkid)
      real*4 vx(npkid),vy(npkid),vz(npkid)
      character*2 number
      character*8 pxname,pyname,pzname
      character*9 vxname,vyname,vzname

      number = '0'//char(iread+48)
      if(iread.ge.10)number = '1'//char(iread-10+48)
      if(iread.ge.20)number = '2'//char(iread-20+48)
      if(iread.ge.30)number = '3'//char(iread-30+48)
      if(iread.ge.40)number = '4'//char(iread-40+48)
      if(iread.ge.50)number = '5'//char(iread-50+48)
      if(iread.ge.60)number = '6'//char(iread-60+48)
      pxname = 'x'//number//'.data'
      pyname = 'y'//number//'.data'
      pzname = 'z'//number//'.data'
      ipx = 20
      ipy = 36
      ipz = 52
      open(ipx,file=pxname,form='unformatted',status='old')
      rewind ipx
      read(ipx)(x(i),i=1,npkid)
      close(ipx)
      open(ipy,file=pyname,form='unformatted',status='old')
      rewind ipy
      read(ipy)(y(i),i=1,npkid)
      close(ipy)
      open(ipz,file=pzname,form='unformatted',status='old')
      rewind ipz
      read(ipz)(z(i),i=1,npkid)
      close(ipz)

      if(itype.eq.2)then
      vxname = 'vx'//number//'.data'
      vyname = 'vy'//number//'.data'
      vzname = 'vz'//number//'.data'
      ivx = 100
      ivy = 116
      ivz = 132
c     open(ivx,file='/ufs/chico/tmp/cbp/'//vxname,form='unformatted'
c    &   ,status='old')
      open(ivx,file=vxname,form='unformatted',status='old')
      rewind ivx
      read(ivx)(vx(i),i=1,npkid)
      close(ivx)
c     open(ivy,file='/ufs/chico/tmp/cbp/'//vyname,form='unformatted'
c    &   ,status='old')
      open(ivy,file=vyname,form='unformatted',status='old')
      rewind ivy
      read(ivy)(vy(i),i=1,npkid)
      close(ivy)
c     open(ivz,file='/ufs/chico/tmp/cbp/'//vzname,form='unformatted',
c    &   status='old')
      open(ivz,file=vzname,form='unformatted',status='old')
      rewind ivz
      read(ivz)(vz(i),i=1,npkid)
      close(ivz)
      end if
      return
      end

c---  Writes position and velocity data
c---  npkid = number of particles in the subset
      subroutine pvwrite(iread,x,y,z,vx,vy,vz,npkid)
      real*4 x(npkid),y(npkid),z(npkid)
      real*4 vx(npkid),vy(npkid),vz(npkid)
      character*2 number
      character*8 pxname,pyname,pzname
      character*9 vxname,vyname,vzname

      number = '0'//char(iread+48)
      if(iread.ge.10)number = '1'//char(iread-10+48)
      if(iread.ge.20)number = '2'//char(iread-20+48)
      if(iread.ge.30)number = '3'//char(iread-30+48)
      if(iread.ge.40)number = '4'//char(iread-40+48)
      if(iread.ge.50)number = '5'//char(iread-50+48)
      if(iread.ge.60)number = '6'//char(iread-60+48)
      pxname = 'x'//number//'.data'
      pyname = 'y'//number//'.data'
      pzname = 'z'//number//'.data'
      vxname = 'vx'//number//'.data'
      vyname = 'vy'//number//'.data'
      vzname = 'vz'//number//'.data'
      ipx = 20+iread
      ipy = 36+iread
      ipz = 52+iread
      ivx = 100+iread
      ivy = 116+iread
      ivz = 132+iread

c---  Write position & velocity data
      open(ipx,file=pxname,form='unformatted')
      rewind ipx
      write(ipx)(x(i),i=1,npkid)
      close(ipx)
      open(ipy,file=pyname,form='unformatted')
      rewind ipy
      write(ipy)(y(i),i=1,npkid)
      close(ipy)
      open(ipz,file=pzname,form='unformatted')
      rewind ipz
      write(ipz)(z(i),i=1,npkid)
      close(ipz)
      open(ivx,file=vxname,form='unformatted')
      rewind ivx
      write(ivx)(vx(i),i=1,npkid)
      close(ivx)
      open(ivy,file=vyname,form='unformatted')
      rewind ivy
      write(ivy)(vy(i),i=1,npkid)
      close(ivy)
      open(ivz,file=vzname,form='unformatted')
      rewind ivz
      write(ivz)(vz(i),i=1,npkid)
      close(ivz)
      return
      end



      FUNCTION RAN1(IDUM)
      DIMENSION R(97)
      PARAMETER (M1=259200,IA1=7141,IC1=54773,RM1=3.8580247E-6)
      PARAMETER (M2=134456,IA2=8121,IC2=28411,RM2=7.4373773E-6)
      PARAMETER (M3=243000,IA3=4561,IC3=51349)
      DATA IFF /0/
      IF (IDUM.LT.0.OR.IFF.EQ.0) THEN
        IFF=1
        IX1=MOD(IC1-IDUM,M1)
        IX1=MOD(IA1*IX1+IC1,M1)
        IX2=MOD(IX1,M2)
        IX1=MOD(IA1*IX1+IC1,M1)
        IX3=MOD(IX1,M3)
        DO 11 J=1,97
          IX1=MOD(IA1*IX1+IC1,M1)
          IX2=MOD(IA2*IX2+IC2,M2)
          R(J)=(FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
11      CONTINUE
        IDUM=1
      ENDIF
      IX1=MOD(IA1*IX1+IC1,M1)
      IX2=MOD(IA2*IX2+IC2,M2)
      IX3=MOD(IA3*IX3+IC3,M3)
      J=1+(97*IX3)/M3
      IF(J.GT.97.OR.J.LT.1)PAUSE
      RAN1=R(J)
      R(J)=(FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
      RETURN
      END

      FUNCTION RAN3(IDUM)
C         IMPLICIT REAL*4(M)
C         PARAMETER (MBIG=4000000.,MSEED=1618033.,MZ=0.,FAC=2.5E-7)
      PARAMETER (MBIG=1000000000,MSEED=161803398,MZ=0,FAC=1.E-9)
      DIMENSION MA(55)
      DATA IFF /0/
      IF(IDUM.LT.0.OR.IFF.EQ.0)THEN
        IFF=1
        MJ=MSEED-IABS(IDUM)
        MJ=MOD(MJ,MBIG)
        MA(55)=MJ
        MK=1
        DO 11 I=1,54
          II=MOD(21*I,55)
          MA(II)=MK
          MK=MJ-MK
          IF(MK.LT.MZ)MK=MK+MBIG
          MJ=MA(II)
11      CONTINUE
        DO 13 K=1,4
          DO 12 I=1,55
            MA(I)=MA(I)-MA(1+MOD(I+30,55))
            IF(MA(I).LT.MZ)MA(I)=MA(I)+MBIG
12        CONTINUE
13      CONTINUE
        INEXT=0
        INEXTP=31
        IDUM=1
      ENDIF
      INEXT=INEXT+1
      IF(INEXT.EQ.56)INEXT=1
      INEXTP=INEXTP+1
      IF(INEXTP.EQ.56)INEXTP=1
      MJ=MA(INEXT)-MA(INEXTP)
      IF(MJ.LT.MZ)MJ=MJ+MBIG
      MA(INEXT)=MJ
      RAN3=MJ*FAC
      RETURN
      END


      FUNCTION GASDEV(IDUM)
      DATA ISET/0/
      IF (ISET.EQ.0) THEN
1       V1=2.*RAN3(IDUM)-1.
        V2=2.*RAN3(IDUM)-1.
        R=V1**2+V2**2
        IF(R.GE.1.)GO TO 1
        FAC=SQRT(-2.*LOG(R)/R)
        GSET=V1*FAC
        GASDEV=V2*FAC
        ISET=1
      ELSE
        GASDEV=GSET
        ISET=0
      ENDIF
      RETURN
      END

      function power(rk)
c---  Calculates sqrt(Power spectrum) with gaussian smoothing and with
c---  biquadratic cutoff at Nyquist frequency
c---  Power spectrum consists of primordial scale-free power law and 
c---  transfer function
      character*3 dark
      common/powsp/rknyq,rkinv,powh,smooth,omehs,dark

c***  Primordial scale-free power spectrum : power = sqrt(P(k))
c---  rk = 2*pi*(wave number) & rkinv = 1./(2*pi*knyq)
c---  smooth = (smoothing length in pixels /ng) /sqrt(2)
      if(rk.gt.rknyq.or.rk.eq.0.)then
      power=0.
      return
      else
c      power=rk**powh*(1.-(rk*rkinv)**4.)*exp(-(rk*smooth)**2.)
      power=rk**powh
      end if

c***  Transfer function (BBKS 1986, p60) 
c---  omehs = 1/(omega*h*v[100])
      qq = rk*omehs
c---  Cold dark matter, adiabatic fluctuations with 3 flavors of 
c---  relativistic neutrinos plus photons and negligible baryon
      if(dark.eq.'cdm')then
          power=power*alog(1+2.34*qq)/(2.34*qq)*(1+3.89*qq
     &     +(16.1*qq)**2+(5.46*qq)**3+(6.71*qq)**4)**(-0.25)

c---  Hot dark matter, adiabatic fluctuations with 2 species of
c---  relativiatic neutrinos
      else if(dark.eq.'hdm')then 
          damp=2.6*qq
          power=power*exp(-0.16*damp-0.5*damp**2)/(1+1.6*qq+
     &     +(4.*qq)**1.5+(0.92*qq)**2)
      end if
ccccccccccccccccccccc a cutoff at k=8
c     if(rk/2./3.141592654.gt.8)power = 0
      return
      end


c---  Integrand for calculating (dM/M)**2 in top hat window
      function powint(xk)
      common/tophat/rth
      data twopi/6.28318531/,fopi/12.566371/

c---  xk = wave number
      rk = twopi*xk
c---  Power spectrum(without knyquist cutoff) times volumn factor
      powint = fopi*xk*xk*(power1(rk))**2.
c---  Fourier transform of top-hat window function
      xk1   = rth*rk
      if(xk1.gt.0.02)then
      powint = powint*9*((sin(xk1)-xk1*cos(xk1))/xk1**3)**2
      else
      powint = powint*(1-xk1*xk1*0.1)**2
      end if
      return
      end

c---  Integrand for calculating integral(P(k)*k^2) in top hat window
      function pow2int(xk)
      common/tophat/rth
      data twopi/6.28318531/,fopi/12.566371/

c---  xk = wave number
      rk = twopi*xk
c---  Power spectrum times volumn factor
      powint = fopi*xk**2*rk**2*(power1(rk))**2
c---  Fourier transform of top-hat window function
      xk1   = rth*rk
      if(xk1.gt.0.02)then
      pow2int = powint*9*((sin(xk1)-xk1*cos(xk1))/xk1**3)**2
      else
      pow2int = powint*(1-xk1*xk1*0.1)**2
      end if
      return
      end

      function power1(rk)
c---  Calculates sqrt(Power spectrum) with gaussian smoothing and with
c---  biquadratic cutoff at Nyquist frequency
c---  Power spectrum consists of primordial scale-free power law and 
c---  transfer function
      character*3 dark
      common/powsp/rknyq,rkinv,powh,smooth,omehs,dark

c***  Primordial scale-free power spectrum : power = sqrt(P(k))
c---  rk = 2*pi*(wave number) & rkinv = 1./(2*pi*knyq)
c---  smooth = (smoothing length in pixels /ng) /sqrt(2)
      power=rk**powh*exp(-(rk*smooth)**2)

c***  Transfer function (BBKS 1986, p60) 
c---  omehs = 1/(omega*h*v[100])
      qq = rk*omehs
c---  Cold dark matter, adiabatic fluctuations with 3 flavors of 
c---  relativistic neutrinos plus photons and negligible baryon
      if(dark.eq.'cdm')then
      if(qq.lt.0.002)then
          power=power*(1-1.17*qq+(1.351*qq)**2)*(1+3.89*qq
     &     +(16.1*qq)**2+(5.46*qq)**3+(6.71*qq)**4)**(-0.25)
      else
          power=power*alog(1+2.34*qq)/(2.34*qq)*(1+3.89*qq
     &     +(16.1*qq)**2+(5.46*qq)**3+(6.71*qq)**4)**(-0.25)
      end if

c---  Hot dark matter, adiabatic fluctuations with 2 species of
c---  relativiatic neutrinos
      else if(dark.eq.'hdm')then 
          damp=2.6*qq
          power=power*exp(-0.16*damp-0.5*damp**2)/(1+1.6*qq+
     &     +(4*qq)**1.5+(0.92*qq)**2)
      end if
      power1 = power
ccccccccccccccccccccccccccc
c     if(rk/2./3.141592654.gt.8)power = 0
      return
      end

      SUBROUTINE QSIMP(FUNC,A,B,S)
      PARAMETER (EPS=1.E-3, JMAX=128)
      EXTERNAL FUNC
      OST=-1.E30
      OS= -1.E30
      DO 11 J=1,JMAX
        CALL TRAPZD(FUNC,A,B,ST,J)
        S=(4.*ST-OST)/3.
        IF (ABS(S-OS).LT.EPS*ABS(OS)) RETURN
        OS=S
        OST=ST
11    CONTINUE
      PAUSE 'Too many steps.'
      END

      SUBROUTINE TRAPZD(FUNC,A,B,S,N)
      EXTERNAL FUNC
      IF (N.EQ.1) THEN
        S=0.5*(B-A)*(FUNC(A)+FUNC(B))
        IT=1
      ELSE
        TNM=IT
        DEL=(B-A)/TNM
        X=A+0.5*DEL
        SUM=0.
        DO 11 J=1,IT
          SUM=SUM+FUNC(X)
          X=X+DEL
11      CONTINUE
        S=0.5*(S+(B-A)*SUM/TNM)
        IT=2*IT
      ENDIF
      RETURN
      END
