#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "mpi.h"
#include "pmheader.h"
/*
#include "pm_extern.h"
*/
#include "survey.h"
extern double Theta,Phi,DTheta,DPhi;
extern char surveyfilename[100];
#include "Memory.h"
#define BLOCKSIZE 1000;
#define COPYSAVING(i)  {\
	wblock[wnp].x = particles[i].x;\
	wblock[wnp].y = particles[i].y;\
	wblock[wnp].z = particles[i].z;\
	wblock[wnp].vx = particles[i].vx;\
	wblock[wnp].vy = particles[i].vy;\
	wblock[wnp].vz = particles[i].vz;\
	wblock[wnp].indx = particles[i].indx;\
	wnp++;\
}
#define COPYSAVING1(i,jj)  {\
	/*float xp,yp,zp,xpp,zpp;\
	xpp = particles[i].x+mpx[jj];\
	yp = particles[i].y+mpy[jj];\
	zpp = particles[i].z+mpz[jj];\
	zp = cos(rot)*zpp-sin(rot)*xpp;\
	xp = sin(rot)*zpp+cos(rot)*xpp;\
	wblock[wnp].x = xp;\
	wblock[wnp].y = yp;\
	wblock[wnp].z = zp;\
	*/\
	wblock[wnp].x = particles[i].x+mpx[jj];\
	wblock[wnp].y = particles[i].y+mpy[jj];\
	wblock[wnp].z = particles[i].z+mpz[jj];\
	wblock[wnp].vx = particles[i].vx;\
	wblock[wnp].vy = particles[i].vy;\
	wblock[wnp].vz = particles[i].vz;\
	wblock[wnp].indx = particles[i].indx;\
	wnp++;\
}
typedef struct {
	float x,y,z,vx,vy,vz;
	indextype indx;
} phase;
int semi_surveywrite(pmparticletype *particles,int np, float x0,float y0,float z0,InBox *box,int nbox,
		int nx,int ny,int nz,double r1,double r2,int mstep,float amax,float a,
		float boxsize, int myrank,int nrank,int *freework,float maxd,double rot){
	int i,j,k,jj;
	char filename[100];
	int nwtot,count,ncount,nblock,nremain,ncheck;
	float rmin2,rmax2;
	float rmin,rmax;
	FILE *wp,*fp;
	INT8 MaxNp;
	int totalnp;
	int SavingPerfect;
	int wnp,nownp;
	int savingflag;
	double xp,yp,zp,theta,phi;
	double vxp,vyp,vzp;
	float *mpx,*mpy,*mpz;
	double dist2,dist;
	float theta1,theta2,phi1,phi2;
	int *nowbits;
	int sizeofint;
	phase *wblock;
	MPI_Status  status;
	theta1 = Theta-DTheta;theta2 = Theta+DTheta;
	phi1 = Phi-DPhi;phi2 = Phi+DPhi;
	rmin2 = r1*r1;rmax2 = r2*r2;
	sprintf(filename,"%s%.5d.dat",surveyfilename,mstep);
	mpx = (float *)Malloc(sizeof(float)*nbox,PPTR(mpx));
	mpy = (float *)Malloc(sizeof(float)*nbox,PPTR(mpy));
	mpz = (float *)Malloc(sizeof(float)*nbox,PPTR(mpz));
	for(i=0;i<nbox;i++){
		mpx[i] = box[i].nx*nx-x0;
		mpy[i] = box[i].ny*ny-y0;
		mpz[i] = box[i].nz*nz-z0;
	}

	MaxNp = CheckAvailableMemory()/sizeof(phase)/2;
	fprintf(stdout,"encapsulating MaxNp %d\n",MaxNp);
	wblock = ( phase *) Malloc(sizeof(phase)*MaxNp,PPTR(wblock));
	sizeofint = sizeof(int);
	SavingPerfect = 0;
	for(i=0;i<np;i++) freework[i] = 0;
	for(i=0;i<np;i++){
		for(j=0;j<nbox;j++){
			double xpp,zpp;
			xpp = particles[i].x+mpx[j];
			yp = particles[i].y+mpy[j];
			zpp = particles[i].z+mpz[j];
			zp = cos(rot)*zpp-sin(rot)*xpp;
			xp = sin(rot)*zpp+cos(rot)*xpp;
			dist2 = xp*xp+yp*yp+zp*zp;
			dist = sqrt(dist2);
			if(dist >= r1-maxd && dist < r2+maxd) {
				theta = acos(zp/dist);
				if((theta >= theta1 && theta < theta2) ){
					phi = acos(xp/sqrt(xp*xp+yp*yp));
					/*
					if(yp <0.) phi = 2.*pi-phi;
					*/
					if((phi >=phi1 && phi < phi2)){
						if(dist >= r1 && dist < r2) freework[i] = 1;
						else if(dist >= r1-maxd&& dist<r1) freework[i] = 2; /* particles in inner buffer zone */
						else freework[i] = 3; /* particles in outer buffer zone */
						freework[i] += 1000*j;
						break;
					}
				}
			}
		}
	}
	for(k=1;k<4;k++){
		char outfile[190];
		if(k==1) sprintf(outfile,"%s",filename);
		else if(k==2) sprintf(outfile,"%s.in",filename);
		else sprintf(outfile,"%s.out",filename);
		wnp = 0;
		for(i=0;i<np;i++){
			if(freework[i]%1000 == k) {
				j = freework[i]/1000;
				COPYSAVING1(i,j);
			}
			if(wnp > MaxNp) break;
		}
		nownp = i;
		totalnp = wnp;
		for(i=0;i<nrank;i++){
			if(myrank == i){
				if(myrank == 0){
					wp = fopen(outfile,"w");
					fwrite(&amax,sizeof(float),1,wp);
					fwrite(&a,sizeof(float),1,wp);
					fwrite(&boxsize,sizeof(float),1,wp);
					fwrite(&nbox,sizeof(int),1,wp);
					fwrite(mpx,sizeof(float),nbox,wp);
					fwrite(mpy,sizeof(float),nbox,wp);
					fwrite(mpz,sizeof(float),nbox,wp);
					fwrite(&nx,sizeof(float),1,wp);
					fwrite(&ny,sizeof(float),1,wp);
					fwrite(&nz,sizeof(float),1,wp);
					fwrite(&x0,sizeof(float),1,wp);
					fwrite(&y0,sizeof(float),1,wp);
					fwrite(&z0,sizeof(float),1,wp);
					fwrite(&rmin2,sizeof(float),1,wp);
					fwrite(&rmax2,sizeof(float),1,wp);
					fwrite(&theta1,sizeof(float),1,wp);
					fwrite(&theta2,sizeof(float),1,wp);
					fwrite(&phi1,sizeof(float),1,wp);
					fwrite(&phi2,sizeof(float),1,wp);
				}
				else{
					wp = fopen(outfile,"a");
				}
				fwrite(wblock,sizeof(phase),wnp,wp);
				while(nownp != np){
					wnp = 0;
					for(j=nownp;j<np;j++){
						if(freework[j]%1000 == k) {
							jj=freework[i]/1000;
							COPYSAVING1(j,jj);
						}
						if(wnp > MaxNp) break;
					}
					fwrite(wblock,sizeof(phase),wnp,wp);
					totalnp += wnp;
					nownp = j;
				}
				fclose(wp);
			}
			MPI_Barrier(MPI_COMM_WORLD);
		}
	}
	fprintf(stdout,"P%d saving survey data %d\n",myrank,totalnp);
	Free(wblock);Free(mpz);Free(mpy);Free(mpx);
	if(myrank == 0) fprintf(stdout,"End of saving Survey Data\n");
	return 0;
}
int surveywrite(pmparticletype *particles,int np, InBox *box,int nbox,
		int nx,int ny,int nz,double r1,double r2,int mstep,float amax,float a,
		float boxsize, int myrank,int nrank,int *freework){
	int i,j,k;
	char filename[100];
	int nwtot,count,ncount,nblock,nremain,ncheck;
	float rmin2,rmax2;
	FILE *wp,*fp;
	INT8 MaxNp;
	int totalnp;
	int SavingPerfect;
	int wnp,nownp;
	int savingflag;
	double xp,yp,zp,theta,phi;
	float *mpx,*mpy,*mpz;
	double dist2;
	float invx2y2,theta1,theta2,phi1,phi2;
	int *nowbits;
	int sizeofint;
	phase *wblock;
	MPI_Status  status;
	theta1 = Theta;theta2 = Theta+DTheta;
	phi1 = Phi;phi2 = Phi+DPhi;
	rmin2 = r1*r1;rmax2 = r2*r2;
	sprintf(filename,"%s%.5d.dat",surveyfilename,mstep);
	mpx = (float *)Malloc(sizeof(float)*nbox,PPTR(mpx));
	mpy = (float *)Malloc(sizeof(float)*nbox,PPTR(mpy));
	mpz = (float *)Malloc(sizeof(float)*nbox,PPTR(mpz));
	for(i=0;i<nbox;i++){
		mpx[i] = box[i].nx*nx-X0;
		mpy[i] = box[i].ny*ny-Y0;
		mpz[i] = box[i].nz*nz-Z0;
	}

	MaxNp = CheckAvailableMemory()/sizeof(phase)/2;
	fprintf(stdout,"encapsulating MaxNp %d\n",MaxNp);
	wblock = ( phase *) Malloc(sizeof(phase)*MaxNp,PPTR(wblock));
	sizeofint = sizeof(int);
	SavingPerfect = 0;
	for(i=0;i<np;i++) freework[i] = 0;
	for(i=0;i<np;i++){
		for(j=0;j<nbox;j++){
			xp = particles[i].x+mpx[j];
			yp = particles[i].y+mpy[j];
			zp = particles[i].z+mpz[j];
			dist2 = xp*xp+yp*yp+zp*zp;
			if(dist2 >= rmin2 && dist2 < rmax2) {
				theta = acos(zp/sqrt(dist2));
				if((theta >= theta1 && theta < theta2) ){
					phi = acos(xp/sqrt(xp*xp+yp*yp));
					if(yp <0.) phi = 2.*pi-phi;
					if((phi >=phi1 && phi < phi2)){
						freework[i] = 1;
						break;
					}
				}
			}
		}
	}
	wnp = 0;
	for(i=0;i<np;i++){
		if(freework[i] == 1) COPYSAVING(i);
		if(wnp > MaxNp) break;
	}
	nownp = i;
	totalnp = wnp;
	for(i=0;i<nrank;i++){
		if(myrank == i){
			if(myrank == 0){
				float x0,y0,z0;
				wp = fopen(filename,"w");
				x0 = X0; y0 = Y0; z0 = Z0;
				fwrite(&amax,sizeof(float),1,wp);
				fwrite(&a,sizeof(float),1,wp);
				fwrite(&boxsize,sizeof(float),1,wp);
				fwrite(&nbox,sizeof(int),1,wp);
				fwrite(mpx,sizeof(float),nbox,wp);
				fwrite(mpy,sizeof(float),nbox,wp);
				fwrite(mpz,sizeof(float),nbox,wp);
				fwrite(&nx,sizeof(float),1,wp);
				fwrite(&ny,sizeof(float),1,wp);
				fwrite(&nz,sizeof(float),1,wp);
				fwrite(&x0,sizeof(float),1,wp);
				fwrite(&y0,sizeof(float),1,wp);
				fwrite(&z0,sizeof(float),1,wp);
				fwrite(&rmin2,sizeof(float),1,wp);
				fwrite(&rmax2,sizeof(float),1,wp);
				fwrite(&theta1,sizeof(float),1,wp);
				fwrite(&theta2,sizeof(float),1,wp);
				fwrite(&phi1,sizeof(float),1,wp);
				fwrite(&phi2,sizeof(float),1,wp);
			}
			else{
				wp = fopen(filename,"a");
			}
			fwrite(wblock,sizeof(phase),wnp,wp);
			while(nownp != np){
				wnp = 0;
				for(j=nownp;j<np;j++){
					if(freework[j] == 1) COPYSAVING(j);
					if(wnp > MaxNp) break;
				}
				fwrite(wblock,sizeof(phase),wnp,wp);
				totalnp += wnp;
				nownp = j;
			}
			fclose(wp);
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}
	fprintf(stdout,"P%d saving survey data %d\n",myrank,totalnp);
	Free(wblock);Free(mpz);Free(mpy);Free(mpx);
	if(myrank == 0) fprintf(stdout,"End of saving Survey Data\n");
	return 0;
}
int simplesurveywrite(pmparticletype *particles,int np, 
		int nx,int ny,int nz,double r1,double r2,int mstep,float amax,float a,
		float boxsize, int myrank,int nrank,int *freework){
	InBox box[1];
	int nbox;
	int i,j,k;
	char filename[100];
	int nwtot,count,ncount,nblock,nremain,ncheck;
	float rmin2,rmax2;
	FILE *wp,*fp;
	INT8 MaxNp;
	int totalnp;
	int SavingPerfect;
	int wnp,nownp;
	int savingflag;
	double xp,yp,zp,theta,phi;
	float *mpx,*mpy,*mpz;
	double dist2;
	float invx2y2,theta1,theta2,phi1,phi2;
	int *nowbits;
	int sizeofint;
	phase *wblock;
	MPI_Status  status;
	/*
	theta1 = Theta;theta2 = Theta+DTheta;
	phi1 = Phi;phi2 = Phi+DPhi;
	*/
	rmin2 = r1*r1;rmax2 = r2*r2;
	sprintf(filename,"%s%.5d.dat",surveyfilename,mstep);
	nbox = 1;
	box[0].nx = box[0].ny = box[0].nz = 0;
	mpx = (float *)Malloc(sizeof(float)*nbox,PPTR(mpx));
	mpy = (float *)Malloc(sizeof(float)*nbox,PPTR(mpy));
	mpz = (float *)Malloc(sizeof(float)*nbox,PPTR(mpz));
	for(i=0;i<nbox;i++){
		mpx[i] = box[i].nx*nx-X1;
		mpy[i] = box[i].ny*ny-Y1;
		mpz[i] = box[i].nz*nz-Z1;
	}

	MaxNp = CheckAvailableMemory()/sizeof(phase)/2;
	fprintf(stdout,"encapsulating MaxNp %lld\n",MaxNp);
	wblock = ( phase *) Malloc(sizeof(phase)*MaxNp,PPTR(wblock));
	sizeofint = sizeof(int);
	SavingPerfect = 0;
	for(i=0;i<np;i++) freework[i] = 0;
	for(i=0;i<np;i++){
		xp = particles[i].x+mpx[0];
		yp = particles[i].y+mpy[0];
		zp = particles[i].z+mpz[0];
		dist2 = xp*xp+yp*yp+zp*zp;
		if(dist2 >= rmin2 && dist2 < rmax2) {
				freework[i] = 1;
		}
	}
	wnp = 0;
	for(i=0;i<np;i++){
		if(freework[i] == 1) COPYSAVING(i);
		if(wnp > MaxNp) break;
	}
	nownp = i;
	totalnp = wnp;
	for(i=0;i<nrank;i++){
		if(myrank == i){
			if(myrank == 0){
				float x0,y0,z0;
				wp = fopen(filename,"w");
				x0 = X1; y0 = Y1; z0 = Z1;
				fwrite(&amax,sizeof(float),1,wp);
				fwrite(&a,sizeof(float),1,wp);
				fwrite(&boxsize,sizeof(float),1,wp);
				fwrite(&nbox,sizeof(int),1,wp);
				fwrite(mpx,sizeof(float),nbox,wp);
				fwrite(mpy,sizeof(float),nbox,wp);
				fwrite(mpz,sizeof(float),nbox,wp);
				fwrite(&nx,sizeof(int),1,wp);
				fwrite(&ny,sizeof(int),1,wp);
				fwrite(&nz,sizeof(int),1,wp);
				fwrite(&x0,sizeof(float),1,wp);
				fwrite(&y0,sizeof(float),1,wp);
				fwrite(&z0,sizeof(float),1,wp);
				fwrite(&rmin2,sizeof(float),1,wp);
				fwrite(&rmax2,sizeof(float),1,wp);
				fwrite(&theta1,sizeof(float),1,wp);
				fwrite(&theta2,sizeof(float),1,wp);
				fwrite(&phi1,sizeof(float),1,wp);
				fwrite(&phi2,sizeof(float),1,wp);
			}
			else{
				wp = fopen(filename,"a");
			}
			fwrite(wblock,sizeof(phase),wnp,wp);
			while(nownp != np){
				wnp = 0;
				for(j=nownp;j<np;j++){
					if(freework[j] == 1) COPYSAVING(j);
					if(wnp > MaxNp) break;
				}
				fwrite(wblock,sizeof(phase),wnp,wp);
				totalnp += wnp;
				nownp = j;
			}
			fclose(wp);
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}
	fprintf(stdout,"P%d saving survey data %d\n",myrank,totalnp);
	Free(wblock);Free(mpz);Free(mpy);Free(mpx);
	if(myrank == 0) fprintf(stdout,"End of saving Survey Data\n");
	return 0;
}
