#ifdef OBSERVATION_MODE
		/* reordering particles for constant width */
		{
			float hhh = 1.;
			int nblur = 5;
			int magnitude = 5;
			float hh = 1.,epsilon = 0.01; /* epsilon means epsilon square */
			int oldstacknum;
			/* variables for local half step evolution */
			float ainv,app,apsq,afact,bfact;
			float half_fact1,half_fact2,inhalf_fact1;
			float half_astep;
			int halofinding,syncsaving,surveying,simplesurveying;
#ifdef SURVEY
			surveying = 1;
#else
			surveying = 0;
#endif
#ifdef SIMPLESURVEY
			simplesurveying = 1;
#else
			simplesurveying = 0;
#endif
	
			half_astep = astep*0.5;
			ainv = 1./a;
			app = -4.*pi/3.*(ainv*ainv-2*omeplam/omep*a/amax/amax/amax);
			apsq = 8.*pi/3.*(ainv+1./omei-1+omeplam/omep*(a*a-1)
					/amax/amax/amax);
			afact = (2.+app*a/apsq)/2.*ainv;
			bfact = ainv*ainv*ainv/apsq;
			half_fact1 = (1.-afact*half_astep)/(1.+afact*half_astep);
			half_fact2 = bfact*half_astep/(1.+afact*half_astep)*rng;
			/* check whether finding or syncsaving is necessary */
			if(stepcount % ObservationStride == ModulusOfObservationStride) 
				halofinding = 1;
			else halofinding = 0;
			halofinding = 0;

   		    if(fabs(a-3.) < astep/2.|| fabs(a-4.) < astep/2. || fabs(a-6.) < astep/2.
				|| fabs(a-2.) < astep/2.
				|| fabs(a-12.) < astep/2. || fabs(a-24.) < astep/2.
				|| stepcount == nstep||fabs(a-21.81)<astep) syncsaving = 1;
			else syncsaving = 0;
			if(halofinding == 1 || syncsaving == 1 ||surveying ==1 || 
					simplesurveying==1){
				/* half step evolution of velocities */
				bp = particles;
				for(i=0;i<np;i++){
					bp->vx = half_fact1*(bp->vx) + half_fact2*(bp->ax);
					bp->vy = half_fact1*(bp->vy) + half_fact2*(bp->ay);
					bp->vz = half_fact1*(bp->vz) + half_fact2*(bp->az);
					bp++;
				}
			}
			else {
				/* one step evolution of velocities */
				bp = particles;
				for(i=0;i<np;i++){
					bp->vx = fact1*(bp->vx) + fact2*(bp->ax);
					bp->vy = fact1*(bp->vy) + fact2*(bp->ay);
					bp->vz = fact1*(bp->vz) + fact2*(bp->az);
					bp++;
				}
			}
			/* if in this step surveying observations is needed */
			if(surveying == 1) {
				int survey(basicparticletype *,int,int,int,int,int,
						float,float,float,float,float,float,float,float,
						int,int,int),nntmp;
				fprintf(stdout,"P%d %f %f %f %d\n",myrank,particles[np-1].x,
						particles[np-1].y,particles[np-1].z,CurMemStack());
				fflush(stdout);
				nntmp = survey(particles,np,nx,ny,nz,stepcount,amax,a,
						 astep,nextastep,size,omep,omeplam,
						 hubble_parameter,myrank,nrank,0);
				fprintf(stdout,"P%d %f %f %f %d\n",myrank,particles[np-1].x,
						particles[np-1].y,particles[np-1].z,CurMemStack());
				nntmp = survey(particles,np,nx,ny,nz,stepcount,amax,a,
						 astep,nextastep,size,omep,omeplam,
						 hubble_parameter,myrank,nrank,1);
				fprintf(stdout,"P%d is out of survey 1\n",myrank);
				fflush(stdout);
			}
			if(simplesurveying == 1){
				int simplesurvey(basicparticletype *,int ,int ,int ,int , 
						int , float , float , float ,float , float , float ,
						float ,float ,int ,int ,int ),nntmp;
				nntmp = simplesurvey(particles,np,nx,ny,nz,stepcount,amax,a,
						 astep,nextastep,size,omep,omeplam,
						 hubble_parameter,myrank,nrank,1);
			}
			/* if in this step halo finding is needed */
			if(halofinding == 1){
				migrate(&np, ngz, zheight, zstart);
				printf("P%d before prework %d is allocated %d\n",
						myrank,CurMemStack(),np);
				fflush(stdout);
				prework(np,particles,hhh,nblur,ng,ngz,nspace,
						myrank,nrank,local_z_start,local_nz,stepcount);
				printf("P%d after prework %d is allocated %d\n",
						myrank,CurMemStack(),np);
				fflush(stdout);
				oldstacknum = CurMemStack();
/*
				(void) hfind(ng,nspace,omep,omeplam,hubble_parameter,
							 size,amax,a,
							 epsilon,hh,magnitude,stepcount,myrank,nrank);
*/
				InitialOldMemStack(oldstacknum);
				printf("P%d after hfind %d is allocated %d\n",
						myrank,CurMemStack(),np);
			}
			/* syncsaving particles */
			/* These data files have particles of synchronized pos. and vel. */
   		    if(syncsaving == 1){
				char saveprefix[80],synchronizervprefix[80];
				strcpy(saveprefix,rvprefix);
				strcpy(synchronizervprefix,rvprefix);
				sprintf(rvprefix,"Sync%s",synchronizervprefix);

/* Sort particles by index */
				/*
				HyperSort(&np,particles);
				*/
/* Write out the particles */
				delta_a = astep;
				jwrite(stepcount);
/* Resort particles by slice bins */
				migrate(&np, ngz, zheight, zstart);
	
				if(myrank == 0){
	   	            fp=fopen("PHYSICAL_PARAMETERS.dat","a");
              		fprintf(fp,"Synchronous saving\n");
   		            fprintf(fp,"%d %d %d %d %12.4f \n",ng,ngz,nspace,iseed,
							size);
   		            fprintf(fp,"%10.4f %10.4f %10.4f %10.4f %10.4f %10.4f \n",
   		                    omep,omeplam,amax,astep,pconv,vconv);
   		            fprintf(fp,"%10.4f %10.4f %d \n",a,redshift, stepcount);
   		            fclose(fp);
				}
				strcpy(rvprefix,saveprefix);
			}
			if(halofinding == 1 || syncsaving == 1 || surveying ==1 || 
					simplesurveying == 1){
				/* half step backward evolution of velocities.. */
				/* recover to original velocities */
				float Fact1InhalfFact1;
				inhalf_fact1 = 1./half_fact1;
				Fact1InhalfFact1 = fact1*inhalf_fact1;

#ifdef OLD_VERSION_OBSOLETE
				bp = particles;
				for(i=0;i<np;i++){
					bp->vx = inhalf_fact1*(bp->vx - half_fact2*(bp->ax));
					bp->vy = inhalf_fact1*(bp->vy - half_fact2*(bp->ay));
					bp->vz = inhalf_fact1*(bp->vz - half_fact2*(bp->az));
					bp++;
				}
				/* one step forward for velocities */
				bp = particles;
				for(i=0;i<np;i++){
					bp->vx = fact1*(bp->vx) + fact2*(bp->ax);
					bp->vy = fact1*(bp->vy) + fact2*(bp->ay);
					bp->vz = fact1*(bp->vz) + fact2*(bp->az);
					bp++;
				}
#endif
				bp = particles;
				for(i=0;i<np;i++){
					bp->vx = Fact1InhalfFact1*(bp->vx - half_fact2*(bp->ax))
						+ fact2*(bp->ax);
					bp->vy = Fact1InhalfFact1*(bp->vy - half_fact2*(bp->ay))
						+ fact2*(bp->ay);
					bp->vz = Fact1InhalfFact1*(bp->vz - half_fact2*(bp->az))
						+ fact2*(bp->az);
					bp++;
				}
			}
			/* one step forward for positions. This position data
			 * is at one step evolution.*/
			bp = particles;
			for(i=0;i<np;i++){
				bp->x += (pfact*(bp->vx));
				bp->y += (pfact*(bp->vy));
				bp->z += (pfact*(bp->vz));
				bp++;
			}
		}
		fmod_(&np,&rngx,&rngy,&rngz,particles,&nn,&nxpos);
#endif

		kentmp = 0.;
		dzmax = 0.;
		for(bp=particles; bp<particles+np; bp++) {
#if defined(MULTIMASS)
			kentmp += (bp->mass)*(pow2(bp->vx) + pow2(bp->vy) + pow2(bp->vz));
#else
			kentmp += (pow2(bp->vx) + pow2(bp->vy) + pow2(bp->vz));
#endif
			if(fabs((bp->vz)*pfact)>dzmax) 
				dzmax =  fabs((bp->vz)*pfact);
		}
		
		ken = (float) kentmp;

		MPI_Allreduce(&dzmax,&tdzmax,1,MPI_FLOAT,MPI_MAX,MPI_COMM_WORLD);
		dzmax = tdzmax;
		if(myrank == 0) fprintf(stderr,"Max. displacement in z = %f\n",dzmax);

		MPI_Allreduce(&ken,&tken,1,MPI_FLOAT,MPI_SUM,MPI_COMM_WORLD);
		ken = tken;
		dxda2 = ken;

/* Cosmic virial theorem */
		ken = 0.5*8.*pi/3.*ken*
             (1./(a+0.5*astep)+1./omei-1+
		     omeplam/omep/amax/amax/amax*((a+0.5*astep)*(a+0.5*astep)-1.));
		kenata = (ken+kenold)/2.;
		ktot = ktot + a*a*kenold*astep;

		if(a == 1) {
			ktot = 0.;
			poten0 = poten;
		}

		Const = a*a*a*kenata+poten+ktot;
		if(a == 1){
			const0 = Const;
			conserv = 0.;
		}
		else
			conserv = (Const-const0)/(poten-poten0);

		if(myrank == 0){
			if((fp=fopen("pm3.out","a")) != NULL){
				fprintf(fp,"%11.3E %11.3E %11.3E %11.3E %11.3E %11.3E\n",
						a,poten,kenata,Const,conserv,dxda2);
				fclose(fp);
			}
		}
		if( myrank == 0 ) {
		    bp = particles;
		    fprintf(stderr,"P%d particle0 is %g %g %g %g %g %g\n", myrank,
			        bp->x, bp->y, bp->z, bp->vx, bp->vy, bp->vz);
		}


	  	migrate(&np, ngz, zheight, zstart);

/*
#ifdef VarPM
		zfinal = zstart+zheight;
		EQNZBox(np,particles,zbox,zstart,zfinal,nz);
		if(myrank==0){
	        for(i=0;i<numprocs;i++){
	            printf("%g -- %g \n",zbox[i].zstart,zbox[i].zfinal);
	        }
	    }
#endif
*/

		if( myrank == 0 ) {
		    bp = particles;
		    fprintf(stderr,"P%d particle0 is %g %g %g %g %g %g\n", myrank,
			        bp->x, bp->y, bp->z, bp->vx, bp->vy, bp->vz);
		}

		lnp = (int8) np;
		MPI_Reduce(&lnp,&tlnp,1,MPI_INT8,MPI_SUM,0,MPI_COMM_WORLD);
		MPI_Reduce(&lnp,&maxnp,1,MPI_INT8,MPI_MAX,0,MPI_COMM_WORLD);
		MPI_Reduce(&lnp,&minnp,1,MPI_INT8,MPI_MIN,0,MPI_COMM_WORLD);
		if(myrank == 0) {
			fprintf(stderr,"Total particle number : %d \n",tlnp);
			fprintf(stderr,"max. # of prts in slices : %d \n",maxnp);
			fprintf(stderr,"min. # of prts in slices : %d \n",minnp);
	    }
		a = a + astep;
		redshift = amax/a - 1.;
    	pconv = 1.; vconv = 1.;
        kenold = ken;
 
		if( myrank == 0 ) {
			elapsedtime = gettime();
		}
		MPI_Bcast(&elapsedtime, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
		/* save for the next run 
		 * Be careful that the data of velocity 
		 * have half step below the current "a" of position of particles */
        if( elapsedtime > maxtime|| stepcount%15 == 0 ||stepcount == nstep) {
/* Sort particles by index */
			/*
			HyperSort(&np,particles);
			*/
/* Write out the particles */
			delta_a = astep;
			jwrite(stepcount+1);
/*
			if(myrank == 0){
				char removefilename[100];
				int iii;
				for(iii=0;iii<nrank;iii++){
					sprintf(removefilename,"%s.%.5d%.5d",rvprefix,
							stepcount-20+1,iii);
					remove(removefilename);
				}
			}
*/
/* Resort particles by slice bins */
			migrate(&np, ngz, zheight, zstart);
			if(myrank == 0){
              fp=fopen("PHYSICAL_PARAMETERS.dat","a");
              fprintf(fp,"Ansynchronous saving\n");
              fprintf(fp,"%d %d %d %d %12.4f \n",ng,ngz,nspace,iseed,size);
              fprintf(fp,"%10.4f %10.4f %10.4f %10.4f %10.4f %10.4f \n",
                      omep,omeplam,amax,astep,pconv,vconv);
              fprintf(fp,"%10.4f %10.4f %d \n",a,redshift, stepcount);
              fprintf(fp,"%12.6E %12.6E %12.6E %12.6E %f %d \n",
                      ken,ktot,const0,poten0,rth,0 );
              fclose(fp);
			}
			if(elapsedtime > maxtime || stepcount == nstep){
				MPI_Finalize();exit(0);
			}
		}
		TIMER_STOP(51);
		if(myrank == 0) {
			elapsedtime = gettime();
            fprintf(stderr,"Step %d CPU= %f \n", stepcount,ELAPSED_TIME(51));
			fprintf(stderr,"Wallclock time = %g\n",elapsedtime);
		}
		MPI_Bcast(&elapsedtime, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
		if( elapsedtime > maxtime ) {
			if( myrank == 0 ) {
				fprintf(stderr,"Exceeded time limit %g seconds - exiting\n",
					maxtime);
			}
		}

	}
    /* end of do-loop */
    if(myrank == 0) printf("Finishing at a = %f \n", a);
	fflush(stdout);
    fftwfinal_(&plan,&iplan);
	if(myrank ==0) fprintf(stderr,"Exiting pm\n");
}

#ifdef ACCOUT
void getrv(myrank,np,particles)
int myrank, np;
basicparticletype *particles;
{
	int i, numprocs, dummy, count;
	float m, x, y, z, vx, vy, vz;
	basicparticletype *p;
	MPI_Status receive_status;
	indextype indx
	FILE *rvfile;

	dummy = 1;
	MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
	if( myrank == 0 ) {
		rvfile = fopen("rvtmp","r");
		count = 0;
		for(i=0; i<np; i++) {
			fread(&m,sizeof(float),1,rvfile);
			fread(&x,sizeof(float),1,rvfile);
			fread(&y,sizeof(float),1,rvfile);
			fread(&z,sizeof(float),1,rvfile);
			fread(&vx,sizeof(float),1,rvfile);
			fread(&vy,sizeof(float),1,rvfile);
			fread(&vz,sizeof(float),1,rvfile);
			fread(&indx,sizeof(indextype),1,rvfile);
			p = &particles[i];
			p->mass = m;
			p->x = (x + 0.5)*L;
			p->y = (y + 0.5)*L;
			p->z = (z + 0.5)*L;
			p->vx = vx;
			p->vy = vy;
			p->vz = vz;
			p->indx = indx;
#ifndef VarPM
			p->freework = 1;
#endif
		}
		fclose(rvfile);
		SEND(1,0,&dummy,sizeof(dummy));
	}
	else {
		RECEIVE(myrank-1,0,&dummy,sizeof(int));
		rvfile = fopen("rvtmp","r");
		fseek(rvfile,myrank*np*28,0);
		for(i=0; i<np; i++) {
			fread(&m,sizeof(float),1,rvfile);
			fread(&x,sizeof(float),1,rvfile);
			fread(&y,sizeof(float),1,rvfile);
			fread(&z,sizeof(float),1,rvfile);
			fread(&vx,sizeof(float),1,rvfile);
			fread(&vy,sizeof(float),1,rvfile);
			fread(&vz,sizeof(float),1,rvfile);
			fread(&indx,sizeof(indextype),1,rvfile);
			p = &particles[i];
            p->mass = m;
            p->x = (x + 0.5)*L;
            p->y = (y + 0.5)*L;
            p->z = (z + 0.5)*L;
            p->vx = vx;
            p->vy = vy;
            p->vz = vz;
            p->indx = indx;
#ifndef VarPM
            p->freework = 1;
#endif
		}
		fclose(rvfile);
		if( myrank + 1 < numprocs ) SEND(myrank+1,0,&dummy,sizeof(int));
	}
    p = particles;
    fprintf(stderr,"P%d %g %g %g\n",myrank,p->x,p->y,p->z);


    SYNCHRONIZE();
}

#endif

/* This structure CPU is for checking the ellapsed time */
#define TICKS 100.
float ctimes(){
    struct tms local;
    times (&local);
    return((float) (local.tms_utime+local.tms_stime+local.tms_cutime
                +local.tms_cstime)/TICKS);
}

void SaveSlice(float *den,int nx,int ny,int nz,int myrank,int stepcount){
	char filename[100];
	FILE *fp;
	int i;
	if(myrank == 0){
		sprintf(filename,"slice.%.5d",stepcount);
		fp = fopen(filename,"wb");
		fwrite(&nx,sizeof(int),1,fp);
		fwrite(&ny,sizeof(int),1,fp);
		for(i=0;i<ny;i++){
			fwrite(den+i*(2*(nx/2+1)),sizeof(float),nx,fp);
		}
		fflush(fp);
		fclose(fp);
	}
}

void SaveFSlice(float *den,int nx,int ny,int nz,int local_nz,
		int myrank,int stepcount){
	char filename[100];
	int nnx;
	FILE *fp;
	int i,numprocs;
	nnx = 2*(nx/2+1);
	MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
	sprintf(filename,"pslice.%.5d",stepcount);
	if(myrank == 0)
		fp = fopen(filename,"w");
	else 
		fp = fopen(filename,"wa");
	for(i=0;i<numprocs;i++){
		if(myrank == i){
			fwrite(&nx,sizeof(int),1,fp);
			fwrite(&ny,sizeof(int),1,fp);
			fwrite(&nz,sizeof(int),1,fp);
			fwrite(den,sizeof(float),2*(nx/2+1)*ny*local_nz,fp);
			fflush(fp);
			fclose(fp);
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}
}
