CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     Parallel version of PMSEED using density array with local_nz+7 zwidth
C     It does not allow inhomogeneous widths of local domains.  Feb. 16, 2006 by Juhan Kim
C     Now under recording to admit the inhomogeneity of domain decompositions.
C     local_nz : local z width in fft
C     local_z_start : starting of z in fft
C     zstart : starting point in z for load balance
C     zwidth : width in z for load balance
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c234567
      subroutine pmseed(np,particles,nn,nxpos,den,omep,omeplam,ken,
     &     denpad,pmesh,zstart,zwidth)
      IMPLICIT none
      include 'mpif.h'
      include "fftw_f77.i"
#include "fortran.i"
      integer nzsend
      real zstart,zwidth,zfinal
	  integer izwidth,izstart

      integer np,mbias,nxpos,NZBUFFER
      parameter(mbias=4,NZBUFFER=4)
      integer nx,ny,nz,local_nz,local_z_start
      integer myid,nid,dest,src,stag,rtag
      integer status(MPI_STATUS_SIZE),root
      real den(2*(nx/2+1),ny,local_nz+NZBUFFER),denpad(2,ny,nz)
      real pmesh(2*(nx/2+1),ny,local_nz+NZBUFFER)
      real displ,mdispl

      integer nn
      real particles(nn,np)
      integer*8 lnp,tlnp
      integer mlocalstartz,mlocalnz

      external powint,pow2int,bpowint
      real ken
      double precision tmpken,tken
      real ktot,cpu(2),stime,etime
      integer xabp0(-10:NNX+10),xabp1(-10:NNX+10),xabm1(-10:NNX+10)
      integer yabp0(-10:NNY+10),yabp1(-10:NNY+10),yabm1(-10:NNY+10)
      integer zabp0(-10:LOCAL_NNZ+NZBUFFER+10)
      integer zabp1(-10:LOCAL_NNZ+NZBUFFER+10)
      integer zabm1(-10:LOCAL_NNZ+NZBUFFER+10)
      common /ptables/ xabp0,xabp1,xabm1,yabp0,yabp1,yabm1,zabp0,
     &       zabp1,zabm1
      character*3 dark
      integer iseed,nspace,iiseed
      real size
      real smooth,h,rth,bias,zi
      integer knyq,ngz,nnp,nznp,ng,ngx,ngy
      real npow
      real rngx,rngy
      real xyz,xyy,omei,powh,pi,omehs,rknyq,rknyq2,rkinv
      real twopi,rngz,rngzc,ran3,xxx,rng,rngc
      real pmas,pmass,ai,anow,wavemax,pamp,pamp2,vamp
      real xnow, xini,bnow,bini
      real vfact,vfact2,pfact,amax,astep,omep,omeplam
      real efold,sfac
      double precision delx,tdelx
      real const,poten,growth
      integer iindex

      external gasdev
      integer ngh,i,j,k,ky,kz,nghx,nghy,nghz
      real rk,velpot,gasdev,xksq,power,bpower
      integer sendsize,recvsize,ierror
      integer displs(NPROCS),rcounts(NPROCS)
  
      integer ii,jj,kk,iim1,jjm1,kkm1,iim2,jjm2,kkm2
      integer iip1,jjp1,kkp1,iip2,jjp2,kkp2
      integer nadd,nzparticles,nzprefixel
      real zstartpos

      real work,rincube
      common/powsp/rknyq,rkinv,powh,smooth,omehs,dark
      common/tophat/rth
      real com_omep,com_omepb,com_omeplam,com_h,com_size,omepb
      common/cospar/com_omep,com_omepb,com_omeplam,com_h,com_size

      integer local_ny_after_transpose,
     &     local_y_start_after_transpose,total_local_size
      common /pmcommon/plan,iplan,nx,ny,nz,local_nz,local_z_start,
     &    local_ny_after_transpose,local_y_start_after_transpose,
     &    total_local_size
C      common/seed2/ai,ken,size,iseed,amax,astep


      call MPI_Comm_rank(MPI_COMM_WORLD,myid,ierror)
      call MPI_Comm_size(MPI_COMM_WORLD,nid,ierror)

      if(myid .eq. 0) stime = etime(CPU)

C This is a hook into the C functions
      call getpowerparams(nspace,size,amax,astep,
     &                        npow,smooth,h,rth,bias,iseed,omepb)
      dark = 'cdm'
      com_omep=omep
      com_omepb = omepb
      com_omeplam=omeplam
      com_h = h
      com_size = size


      rincube = 1./nx/ny/nz
      iiseed = iseed*(myid+1)
      xxx = ran3(iiseed)
      ngx = nx
      ngy = ny
      ngz = nz
      ng = nx
      nghx = ngx/2
      ngh = nghx
      nghy = ngy/2
      nghz = ngz/2
      rng = real(ng)
      rngx = real(ngx)
      rngy = real(ngy)
      rngz = real(ngz)
      ngz = nz
      rngc = rngx*rngy*rngz
      rngz = real(ngz)
      rngzc = rngx*rngy*rngz
      xyz  = rngx/rngz
      xyy  = rngx/rngy
      pi = 3.141592654
      twopi = 2.*pi
      nnp  = ng/nspace
      nznp = ngz/nspace

      if(mod(local_nz,nspace) .gt. mod(local_z_start,nspace)) then
        nadd = 1
      else 
        nadd = 0
      endif
      nzparticles = local_nz/nspace + nadd
      zstartpos = local_z_start + mod(local_z_start,nspace)
      nzprefixel = mod(local_z_start,nspace)
      np = (nx/nspace)*(ny/nspace)*nzparticles



      knyq = ngx/2
      rknyq2 = real(knyq)**2
      rknyq = twopi*real(knyq)
      rkinv = 1./rknyq
      powh = 0.5*real(npow)
      ai = 1.
      zi = amax-1
      anow = ai*(1.+zi)
c     omei = omep*(1.+zi)/(1.+omep*zi)
      omei = omep*(1+zi)**3
     &     /(omep*(1+zi)**3+omeplam+(1-omep-omeplam)*(1+zi)**2)
      omehs = 1./(omep*h*size)
      smooth = (smooth/sqrt(2.))/rng/sqrt(2.)
      rth = rth/rng
c---  Total mass is ngz/ng so that the mean density = 1
      pmas  = real(nspace)**3
      pmass = pmas/rngc

      wavemax = 1000
c     if(size.lt.33)wavemax = 300
      call qsimp(bpowint,0.0001,wavemax,pamp)
c     call qsimp(pow2int,0.00001,wavemax,pamp2)
      if(myid .EQ. 0) print *,' <1>, <k^2>=',pamp,pamp2
c---  Here pamp = initial ms of top-hat smoothed density fluctuation
c---  pamp = 50.06, 800.95, 12815 for 64, 128, 256 h^-1 Mpc
c---  Now pamp*sqrt(P(k)) give rms fluctuation equal to thamp initially.
c---  After the expansion factor grows by the factor anow, the linear
c---  amplitude of fluctuation  will be (1/bias) over the scale rth.
c---  I. Einstein-de Sitter model
      if(omep.eq.1.)then
        pamp = (1./bias)/sqrt(pamp)*ai/anow
        vamp = 1
c---  II. Open model
      else if(omep.lt.1.and.omeplam.eq.0)then
        xnow = (1.-omep)/omep
        xini = xnow/(1.+zi)
        bini = 1.+3./xini+3.*sqrt(1.+xini)/xini**1.5*alog(sqrt(1.+xini)
     &         -sqrt(xini))
        bnow = 1.+3./xnow+3.*sqrt(1.+xnow)/xnow**1.5*alog(sqrt(1.+xnow)
     &         -sqrt(xnow))
        pamp = (1./bias)/sqrt(pamp)*bini/bnow
        vamp = omei**0.6
      else if(omep.lt.1.and.omeplam.gt.0)then
c---  III. Zero curvature with cosmological constant model
        bini = growth(1.,  amax,omep)
        bnow = growth(amax,amax,omep)
        pamp = (1./bias)/sqrt(pamp)*bini/bnow
        vamp = (growth(1.+0.005,amax,omep)-growth(1.-0.005,amax,omep))
     &        /(0.01)*1./bini
        if(myid.eq.0) then
           print *,omep,' bini=',bini,' bnow=',bnow,vamp
        endif
      end if

c---  Periodic table for mesh
ccc   local_nz+NZBUFFER is the local periodic condition in the current processor
      ngz = local_nz+NZBUFFER
      do 4 i=-10,0
      xabp0(i)=ngx+i
      xabp1(i)=ngx+i+1
      yabp0(i)=ngy+i
      yabp1(i)=ngy+i+1
      zabp0(i)=ngz+i
    4 zabp1(i)=ngz+i+1
      xabp1(0)=1
      yabp1(0)=1
      zabp1(0)=1

      do 5 i=1,ngx
      xabp0(i)=i
    5 xabp1(i)=i+1
      xabp1(ngx)=1
      do 51 i=1,ngy
      yabp0(i)=i
   51 yabp1(i)=i+1
      yabp1(ngy)=1

      do 6 i=1,ngz
      zabp0(i) = i
    6 zabp1(i) = i+1
      zabp1(ngz)=1
      do 7 i=ngx+1,ngx+10
      xabp0(i)=i-ngx
    7 xabp1(i)=i+1-ngx
      do 71 i=ngy+1,ngy+10
      yabp0(i)=i-ngy
   71 yabp1(i)=i+1-ngy

      do 8 i=ngz+1,ngz+10
      zabp0(i)=i-ngz
    8 zabp1(i)=i+1-ngz
ccc   recover the original value of ngz
      ngz = nz

      efold = 0.585*sqrt(2.)
      sfac   = -(pi*efold/size)**2
c***  Velocity Potential
c     pamp = pamp*rngzc*xyz*sqrt(0.5)/rng**3
c     pamp = pamp*rngzc*xyz*xyy*sqrt(0.5)
      pamp = pamp*rngzc*sqrt(0.5)
      do i=0,nghx
      do j=1,ngy
      ky=xyy*(j-1)
      if(ky.gt.nghx)ky=ky-ngx
      do k=1,local_nz
         kz=xyz*((k-1)+local_z_start)
         if(kz.gt.nghx)kz=kz-ngx
            xksq = i**2+ky**2+kz**2
            if(xksq.eq.0..or.xksq.gt.rknyq2)then
              den(2*i+1,j,k)=0.
              den(2*i+2,j,k)=0.
            else
              rk = twopi*sqrt(xksq)
              velpot = pamp*bpower(rk)/rk**2
              den(2*i+1,j,k) = velpot*gasdev(iiseed)
              den(2*i+2,j,k) = velpot*gasdev(iiseed)
            end if
         enddo
      enddo
      enddo
      if(myid .EQ. 0) print *,'last #=',ran3(iiseed)
cccc
c***  Make an array, den(*,*,local_nz+1:local_nz+2) which is needed to
ccc   follow the complex conjugate relation for a real array.
ccc   mpi_gatherv is gathering values with displacement of local_nz.
ccc   0 is the root node number.
      do ii = 1, 2
      do k = 1, local_nz
      do j = 1, ny
         den(j,k+local_nz*myid,local_nz+ii) = den(ii,j,k)
      enddo
      enddo
      enddo
ccc   Gathering all the den(*,*,local_nz+1:local_nz+2) to 
ccc     den(*,*,local_nz+1:local_nz+2) of 0'th processor.
ccc   rcounts is the size of sending buffer and also displs is displacement of
ccc   receive buffer saved to 0'th node.
      root = 0
      sendsize = local_nz*2*(nx/2+1)
      do i = 1, nid
         rcounts(i) = sendsize
         displs(i) = (i-1)*sendsize
      enddo
      do i = 1, 2
         call MPI_GATHERV(den(1,1+local_nz*myid,local_nz+i),sendsize,
     &          MPI_REAL,den(1,1,local_nz+i),rcounts,displs,MPI_REAL,
     &          root,MPI_COMM_WORLD,ierror)
      enddo
c---  Satisfy complex conjugation relation for a real array
ccc   Only on rank 0 processor.
      do k = 1, local_nz
      do j = 1, ny
      do i = 1, 2
          denpad(i,j,local_z_start+k) = den(i,j,k)
      enddo
      enddo
      enddo
      if(myid .eq. 0) then
         do i = 1, nid-1
           call MPI_RECV(mlocalstartz,1,MPI_INTEGER,i,0,MPI_COMM_WORLD,
     &              status,ierror)
           call MPI_RECV(mlocalnz,1,MPI_INTEGER,i,0,MPI_COMM_WORLD,
     &              status,ierror)
           call MPI_RECV(denpad(1,1,mlocalstartz+1),2*ny*mlocalnz,
     &              MPI_REAL,i,0,MPI_COMM_WORLD,status,ierror)
         enddo
      else
         call MPI_SEND(local_z_start,1,MPI_INTEGER,0,0,MPI_COMM_WORLD,
     &             ierror)
         call MPI_SEND(local_nz,1,MPI_INTEGER,0,0,MPI_COMM_WORLD,
     &             ierror)
         call MPI_SEND(denpad(1,1,local_z_start+1),2*ny*local_nz,
     &     MPI_REAL,0,0,MPI_COMM_WORLD,ierror)
      endif
c---  Satisfy complex conjugation relation for a real array
      if(myid .eq. 0) then
         do 12 k = 2, nghz
            denpad(1,1,ngz+2-k) = denpad(1,1,k)
            denpad(2,1,ngz+2-k) =-denpad(2,1,k)
            do 12 j=2,nghy
            denpad(1,ngy+2-j,ngz+2-k) = denpad(1,j,k)
12          denpad(2,ngy+2-j,ngz+2-k) =-denpad(2,j,k)

         do 13 j=2,nghy
            denpad(1,ngy+2-j,1) = denpad(1,j,1)
13          denpad(2,ngy+2-j,1) =-denpad(2,j,1)

         do 14 k=2,nghz
         do 14 j=nghy+2,ngy
            denpad(1,ngy+2-j,ngz+2-k) = denpad(1,j,k)
14          denpad(2,ngy+2-j,ngz+2-k) =-denpad(2,j,k)
      endif
      sendsize = 2*ny*nz
      call MPI_BCAST(denpad,sendsize,MPI_REAL,0,MPI_COMM_WORLD,ierror)
      do k = 1, local_nz
      do j = 1, ny
      do i = 1, 2
          den(i,j,k) = denpad(i,j,local_z_start+k)
      enddo
      enddo
      enddo


ccc   FFT COMPLEX-TO-REAL 
      call rfftwnd_f77_mpi(iplan,1,den,work,USE_WORK,FFTW_NORMAL_ORDER)
ccc   To divide by total volume of simulation cube
       do k = 1, local_nz
       do j = 1, ny
       do i = 1, nx
           den(i,j,k) = den(i,j,k)*rincube
       enddo
       enddo
       enddo




c***  To allocate buffer space for local periodic calculation 
ccc                of each processor.
ccc   In case of 4 point FDA, you should arrange mesh before this routine.
      nzsend = 2
      sendsize = 2*(nx/2+1)*ny*nzsend
      recvsize = sendsize
      dest = mod(myid+1+nid,nid)
      src = mod(myid-1+nid,nid)
      stag = 0
      rtag = 0
      call MPI_SENDRECV(den(1,1,local_nz-nzsend+1),sendsize,MPI_REAL,
     &    dest,stag,den(1,1,local_nz+NZBUFFER-nzsend+1),
     &    recvsize,MPI_REAL,src,rtag,MPI_COMM_WORLD,status,ierror)
      nzsend = 2
      sendsize = 2*(nx/2+1)*ny*nzsend
      recvsize = sendsize
      dest = mod(myid-1+nid,nid)
      src = mod(myid+1+nid,nid)
      stag = 2
      rtag = 2
      call MPI_SENDRECV(den(1,1,1),sendsize,MPI_REAL,dest,stag,
     &          den(1,1,local_nz+1),recvsize,MPI_REAL,src,rtag,
     &                  MPI_COMM_WORLD,status,ierror)

c---  For positions we use the pixel size as the length unit
      vfact = (4./3.)*rng/2.*vamp
      vfact2 = -(1./3.)*rng/4.*vamp
      iindex = 1
      do 20 k=1,nzparticles
      do 20 j=1,ny/nspace
      do 20 i=1,nx/nspace
c--------------------------------------------------------------
      particles(nxpos+1,iindex) = nspace*(i-1.)
      particles(nxpos+2,iindex) = nspace*(j-1.)
      particles(nxpos+3,iindex) = nspace*(k-1.)+zstartpos
c--------------------------------------------------------------
      ii = nspace*(i-1)+1
      jj = nspace*(j-1)+1
      kk = nspace*(k-1)+1+nzprefixel
      iim1 = xabp0(ii-1)
      jjm1 = yabp0(jj-1)
      kkm1 = zabp0(kk-1)
      iim2 = xabp0(iim1-1)
      jjm2 = yabp0(jjm1-1)
      kkm2 = zabp0(kkm1-1)
      iip1 = xabp1(ii)
      jjp1 = yabp1(jj)
      kkp1 = zabp1(kk)
      iip2 = xabp1(iip1)
      jjp2 = yabp1(jjp1)
      kkp2 = zabp1(kkp1)
c--------------------------------------------------------------
      particles(nxpos+4,iindex) = 
     &     vfact*(den(iip1,jj,kk)-den(iim1,jj,kk))
     &          +vfact2*(den(iip2,jj,kk)-den(iim2,jj,kk))
      particles(nxpos+5,iindex) = 
     &     vfact*(den(ii,jjp1,kk)-den(ii,jjm1,kk))
     &          +vfact2*(den(ii,jjp2,kk)-den(ii,jjm2,kk))
      particles(nxpos+6,iindex) = 
     &     vfact*(den(ii,jj,kkp1)-den(ii,jj,kkm1))
     &          +vfact2*(den(ii,jj,kkp2)-den(ii,jj,kkm2))
c--------------------------------------------------------------
      iindex = iindex + 1
   20 continue

c---  For (n,size,seed)=(64,64,17), vx(1,1,1)=-0.0051 & vy(1,1,1)=-0.0049

c***  Push : position at a=ai (dx/da is constant from a=0 to ai)
c---  Displacement from ai*dx/da at particle position
c     pfact = rng*ai*omei**(-0.6)
      pfact = rng*ai/vamp
      delx = 0.D0
      displ = 0
      mdispl = 0.
c--------------------------------------------------------------------
      do i = 1, np
         particles(nxpos+1,i) = 
     &         amod(particles(nxpos+1,i)+
     &         particles(nxpos+4,i)*pfact+rngx,rngx)
         particles(nxpos+2,i) = 
     &         amod(particles(nxpos+2,i)+
     &         particles(nxpos+5,i)*pfact+rngy,rngy)
         particles(nxpos+3,i) = 
     &         amod(particles(nxpos+3,i)+
     &         particles(nxpos+6,i)*pfact+rngz,rngz)
         delx = delx + particles(nxpos+4,i)**2 + 
     &         particles(nxpos+5,i)**2+particles(nxpos+6,i)**2
         displ = sqrt(particles(nxpos+4,i)**2+particles(nxpos+5,i)**2+
     &                particles(nxpos+6,i)**2)*pfact
         mdispl = amax1(displ,mdispl)
      enddo
       print *,myid,'maximum displacement ',mdispl
c--------------------------------------------------------------------
      call MPI_REDUCE(delx,tdelx,1,MPI_DOUBLE_PRECISION,MPI_SUM,root,
     &                MPI_COMM_WORLD,ierror)
      delx = tdelx
      call MPI_BCAST(delx,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,
     &          ierror)
      lnp = np
      call MPI_REDUCE(lnp,tlnp,1,MPI_INTEGER8,MPI_SUM,root,
     &                MPI_COMM_WORLD,ierror)
      call MPI_BCAST(tlnp,1,MPI_INTEGER8,0,MPI_COMM_WORLD,ierror)
      if(myid.eq.0)print *, 'P',myid,delx,pfact, tlnp
      if(myid.eq.0)print *,'rms displacement=',dsqrt(delx)*pfact
     &           /sqrt(real(tlnp))

cccc
c     open(1,file='final.out'//char(48+myid))
c     do i = 1, np
c        write(1,*) x(i),y(i),z(i),vx(i),vy(i),vz(i)
c     enddo
c     close(1)
c***  Energy
      tmpken=0.D0
      do 70 i=1,np
          tmpken=tmpken+ particles(nxpos,i)*
     &        (particles(nxpos+4,i)**2.+particles(nxpos+5,i)**2.
     &        +particles(nxpos+6,i)**2.)
70    continue
      call MPI_REDUCE(tmpken,tken,1,MPI_DOUBLE_PRECISION,MPI_SUM,root,
     &                MPI_COMM_WORLD,ierror)
      tmpken = tken
      call MPI_BCAST(tmpken,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,
     &                ierror)
      if(myid.eq.0)then
      print *,'sum of dx/da**2=',tmpken
      tmpken=0.5D0*8.D0*pi/3.D0*(1.D0/ai+1.D0/omei-1.)*tmpken
C
C possible error?
C
      ktot = 0.
      poten = 0.
      const = ai**3.*tmpken+poten+ktot
      print *,' poten,ken,const=',poten,tmpken,const
      endif
      ken = tmpken
 
    
      if(myid .eq. 0) 
     &     print *,'Generating Initial Condition ',etime(CPU)-stime
      return
      end

c---  Growth factor in the universe with zero curvature
c---  omep= present matter density parameter
c---  omeplam = 1-omep is assumed (zero curvature inflation model)
      function growth(a,amax,omep)
      external coscon
      common/pass/x

      x0 = (1./omep-1)**(1./3.)
      red = amax/a-1
      x = (1./omep-1)**(1./3.)/(1+red)
      call qsimp(coscon,0.,1.,gfac)
      growth = (x/x0)*sqrt(x**3+1)*gfac
      return
      end

      function coscon(y)
      common/pass/x
      coscon = 1./(sqrt(1+x**3*y**1.2))**3
      return
      end


