CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     Parallel version of PMSEED using density array with local_nz+7 zwidth
C     It does not allow inhomogeneous widths of local domains.  Feb. 16, 2006 by Juhan Kim
C     Now under recording to admit the inhomogeneity of domain decompositions.
C     local_nz : local z width in fft
C     local_z_start : starting of z in fft
C     zstart : starting point in z for load balance
C     zwidth : width in z for load balance
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c234567
      subroutine pmseed(np,particles,nn,nxpos,den,omep,omeplam,ken,
     &     denpad,zstart,zwidth,vamp,omei)
      IMPLICIT none
      include 'mpif.h'
      include "fftw_f77.i"
#include "fortran.i"
      real iceil
      external iceil
      integer nzsend,noffset
      real zstart,zwidth,zfinal
      integer izwidth,izstart
      integer m2z,p2z

      integer np,mbias,nxpos,NZBUFFER
      parameter(mbias=4,NZBUFFER=4)
      integer nx,ny,nz,local_nz,local_z_start
      integer myid,nid,dest,src,stag,rtag
      real den(2*(nx/2+1),ny,local_nz+NZBUFFER),denpad(2,ny,nz)
      real displ,mdispl
      integer status(MPI_STATUS_SIZE),root

      integer nn
      real particles(nn,np)
      integer*8 lnp,tlnp
      integer mlocalstartz,mlocalnz

      external powint,pow2int,bpowint
      real ken
      double precision tmpken,tken
      real ktot,cpu(2),stime,etime
      character*3 dark
      integer iseed,nspace,iiseed
      real size
      real smooth,h,rth,bias,zi
      integer knyq,ngz,nnp,nznp,ng,ngx,ngy
      real npow
      real rngx,rngy
      real xyz,xyy,omei,powh,pi,omehs,rknyq,rknyq2,rkinv
      real twopi,rngz,rngzc,ran3,xxx,rng,rngc
      real pmas,pmass,ai,anow,wavemax,pamp,pamp2,vamp
      real xnow, xini,bnow,bini
      real vfact,vfact2,pfact,amax,astep,omep,omeplam
      real efold,sfac
      real const,poten,growth
      integer iindex

      external gasdev
      integer ngh,i,j,k,ky,kz,nghx,nghy,nghz
      real rk,velpot,gasdev,xksq,power,bpower
      integer sendsize,recvsize,ierror
      integer displs(NPROCS),rcounts(NPROCS)
  
      integer ii,jj,kk,iim1,jjm1,kkm1,iim2,jjm2,kkm2
      integer iip1,jjp1,kkp1,iip2,jjp2,kkp2
      integer nadd,nzparticles,nzprefixel

      real work,rincube
      common/powsp/rknyq,rkinv,powh,smooth,omehs,dark
      common/tophat/rth
      real com_omep,com_omepb,com_omeplam,com_h,com_size,omepb
      common/cospar/com_omep,com_omepb,com_omeplam,com_h,com_size

      integer local_ny_after_transpose,
     &     local_y_start_after_transpose,total_local_size
      common /pmcommon/plan,iplan,nx,ny,nz,local_nz,local_z_start,
     &    local_ny_after_transpose,local_y_start_after_transpose,
     &    total_local_size
C      common/seed2/ai,ken,size,iseed,amax,astep


      call MPI_Comm_rank(MPI_COMM_WORLD,myid,ierror)
      call MPI_Comm_size(MPI_COMM_WORLD,nid,ierror)

      if(myid .eq. 0) stime = etime(CPU)

      print *, myid,zstart,zwidth

C This is a hook into the C functions
      call getpowerparams(nspace,size,amax,astep,
     &                        npow,smooth,h,rth,bias,iseed,omepb)
      dark = 'cdm'
      com_omep=omep
      com_omepb = omepb
      com_omeplam=omeplam
      com_h = h
      com_size = size


      rincube = 1./nx/ny/nz
      iiseed = iseed*(myid+1)
      xxx = ran3(iiseed)
      ngx = nx
      ngy = ny
      ngz = nz
      ng = nx
      nghx = ngx/2
      ngh = nghx
      nghy = ngy/2
      nghz = ngz/2
      rng = real(ng)
      rngx = real(ngx)
      rngy = real(ngy)
      rngz = real(ngz)
      ngz = nz
      rngc = rngx*rngy*rngz
      rngz = real(ngz)
      rngzc = rngx*rngy*rngz
      xyz  = rngx/rngz
      xyy  = rngx/rngy
      pi = 3.141592654
      twopi = 2.*pi
      nnp  = ng/nspace
      nznp = ngz/nspace




      knyq = ngx/2
      rknyq2 = real(knyq)**2
      rknyq = twopi*real(knyq)
      rkinv = 1./rknyq
      powh = 0.5*real(npow)
      ai = 1.
      zi = amax-1
      anow = ai*(1.+zi)
c     omei = omep*(1.+zi)/(1.+omep*zi)
      omei = omep*(1+zi)**3
     &     /(omep*(1+zi)**3+omeplam+(1-omep-omeplam)*(1+zi)**2)
      omehs = 1./(omep*h*size)
      smooth = (smooth/sqrt(2.))/rng/sqrt(2.)
      rth = rth/rng
c---  Total mass is ngz/ng so that the mean density = 1
      pmas  = real(nspace)**3
      pmass = pmas/rngc


      wavemax = 1000
c     if(size.lt.33)wavemax = 300
      call qsimp(bpowint,0.0001,wavemax,pamp)
c     call qsimp(pow2int,0.00001,wavemax,pamp2)
      if(myid .EQ. 0) print *,' <1>=',pamp
c---  Here pamp = initial ms of top-hat smoothed density fluctuation
c---  pamp = 50.06, 800.95, 12815 for 64, 128, 256 h^-1 Mpc
c---  Now pamp*sqrt(P(k)) give rms fluctuation equal to thamp initially.
c---  After the expansion factor grows by the factor anow, the linear
c---  amplitude of fluctuation  will be (1/bias) over the scale rth.
c---  I. Einstein-de Sitter model

      if(omep.eq.1.)then
        pamp = (1./bias)/sqrt(pamp)*ai/anow
        vamp = 1
c---  II. Open model
      else if(omep.lt.1.and.omeplam.eq.0)then
        xnow = (1.-omep)/omep
        xini = xnow/(1.+zi)
        bini = 1.+3./xini+3.*sqrt(1.+xini)/xini**1.5*alog(sqrt(1.+xini)
     &         -sqrt(xini))
        bnow = 1.+3./xnow+3.*sqrt(1.+xnow)/xnow**1.5*alog(sqrt(1.+xnow)
     &         -sqrt(xnow))
        pamp = (1./bias)/sqrt(pamp)*bini/bnow
        vamp = omei**0.6
      else if(omep.lt.1.and.omeplam.gt.0)then
c---  III. Zero curvature with cosmological constant model
        bini = growth(1.,  amax,omep)
        bnow = growth(amax,amax,omep)
        pamp = (1./bias)/sqrt(pamp)*bini/bnow
        vamp = (growth(1.+0.005,amax,omep)-growth(1.-0.005,amax,omep))
     &        /(0.01)*1./bini
        if(myid.eq.0) then
           print *,omep,' bini=',bini,' bnow=',bnow,vamp
        endif
      end if

      ngz = nz

      efold = 0.585*sqrt(2.)
      sfac   = -(pi*efold/size)**2
c***  Velocity Potential
c     pamp = pamp*rngzc*xyz*sqrt(0.5)/rng**3
c     pamp = pamp*rngzc*xyz*xyy*sqrt(0.5)
      pamp = pamp*rngzc*sqrt(0.5)

      do i=0,nghx
      do j=1,ngy
      ky=xyy*(j-1)
      if(ky.gt.nghx)ky=ky-ngx
      do k=1,local_nz
         kz=xyz*((k-1)+local_z_start)
         if(kz.gt.nghx)kz=kz-ngx
            xksq = i**2+ky**2+kz**2
            if(xksq.eq.0..or.xksq.gt.rknyq2)then
              den(2*i+1,j,k)=0.
              den(2*i+2,j,k)=0.
            else
              rk = twopi*sqrt(xksq)
              velpot = pamp*bpower(rk)/rk**2
              den(2*i+1,j,k) = velpot*gasdev(iiseed)
              den(2*i+2,j,k) = velpot*gasdev(iiseed)
            end if
         enddo
      enddo
      enddo
      if(myid .EQ. 0) print *,'last #=',ran3(iiseed)
cccc
c***  Make an array, den(*,*,local_nz+1:local_nz+2) which is needed to
ccc   follow the complex conjugate relation for a real array.
ccc   mpi_gatherv is gathering values with displacement of local_nz.
ccc   0 is the root node number.
ccc   Gathering all the den(*,*,local_nz+1:local_nz+2) to 
ccc     den(*,*,local_nz+1:local_nz+2) of 0'th processor.
ccc   rcounts is the size of sending buffer and also displs is displacement of
ccc   receive buffer saved to 0'th node.
c     root = 0
c     sendsize = local_nz*2*(nx/2+1)
c     if(myid.eq.0) then
c        rcounts(1) = sendsize
c        do i = 1, nid-1
c           call MPI_Recv(rcounts(i+1),1,MPI_INTEGER,i,0,MPI_COMM_WORLD,
c    &            status,ierror)
c        enddo
c     else
c        call MPI_Send(sendsize,1,MPI_INTEGER,0,0,MPI_COMM_WORLD,ierror)
c     endif
c     call MPI_Bcast(rcounts,nid,MPI_INTEGER,0,MPI_COMM_WORLD,ierror)
c     noffset = 0
c     do i = 1, nid
c        displs(i) = noffset
c        noffset = noffset + rcounts(i)
c     enddo
c     noffset = displs(myid+1)/(2*(nx/2+1))
c     do ii = 1, 2
c     do k = 1, local_nz
c     do j = 1, ny
c        den(j,k+noffset,local_nz+ii) = den(ii,j,k)
c     enddo
c     enddo
c     enddo

c     do i = 1, 2
c        call MPI_GATHERV(den(1,1+noffset,local_nz+i),sendsize,
c    &          MPI_REAL,den(1,1,local_nz+i),rcounts,displs,MPI_REAL,
c    &          root,MPI_COMM_WORLD,ierror)
c     enddo
c---  Satisfy complex conjugation relation for a real array
ccc   Only on rank 0 processor.
      do k = 1, local_nz
      do j = 1, ny
      do i = 1, 2
          denpad(i,j,local_z_start+k) = den(i,j,k)
      enddo
      enddo
      enddo
      if(myid .eq. 0) then
         do i = 1, nid-1
           call MPI_RECV(mlocalstartz,1,MPI_INTEGER,i,0,MPI_COMM_WORLD,
     &              status,ierror)
           call MPI_RECV(mlocalnz,1,MPI_INTEGER,i,0,MPI_COMM_WORLD,
     &              status,ierror)
           call MPI_RECV(denpad(1,1,mlocalstartz+1),2*ny*mlocalnz,
     &              MPI_REAL,i,0,MPI_COMM_WORLD,status,ierror)
         enddo
      else
         call MPI_SEND(local_z_start,1,MPI_INTEGER,0,0,MPI_COMM_WORLD,
     &             ierror)
         call MPI_SEND(local_nz,1,MPI_INTEGER,0,0,MPI_COMM_WORLD,
     &             ierror)
         call MPI_SEND(denpad(1,1,local_z_start+1),2*ny*local_nz,
     &     MPI_REAL,0,0,MPI_COMM_WORLD,ierror)
      endif
c---  Satisfy complex conjugation relation for a real array
      if(myid .eq. 0) then
         do 12 k = 2, nghz
            denpad(1,1,ngz+2-k) = denpad(1,1,k)
            denpad(2,1,ngz+2-k) =-denpad(2,1,k)
            do 12 j=2,nghy
            denpad(1,ngy+2-j,ngz+2-k) = denpad(1,j,k)
12          denpad(2,ngy+2-j,ngz+2-k) =-denpad(2,j,k)

         do 13 j=2,nghy
            denpad(1,ngy+2-j,1) = denpad(1,j,1)
13          denpad(2,ngy+2-j,1) =-denpad(2,j,1)

         do 14 k=2,nghz
         do 14 j=nghy+2,ngy
            denpad(1,ngy+2-j,ngz+2-k) = denpad(1,j,k)
14          denpad(2,ngy+2-j,ngz+2-k) =-denpad(2,j,k)
      endif
      sendsize = 2*ny*nz
      call MPI_BCAST(denpad,sendsize,MPI_REAL,0,MPI_COMM_WORLD,ierror)
      do k = 1, local_nz
      do j = 1, ny
      do i = 1, 2
          den(i,j,k) = denpad(i,j,local_z_start+k)
      enddo
      enddo
      enddo


ccc   FFT COMPLEX-TO-REAL 
c$omp parallel 
c$omp single
      call rfftwnd_f77_mpi(iplan,1,den,work,USE_WORK,FFTW_NORMAL_ORDER)
c$omp end single
c$omp end parallel 
c     call flush(6)
c     call MPI_Barrier(MPI_COMM_WORLD,ierror)
c     print *,myid,den(5,5,2)
c     call flush(6)
c     stop
ccc   To divide by total volume of simulation cube
c$omp parallel do
       do k = 1, local_nz
       do j = 1, ny
       do i = 1, nx
           den(i,j,k) = den(i,j,k)*rincube
       enddo
       enddo
       enddo

       return
       end

       subroutine setinnerparticles(np,particles,nn,nxpos,
     &     nzparticles,zstartpos,
     &     nzprefixel,omep,omeplam,ken,pvmesh,zstart,zwidth,vamp,nspace,
     &     omei,amax)
c      IMPLICIT none
      include 'mpif.h'
#include "fortran.i"
      include "fftw_f77.i"
      real omei,amax
      integer*8 lnp,tlnp
      double precision delx,tdelx,tmpken,tken
       integer np,nn,nxpos,nspace,mp
      integer nx,ny,nz,nzper
       real omep,omeplam,ken,zstart,zwidth,vamp
       real particles(nn,np)
       real pvmesh(2*(nx/2+1),ny,*)
       real vfact,vfact2
       integer lindx,i,j,k
       real zstartpos,pfact,ai,pi
      real displ,mdispl,tmdispl
       integer nzparticles,nzprefixel,ngz
       integer NZBUFFER,rng
      parameter(NZBUFFER=4)
      integer xabp0(-10:NNX+10),xabp1(-10:NNX+10),xabm1(-10:NNX+10)
      integer yabp0(-10:NNY+10),yabp1(-10:NNY+10),yabm1(-10:NNY+10)
      integer zabp0(-10:LOCAL_NNZ+NZBUFFER+10)
      integer zabp1(-10:LOCAL_NNZ+NZBUFFER+10)
      integer zabm1(-10:LOCAL_NNZ+NZBUFFER+10)
      common /ptables/ xabp0,xabp1,xabm1,yabp0,yabp1,yabm1,zabp0,
     &       zabp1,zabm1
      real rnx,rny,rnz
      integer local_ny_after_transpose,local_nz,local_z_start,
     &     local_y_start_after_transpose,total_local_size
      common /pmcommon/plan,iplan,nx,ny,nz,local_nz,local_z_start,
     &    local_ny_after_transpose,local_y_start_after_transpose,
     &    total_local_size
      integer myid,nid,ierror
      integer status(MPI_STATUS_SIZE),root
      real ktot,cpu(2),stime,etime
      real const,poten
      integer ii,jj,kk,iim1,jjm1,kkm1,iim2,jjm2,kkm2,iip1,iip2,jjp1,jjp2
      integer kkp1,kkp2
      integer local_mz
      real zfinal

      pi = 3.141592654
      root = 0
      zfinal = zstart+zwidth
      local_mz = int(zfinal) - int(zstart) + 1
      if(zfinal .eq. real(int(zfinal))) local_mz = local_mz - 1



      call MPI_Comm_rank(MPI_COMM_WORLD,myid,ierror)
      call MPI_Comm_size(MPI_COMM_WORLD,nid,ierror)

      ai = 1.
      
      rnx = nx
      rny = ny
      rnz = nz
      rng = rnz
c---  Periodic table for mesh
ccc   local_mz+NZBUFFER is the local periodic condition in the current processor
      nzper = local_mz+NZBUFFER
c     do 4 i=-10,0
c     xabp0(i)=nx+i
c     xabp1(i)=nx+i+1
c     yabp0(i)=ny+i
c     yabp1(i)=ny+i+1
c     zabp0(i)=nzper+i
c   4 zabp1(i)=nzper+i+1
c     xabp1(0)=1
c     yabp1(0)=1
c     zabp1(0)=1

c     do 5 i=1,nx
c     xabp0(i)=i
c   5 xabp1(i)=i+1
c     xabp1(nx)=1
c     do 51 i=1,ny
c     yabp0(i)=i
c  51 yabp1(i)=i+1
c     yabp1(ny)=1

c     do 6 i=1,nzper
c     zabp0(i) = i
c   6 zabp1(i) = i+1
c     zabp1(nzper)=1
c     do 7 i=nx+1,nx+10
c     xabp0(i)=i-nx
c   7 xabp1(i)=i+1-nx
c     do 71 i=ny+1,ny+10
c     yabp0(i)=i-ny
c  71 yabp1(i)=i+1-ny

c     do 8 i=nzper+1,nzper+10
c     zabp0(i)=i-nzper
c   8 zabp1(i)=i+1-nzper

c---  For positions we use the pixel size as the length unit
      mp = np
      vfact = (4./3.)*rng/2.*vamp
      vfact2 = -(1./3.)*rng/4.*vamp
      do 20 k=2,nzparticles-1
      do 20 j=1,ny/nspace
      do 20 i=1,nx/nspace
      np = np + 1
c--------------------------------------------------------------
      particles(nxpos+1,np) = nspace*(i-1.)
      particles(nxpos+2,np) = nspace*(j-1.)
      particles(nxpos+3,np) = nspace*(k-1.)+zstartpos
c--------------------------------------------------------------
      ii = nspace*(i-1)+1
      jj = nspace*(j-1)+1
      kk = nspace*(k-1)+1+nzprefixel
      iim1 = xabp0(ii-1)
      jjm1 = yabp0(jj-1)
      kkm1 = zabp0(kk-1)
      iim2 = xabp0(iim1-1)
      jjm2 = yabp0(jjm1-1)
      kkm2 = zabp0(kkm1-1)
      iip1 = xabp1(ii)
      jjp1 = yabp1(jj)
      kkp1 = zabp1(kk)
      iip2 = xabp1(iip1)
      jjp2 = yabp1(jjp1)
      kkp2 = zabp1(kkp1)
c--------------------------------------------------------------
      particles(nxpos+4,np) = 
     &     vfact*(pvmesh(iip1,jj,kk)-pvmesh(iim1,jj,kk))
     &          +vfact2*(pvmesh(iip2,jj,kk)-pvmesh(iim2,jj,kk))
      particles(nxpos+5,np) = 
     &     vfact*(pvmesh(ii,jjp1,kk)-pvmesh(ii,jjm1,kk))
     &          +vfact2*(pvmesh(ii,jjp2,kk)-pvmesh(ii,jjm2,kk))
      particles(nxpos+6,np) = 
     &     vfact*(pvmesh(ii,jj,kkp1)-pvmesh(ii,jj,kkm1))
     &          +vfact2*(pvmesh(ii,jj,kkp2)-pvmesh(ii,jj,kkm2))
c--------------------------------------------------------------
   20 continue

c---  For (n,size,seed)=(64,64,17), vx(1,1,1)=-0.0051 & vy(1,1,1)=-0.0049

c***  Push : position at a=ai (dx/da is constant from a=0 to ai)
c---  Displacement from ai*dx/da at particle position
c     pfact = rng*ai*omei**(-0.6)
      pfact = rng*ai/vamp
#ifdef INDEX
      call indexingip(particles,np,mp,nzparticles,nspace,nx,ny,nz)
#endif
c--------------------------------------------------------------------
c$omp parallel do private(i)
      do i = mp+1, np
         particles(nxpos+1,i) = amod(particles(nxpos+1,i)+
     &         particles(nxpos+4,i)*pfact+rnx,rnx)
         particles(nxpos+2,i) = amod(particles(nxpos+2,i)+
     &         particles(nxpos+5,i)*pfact+rny,rny)
         particles(nxpos+3,i) = amod(particles(nxpos+3,i)+
     &         particles(nxpos+6,i)*pfact+rnz,rnz)
      enddo
      delx = 0.D0
      displ = 0
      mdispl = 0.
c$omp parallel do private(i,displ)
c$omp+ reduction(+:delx)
c$omp+ reduction(MAX:mdispl)
	  do i = 1, np
         delx = delx + particles(nxpos+4,i)**2 + 
     &         particles(nxpos+5,i)**2+particles(nxpos+6,i)**2
         displ = sqrt(particles(nxpos+4,i)**2+particles(nxpos+5,i)**2+
     &                particles(nxpos+6,i)**2)*pfact
         mdispl = amax1(displ,mdispl)
      enddo
c--------------------------------------------------------------------
      call MPI_REDUCE(delx,tdelx,1,MPI_DOUBLE_PRECISION,MPI_SUM,root,
     &                MPI_COMM_WORLD,ierror)
      delx = tdelx
      call MPI_BCAST(delx,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,
     &          ierror)
      lnp = np
      call MPI_REDUCE(lnp,tlnp,1,MPI_INTEGER8,MPI_SUM,root,
     &                MPI_COMM_WORLD,ierror)
      call MPI_BCAST(tlnp,1,MPI_INTEGER8,0,MPI_COMM_WORLD,ierror)
      if(myid.eq.0)print *, 'P',myid,delx,pfact, tlnp
      if(myid.eq.0)print *,'rms displacement=',dsqrt(delx)*pfact
     &           /sqrt(real(tlnp))
      call MPI_REDUCE(mdispl,tmdispl,1,MPI_REAL,MPI_MAX,0,
     &                MPI_COMM_WORLD,ierror)
      if(myid.eq.0)print *, 'Maximum displacement =',tmdispl


cccc
c     open(1,file='final.out'//char(48+myid))
c     do i = 1, np
c        write(1,*) x(i),y(i),z(i),vx(i),vy(i),vz(i)
c     enddo
c     close(1)
c***  Energy
      tmpken=0.D0
c$omp parallel do reduction(+:tmpken)
      do 70 i=1,np
          tmpken=tmpken+ 
     &        (particles(nxpos+4,i)**2.+particles(nxpos+5,i)**2.
     &        +particles(nxpos+6,i)**2.)
70    continue
      call MPI_REDUCE(tmpken,tken,1,MPI_DOUBLE_PRECISION,MPI_SUM,root,
     &                MPI_COMM_WORLD,ierror)
      tmpken = tken
      call MPI_BCAST(tmpken,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,
     &                ierror)
      if(myid.eq.0)then
      print *,'sum of dx/da**2=',tmpken
      tmpken=0.5D0*8.D0*pi/3.D0*(1.D0/ai+1.D0/omei-1.)*tmpken
C
C possible error?
C
      ktot = 0.
      poten = 0.
      const = ai**3.*tmpken+poten+ktot
      print *,' poten,ken,const=',poten,tmpken,const
      endif
      ken = tmpken
 
    
      if(myid .eq. 0) 
     &     print *,'Generating Initial Condition ',etime(CPU)-stime

	  
      return
      end

c---  Growth factor in the universe with zero curvature
c---  omep= present matter density parameter
c---  omeplam = 1-omep is assumed (zero curvature inflation model)
      function growth(a,amax,omep)
      external coscon
      common/pass/x

      x0 = (1./omep-1)**(1./3.)
      red = amax/a-1
      x = (1./omep-1)**(1./3.)/(1+red)
      call qsimp(coscon,0.,1.,gfac)
      growth = (x/x0)*sqrt(x**3+1)*gfac
      return
      end

      function coscon(y)
      common/pass/x
      coscon = 1./(sqrt(1+x**3*y**1.2))**3
      return
      end


      function iceil(x)
      integer iceil
      real x
      if(amod(x,1.) .eq. 0.) then
        iceil = int(x)
      else
        iceil = int(x)+1
      endif
      return
      end

c----- First initialize boundary particles and migrate them
c----- to neighbor domains.
      subroutine setboundaryparticles(np,particles,nn,nxpos,
     &     nzparticles,zstartpos,
     &   nzprefixel,omep,omeplam,ken,pvmesh,zstart,zwidth,vamp,nspace,
     &     omei,amax)
c      IMPLICIT none
      include 'mpif.h'
#include "fortran.i"
      include "fftw_f77.i"
      real omei,amax
      integer*8 lnp,tlnp
      double precision delx,tdelx,tmpken,tken
       integer np,nn,nxpos,nspace
      integer nx,ny,nz,nzper
       real omep,omeplam,ken,zstart,zwidth,vamp
       real particles(nn,np)
       real pvmesh(2*(nx/2+1),ny,*)
       real vfact,vfact2
       integer lindx,i,j,k
       real zstartpos,pfact,ai,pi
      real displ,mdispl,tmdispl
       integer nzparticles,nzprefixel,ngz
       integer NZBUFFER,rng
      parameter(NZBUFFER=4)
      integer xabp0(-10:NNX+10),xabp1(-10:NNX+10),xabm1(-10:NNX+10)
      integer yabp0(-10:NNY+10),yabp1(-10:NNY+10),yabm1(-10:NNY+10)
      integer zabp0(-10:LOCAL_NNZ+NZBUFFER+10)
      integer zabp1(-10:LOCAL_NNZ+NZBUFFER+10)
      integer zabm1(-10:LOCAL_NNZ+NZBUFFER+10)
      common /ptables/ xabp0,xabp1,xabm1,yabp0,yabp1,yabm1,zabp0,
     &       zabp1,zabm1
      real rnx,rny,rnz
      integer local_ny_after_transpose,local_nz,local_z_start,
     &     local_y_start_after_transpose,total_local_size
      common /pmcommon/plan,iplan,nx,ny,nz,local_nz,local_z_start,
     &    local_ny_after_transpose,local_y_start_after_transpose,
     &    total_local_size
      integer myid,nid,ierror
      integer status(MPI_STATUS_SIZE),root
      real ktot,cpu(2),stime,etime
      real const,poten
      integer ii,jj,kk,iim1,jjm1,kkm1,iim2,jjm2,kkm2,iip1,iip2,jjp1,jjp2
      integer kkp1,kkp2
      integer local_mz
      real zfinal

      pi = 3.141592654
      root = 0
      zfinal = zstart+zwidth
      local_mz = int(zfinal) - int(zstart) + 1
      if(zfinal .eq. real(int(zfinal))) local_mz = local_mz - 1



      call MPI_Comm_rank(MPI_COMM_WORLD,myid,ierror)
      call MPI_Comm_size(MPI_COMM_WORLD,nid,ierror)

      ai = 1.
      
      rnx = nx
      rny = ny
      rnz = nz
      rng = rnz
c---  Periodic table for mesh
ccc   local_mz+NZBUFFER is the local periodic condition in the current processor
      nzper = local_mz+NZBUFFER
      do 4 i=-10,0
      xabp0(i)=nx+i
      xabp1(i)=nx+i+1
      yabp0(i)=ny+i
      yabp1(i)=ny+i+1
      zabp0(i)=nzper+i
    4 zabp1(i)=nzper+i+1
      xabp1(0)=1
      yabp1(0)=1
      zabp1(0)=1

      do 5 i=1,nx
      xabp0(i)=i
    5 xabp1(i)=i+1
      xabp1(nx)=1
      do 51 i=1,ny
      yabp0(i)=i
   51 yabp1(i)=i+1
      yabp1(ny)=1

      do 6 i=1,nzper
      zabp0(i) = i
    6 zabp1(i) = i+1
      zabp1(nzper)=1
      do 7 i=nx+1,nx+10
      xabp0(i)=i-nx
    7 xabp1(i)=i+1-nx
      do 71 i=ny+1,ny+10
      yabp0(i)=i-ny
   71 yabp1(i)=i+1-ny

      do 8 i=nzper+1,nzper+10
      zabp0(i)=i-nzper
    8 zabp1(i)=i+1-nzper

c---  For positions we use the pixel size as the length unit
      vfact = (4./3.)*rng/2.*vamp
      vfact2 = -(1./3.)*rng/4.*vamp
	  np = 0
	  nzstride = max(nzparticles-1,1)
      do 20 k=1,nzparticles,nzstride
      do 20 j=1,ny/nspace
      do 20 i=1,nx/nspace
      np = np + 1
c--------------------------------------------------------------
      particles(nxpos+1,np) = nspace*(i-1.)
      particles(nxpos+2,np) = nspace*(j-1.)
      particles(nxpos+3,np) = nspace*(k-1.)+zstartpos
c--------------------------------------------------------------
      ii = nspace*(i-1)+1
      jj = nspace*(j-1)+1
      kk = nspace*(k-1)+1+nzprefixel
      iim1 = xabp0(ii-1)
      jjm1 = yabp0(jj-1)
      kkm1 = zabp0(kk-1)
      iim2 = xabp0(iim1-1)
      jjm2 = yabp0(jjm1-1)
      kkm2 = zabp0(kkm1-1)
      iip1 = xabp1(ii)
      jjp1 = yabp1(jj)
      kkp1 = zabp1(kk)
      iip2 = xabp1(iip1)
      jjp2 = yabp1(jjp1)
      kkp2 = zabp1(kkp1)
c--------------------------------------------------------------
      particles(nxpos+4,np) = 
     &     vfact*(pvmesh(iip1,jj,kk)-pvmesh(iim1,jj,kk))
     &          +vfact2*(pvmesh(iip2,jj,kk)-pvmesh(iim2,jj,kk))
      particles(nxpos+5,np) = 
     &     vfact*(pvmesh(ii,jjp1,kk)-pvmesh(ii,jjm1,kk))
     &          +vfact2*(pvmesh(ii,jjp2,kk)-pvmesh(ii,jjm2,kk))
      particles(nxpos+6,np) = 
     &     vfact*(pvmesh(ii,jj,kkp1)-pvmesh(ii,jj,kkm1))
     &          +vfact2*(pvmesh(ii,jj,kkp2)-pvmesh(ii,jj,kkm2))
c--------------------------------------------------------------
   20 continue
c--------------------------------------------------------------------
#ifdef INDEX
      call indexingbp(particles,np,nzparticles,nspace,nx,ny,nz)
#endif
c--------------------------------------------------------------------
      pfact = rng*ai/vamp
c$omp parallel do private(i)
      do i = 1, np
         particles(nxpos+1,i) = amod(particles(nxpos+1,i)+
     &         particles(nxpos+4,i)*pfact+rnx,rnx)
         particles(nxpos+2,i) = amod(particles(nxpos+2,i)+
     &         particles(nxpos+5,i)*pfact+rny,rny)
         particles(nxpos+3,i) = amod(particles(nxpos+3,i)+
     &         particles(nxpos+6,i)*pfact+rnz,rnz)
      enddo

      return
      end

